/* AUTOMATICALLY GENERATED on Fri Jun 15 01:01:09 WEDT 2018
 * for ManageSoft release 11.0 (build 1.3661)
 *
 * DO NOT EDIT THIS FILE BY HAND!
 * 
 * Protected by US patents 6,006,034 and 6,360,366.
 * Copyright 2018 ManageSoft Corporation. All rights reserved.
 * Reproduction, adaptation, or translation without prior permission
 * is prohibited.
 */

USE ManageSoft
/*
 * $Header$
 *
 * DESCRIPTION:
 *
 *	Stored procedure to copy permissions from one object in the
 *	database to another object
 *
 * Protected by US patent 6,006,034; patents pending.
 * Copyright 2011 Flexera Software LLC
 * Reproduction, adaptation, or translation without prior permission
 * is prohibited.
 */

-- USE MANAGESOFT
GO

IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'CopyPermission' AND xtype = 'P'
)
        DROP PROCEDURE CopyPermission
GO

CREATE PROCEDURE [CopyPermission]
	@ConfigureObj VARCHAR(80),	-- Object to configure perms on
	@CopyObj VARCHAR(80)		-- Object to copy perms from
AS

	DECLARE @c CURSOR

	SET @c = CURSOR FORWARD_ONLY FOR
	SELECT
		CASE p.protecttype
			WHEN 206 THEN 'DENY'
			ELSE 'GRANT'
		END
		+ ' ' +
		CASE p.action
			WHEN 193 THEN 'SELECT'
			WHEN 195 THEN 'INSERT'
			WHEN 196 THEN 'DELETE'
			WHEN 197 THEN 'UPDATE'
			WHEN 224 THEN 'EXECUTE'
		END
		+ ' ON [' + @ConfigureObj + '] TO [' + user_name(p.uid) + ']'
	from sysobjects o
		inner join sysprotects p on o.id = p.id
	where
		o.name = @CopyObj
		AND p.action in (193, 195, 196, 197, 224)

	OPEN @c

	DECLARE @stmt varchar(200)
	FETCH NEXT FROM @c INTO @stmt

	WHILE @@FETCH_STATUS = 0
	BEGIN
		EXECUTE(@stmt)
		FETCH NEXT FROM @c INTO @stmt
	END

	CLOSE @c
	DEALLOCATE @c

GO
/*
 * $Header$
 *
 * DESCRIPTION:
 *
 *	Configure permissions on WiMi tables.
 *
 *	Note: The CopyPermission stored procedure has been included in
 *	the core ManageSoft product since release 6.5. When/if the
 *	WiMi product no longer supports installation over earlier
 *	releases of ManageSoft, the "exec CopyPermission" statements
 *	below can be moved to the relevant files which create the
 *	schema for the individual tables.
 *
 * Protected by US patent 6,006,034; patents pending.
 * Copyright 2011 Flexera Software LLC
 * Reproduction, adaptation, or translation without prior permission
 * is prohibited.
 */

-- USE MANAGESOFT
GO

exec CopyPermission 'HardwareAssessmentSeverity', 'Computer'
exec CopyPermission 'HardwareAssessmentRule', 'Computer'
exec CopyPermission 'HardwareAssessmentCache', 'Computer'
exec CopyPermission 'WiMiMigrationStateByComputer', 'Computer'
exec CopyPermission 'RolloutGroup', 'Computer'
exec CopyPermission 'RolloutGroupMember', 'Computer'
exec CopyPermission 'GhostServer', 'Computer'
exec CopyPermission 'RolloutGroupToGhostComputer', 'Computer'
exec CopyPermission 'NameMap', 'Computer'

GO

/*
 * $Header$
 *
 * DESCRIPTION:
 *
 *	Stored procedure GrantObjectPermission:  
 *	Grants Objects Permissions to a user / security group.
 *	Example of Object Permissions:
 *	Select, Update, Insert, Delete, Execute, etc.
 *
 *	Input:
 *	@objPermission, @object, @usr
 * 
 *	Usage:
 *	EXEC GrantObjectPermission 'INSERT, UPDATE, DELETE', 'MGS Data Modifiers'
 *
 * Protected by US patent 6,006,034; patents pending.
 * Copyright 2011 Flexera Software LLC
 * Reproduction, adaptation, or translation without prior permission
 * is prohibited.
 */

--DROP VIEW permissions default to the view owner, and are not transferable. 
--Privilege DROP <object> may not be granted or revoked.


-- USE MANAGESOFT
GO

IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'GrantObjectPermission' AND xtype = 'P'
)
        DROP PROCEDURE GrantObjectPermission 
GO

CREATE PROCEDURE [GrantObjectPermission]
	@objPermission VARCHAR(64), --e.g. 'SELECT' or 'INSERT, UPDATE, DELETE'
	@object VARCHAR(64), --Name of object
	@usr VARCHAR(256) --User/Security Group e.g. 'MGS Data Readers', 'MGS Data Modifiers'
AS

DECLARE @usrFullName VARCHAR(256)

SELECT @usrFullName  = user_name(p.uid)
	FROM sysobjects o, sysprotects p 
	WHERE o.id = p.id
	AND o.[name] = 'Computer' --@objName
	AND user_name(p.uid) LIKE '%\'+ @usr --Full name with Domain

 --IF full name for user doesn't exist, use username as is
IF (@usrFullName IS NULL)
	SELECT @usrFullName  = user_name(p.uid)
		FROM sysobjects o, sysprotects p 
		WHERE o.id = p.id
		AND o.[name] = 'Computer' --@objName
		AND user_name(p.uid) LIKE @usr 

-- Fall back to what is passed in as a last resort.
IF (@usrFullName IS NULL)
	SET @usrFullName = @usr

EXEC ('GRANT ' + @objPermission + ' ON ' + @object +' TO [' + @usrFullName  + ']' )

GO

EXEC CopyPermission 'GrantObjectPermission', 'CopyPermission'
GO

GRANT INSERT, UPDATE, DELETE ON HardwareAssessmentCache TO mgs_reader
