/* AUTOMATICALLY GENERATED on Fri Jun 15 01:01:12 WEDT 2018
 * for ManageSoft release 11.0 (build 1.3661
)
 *
 * DO NOT EDIT THIS FILE BY HAND!
 * 
 * Protected by US patents 6,006,034 and 6,360,366.
 * Copyright 2018 ManageSoft Corporation. All rights reserved.
 * Reproduction, adaptation, or translation without prior permission
 * is prohibited.
 */

USE ManageSoft
/*
 * $Header$
 *
 * DESCRIPTION: Stored Procedure: ComplianceComputerAndBulletinList
 *
 * Protected by US patent 6,006,034; patents pending.
 * Copyright 2011 Flexera Software LLC
 * Reproduction, adaptation, or translation without prior permission
 * is prohibited.
 */
 
-- USE MANAGESOFT
GO

IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'ComplianceComputerAndBulletinList' AND xtype = 'P'
)
        DROP PROCEDURE ComplianceComputerAndBulletinList
GO

CREATE PROCEDURE ComplianceComputerAndBulletinList
	@bulletin varchar(64)='%', --All or a specific Bulletin
	@releaseStateID varchar(4) = '%', --All or specific BulletinState (i.e. ID=4 for released state)
	@returnStatusOnly BIT=1, 	
	@compID varchar(64) = '%'
AS

DECLARE @notAnalyzedSeverity int
SELECT @notAnalyzedSeverity = Severity
FROM SecurityPatchStatus
WHERE InternalText = 'NotAnalyzed'

DECLARE @notApplicableSeverity int
SELECT @notApplicableSeverity = Severity
FROM SecurityPatchStatus
WHERE InternalText = 'NotApplicable'

--Returns Status only
IF @returnStatusOnly = 1 

	--Get the highest severity for a given Bulletin
	--from compliance info as its reported per patch
	SELECT 
	sb.BulletinID, 	
	spa.ComputerID,
	StatusSeverity = MIN(sps.Severity)
	
	FROM SecurityBulletin AS sb,
	SecurityPatchAnalysis AS spa,
	SecurityAnalysisReport AS sar,
	SecurityPatchStatus AS sps 
	
	WHERE sb.BulletinID = spa.BulletinID
	AND spa.Status = sps.SecurityPatchStatusID
	AND spa.ComputerID = sar.ComputerID
	AND sb.BulletinID LIKE  @bulletin
	AND sb.State LIKE  @releaseStateID
	AND spa.ComputerID LIKE @compID
	AND DATEDIFF(d, sb.DateRevised, sar.DataSourceDate) >= 0 --discard not analyzed Bulletins
	
	GROUP BY sb.BulletinID, spa.ComputerID

	UNION ALL

	--Any bulletins newer than the MSSecure Date
	--are marked as NotAnalyzed for the clnt
	SELECT
	sb.BulletinID,
	spr.ComputerID,	
	StatusSeverity = @notAnalyzedSeverity --NotAnalyzed
		
	FROM 
	SDOU s INNER JOIN Computer c
		ON s.OUID = c.ComputerOUID
	LEFT OUTER JOIN SecurityAnalysisReport spr
		ON spr.ComputerID = c.ComputerID
	INNER JOIN SecurityBulletin sb
		ON DATEDIFF(d, sb.DateRevised, spr.DataSourceDate) < 0

	WHERE sb.BulletinID LIKE  @bulletin
	AND sb.State LIKE  @releaseStateID
	AND spr.ComputerID LIKE @compID
	
	UNION ALL
	
	--NotApplicable status never returned from clnt
	--this is deduced based on the fact that clnt did return
	--some compliance information
	SELECT 
	sb.BulletinID, 
	spr.ComputerID, 
	Status = @notApplicableSeverity --NotApplicable
	
	FROM
	SecurityBulletin sb
	 INNER JOIN SecurityAnalysisReport spr
		ON  DATEDIFF(d, sb.DateRevised, spr.DataSourceDate) >= 0 --discard not analyzed Bulletins
	 LEFT OUTER JOIN SecurityPatchAnalysis AS spa
		ON (sb.BulletinID = spa.BulletinID 
			AND spr.ComputerID = spa.ComputerID)
	
	WHERE
	spa.ComputerID IS NULL
	AND sb.BulletinID LIKE @bulletin
	AND sb.BulletinID <> 'Unknown'
	AND sb.State LIKE @releaseStateID
	AND spr.ComputerID LIKE @compID
	AND EXISTS (
		SELECT * FROM SecurityPatchAnalysis spa2
		WHERE spa2.BulletinID = sb.BulletinID
	)
	
--Returns Other details along with Status
ELSE	
	
	SELECT
	tmp.BulletinID,
	tmp.ComputerID,
	sp_b.Title,	
	tmp.HelpUrl, 	
	tmp.DateRevised,
	tmp.StatusSeverity

	FROM
	(
		--Get the highest severity for a given Bulletin
		--from compliance info as its reported per patch
		SELECT 
		spa.BulletinID, 	
		spa.ComputerID,	
		sb.HelpUrl,
		sb.DateRevised,
		sb.State,
		StatusSeverity = MIN(sps.Severity)
		
		FROM SecurityBulletin AS sb, 
		SecurityPatchAnalysis AS spa,
		SecurityAnalysisReport AS sar,
		SecurityPatchStatus AS sps
		
		WHERE sb.BulletinID = spa.BulletinID
		AND spa.Status = sps.SecurityPatchStatusID
		AND spa.ComputerID = sar.ComputerID
		AND spa.ComputerID LIKE @compID 
		AND DATEDIFF(d, sb.DateRevised, sar.DataSourceDate) >= 0 --discard not analyzed Bulletins
		
		GROUP BY spa.BulletinID, spa.ComputerID, sb.HelpUrl, sb.DateRevised, sb.State
		
		UNION ALL
		
		--Any bulletins newer than the MSSecure Date
		--are marked as NotAnalyzed for the clnt
		SELECT
		sb.BulletinID,
		spr.ComputerID,	
		sb.HelpUrl,
		sb.DateRevised,
		sb.State,
		StatusSeverity = @notAnalyzedSeverity --NotAnalyzed
			
		FROM SecurityBulletin sb, 
		SecurityAnalysisReport spr
		
		WHERE DATEDIFF(d, sb.DateRevised, spr.DataSourceDate) < 0
		AND spr.ComputerID LIKE @compID
		
		UNION ALL
		
		--NotApplicable status never returned from clnt
		--this is deduced based on the fact that clnt did return
		--some compliance information
		SELECT 
		sb.BulletinID, 
		spr.ComputerID, 
		sb.HelpUrl,
		sb.DateRevised,
		sb.State,
		Status = @notApplicableSeverity --NotApplicable
		
		FROM
		SecurityBulletin sb
		 INNER JOIN SecurityAnalysisReport spr
			ON  DATEDIFF(d, sb.DateRevised, spr.DataSourceDate) >= 0 --discard not analyzed Bulletins
		 LEFT OUTER JOIN SecurityPatchAnalysis AS spa
			ON (sb.BulletinID = spa.BulletinID 
				AND spr.ComputerID = spa.ComputerID)
		
		WHERE
		spa.ComputerID IS NULL
		AND spr.ComputerID LIKE @compID 
		AND EXISTS (
			SELECT * FROM SecurityPatchAnalysis spa2
			WHERE spa2.BulletinID = sb.BulletinID
		)

	) AS tmp,	
	SecPatch_Bulletin AS sp_b

	WHERE tmp.BulletinID = sp_b.BulletinID
	AND tmp.BulletinID LIKE @bulletin
	AND tmp.BulletinID <> 'Unknown'
	AND tmp.State LIKE @releaseStateID


GO

CopyPermission 'ComplianceComputerAndBulletinList', 'mgsOSBreakdown'
GO

/*
 * $Header$
 *
 * DESCRIPTION: Stored Procedure: ComplianceBulletinAndComputerDetails
 *
 * Protected by US patent 6,006,034; patents pending.
 * Copyright 2011 Flexera Software LLC
 * Reproduction, adaptation, or translation without prior permission
 * is prohibited.
 */
 
-- USE MANAGESOFT
GO

IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'ComplianceBulletinAndComputerDetails' AND xtype = 'P'
)
        DROP PROCEDURE ComplianceBulletinAndComputerDetails
GO

CREATE PROCEDURE [ComplianceBulletinAndComputerDetails]
	@compID int,
	@bulletin varchar(64)
AS
	SELECT
	Status = CASE sps.InternalText 
		WHEN 'NotApplied' THEN 'Not Applied'
		ELSE sps.InternalText 
	END,
	spa.StatusMessage,
	spa.IsManaged,
	sb.BulletinID,
	sb.HelpUrl,
	sp.PatchID, 
	sp.Title As PatchName, 
	sp.QNumber,	
	( CASE WHEN spa.ProductID IS NULL
		THEN
		(SELECT TOP 1 sp_prod.[Name]
		FROM SecPatch_AffectedProduct sp_ap
		INNER JOIN SecPatch_Product sp_prod ON sp_ap.ProductID = sp_prod.ProductID
		WHERE sp_ap.PatchID = sp_p.PatchID
		)
		ELSE
		sp_prod2.[Name]
		END
	) AS [Product], 
	sppv.PackageFullName
	
	FROM SecurityPatchAnalysis spa 
	INNER JOIN SecurityBulletin sb
		ON spa.BulletinID = sb.BulletinID
	INNER JOIN SecurityPatchStatus sps
		ON spa.Status = sps.SecurityPatchStatusID
	LEFT OUTER JOIN SecurityPatch sp
		ON spa.SecurityPatchID = sp.PatchID
	LEFT OUTER JOIN SecurityPatchToPackageVersion sppv
		ON sp.PatchID = sppv.PatchID
	LEFT OUTER JOIN SecPatch_Patch sp_p
		ON spa.SecurityPatchID = sp_p.SecurityPatchID
	LEFT OUTER JOIN SecPatch_Product sp_prod2
		ON spa.ProductID = sp_prod2.ProductID
	WHERE 
	spa.BulletinID = @bulletin
	AND spa.ComputerID = @compID

GO


CopyPermission 'ComplianceBulletinAndComputerDetails', 'mgsOSBreakdown'
GO

GO
/*
 * $Id: ComplianceByBulletinComputerList.sql 20141030 o.akimov $
 * $Locker$
 *
 * DESCRIPTION: Stored Procedure: ComplianceByBulletinComputerList
 *
 * Copyright 2014 Raynet GmbH
 * Reproduction, adaptation, or translation without prior permission
 * is prohibited.
 *
 */

-- USE ManageSoft
GO

IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'ComplianceByBulletinComputerList' AND xtype = 'P'
)
        DROP PROCEDURE ComplianceByBulletinComputerList
GO

CREATE PROCEDURE ComplianceByBulletinComputerList
	@oudn varchar(800) = '%', --'%CN=Computers,DC=devscarlett,DC=mgsft,DC=com', --'%',
	@ouMatch bit = 1, --Values:[0=do exact OU Match | 1=include child-OUs in match]
	@bulletin varchar(64) = '%', --All or specific Bulletin
	@approvedBulletin BIT = 0, -- Values:[0=All bulletins | 1=Approved bulletins only]
	@status varchar(64) = '%', --Status of a bulletin
	@compCN Varchar(128) = '%' --filter computer name (size=64*2 for encoded chars)
AS

--REVISIT: @approvedBulletin is not reqd here for filter
-- as we pass in the Bulletin name always
DECLARE @releaseStateID varchar(4)
--Process only approved bulletins
IF  @approvedBulletin = 1
	SELECT @releaseStateID = StateID
	FROM SecurityState
	WHERE [Description] = 'Released'
--Process all bulletins
ELSE
	SELECT @releaseStateID = '%'

IF OBJECT_ID('tempdb..#Organization') IS NOT NULL DROP TABLE #Organization
CREATE TABLE #Organization(OrganizationID int PRIMARY KEY)
EXEC OrganizationIdentifyDescendentsByOUDN @oudn, @ouMatch, 0

-- Populate a temporary table with relevant computer data
IF OBJECT_ID('tempdb..#Computer') IS NOT NULL DROP TABLE #Computer
CREATE TABLE #Computer (
	ComputerID int NOT NULL,
	ComputerOUID int NOT NULL,
	DataSourceDate datetime NULL,
	AnalysisDate datetime NULL
)

INSERT INTO #Computer
SELECT	c.ComputerID, c.ComputerOUID, sar.DataSourceDate, sar.AnalysisDate
FROM	Computer c
	INNER JOIN #Organization o ON o.OrganizationID = c.ComputerOUID
	LEFT OUTER JOIN SecurityAnalysisReport sar
		ON sar.ComputerID = c.ComputerID
WHERE	c.ComputerCN LIKE @compCN


IF OBJECT_ID('tempdb..#ExcludedPatches') IS NOT NULL DROP TABLE #ExcludedPatches
CREATE TABLE #ExcludedPatches (
ComputerID int NOT NULL,
BulletinID nvarchar(32) COLLATE database_default NOT NULL,
SecurityPatchID int NOT NULL,
)


INSERT INTO #ExcludedPatches
SELECT 
spa.ComputerID, spa.BulletinID, spa.SecurityPatchID
FROM SecurityBulletin sb
INNER JOIN SecurityPatchAnalysis spa ON spa.BulletinID = sb.BulletinID
INNER JOIN SecurityPatchStatus sps ON sps.SecurityPatchStatusID = spa.Status
INNER JOIN SecurityPatchAnalysis spa2 ON spa2.ComputerID = spa.ComputerID AND spa2.BulletinID = spa.BulletinID
INNER JOIN SecurityPatchStatus sps2 ON sps2.SecurityPatchStatusID = spa2.Status
INNER JOIN #Computer c ON c.ComputerID = spa.ComputerID
INNER JOIN Organization o ON o.OrganizationID = c.ComputerOUID
WHERE	sps.SecurityPatchStatusID = spa.Status
	AND spa2.ComputerID = spa.ComputerID
	AND spa2.BulletinID = spa.BulletinID
	AND (	sps2.Severity < sps.Severity
		OR (	sps2.Severity = sps.Severity
			AND spa2.SecurityPatchID < spa.SecurityPatchID
		)
	)

SELECT	c.ComputerID,
	c.ComputerCN,
	dbo.OUName(s.OrganizationID) AS OUDN,
	Analysis.BulletinID,
	Status = CASE
		WHEN 	Analysis.Compliant_Applied > 0
			THEN 'Applied'
		WHEN	Analysis.Compliant_Warning > 0
			THEN 'Warning'
		WHEN	Analysis.Compliant_Superseded > 0
			THEN 'Superseded'
		WHEN	Analysis.NotCompliant_InstallFailed > 0
			THEN 'InstallFailed'
		WHEN	Analysis.NotCompliant_NotInPolicy > 0
			OR Analysis.NotCompliant_NoPackage > 0
			THEN 'NotInPolicy'
		WHEN	Analysis.NotCompliant_PendingReboot > 0
			THEN 'RebootPending'
		WHEN	Analysis.NotCompliant_PolicyPending > 0
			THEN 'PolicyPending'
		WHEN	Analysis.Unknown_OutOfDateReport > 0
			OR Analysis.Unknown_NeverReported > 0
			THEN 'NotAnalyzed'
		WHEN	Analysis.Unknown_Unknown > 0
			THEN 'Unknown'
		ELSE	'NotRequired'
	END,
	StatusDetail = CASE
		WHEN 	(	Analysis.Compliant_Applied > 0
				OR Analysis.Compliant_Warning > 0
			) AND Analysis.IsManaged = 1
			THEN 'AppliedViaManageSoft'
		WHEN 	(	Analysis.Compliant_Applied > 0
				OR Analysis.Compliant_Warning > 0
			) AND Analysis.IsManaged = 0
			THEN 'Applied'
		WHEN	Analysis.Compliant_Superseded > 0
			AND Analysis.IsManaged = 1
			THEN 'SupersededPatchAppliedViaManageSoft'
		WHEN	Analysis.Compliant_Superseded > 0
			AND Analysis.IsManaged = 0
			THEN 'SupersededPatchApplied'
		WHEN	Analysis.NotCompliant_InstallFailed > 0
			THEN 'RequiredAndApprovedButInstallFailed'
		WHEN	Analysis.NotCompliant_NoPackage > 0
			THEN 'RequiredButNotApproved'
		WHEN	Analysis.NotCompliant_NotInPolicy > 0
			THEN 'RequiredButNotInPolicy'
		WHEN	Analysis.NotCompliant_PendingReboot > 0
			THEN 'RequiredApprovedAndInstalledButNotCompliantMayBePendingReboot'
		WHEN	Analysis.NotCompliant_PolicyPending > 0
			THEN 'RequiredAndApprovedButNotYetInstalled'
		WHEN	Analysis.Unknown_OutOfDateReport > 0
			THEN 'SecurityAnalysisHasNotBeenPerformedSinceTheBulletinLastRevised'
		WHEN	Analysis.Unknown_NeverReported > 0
			THEN 'SecurityAnalysisHasNeverBeenPerformedForThisManagedDevice'
		WHEN	Analysis.Unknown_Unknown > 0
			THEN 'Unknown'
		ELSE	'PatchNotRequired'
	END,
	Analysis.AnalysisDate,
	Analysis.DataSourceDate,
	Analysis.DateRevised

FROM	(	SELECT DISTINCT
			c.ComputerID,
			sb.BulletinID,
			c.AnalysisDate,
			c.DataSourceDate,
			sb.DateRevised,
			spa.IsManaged

			------- Compliant states --------
			, (	CASE	WHEN	spa.Status = 4 -- Warning
						AND DATEDIFF(d, c.DataSourceDate, sb.DateRevised) <= 0
					THEN 1
					ELSE 0 END
			) AS Compliant_Warning

			, (	CASE	WHEN	spa.Status = 6 -- Superseded
						AND DATEDIFF(d, c.DataSourceDate, sb.DateRevised) <= 0
					THEN 1
					ELSE 0 END
			) AS Compliant_Superseded

			, (	CASE	WHEN	DATEDIFF(d, c.DataSourceDate, sb.DateRevised) <= 0
						AND (	spa.Status = 7 -- Applied
							OR (
								spa.Status = 1 -- NotApplied
								AND ins.Action IN ('install', 'installex', 'installne')
								AND ins.Result = 'success'
								AND c.AnalysisDate < ins.Reported
							)
						)
				THEN 1
				ELSE 0 END
			) AS Compliant_Applied

			------ Non Compliant states ------
			, (	CASE	WHEN	spa.Status = 1 -- Not Applied
						AND DATEDIFF(d, c.DataSourceDate, sb.DateRevised) <= 0
						AND sppv.PackageFullName IS NULL
					THEN 1
					ELSE 0 END
			) AS NotCompliant_NoPackage

			, (	CASE	WHEN	spa.Status = 1 -- Not Applied
						AND DATEDIFF(d, c.DataSourceDate, sb.DateRevised) <= 0
						AND sppv.PackageFullName IS NOT NULL
						AND ISNULL(tp.PackagePathID, tpg.PackagePathID) IS NULL
						AND ( ins.Action IS NULL
							OR ins.Action NOT IN ('install', 'installex', 'installne')
							OR ins.Result <> 'success'
							OR c.AnalysisDate >= ins.Reported
						)
					THEN 1
					ELSE 0 END
			) AS NotCompliant_NotInPolicy

			, (	CASE	WHEN 	spa.Status = 1 -- NotApplied
						AND DATEDIFF(d, c.DataSourceDate, sb.DateRevised) <= 0
						AND ISNULL(tp.PackagePathID, tpg.PackagePathID) IS NOT NULL
						AND ( ins.Action IS NULL
							OR ins.Action NOT IN ('install', 'installex', 'installne')
						)
					THEN 1
					ELSE 0 END
			) AS NotCompliant_PolicyPending

			, (	CASE	WHEN	spa.Status = 1 -- Not Applied
						AND DATEDIFF(d, c.DataSourceDate, sb.DateRevised) <= 0
						AND ISNULL(tp.PackagePathID, tpg.PackagePathID) IS NOT NULL
						AND ins.Action IN ('install', 'installex', 'installne')
						AND ins.Result NOT IN ('success', 'rebootrequired')
					THEN 1
					ELSE 0 END
			) AS NotCompliant_InstallFailed

			-- Reboot pending is an assumption.
			-- This need to read the installation states when the
			-- client and resolvers support reporting on "reboot"
			-- state of a managed device
			, (	CASE	WHEN 	spa.Status = 1 -- NotApplied
						AND DATEDIFF(d, c.DataSourceDate, sb.DateRevised) <= 0
						AND ISNULL(tp.PackagePathID, tpg.PackagePathID) IS NOT NULL
						AND ins.Action IN ('install', 'installex', 'installne')
						AND (	ins.Result = 'rebootrequired'
							OR (
								ins.Result = 'success'
								AND c.AnalysisDate >= ins.Reported
							)
						)
					THEN 1
					ELSE 0 END
			) AS NotCompliant_PendingReboot

			------ Unknown states -----
			, (	CASE	WHEN	spa.Status = 2 -- Unknown
						AND DATEDIFF(d, c.DataSourceDate, sb.DateRevised) <= 0
					THEN 1
					ELSE 0 END
			) AS Unknown_Unknown

			, (	CASE	WHEN	DATEDIFF(d, c.DataSourceDate, sb.DateRevised) > 0
					THEN 1
					ELSE 0 END
			) AS Unknown_OutOfDateReport

			, 0 AS Unknown_NeverReported

		FROM	SecurityBulletin sb
			INNER JOIN SecurityPatchAnalysis AS spa
				ON spa.BulletinID = sb.BulletinID
			INNER JOIN #Computer c
				ON c.ComputerID = spa.ComputerID
			INNER JOIN Organization o
				ON o.OrganizationID = c.ComputerOUID
			LEFT OUTER JOIN (
				SecurityPatchToPackageVersion sppv
				INNER JOIN PackageVersionFull AS pv
					ON pv.PackageFullName = sppv.PackageFullName
						AND pv.MediaID = 1 -- in software library
			)
				ON sppv.PatchID = spa.SecurityPatchID
			-- Direct PackageApplies target
			LEFT OUTER JOIN PackageApplies AS tp
				ON tp.PackagePathID = pv.PackagePathID
				AND tp.TargetTypeID = 1
				AND tp.TargetOUID = c.ComputerOUID
				AND tp.TargetID = c.ComputerID
			-- Indirect PackageApplies target
			LEFT OUTER JOIN PackageApplies AS tpg
				ON tpg.PackagePathID = pv.PackagePathID
				AND tpg.TargetTypeID = 3
				-- RSoP group's OU is the domain itself
				AND tpg.TargetOUID = o.DomainID
				AND EXISTS (
					SELECT * FROM Member
					WHERE TargetTypeID = 1 -- computer policies only
					AND TargetID = c.ComputerID
					AND GroupID = tpg.TargetID
				)
			LEFT OUTER JOIN Installation AS ins
				ON ins.ComputerID = c.ComputerID
				AND ins.OrganizationID = c.ComputerOUID
				AND ins.UserID = 1 --SYSTEM
				AND ins.PackageVersionID = pv.PackageVersionID

		WHERE	NOT EXISTS(
			SELECT 1 FROM #ExcludedPatches ex
			WHERE ex.ComputerID = spa.ComputerID
			AND ex.BulletinID = spa.BulletinID
			AND ex.SecurityPatchID = spa.SecurityPatchID

			)
			AND sb.State LIKE @releaseStateID
			AND sb.BulletinID LIKE @bulletin
			AND sb.BulletinID <> 'Unknown'

		UNION ALL

		-- Supply all not required computers
		-- Supply all computers that have previously reported
		-- compliance data but not since this bulletin was revised
		SELECT DISTINCT
			c.ComputerID,
			sb.BulletinID,
			AnalysisDate = NULL,
			DataSourceDate = NULL,
			DateRevised = NULL,
			IsManaged = 0,
			Compliant_Warning = 0,
			Compliant_Superseded = 0,
			Compliant_Applied = 0,
			NotCompliant_NoPackage = 0,
			NotCompliant_NotInPolicy = 0,
			NotCompliant_PolicyPending = 0,
			NotCompliant_InstallFailed = 0,
			NotCompliant_PendingReboot = 0,
			Unknown_Unknown = 0,
			(	CASE	WHEN	DATEDIFF(d, c.DataSourceDate, sb.DateRevised) > 0
					THEN 1
					ELSE 0 END
			) AS Unknown_OutOfDateReport,
			Unknown_NeverReported = 0

		FROM	#Computer AS c
			INNER JOIN SecurityBulletin sb
				ON c.DataSourceDate IS NOT NULL

		WHERE	sb.BulletinID LIKE @bulletin
			AND NOT EXISTS (
				SELECT	1
				FROM	SecurityPatchAnalysis spa
				WHERE	spa.ComputerID = c.ComputerID
					AND spa.BulletinID = sb.BulletinID
			)

		UNION ALL

		-- Supply all computers that have never reported
		-- compliance data
		SELECT DISTINCT
			c.ComputerID,
			sb.BulletinID,
			AnalysisDate = NULL,
			DataSourceDate = NULL,
			DateRevised = NULL,
			IsManaged = 0,
			Compliant_Warning = 0,
			Compliant_Superseded = 0,
			Compliant_Applied = 0,
			NotCompliant_NoPackage = 0,
			NotCompliant_NotInPolicy = 0,
			NotCompliant_PolicyPending = 0,
			NotCompliant_InstallFailed = 0,
			NotCompliant_PendingReboot = 0,
			Unknown_Unknown = 0,
			Unknown_OutOfDateReport = 0,
			Unknown_NeverReported = 1

		FROM	#Computer AS c
			LEFT OUTER JOIN SecurityBulletin sb
				ON sb.BulletinID LIKE @bulletin

		WHERE	c.AnalysisDate IS NULL
	) AS Analysis

	INNER JOIN Computer c ON c.ComputerID = Analysis.ComputerID
	INNER JOIN #Organization s ON s.OrganizationID = c.ComputerOUID

WHERE	(	@status = 'applied'
		AND Analysis.Compliant_Applied > 0
	)
	OR (	@status = 'notapplicable'
		AND (	Analysis.Compliant_Applied = 0
			AND Analysis.Compliant_Warning = 0
			AND Analysis.Compliant_Superseded = 0
			AND Analysis.NotCompliant_InstallFailed = 0
			AND Analysis.NotCompliant_NotInPolicy = 0
			AND Analysis.NotCompliant_NoPackage = 0
			AND Analysis.NotCompliant_PendingReboot = 0
			AND Analysis.NotCompliant_PolicyPending = 0
			AND Analysis.Unknown_OutOfDateReport = 0
			AND Analysis.Unknown_NeverReported = 0
			AND Analysis.Unknown_Unknown = 0
		)
	)
	OR (	@status = 'warning'
		AND Analysis.Compliant_Warning > 0
	)
	OR (	@status = 'superseded'
		AND Analysis.Compliant_Superseded > 0
	)
	OR (	@status = 'totalcompliant'
		AND (	Analysis.Compliant_Applied > 0
			OR Analysis.Compliant_Warning > 0
			OR Analysis.Compliant_Superseded > 0
			OR(	Analysis.Compliant_Applied = 0
				AND Analysis.Compliant_Warning = 0
				AND Analysis.Compliant_Superseded = 0
				AND Analysis.NotCompliant_InstallFailed = 0
				AND Analysis.NotCompliant_NotInPolicy = 0
				AND Analysis.NotCompliant_NoPackage = 0
				AND Analysis.NotCompliant_PendingReboot = 0
				AND Analysis.NotCompliant_PolicyPending = 0
				AND Analysis.Unknown_OutOfDateReport = 0
				AND Analysis.Unknown_NeverReported = 0
				AND Analysis.Unknown_Unknown = 0
			)
		)
	)
	OR (	@status = 'installfailed'
		AND Analysis.NotCompliant_InstallFailed > 0
	)
	OR (	@status = 'notinpolicy'
		AND (	Analysis.NotCompliant_NotInPolicy > 0
			OR Analysis.NotCompliant_NoPackage > 0
		)
	)
	OR (	@status = 'rebootpending'
		AND Analysis.NotCompliant_PendingReboot > 0
	)
	OR (	@status = 'policypending'
		AND Analysis.NotCompliant_PolicyPending > 0
	)
	OR (	@status = 'totalnotcompliant'
		AND (	Analysis.NotCompliant_InstallFailed > 0
			OR Analysis.NotCompliant_NotInPolicy > 0
			OR Analysis.NotCompliant_NoPackage > 0
			OR Analysis.NotCompliant_PendingReboot > 0
			OR Analysis.NotCompliant_PolicyPending > 0
		)
	)
	OR (	@status = 'notanalyzed'
		AND (	Analysis.Unknown_OutOfDateReport > 0
			OR Analysis.Unknown_NeverReported > 0
		)
	)
	OR (	@status = 'unknown'
		AND Analysis.Unknown_Unknown > 0
	)
	OR (	@status = 'totalunknown'
		AND (	Analysis.Unknown_Unknown > 0
			OR Analysis.Unknown_OutOfDateReport > 0
			OR Analysis.Unknown_NeverReported > 0
		)
	)
	OR (@status = '%')

	--OPTION (MAXDOP 1)

DROP TABLE #Computer
DROP TABLE #Organization
DROP TABLE #ExcludedPatches
GO

CopyPermission 'ComplianceByBulletinComputerList', 'mgsOSBreakdown'
GO
-- USE ManageSoft
GO

IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'ComplianceByBulletinSummaryList' AND xtype = 'P'
)
        DROP PROCEDURE ComplianceByBulletinSummaryList
GO

CREATE PROCEDURE ComplianceByBulletinSummaryList
	@bulletin varchar(64) = '%', --filter
	@oudn varchar(800) = '%',
	@ouMatch bit = 1, --Values:[0=do exact OU Match | 1=include child-OUs in match]
	@approvedBulletin bit = 0 -- Values:[0=All bulletins | 1=Approved bulletins only]
AS


IF OBJECT_ID('tempdb..#Organization') IS NOT NULL DROP TABLE #Organization
CREATE TABLE #Organization(OrganizationID int PRIMARY KEY)
TRUNCATE TABLE #Organization
EXEC OrganizationIdentifyDescendentsByOUDN @oudn, @ouMatch, 0

-- Populate a temporary table with relevant computer data
IF OBJECT_ID('tempdb..#Computer') IS NOT NULL DROP TABLE #Computer

CREATE TABLE #Computer (
	ComputerID int NOT NULL,
	ComputerOUID int NOT NULL,
	DataSourceDate datetime NULL,
	AnalysisDate datetime NULL
)

IF EXISTS (SELECT [Property],[Value],[Created],[LastUpdate]  FROM DatabaseConfiguration WHERE [Property] = 'PrecalculateSummary' AND Value = 'True') 
-- GET PRECALCULATED DATA
BEGIN
 
 
INSERT INTO #Computer
SELECT	c.ComputerID, c.ComputerOUID, sar.DataSourceDate, sar.AnalysisDate
FROM	Computer c
	INNER JOIN #Organization o ON o.OrganizationID = c.ComputerOUID
	LEFT OUTER JOIN SecurityAnalysisReport sar
		ON sar.ComputerID = c.ComputerID

DECLARE @totalComps INT
SET @totalComps = @@ROWCOUNT


DECLARE @NotAnalyzedComputers INT
SELECT	@NotAnalyzedComputers = COUNT(ComputerID)
FROM	#Computer
WHERE	DataSourceDate IS NULL




SELECT BulletinID
      ,DateRevised
      ,Title
      ,HelpUrl
      ,@totalComps as Total
      ,@totalComps- (@NotAnalyzedComputers + SUM(Unknown_Unknown) + SUM(TotalNotCompliant) + (  SELECT COUNT(*) FROM #Computer ccount WHERE  DATEDIFF(d, ccount.DataSourceDate, DateRevised) > 0 )) as TotalCompliant
      ,SUM(TotalNotCompliant) as TotalNotCompliant
      ,@NotAnalyzedComputers  + SUM(Unknown_Unknown) +  (  SELECT COUNT(*) FROM #Computer ccount WHERE  DATEDIFF(d, ccount.DataSourceDate, DateRevised) > 0 ) as TotalUnknown
      ,SUM(Compliant_Applied) as Compliant_Applied
      ,SUM(Compliant_Warning) as Compliant_Warning
      ,SUM(Compliant_Superseded) as Compliant_Superseded
      ,@totalComps-(@NotAnalyzedComputers + SUM(Unknown_Unknown) +  SUM(Compliant_Superseded) + SUM(Compliant_Applied) + SUM(TotalNotCompliant) + ( SELECT COUNT(*) FROM #Computer ccount WHERE  DATEDIFF(d, ccount.DataSourceDate, DateRevised)>0)) as Compliant_NotRequired
      ,SUM(NotCompliant_InstallFailed) as NotCompliant_InstallFailed
      ,SUM(NotCompliant_NotInPolicy) as NotCompliant_NotInPolicy
      ,SUM(NotCompliant_PolicyPending) as NotCompliant_PolicyPending
      ,SUM(NotCompliant_PendingReboot) as NotCompliant_PendingReboot
      ,SUM(Unknown_Unknown) as Unknown_Unknown
      ,@NotAnalyzedComputers  +  (  SELECT COUNT(*) FROM #Computer ccount WHERE  DATEDIFF(d, ccount.DataSourceDate, DateRevised) > 0 )
	   as Unknown_NotAnalyzed 
  FROM  Reporting_ComplianceByBulletinSummaryList
 
	   LEFT JOIN Organization ON Reporting_ComplianceByBulletinSummaryList.OUID = Organization.OrganizationID
	     LEFT JOIN Domain ON Organization.DomainID = Domain.OrganizationID
  
  WHERE BulletinID LIKE @bulletin AND 

  ( ISNULL(Organization.RDN + ',' + Domain.DN, Domain.DN)   LIKE @oudn
    OR
   SUBSTRING(@oudn,0,4) = 'DC=' AND Domain.DN  LIKE @oudn )

  GROUP BY  BulletinID, DateRevised,Title,HelpUrl

  UNION ALL

	SELECT
		
		sb.BulletinID,
		sb.DateRevised,
		spb.Title,
		sb.HelpUrl,
		Total = @totalComps,
		TotalCompliant = 0,
		TotalNotCompliant = 0,
		TotalUnknown = @totalComps,
		Compliant_Applied = 0,
		Compliant_Warning = 0,
		Compliant_Superseded = 0,
		Compliant_NotRequired = 0,
		NotCompliant_InstallFailed = 0,
		NotCompliant_NotInPolicy = 0,
		NotCompliant_PolicyPending = 0,
		NotCompliant_PendingReboot = 0,
		Unknown_Unknown = 0,
		Unknown_NotAnalyzed = @totalComps
	FROM	SecurityBulletin sb
	LEFT OUTER JOIN SecPatch_Bulletin spb	ON spb.BulletinID = sb.BulletinID
	WHERE 	DATEDIFF(d, (SELECT ISNULL(MAX(DataSourceDate),0) FROM #Computer), sb.DateRevised) > 0
		AND NOT EXISTS (SELECT	1 FROM	SecurityPatchAnalysis WHERE	BulletinID = sb.BulletinID ) AND	sb.BulletinID LIKE @bulletin
	



  ORDER BY BulletinID

END
-- GET LIVE DATA
ELSE
BEGIN


DECLARE @releaseStateID VARCHAR(4)
SET @releaseStateID = '%'
IF  @approvedBulletin = 1
	SELECT @releaseStateID = StateID
	FROM SecurityState
	WHERE [Description] = 'Released'

TRUNCATE TABLE #Organization 
EXEC OrganizationIdentifyDescendentsByOUDN @oudn, @ouMatch, 0

CREATE TABLE #ExcludedPatches (
ComputerID int NOT NULL,
BulletinID nvarchar(32) COLLATE database_default NOT NULL,   
SecurityPatchID int NOT NULL,
Status int NOT NULL)

INSERT INTO #ExcludedPatches
SELECT 
spa.ComputerID, spa.BulletinID, spa2.SecurityPatchID, spa2.Status
FROM SecurityPatchAnalysis spa
JOIN SecurityPatchStatus sps ON sps.SecurityPatchStatusID = spa.Status
JOIN SecurityPatchAnalysis spa2 ON spa2.ComputerID = spa.ComputerID AND spa2.BulletinID = spa.BulletinID 
JOIN SecurityPatchStatus sps2 ON sps2.SecurityPatchStatusID = spa2.Status
WHERE 	sps2.Severity < sps.Severity
		OR (	sps2.Severity = sps.Severity
			AND spa2.SecurityPatchID < spa.SecurityPatchID
		)

-- Populate a temporary table with relevant computer data
TRUNCATE TABLE #Computer 

INSERT INTO #Computer
SELECT	c.ComputerID, c.ComputerOUID, sar.DataSourceDate, sar.AnalysisDate
FROM	Computer c
	INNER JOIN #Organization o ON o.OrganizationID = c.ComputerOUID
	LEFT OUTER JOIN SecurityAnalysisReport sar
		ON sar.ComputerID = c.ComputerID

 
SET @totalComps = @@ROWCOUNT
 
SELECT	@NotAnalyzedComputers = COUNT(ComputerID)
FROM	#Computer
WHERE	DataSourceDate IS NULL


SELECT	Analysis.BulletinID,
	Analysis.DateRevised,
	spb.Title,
	Analysis.HelpUrl,
	@totalComps AS Total,

	----------- Compliance Count Breakdown
	(	@totalComps -
		(	NotCompliant_InstallFailed +
			NotCompliant_NotInPolicy +
			NotCompliant_PolicyPending +
			NotCompliant_PendingReboot +
			Unknown_Unknown +
			Unknown_NotAnalyzed
		)
	) AS TotalCompliant,

	(	NotCompliant_InstallFailed +
		NotCompliant_NotInPolicy +
		NotCompliant_PendingReboot +
		NotCompliant_PolicyPending
	) AS TotalNotCompliant,

	(	Unknown_Unknown +
		Unknown_NotAnalyzed
	) AS TotalUnknown,

	----- Breakdown of Compliant Counts -----
	Compliant_Applied,
	Compliant_Warning,
	Compliant_Superseded,

	@totalComps - (
		Compliant_Applied +
		Compliant_Superseded +
		Compliant_Warning +
		NotCompliant_InstallFailed +
		NotCompliant_NotInPolicy +
		NotCompliant_PolicyPending +
		NotCompliant_PendingReboot +
		Unknown_Unknown +
		Unknown_NotAnalyzed
	) AS Compliant_NotRequired,

	----- Breakdown of Non Compliant Counts -----
	NotCompliant_InstallFailed,
	NotCompliant_NotInPolicy,
	NotCompliant_PolicyPending,
	NotCompliant_PendingReboot,

	----- Breakdown of Unknown Counts -----
	Unknown_Unknown,
	Unknown_NotAnalyzed

FROM
(
	SELECT
	sb.BulletinID,
	sb.State,
	sb.HelpUrl,
	sb.DateRevised

	------- Compliant states --------
	, SUM(	CASE WHEN spa.Status = 4 -- Warning
			AND DATEDIFF(d, c.DataSourceDate, sb.DateRevised) <= 0
		THEN 1
		ELSE 0 END
	) AS Compliant_Warning

	, SUM(	CASE WHEN spa.Status = 6 -- Superseded
			AND DATEDIFF(d, c.DataSourceDate, sb.DateRevised) <= 0
		THEN 1
		ELSE 0 END
	) AS Compliant_Superseded

	, SUM(	CASE WHEN DATEDIFF(d, c.DataSourceDate, sb.DateRevised) <= 0
			AND ( spa.Status = 7 -- Applied
				OR (
					spa.Status = 1 -- NotApplied
					AND ins.Action IN ('install', 'installex', 'installne')
					AND ins.Result = 'success'
					AND c.AnalysisDate < ins.Reported
				)
			)
		THEN 1
		ELSE 0 END
	) AS Compliant_Applied

	------ Non Compliant states ------
	, SUM(	CASE WHEN spa.Status = 1 -- Not applied
			AND DATEDIFF(d, c.DataSourceDate, sb.DateRevised) <= 0
			AND ISNULL(tp.PackagePathID, tpg.PackagePathID) IS NULL
			AND ( ins.Action IS NULL
				OR ins.Action NOT IN ('install', 'installex', 'installne')
				OR ins.Result <> 'success'
				OR c.AnalysisDate >= ins.Reported
			)
		THEN 1
		ELSE 0 END
	) AS NotCompliant_NotInPolicy

	, SUM(	CASE WHEN spa.Status = 1 -- Not applied
			AND DATEDIFF(d, c.DataSourceDate, sb.DateRevised) <= 0
			AND ISNULL(tp.PackagePathID, tpg.PackagePathID) IS NOT NULL
			AND ( ins.Action IS NULL
				OR ins.Action NOT IN ('install', 'installex', 'installne')
			)
		THEN 1
		ELSE 0 END
	) AS NotCompliant_PolicyPending

	, SUM(	CASE WHEN spa.Status = 1 -- Not applied
			AND DATEDIFF(d, c.DataSourceDate, sb.DateRevised) <= 0
			AND ISNULL(tp.PackagePathID, tpg.PackagePathID) IS NOT NULL
			AND ins.Action IN ('install', 'installex', 'installne')
			AND ins.Result NOT IN ('success', 'rebootrequired')
		THEN 1
		ELSE 0 END
	) AS NotCompliant_InstallFailed

	-- Reboot pending is an assumption.
	-- This needs to read the installation states when the client
	-- and resolvers support reporting on "reboot" state of a
	-- managed device

	, SUM(	CASE WHEN spa.Status = 1 -- Not applied
			AND DATEDIFF(d, c.DataSourceDate, sb.DateRevised) <= 0
			AND ISNULL(tp.PackagePathID, tpg.PackagePathID) IS NOT NULL
			AND ins.Action IN ('install', 'installex', 'installne')
			AND (	ins.Result = 'rebootrequired'
				OR (
					ins.Result = 'success'
					AND c.AnalysisDate >= ins.Reported
				)
			)
		THEN 1
		ELSE 0 END
	) AS NotCompliant_PendingReboot

	------ Unknown states -----
	, SUM(	CASE WHEN spa.Status = 2 -- Unknown
			AND DATEDIFF(d, c.DataSourceDate, sb.DateRevised) <= 0
		THEN 1
		ELSE 0 END
	) AS Unknown_Unknown

	, @NotAnalyzedComputers
	+ (	SELECT COUNT(c.ComputerID)
		FROM #Computer c
		WHERE DATEDIFF(d, c.DataSourceDate, sb.DateRevised) > 0
	) AS Unknown_NotAnalyzed

	FROM
	SecurityBulletin sb
	INNER JOIN SecurityPatchAnalysis spa
		ON spa.BulletinID = sb.BulletinID
	INNER JOIN #Computer c
		ON c.ComputerID = spa.ComputerID
	INNER JOIN Organization o
		ON o.OrganizationID = c.ComputerOUID
	LEFT OUTER JOIN (
		SecurityPatchToPackageVersion sppv
		INNER JOIN PackageVersionFull AS pv
			ON pv.PackageFullName = sppv.PackageFullName
				AND pv.MediaID = 1 -- in software library
	)
		ON sppv.PatchID = spa.SecurityPatchID
	-- Direct PackageApplies target
	LEFT OUTER JOIN PackageApplies AS tp
		ON tp.TargetOUID = c.ComputerOUID
		AND tp.TargetTypeID = 1
		AND tp.TargetID = c.ComputerID
		AND tp.PackagePathID = pv.PackagePathID
	-- Indirect PackageApplies target
	LEFT OUTER JOIN PackageApplies AS tpg
		ON tpg.PackagePathID = pv.PackagePathID
		AND tpg.TargetTypeID = 3
		-- RSoP group's OU is the domain itself
		AND tpg.TargetOUID = o.DomainID
		AND EXISTS (
			SELECT * FROM Member
			WHERE TargetTypeID = 1 -- computer policies only
			AND TargetID = c.ComputerID
			AND GroupID = tpg.TargetID
		)
	LEFT OUTER JOIN Installation AS ins
		ON ins.OrganizationID = c.ComputerOUID
		AND ins.ComputerID = c.ComputerID
		AND ins.PackageVersionID = pv.PackageVersionID
		AND ins.UserID = 1 --SYSTEM

	WHERE	NOT EXISTS
		(	 
			SELECT 1 FROM #ExcludedPatches ex
			WHERE ex.ComputerID = spa.ComputerID
			AND ex.BulletinID = spa.BulletinID
			AND ex.SecurityPatchID = spa.SecurityPatchID
			AND ex.Status = spa.Status
		)
		-- using a technique to improve performance by limiting number of records retrieved here
		AND
		sb.BulletinID LIKE @bulletin
		---- should be the same is in outermost WHERE clause

	GROUP BY sb.BulletinID, sb.State, sb.HelpUrl, sb.DateRevised

-- Add to the above list all the bulletins that are newer than the
-- latest reported date from any computer. This is needed for the
-- corner case where a new bulletin has come in and no device has
-- applied the bulletin as yet.

-- Note: as soon as a computer sends back a report, the following will
-- not return any data for the bulletin.

-- Issue: The only time when the union will still return data is if
-- the devices applying the bulletin are in time zones that are behind
-- the time zone of the data server !!

	UNION ALL

	SELECT
		-- These are new bulletins, so NotAnalyzed = Total Computers
		sb.BulletinID,
		sb.State,
		sb.HelpUrl,
		sb.DateRevised,
		------- Compliant states --------
		Compliant_Warning = 0,
		Compliant_Superseded = 0,
		Compliant_Applied = 0,
		------ Non Compliant states ------
		NotCompliant_NotInPolicy = 0,
		NotCompliant_PolicyPending = 0,
		NotCompliant_InstallFailed = 0,
		NotCompliant_PendingReboot = 0,
		------ Unknown states -----
		Unknown_Unknown = 0,
		Unknown_NotAnalyzed = @totalComps
	FROM	SecurityBulletin sb
	WHERE	DATEDIFF(d, (SELECT ISNULL(MAX(DataSourceDate),0) FROM #Computer), sb.DateRevised) > 0
		AND NOT EXISTS (
			SELECT	1
			FROM	SecurityPatchAnalysis
			WHERE	BulletinID = sb.BulletinID
		)
		-- using a technique to improve performance by limiting number of records retrieved here
		AND
		sb.BulletinID LIKE @bulletin
		---- should be the same is in outermost WHERE clause
) AS Analysis
	LEFT OUTER JOIN SecPatch_Bulletin spb
		ON spb.BulletinID = Analysis.BulletinID
WHERE	Analysis.State LIKE @releaseStateID
	AND Analysis.BulletinID LIKE @bulletin	-- this is being correlated in subqueries too - for efficiency
	AND Analysis.BulletinID <> 'Unknown'
	
	-- OPTION (MAXDOP 1)
	
DROP TABLE #Computer
DROP TABLE #Organization
DROP TABLE #ExcludedPatches



END
GO



IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'FillReportTable_ComplianceByBulletinSummaryList') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [FillReportTable_ComplianceByBulletinSummaryList]
GO

CREATE  PROCEDURE [FillReportTable_ComplianceByBulletinSummaryList]

	@bulletin varchar(64) = '%', --filter
	@oudn varchar(800) = '%',
	@ouMatch bit = 1, --Values:[0=do exact OU Match | 1=include child-OUs in match]
	@approvedBulletin bit = 0 -- Values:[0=All bulletins | 1=Approved bulletins only]
AS

IF EXISTS (SELECT [Property],[Value],[Created],[LastUpdate]  FROM DatabaseConfiguration WHERE [Property] = 'PrecalculateSummary' AND Value = 'True') 
-- GET PRECALCULATED DATA
BEGIN
DECLARE @releaseStateID VARCHAR(4)
SET @releaseStateID = '%'
IF  @approvedBulletin = 1
	SELECT @releaseStateID = StateID
	FROM SecurityState
	WHERE [Description] = 'Released'

CREATE TABLE #Organization(OrganizationID int PRIMARY KEY)
EXEC OrganizationIdentifyDescendentsByOUDN @oudn, @ouMatch, 0

CREATE TABLE #ExcludedPatches (
ComputerID int NOT NULL,
BulletinID nvarchar(32) COLLATE database_default NOT NULL,   
SecurityPatchID int NOT NULL,
Status int NOT NULL)

INSERT INTO #ExcludedPatches
SELECT 
spa.ComputerID, spa.BulletinID, spa2.SecurityPatchID, spa2.Status
FROM SecurityPatchAnalysis spa
JOIN SecurityPatchStatus sps ON sps.SecurityPatchStatusID = spa.Status
JOIN SecurityPatchAnalysis spa2 ON spa2.ComputerID = spa.ComputerID AND spa2.BulletinID = spa.BulletinID 
JOIN SecurityPatchStatus sps2 ON sps2.SecurityPatchStatusID = spa2.Status
WHERE 	sps2.Severity < sps.Severity
		OR (	sps2.Severity = sps.Severity
			AND spa2.SecurityPatchID < spa.SecurityPatchID
		)

-- Populate a temporary table with relevant computer data
CREATE TABLE #Computer (
	ComputerID int NOT NULL,
	ComputerOUID int NOT NULL,
	DataSourceDate datetime NULL,
	AnalysisDate datetime NULL
)

INSERT INTO #Computer
SELECT	c.ComputerID, c.ComputerOUID, sar.DataSourceDate, sar.AnalysisDate
FROM	Computer c
	INNER JOIN #Organization o ON o.OrganizationID = c.ComputerOUID
	LEFT OUTER JOIN SecurityAnalysisReport sar
		ON sar.ComputerID = c.ComputerID

DECLARE @totalComps INT
SET @totalComps = @@ROWCOUNT

CREATE TABLE #ComputerNACount (	OUID int NULL,	CNT int NULL)

INSERT INTO #ComputerNACount
SELECT #Computer.ComputerOUID, Count(*) 
FROM	#Computer 
WHERE	DataSourceDate IS NULL
GROUP BY  #Computer.ComputerOUID


CREATE TABLE #ComputerTotalCount (OUID int NULL,	CNT int NULL)

INSERT INTO #ComputerTotalCount
SELECT #Computer.ComputerOUID, Count(*) 
FROM	#Computer 
GROUP BY  #Computer.ComputerOUID


CREATE TABLE #ComplianceByBulletinSummaryList(
	[BulletinID] [nvarchar](200) NULL,
	[DateRevised] [datetime] NULL,
	[Title] [nvarchar](2000) NULL,
	[HelpUrl] [nvarchar](2000) NULL,
	[OUID] [int] NULL,
	[Total] [int] NULL,
	[TotalCompliant] [int] NULL,
	[TotalNotCompliant] [int] NULL,
	[TotalUnknown] [int] NULL,
	[Compliant_Applied] [int] NULL,
	[Compliant_Warning] [int] NULL,
	[Compliant_Superseded] [int] NULL,
	[Compliant_NotRequired] [int] NULL,
	[NotCompliant_InstallFailed] [int] NULL,
	[NotCompliant_NotInPolicy] [int] NULL,
	[NotCompliant_PolicyPending] [int] NULL,
	[NotCompliant_PendingReboot] [int] NULL,
	[Unknown_Unknown] [int] NULL,
	[Unknown_NotAnalyzed] [int] NULL
)  

INSERT INTO #ComplianceByBulletinSummaryList  
SELECT	Analysis.BulletinID,
	Analysis.DateRevised,
	spb.Title,
	Analysis.HelpUrl,
	OrganizationID,
	0 AS Total,

	----------- Compliance Count Breakdown
	
	(	
	NotCompliant_InstallFailed +
	NotCompliant_NotInPolicy +
	NotCompliant_PolicyPending +
	NotCompliant_PendingReboot +
	Unknown_Unknown +
	Unknown_NotAnalyzed
	)
	AS TotalCompliant,

	(
		NotCompliant_InstallFailed +
		NotCompliant_NotInPolicy +
		NotCompliant_PendingReboot +
		NotCompliant_PolicyPending
	) AS TotalNotCompliant,

	(	Unknown_Unknown +
		Unknown_NotAnalyzed
	) AS TotalUnknown,

	----- Breakdown of Compliant Counts -----
	Compliant_Applied,
	Compliant_Warning,
	Compliant_Superseded,

	--@totalComps 
	 (
		Compliant_Applied +
		Compliant_Superseded +
		Compliant_Warning +
		NotCompliant_InstallFailed +
		NotCompliant_NotInPolicy +
		NotCompliant_PolicyPending +
		NotCompliant_PendingReboot +
		Unknown_Unknown +
		Unknown_NotAnalyzed
	) AS Compliant_NotRequired,

	----- Breakdown of Non Compliant Counts -----
	NotCompliant_InstallFailed,
	NotCompliant_NotInPolicy,
	NotCompliant_PolicyPending,
	NotCompliant_PendingReboot,

	----- Breakdown of Unknown Counts -----
	Unknown_Unknown,
	Unknown_NotAnalyzed

FROM
(
	SELECT
	sb.BulletinID,
	sb.State,
	sb.HelpUrl,
	o.OrganizationID,
	sb.DateRevised

	------- Compliant states --------
	, SUM(	CASE WHEN spa.Status = 4 -- Warning
			AND DATEDIFF(d, c.DataSourceDate, sb.DateRevised) <= 0
		THEN 1
		ELSE 0 END
	) AS Compliant_Warning

	, SUM(	CASE WHEN spa.Status = 6 -- Superseded
			AND DATEDIFF(d, c.DataSourceDate, sb.DateRevised) <= 0
		THEN 1
		ELSE 0 END
	) AS Compliant_Superseded

	, SUM(	CASE WHEN DATEDIFF(d, c.DataSourceDate, sb.DateRevised) <= 0
			AND ( spa.Status = 7 -- Applied
				OR (
					spa.Status = 1 -- NotApplied
					AND ins.Action IN ('install', 'installex', 'installne')
					AND ins.Result = 'success'
					AND c.AnalysisDate < ins.Reported
				)
			)
		THEN 1
		ELSE 0 END
	) AS Compliant_Applied

	------ Non Compliant states ------
	, SUM(	CASE WHEN spa.Status = 1 -- Not applied
			AND DATEDIFF(d, c.DataSourceDate, sb.DateRevised) <= 0
			AND ISNULL(tp.PackagePathID, tpg.PackagePathID) IS NULL
			AND ( ins.Action IS NULL
				OR ins.Action NOT IN ('install', 'installex', 'installne')
				OR ins.Result <> 'success'
				OR c.AnalysisDate >= ins.Reported
			)
		THEN 1
		ELSE 0 END
	) AS NotCompliant_NotInPolicy

	, SUM(	CASE WHEN spa.Status = 1 -- Not applied
			AND DATEDIFF(d, c.DataSourceDate, sb.DateRevised) <= 0
			AND ISNULL(tp.PackagePathID, tpg.PackagePathID) IS NOT NULL
			AND ( ins.Action IS NULL
				OR ins.Action NOT IN ('install', 'installex', 'installne')
			)
		THEN 1
		ELSE 0 END
	) AS NotCompliant_PolicyPending

	, SUM(	CASE WHEN spa.Status = 1 -- Not applied
			AND DATEDIFF(d, c.DataSourceDate, sb.DateRevised) <= 0
			AND ISNULL(tp.PackagePathID, tpg.PackagePathID) IS NOT NULL
			AND ins.Action IN ('install', 'installex', 'installne')
			AND ins.Result NOT IN ('success', 'rebootrequired')
		THEN 1
		ELSE 0 END
	) AS NotCompliant_InstallFailed

	-- Reboot pending is an assumption.
	-- This needs to read the installation states when the client
	-- and resolvers support reporting on "reboot" state of a
	-- managed device

	, SUM(	CASE WHEN spa.Status = 1 -- Not applied
			AND DATEDIFF(d, c.DataSourceDate, sb.DateRevised) <= 0
			AND ISNULL(tp.PackagePathID, tpg.PackagePathID) IS NOT NULL
			AND ins.Action IN ('install', 'installex', 'installne')
			AND (	ins.Result = 'rebootrequired'
				OR (
					ins.Result = 'success'
					AND c.AnalysisDate >= ins.Reported
				)
			)
		THEN 1
		ELSE 0 END
	) AS NotCompliant_PendingReboot

	------ Unknown states -----
	, SUM(	CASE WHEN spa.Status = 2 -- Unknown
			AND DATEDIFF(d, c.DataSourceDate, sb.DateRevised) <= 0 
		THEN 1
		ELSE 0 END
	) AS Unknown_Unknown

	,   0  AS Unknown_NotAnalyzed

	FROM
	SecurityBulletin sb
	INNER JOIN SecurityPatchAnalysis spa ON spa.BulletinID = sb.BulletinID
	INNER JOIN #Computer c ON c.ComputerID = spa.ComputerID
	INNER JOIN Organization o ON o.OrganizationID = c.ComputerOUID
	LEFT OUTER JOIN ( SecurityPatchToPackageVersion sppv
					INNER JOIN PackageVersionFull AS pv ON pv.PackageFullName = sppv.PackageFullName AND pv.MediaID = 1 -- in software library
	)
		ON sppv.PatchID = spa.SecurityPatchID
	-- Direct PackageApplies target
	LEFT OUTER JOIN PackageApplies AS tp
		ON tp.TargetOUID = c.ComputerOUID
		AND tp.TargetTypeID = 1
		AND tp.TargetID = c.ComputerID
		AND tp.PackagePathID = pv.PackagePathID
	-- Indirect PackageApplies target
	LEFT OUTER JOIN PackageApplies AS tpg
		ON tpg.PackagePathID = pv.PackagePathID
		AND tpg.TargetTypeID = 3
		-- RSoP group's OU is the domain itself
		AND tpg.TargetOUID = o.DomainID
		AND EXISTS (
			SELECT * FROM Member
			WHERE TargetTypeID = 1 -- computer policies only
			AND TargetID = c.ComputerID
			AND GroupID = tpg.TargetID
		)
	LEFT OUTER JOIN Installation AS ins
		ON ins.OrganizationID = c.ComputerOUID
		AND ins.ComputerID = c.ComputerID
		AND ins.PackageVersionID = pv.PackageVersionID
		AND ins.UserID = 1 --SYSTEM

	 WHERE	
	NOT EXISTS
		(	 
			SELECT 1 FROM #ExcludedPatches ex
			WHERE ex.ComputerID = spa.ComputerID
			AND ex.BulletinID = spa.BulletinID
			AND ex.SecurityPatchID = spa.SecurityPatchID
			AND ex.Status = spa.Status
		)
		-- using a technique to improve performance by limiting number of records retrieved here
		AND
		sb.BulletinID LIKE @bulletin
		---- should be the same is in outermost WHERE clause

	GROUP BY sb.BulletinID, sb.State, sb.HelpUrl, sb.DateRevised, 	o.OrganizationID


) AS Analysis
	LEFT OUTER JOIN SecPatch_Bulletin spb
		ON spb.BulletinID = Analysis.BulletinID
WHERE	Analysis.State LIKE @releaseStateID
	AND Analysis.BulletinID LIKE @bulletin	-- this is being correlated in subqueries too - for efficiency
	AND Analysis.BulletinID <> 'Unknown'
	
	-- OPTION (MAXDOP 1)
	
TRUNCATE TABLE Reporting_ComplianceByBulletinSummaryList

INSERT INTO  Reporting_ComplianceByBulletinSummaryList
SELECT * FROM #ComplianceByBulletinSummaryList

DROP TABLE #ComplianceByBulletinSummaryList
DROP TABLE #Computer
DROP TABLE #ComputerNACount
DROP TABLE #ComputerTotalCount
DROP TABLE #Organization
DROP TABLE #ExcludedPatches

END
GO

CopyPermission 'ComplianceByBulletinSummaryList', 'mgsOSBreakdown'
GO


/*
 * $Header$
 *
 * DESCRIPTION: Stored Procedure: ComplianceByComputerBulletinList
 *
 * Protected by US patent 6,006,034; patents pending.
 * Copyright 2011 Flexera Software LLC
 * Reproduction, adaptation, or translation without prior permission
 * is prohibited.
 */
 
-- USE MANAGESOFT
GO

IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'ComplianceByComputerBulletinList' AND xtype = 'P'
)
        DROP PROCEDURE ComplianceByComputerBulletinList
GO

CREATE PROCEDURE [ComplianceByComputerBulletinList]
	@compID int, --computer id
	@approvedBulletin bit = 0, -- Values:[0=All bulletins | 1=Approved bulletins only]	
	@status varchar(64) = '%', --Status of a bulletin
	@bulletin varchar(64) = '%' --filter
AS
	
	--REVISIT: @approvedBulletin is not reqd here for filter
	-- as we pass in the Bulletin name always
	DECLARE @releaseStateID varchar(4)
	--Process only approved bulletins
	IF  @approvedBulletin = 1
		SELECT @releaseStateID = StateID 
		FROM SecurityState 
		WHERE [Description] = 'Released'
	--Process all bulletins
	ELSE
		SELECT @releaseStateID = '%'
		
	DECLARE @bulletinStatusID varchar(4)
	--Process for a specific status
	IF @status <> '%'
		SELECT @bulletinStatusID = SecurityPatchStatusID 
		FROM SecurityPatchStatus 
		WHERE InternalText = @status
	--Process for all statuses
	ELSE
		SELECT @bulletinStatusID = '%'

	CREATE TABLE #ComplianceComputerList(
		BulletinID nvarchar(64) COLLATE database_default,
		ComputerID int,
		StatusSeverity int
	)

	INSERT INTO #ComplianceComputerList
		EXEC ComplianceComputerAndBulletinList '%', @releaseStateID, 1, @compID

	SELECT DISTINCT
	c.ComputerID, 
	c.ComputerCN,
	s.OU AS OUDN,
	list.BulletinID,
	sp_b.Title,
	sb.HelpUrl,
	state.[Description] AS [BulletinState],

	Status = CASE
		WHEN sps.InternalText IS NULL OR sps.InternalText = 'NotAnalyzed' THEN 'NotAnalyzed'
		WHEN sps.InternalText = 'NotApplicable' THEN 'NotRequired'
		ELSE sps.InternalText
	END,

	[StatusDetail] = CASE
		--Either Applied or Applied with Warning (like its obsolete)
		----Status Severity: Warning=4, Applied=7
		WHEN spa.IsManaged = 0 AND list.StatusSeverity IN (4,7)	
			THEN 'Applied'
		WHEN spa.IsManaged = 1 AND list.StatusSeverity IN (4,7)  
			THEN 'AppliedViaManageSoft'

		--Superseded patch Applied
		--Status Severity: Superseded=6	
		WHEN IsManaged = 0 AND list.StatusSeverity = 6		
			THEN 'SupersededPatchApplied'
		WHEN IsManaged = 1 AND list.StatusSeverity = 6  
			THEN 'SupersededPatchAppliedViaManageSoft'

		--Either Not Applied or status Unknown
		--Status Severity: NotApplied=1, Unknown=2	
		WHEN IsManaged = 0 AND list.StatusSeverity IN (1,2)	
			AND sppv.PackageFullName IS NOT NULL 
			AND ISNULL(tp.PackagePathID, tpg.PackagePathID) IS NOT NULL
			AND ins.Action IN ('install', 'installex', 'installne')
			AND ins.Result = 'failure' 
			THEN 'RequiredApprovedButInstallFailed'
		
		--Either Not Applied or status Unknown
		--Status Severity: NotApplied=1, Unknown=2	
		WHEN IsManaged = 0 AND list.StatusSeverity IN (1,2) 
			AND sppv.PackageFullName IS NOT NULL 
			AND ISNULL(tp.PackagePathID, tpg.PackagePathID) IS NOT NULL
			AND ins.Action IN ('install', 'installex', 'installne')
			AND ins.Result = 'success' 
			THEN 'RequiredApprovedAndInstalled'

		--Either Not Applied or status Unknown
		--Status Severity: NotApplied=1, Unknown=2	
		WHEN IsManaged = 0 AND list.StatusSeverity IN (1,2) 
			AND sppv.PackageFullName IS NOT NULL 
			AND ISNULL(tp.PackagePathID, tpg.PackagePathID) IS NOT NULL
			AND ins.Action IN ('install', 'installex', 'installne')
			AND ins.Result = 'notrequired' 
			THEN 'ApprovedButInstallNotRequired'

		--Either Not Applied or status Unknown
		--Status Severity: NotApplied=1, Unknown=2	
		WHEN IsManaged = 0 AND list.StatusSeverity IN (1,2) 
			AND sppv.PackageFullName IS NOT NULL 
			AND ISNULL(tp.PackagePathID, tpg.PackagePathID) IS NOT NULL
			AND ( ins.Action IS NULL
				OR ins.Action NOT IN ('install', 'installex', 'installne')
			)
			THEN 'RequiredApprovedAndInstallPending'
		
		--Either Not Applied or status Unknown
		--Status Severity: NotApplied=1, Unknown=2		
		WHEN IsManaged = 0 AND list.StatusSeverity IN (1,2) 
			AND sppv.PackageFullName IS NOT NULL 
			AND ISNULL(tp.PackagePathID, tpg.PackagePathID) IS NULL  
			THEN 'RequiredAndPackaged'
		
		--Either Not Applied or status Unknown
		--Status Severity: NotApplied=1, Unknown=2		
		WHEN IsManaged = 0 AND list.StatusSeverity IN (1,2) 
			AND sppv.PackageFullName IS NULL
			THEN 'RequiredButNotPackaged'
			
		-- Check whether this computer has reported compliance data
		WHEN list.ComputerID IS NULL
			THEN 'NeverReportedComplianceData'
			
		-- NotApplicable: list.StatusSeverity = 5 
		WHEN list.StatusSeverity = 5
			THEN 'NotRequiredOnThisManagedDevice'

		-- NotAnalyzed: list.StatusSeverity = [NULL | 3]
		WHEN list.StatusSeverity IS NULL OR list.StatusSeverity = 3
			THEN 'BulletinNotAnalyzedOnThisManagedDevice'

		-- Anything else
		ELSE	'Unknown'
	END,
	spr.AnalysisDate, 
	spr.DataSourceDate, 
	sb.DateRevised

	FROM
	SDOU s
	INNER JOIN Computer AS c 
		ON s.OUID = c.ComputerOUID
	LEFT OUTER JOIN #ComplianceComputerList AS list
		ON c.ComputerID = list.ComputerID
	LEFT OUTER JOIN SecurityPatchStatus AS sps
		ON list.StatusSeverity = sps.Severity	
	LEFT OUTER JOIN SecurityAnalysisReport AS spr
		ON list.ComputerID = spr.ComputerID
	LEFT OUTER JOIN SecurityPatchAnalysis AS spa
		ON (list.ComputerID = spa.ComputerID 
		AND list.BulletinID = spa.BulletinID 
		AND sps.SecurityPatchStatusID = spa.Status) 	
	LEFT OUTER JOIN SecurityBulletin AS sb
		ON list.BulletinID = sb.BulletinID
	LEFT OUTER JOIN SecPatch_Bulletin AS sp_b
		ON sb.BulletinID = sp_b.BulletinID
	LEFT OUTER JOIN SecurityState AS state
		ON sb.State = state.StateID
	LEFT OUTER JOIN SecurityPatch AS sp
		ON spa.SecurityPatchID = sp.PatchID
	LEFT OUTER JOIN (
		SecurityPatchToPackageVersion sppv
		INNER JOIN PackageVersionFull AS pv
			ON pv.PackageFullName = sppv.PackageFullName
				AND pv.MediaID = 1 -- in software library
	)
		ON sp.PatchID = sppv.PatchID
	-- Direct PackageApplies target
	LEFT OUTER JOIN PackageApplies AS tp
			ON tp.PackagePathID = pv.PackagePathID
		AND tp.TargetTypeID = 1
		AND tp.TargetID = spa.ComputerID
	-- Indirect PackageApplies target
	LEFT OUTER JOIN PackageApplies AS tpg
		ON tpg.PackagePathID = pv.PackagePathID
		AND tpg.TargetTypeID = 3
		AND EXISTS (
			SELECT * FROM Member
			WHERE TargetTypeID = 1 -- computer policies only
			AND TargetID = spa.ComputerID
			AND GroupID = tpg.TargetID
		)
		LEFT OUTER JOIN Installation AS ins
		ON	(spa.ComputerID = ins.ComputerID
				AND ins.UserID = 1 --SYSTEM
				AND ins.PackageVersionID = pv.PackageVersionID)
	WHERE 
	((list.BulletinID LIKE @bulletin AND list.BulletinID <> 'Unknown') OR list.BulletinID IS NULL)
	AND c.ComputerID = @compID
	AND (
		sps.SecurityPatchStatusID LIKE @bulletinStatusID
		OR @bulletinStatusID = '%' 
		OR (sps.SecurityPatchStatusID IS NULL AND @bulletinStatusID = '3') --NotAnalyzed=3
	)  -- specific or all bulletin status
	AND (
		sb.State LIKE @releaseStateID 
		OR @releaseStateID = '%' 
		OR (sb.State IS NULL AND @releaseStateID = '4') --Released=4
	)-- approved or all bulletins

	OPTION (MAXDOP 1)

	DROP TABLE #ComplianceComputerList

GO


CopyPermission 'ComplianceByComputerBulletinList', 'mgsOSBreakdown'
GO
/*
 * $Header$
 *
 * DESCRIPTION: Stored Procedure: ComplianceByComputerSummaryList
 *
 * Protected by US patent 6,006,034; patents pending.
 * Copyright 2011 Flexera Software LLC
 * Reproduction, adaptation, or translation without prior permission
 * is prohibited.
 */
 
-- USE MANAGESOFT
GO

IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'ComplianceByComputerSummaryList' AND xtype = 'P'
)
        DROP PROCEDURE ComplianceByComputerSummaryList
GO


CREATE PROCEDURE [ComplianceByComputerSummaryList]
	@oudn varchar(800) = '%', --'%CN=Computers,DC=devscarlett,DC=mgsft,DC=com', --'%',
	@ouMatch bit = 1, --Values:[0=do exact OU Match | 1=include child-OUs in match]
	@compCN Varchar(128) = '%', --computer name (size=64*2 --to take into acct encoded chars)
	@approvedBulletin bit = 0 -- Values:[0=All bulletins | 1=Approved bulletins only]
AS

CREATE TABLE #Organization(OrganizationID int PRIMARY KEY)
EXEC OrganizationIdentifyDescendentsByOUDN @oudn, @ouMatch, 0

DECLARE @releaseStateID varchar(4)
--Process only approved bulletins
IF  @approvedBulletin = 1
	SELECT @releaseStateID = StateID 
	FROM SecurityState 
	WHERE [Description] = 'Released'
ELSE
	SET @releaseStateID = '%'

-- Count the total number of bulletins that have been reported
CREATE TABLE #BulletinCount(
	DataSourceDate datetime PRIMARY KEY,
	AnalyzedBulletinCount int,
	NotAnalyzedBulletinCount int
)

INSERT INTO #BulletinCount
SELECT sb.DataSourceDate,
	AnalyzedBulletinCount = SUM(
		CASE 
			WHEN DATEDIFF(d, sb.DateRevised, sb.DataSourceDate) >= 0 THEN 1
			ELSE 0
		END),
	NotAnalyzedBulletinCount = SUM(
		CASE 
			WHEN DATEDIFF(d, sb.DateRevised, sb.DataSourceDate) < 0 THEN 1
			ELSE 0
		END)
FROM
(
	SELECT DISTINCT sb.BulletinID, sb.DateRevised, sar.DataSourceDate
	FROM SecurityBulletin sb, SecurityAnalysisReport sar
	WHERE sb.State LIKE @releaseStateID
) AS sb
GROUP BY sb.DataSourceDate

SELECT 
	*,
	TotalBulletins = 
		TotalOK + 
		TotalSuperseded + 
		TotalNotApplicable + 
		TotalWarn +
		TotalNotAnalyzed +
		TotalRUnk + 
		TotalNApp

FROM
(	
	SELECT
	c.ComputerID,
	c.ComputerCN,
	dbo.OUName(o.OrganizationID) AS OUDN,

	TotalOK = SUM(
		CASE 
			WHEN DATEDIFF(d, sb.DateRevised, sar.DataSourceDate) >= 0 AND spa.Status = 7 THEN 1 --'Applied'
			ELSE 0
		END
	),

	TotalSuperseded = SUM(
		CASE 
			WHEN DATEDIFF(d, sb.DateRevised, sar.DataSourceDate) >= 0 AND spa.Status = 6 THEN 1 --'Superceded' (superseded patch applied)
			ELSE 0
		END
	),

	--NotApplicable status never returned from clnt
	--this is deduced based on the fact that clnt did return
	--some compliance information
	-- So NotApplicable = (Number of bulletins that have been reported - Number of bulletins that have been reported for the specific computer)
	TotalNotApplicable = 
	(
		-- Check to see whether the MD has reported compliance. If not, then NotApplicable = 0, as all are NotAnalyzed
		CASE WHEN sar.DataSourceDate IS NOT NULL THEN 
			bc.AnalyzedBulletinCount -
			(
				SELECT COUNT(spa.BulletinID) 
				FROM SecurityBulletin sb,
				(
					SELECT spa.ComputerID, spa.BulletinID, MIN(spa.Status) AS Status
					FROM SecurityPatchAnalysis spa
					WHERE spa.ComputerID = c.ComputerID
					GROUP BY spa.ComputerID, spa.BulletinID
				) AS spa
				WHERE spa.BulletinID = sb.BulletinID
			  	  AND sb.State LIKE @releaseStateID 
				  AND DATEDIFF(d, sb.DateRevised, sar.DataSourceDate) >= 0
				  AND spa.Status <> 5
			)
		ELSE 0 END
	),	
	
	TotalWarn = SUM(
		CASE 
			WHEN DATEDIFF(d, sb.DateRevised, sar.DataSourceDate) >= 0 AND spa.Status = 4 THEN 1 --'Warning' (Applied w/ warning)
			ELSE 0
		END
	),

	TotalNotAnalyzed =
	(
		-- Check to see whether the MD has reported compliance. If not, then all are NotAnalyzed
		CASE WHEN sar.DataSourceDate IS NOT NULL THEN bc.NotAnalyzedBulletinCount
		-- All bulletins 'NotAnalyzed' as MD has never reported compliance. If MD has reported compliance, sar.DataSourceDate cannot be NULL
		ELSE (SELECT MAX(AnalyzedBulletinCount) FROM #BulletinCount) END
	),
			
	TotalRUnk = SUM(
		CASE 
			WHEN DATEDIFF(d, sb.DateRevised, sar.DataSourceDate) >= 0 AND spa.Status = 2 THEN 1  --'Unknown' (required but don't know whether applied or not)
			ELSE 0
		END
	),

	TotalNApp = SUM(
		CASE 
			WHEN DATEDIFF(d, sb.DateRevised, sar.DataSourceDate) >= 0 AND spa.Status = 1 THEN 1 --'NotApplied' (required) 
			ELSE 0
		END
	)
	
	FROM	#Organization o
		INNER JOIN Computer AS c
			ON o.OrganizationID = c.ComputerOUID
		LEFT OUTER JOIN SecurityAnalysisReport sar
			ON c.ComputerID = sar.ComputerID
		LEFT OUTER JOIN #BulletinCount bc
			ON sar.DataSourceDate = bc.DataSourceDate
		LEFT OUTER JOIN 
			(
				SELECT spa.ComputerID, spa.BulletinID, MIN(spa.Status) AS Status
				  FROM SecurityPatchAnalysis spa
				GROUP BY spa.ComputerID, spa.BulletinID
			) AS spa
			ON c.ComputerID = spa.ComputerID
		LEFT OUTER JOIN SecurityBulletin sb
			ON spa.BulletinID = sb.BulletinID

	WHERE	(sb.State LIKE @releaseStateID OR sb.State IS NULL)
	  AND	c.ComputerCN LIKE @compCN

	GROUP BY 
		c.ComputerID, 
		c.ComputerCN, 
		sar.DataSourceDate,
		bc.AnalyzedBulletinCount,
		bc.NotAnalyzedBulletinCount,
		dbo.OUName(o.OrganizationID)

) AS CompCompliance
GO

CopyPermission 'ComplianceByComputerSummaryList', 'mgsOSBreakdown'
GO
/*
 * $Header$
 *
 * DESCRIPTION: Stored Procedure: SecurityAnalysisComputerList
 *
 * Protected by US patent 6,006,034; patents pending.
 * Copyright 2011 Flexera Software LLC
 * Reproduction, adaptation, or translation without prior permission
 * is prohibited.
 */
 
-- USE MANAGESOFT
GO

IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'SecurityAnalysisComputerList' AND xtype = 'P'
)
        DROP PROCEDURE SecurityAnalysisComputerList
GO

CREATE PROCEDURE SecurityAnalysisComputerList
	@oudn varchar(800) = '%', --'%CN=Computers,DC=devscarlett,DC=mgsft,DC=com', --'%',
	@ouMatch bit = 1, --Values:[0=do exact OU Match | 1=include child-OUs in match]
	@compCN Varchar(128) = '%' --computer name (size=64*2 --to take into acct encoded chars)
AS
BEGIN
CREATE TABLE #Organization(OUID int PRIMARY KEY)
EXEC OrganizationIdentifyDescendentsByOUDN @oudn, @ouMatch, 0

SELECT
c.ComputerID, 
c.ComputerCN, 
dbo.OUName(s.OUID) AS OU,
sar.DataSourceDate,
sar.AnalysisDate 
FROM 
#Organization AS s
INNER JOIN Computer AS c 
	ON s.OUID = c.ComputerOUID
LEFT OUTER JOIN SecurityAnalysisReport AS sar
	ON c.ComputerID = sar.ComputerID

WHERE 
c.ComputerCN LIKE @compCN
END
GO

CopyPermission 'SecurityAnalysisComputerList', 'mgsOSBreakdown'
GO
/*
 * $Header$
 *
 * DESCRIPTION: Stored Procedure: SecurityBulletinList
 *
 * Protected by US patent 6,006,034; patents pending.
 * Copyright 2011 Flexera Software LLC
 * Reproduction, adaptation, or translation without prior permission
 * is prohibited.
 */
 
-- USE MANAGESOFT
GO

IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'SecurityBulletinList' AND xtype = 'P'
)
        DROP PROCEDURE SecurityBulletinList
GO

CREATE PROCEDURE [dbo].[SecurityBulletinList]
	@bulletin varchar(64) = '%', --filter
	@customID varchar(64) = '%',
	@approvedBulletin bit = 0 -- Values:[0=All bulletins | 1=Approved bulletins only]
AS

DECLARE @releaseStateID varchar(4)
--Process only approved bulletins
IF  @approvedBulletin = 1
	SELECT @releaseStateID = StateID 
	FROM SecurityState 
	WHERE [Description] = 'Released'
--Process all bulletins
ELSE
	SELECT @releaseStateID = '%'


SELECT
sb.BulletinID,
sp_b.Title,
sb.HelpUrl,
sb.DateRevised,
sb.CustomID,
sb.RequiredCount
FROM
SecurityBulletin AS sb,
SecPatch_Bulletin AS sp_b

WHERE 
sb.BulletinID = sp_b.BulletinID
AND sb.BulletinID LIKE @bulletin
AND sb.BulletinID <> 'Unknown'
AND sb.State LIKE @releaseStateID 
AND sb.CustomID LIKE @customID

GO

CopyPermission 'SecurityBulletinList', 'mgsOSBreakdown'
GO
IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'PatchesDistributionSummaryList' AND xtype = 'P'
)
        DROP PROCEDURE PatchesDistributionSummaryList
GO
	
CREATE PROCEDURE [PatchesDistributionSummaryList]
	@serverType	int = 0, -- DL (not DS)
	@pkgName VARCHAR(128) = '%', --(size=64*2 --to take into acct encoded chars)
	@pkgVer VARCHAR(32)= '%'
AS	
	
	--NOTE: @pkgName and @pkgVer IS NULL case not handled!
	--i.e. include NULL value when @pkgName = '%' and @pkgVer = '%'
	
	SELECT	pp.PackageFullName,
		pf.PackageName,
		pv.Version,
		CASE
		WHEN pp.PackageFullName LIKE 'Package%'
			THEN 'Software'
		WHEN pp.PackageFullName LIKE 'Policy%'
			THEN 'Policy'
		WHEN pp.PackageFullName LIKE 'Schedule%'
			THEN 'Schedule'
		WHEN pp.PackageFullName LIKE 'OSMigration/OSImage%'
			THEN 'OSImage'
		WHEN pp.PackageFullName LIKE 'OSMigration/ComputerNameMapping%'
			THEN 'ComputerNameMapping'
		WHEN pp.PackageFullName LIKE 'OSMigration/RolloutConfiguration%'
			THEN 'RolloutConfiguration'
		ELSE	'Other' -- default
		END as Type,
		SUM(CASE WHEN (
				dp.ConfirmedState = 'available' OR
				dp.ConfirmedState = 'quarantined' OR
				dp.ConfirmedState = 'rolled back'
			 )
			  AND dp.RequestState = 'empty'
			 THEN 1 ELSE 0 END
		) AS Available,
		SUM(CASE WHEN dp.RequestState = 'pending'
			 THEN 1 ELSE 0 END
		) AS Pending,
		SUM(CASE WHEN dp.ConfirmedState = 'unavailable'
			  AND dp.RequestState = 'empty'
			 THEN 1 ELSE 0 END
		) AS Unavailable,
		SUM(CASE WHEN dp.RequestState = 'removing'
			 THEN 1 ELSE 0 END
		) AS Removing,
		COUNT(DISTINCT(ds.ServerUID)) AS Total

	FROM	DistributedPackage AS dp,
		DistributionServer AS ds,
		PackageVersion AS pv,		
		PackageFamily AS pf,
		PackagePath AS pp,
		SecurityPatchToPackageVersion AS sppv

	WHERE	dp.ServerUID = ds.ServerUID		-- On which server?
	  AND	ds.ServerType = @serverType		-- Of this type
	  AND	dp.RequestedVersionID = pv.PackageVersionID -- Which package ver
	  AND	pv.PackagePathID = pp.PackagePathID
	  AND	pv.Version LIKE @pkgVer
	  AND	pv.PackageFamilyID = pf.PackageFamilyID
	  AND	pf.PackageName LIKE @pkgName
	  AND	pp.PackageFullName = sppv.PackageFullName	

	GROUP BY pp.PackageFullName, pf.PackageName, pv.Version
	ORDER BY pp.PackageFullName
GO


CopyPermission 'PatchesDistributionSummaryList', 'mgsOSBreakdown'
GO
/*
 * $Header$
 *
 * DESCRIPTION: Stored Procedure: PatchPackageVersionList
 *
 * Protected by US patent 6,006,034; patents pending.
 * Copyright 2011 Flexera Software LLC
 * Reproduction, adaptation, or translation without prior permission
 * is prohibited.
 */
 
-- USE MANAGESOFT
GO

IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'PatchPackageVersionList' AND xtype = 'P'
)
        DROP PROCEDURE PatchPackageVersionList
GO

CREATE PROCEDURE [PatchPackageVersionList]
	@pkgName VARCHAR(128)='%'  --Match on specific PackageName (default: all packages)
AS
BEGIN
	IF @pkgName = '%'   -- Get ALL packages
	BEGIN
		SELECT
		sp.BulletinID,
		sp.QNumber,
		sp.PatchName,
		pf.PackageName,
		pv.Version,
		pp.PackageFullName
		FROM
		PackageVersion pv,
		PackageFamily pf,
		PackagePath pp
		LEFT OUTER JOIN SecurityPatchToPackageVersion sppv
			INNER JOIN SecurityPatch sp
			ON sppv.PatchID = sp.PatchID
		ON pp.PackageFullName = sppv.PackageFullName
		WHERE sppv.PackageFullName IS NOT NULL
		  AND pv.PackagePathID = pp.PackagePathID
		  AND pv.PackageFamilyID = pf.PackageFamilyID
		ORDER BY pf.PackageName
	END

	ELSE	-- Filter on the specified package name
	BEGIN
		SELECT
		sp.BulletinID,
		sp.QNumber,
		sp.PatchName,
		pf.PackageName,
		pv.Version,
		pp.PackageFullName
		FROM
		PackageVersion pv,
		PackageFamily pf,
		PackagePath pp
		LEFT OUTER JOIN SecurityPatchToPackageVersion sppv
			INNER JOIN SecurityPatch sp
			ON sppv.PatchID = sp.PatchID			
		ON pp.PackageFullName = sppv.PackageFullName
		WHERE sppv.PackageFullName IS NOT NULL
		  AND pf.PackageName LIKE @pkgName
		  AND pv.PackagePathID = pp.PackagePathID
		  AND pv.PackageFamilyID = pf.PackageFamilyID
		ORDER BY pf.PackageName
	END

END

GO


CopyPermission 'PatchPackageVersionList', 'mgsOSBreakdown'
GO
/*
 * $Id: SecurityPatchInstallationDetail.sql 84480 2007-07-24 06:34:27Z pca $
 *
 * Stored procedures to report all succeeded/failed TargetedPackage (RSOP)
 * Installations
 */

/*
 * Enumerate the successful/failed applications of Policy
 * for packages which are selected in #Packages matching @pkgVer
 * on computers in an OU matching oudn
 *
 * TargetTypeID must be the value for 'Computer'
 */

IF EXISTS (
	SELECT * FROM dbo.sysobjects
	WHERE [name] = 'SecurityPatchInstallationDetailComputerMatchOU' AND xtype = 'P'
)
	DROP PROCEDURE SecurityPatchInstallationDetailComputerMatchOU
GO
CREATE PROCEDURE [SecurityPatchInstallationDetailComputerMatchOU]
	@pkgName	VARCHAR(128) = '%',
	@pkgVer		VARCHAR(32) = '%',
	@pkgFName	VARCHAR(256) = '%',
	@installPolicy	VARCHAR(16) = NULL,
	@Status		VARCHAR(16) = 'success'
AS
	DECLARE @TargetTypeID	INT		-- TargetTypeId of 'Computer'
	SET @TargetTypeID =
		(SELECT TargetTypeID FROM TargetType
		 WHERE TargetTypeName = 'Computer')

		DECLARE @pkgPathId INT
	
	IF @pkgFName <> '%'
		SET @pkgPathId = (SELECT PackagePathID FROM PackagePath WHERE PackageFullName = @pkgFName)
	ELSE
	SET @pkgPathId =
	(SELECT PackagePath.PackagePathID FROM PackagePath 
	INNER JOIN PackageVersion ON  PackagePath.PackagePathID = PackageVersion.PackagePathID
	INNER JOIN PackageFamily ON  PackageFamily.PackageFamilyID = PackageVersion.PackageFamilyID
	WHERE PackageVersion.Version = @pkgVer AND PackageFamily.PackageName = @pkgName AND IsActive = 1)



	SELECT	pp.PackageFullName
		,pf.PackageName
		,pv.Version
		,case
			when ntt.[Action] is null then 'Null'
			else ntt.[Action]
		end as [InstallPolicy]
		,UserOU = dbo.OUName(c_ou.OUID)
		,UserCN = 'SYSTEM'
		,ComputerOU = dbo.OUName(c_ou.OUID)
		,ComputerCN = c.ComputerCN
		,i.Reported
		,r.ReasonText AS FailReason
		,InstallationAction = i.[Action]
		,ntt.PostponeNoLaterThan
		,ntt.PostponeNoLaterThanIsLocal
		,ntt.PostponePeriod
		,ntt.PostponePeriodStart
		,ntt.PostponeLatest
	FROM
		PackageVersion AS pv
		INNER JOIN PackageFamily AS pf ON pf.PackageFamilyID = pv.PackageFamilyID
		INNER JOIN PackagePath AS pp ON pp.PackagePathID = pv.PackagePathID
		INNER JOIN Installation AS i ON i.PackageVersionID = pv.PackageVersionID
		LEFT OUTER JOIN Reason AS r ON i.FailReasonID = r.ReasonID
		INNER JOIN Computer as c ON	i.ComputerID = c.ComputerID	-- on this computer
									AND	i.OrganizationID = c.ComputerOUID		-- in this OU
		INNER JOIN #Organization as c_ou ON	c.ComputerOUID = c_ou.OUID
		
		LEFT OUTER JOIN (

			SELECT	DISTINCT ppath.PackageFullName
				,ppath.PackagePathID
				,pversion.PackageVersionID-- CHANGED
				,pfamily.PackageFamilyID
				,ad.Action
				,pa.TargetID
				,pa.TargetOUID
				,ad.PostponeNoLaterThan
				,ad.PostponeNoLaterThanIsLocal
				,ad.PostponePeriod
				,ip.PostponePeriodStart
				,ad.PostponeLatest
			FROM	PackageApplies AS pa
			INNER JOIN AllocationDetails AS ad 				ON pa.AllocationDetailsID = ad.AllocationDetailsID
			INNER JOIN PackagePath AS ppath 				ON ppath.PackagePathID = pa.PackagePathID
			INNER JOIN PackageVersion AS pversion  ON pversion.PackagePathID = pa.PackagePathID AND pa.PackagePathID = @pkgPathId
			INNER JOIN PackageFamily AS pfamily		ON pfamily.PackageFamilyID = pversion.PackageFamilyID
			LEFT OUTER JOIN InstallationPostponement AS ip	ON ip.TargetTypeID = @TargetTypeID
				AND ip.TargetID = pa.TargetID
				AND ip.PackagePathID = ppath.PackagePathID
				AND ip.PolicyGUID = pa.PolicyGUID
			WHERE	pa.TargetTypeID = @TargetTypeID

			UNION

			SELECT	DISTINCT ppath.PackageFullName
				,ppath.PackagePathID
				,pversion.PackageVersionID-- CHANGED
				,pfamily.PackageFamilyID
				,ad.Action
				,m.TargetID
				,comp.ComputerOUID AS TargetOUID
				,ad.PostponeNoLaterThan
				,ad.PostponeNoLaterThanIsLocal
				,ad.PostponePeriod
				,ip.PostponePeriodStart
				,ad.PostponeLatest
			FROM	PackageApplies AS pa
			INNER JOIN Member AS m  ON m.GroupID = pa.TargetID AND m.TargetTypeID = @TargetTypeID
			INNER JOIN Computer AS comp ON comp.ComputerID = m.TargetID
			INNER JOIN AllocationDetails AS ad ON pa.AllocationDetailsID = ad.AllocationDetailsID
			INNER JOIN PackagePath AS ppath ON ppath.PackagePathID = pa.PackagePathID AND pa.PackagePathID = @pkgPathId
			INNER JOIN PackageVersion AS pversion ON pversion.PackagePathID = pa.PackagePathID
			INNER JOIN PackageFamily AS pfamily ON pfamily.PackageFamilyID = pversion.PackageFamilyID
			LEFT OUTER JOIN InstallationPostponement AS ip
				ON ip.TargetTypeID = @TargetTypeID
				AND ip.TargetID = m.TargetID
				AND ip.PackagePathID = ppath.PackagePathID
				AND ip.PolicyGUID = pa.PolicyGUID
			WHERE	pa.TargetTypeID = 3
		) AS ntt ON ntt.PackageVersionID = pv.PackageVersionID
			AND ntt.TargetID = i.ComputerID
			AND ntt.TargetOUID = i.OrganizationID
	WHERE	
 
	 pp.PackagePathID = @pkgPathId
	  AND	i.UserID = 1				-- Computer install
	  AND	i.Result = @Status			-- only this status
	  AND	(
		@installPolicy IS NULL
		OR (	@installPolicy = 'install'
			AND ntt.Action = 'install'
		)
		OR (	@installPolicy = 'alwaysupdate'
			AND ntt.Action = 'alwaysupdate'
			AND i.Result <> 'success'
			AND EXISTS (
				SELECT	*
				FROM	Installation i2
					INNER JOIN PackageVersion pv2
						ON i2.PackageVersionID = pv2.PackageVersionID
				WHERE i2.Result = 'success'
				AND pv2.PackageFamilyID = ntt.PackageFamilyID
				AND pv2.PackagePathID <> ntt.PackagePathID
				AND i2.ComputerID = i.ComputerID
				AND i2.UserID = i.UserID
				AND i2.OrganizationID = i.OrganizationID
			)
		)
		OR (	@installPolicy = 'choose'
			AND (	ntt.Action = 'choose'
				OR (	ntt.Action = 'alwaysupdate'
					AND (	i.Result = 'success'
						OR NOT EXISTS (
							SELECT	*
							FROM	Installation i2
								INNER JOIN PackageVersion pv2
									ON i2.PackageVersionID = pv2.PackageVersionID
							WHERE i2.Result = 'success'
							AND pv2.PackageFamilyID = ntt.PackageFamilyID
							AND pv2.PackagePathID <> ntt.PackagePathID
							AND i2.ComputerID = i.ComputerID
							AND i2.UserID = i.UserID
							AND i2.OrganizationID = i.OrganizationID
						)
					)
				)
			)
		)
	    )
	ORDER BY pp.PackageFullName, pv.Version, dbo.OUName(c_ou.OUID), ComputerCN


GO

CopyPermission 'SecurityPatchInstallationDetailComputerMatchOU', 'mgsOSBreakdown'
GO

/*
 * Enumerate the successful/failed non-Policy installs
 * for packages which are selected in #Packages matching @pkgVer
 * on computers in an OU matching oudn
 *
 * TargetTypeID must be the value for 'Computer'
 */

IF EXISTS (
	SELECT * FROM dbo.sysobjects
	WHERE [name] = 'SecurityPatchInstallationNonPolicyComputerMatchOU' AND xtype = 'P'
)
	DROP PROCEDURE SecurityPatchInstallationNonPolicyComputerMatchOU
GO

CREATE PROCEDURE [SecurityPatchInstallationNonPolicyComputerMatchOU]
	@pkgName	VARCHAR(128) = '%',
	@pkgVer		VARCHAR(32) = '%',
	@pkgFName	VARCHAR(256) = '%',
	@Status		VARCHAR(16) = 'success',
	@actionMatch VARCHAR(10) = NULL
AS
	DECLARE @TargetTypeID	INT		-- TargetTypeId of 'Computer'
	SET @TargetTypeID =
		(SELECT TargetTypeID FROM TargetType
		 WHERE TargetTypeName = 'Computer')

	SELECT	pp.PackageFullName
		,pf.PackageName
		,pv.Version
		,'out of policy' as [InstallPolicy]
		,UserOU = dbo.OUName(c_ou.OUID)
		,UserCN = 'SYSTEM'
		,ComputerOU = dbo.OUName(c_ou.OUID)
		,ComputerCN = c.ComputerCN
		,i.Reported
		,r.ReasonText AS FailReason
		,InstallationAction = i.[Action]
		,NULL AS PostponeNoLaterThan
		,NULL AS PostponeNoLaterThanIsLocal
		,NULL AS PostponePeriod
		,NULL AS PostponePeriodStart
		,NULL AS PostponeLatest
	FROM
		PackageFamily as pf,
		PackageVersion as pv,
		PackagePath as pp,
		Installation as i
		LEFT OUTER JOIN Reason AS r
			ON i.FailReasonID = r.ReasonID,
		Computer as c,
		#Organization as c_ou
	WHERE	pf.PackageName LIKE @pkgName		-- desired family
	  AND	pp.PackageFullName LIKE @pkgFName	-- desired path
	  AND	pf.PackageFamilyID = pv.PackageFamilyID -- any version
	  AND	pv.PackagePathID = pp.PackagePathID
	  AND	pv.Version LIKE @pkgVer			-- having this version
	  AND	pv.PackageVersionID = i.PackageVersionID-- ... matches installed
	  AND	1 = i.UserID				-- Computer install
	  AND	@Status = i.Result			-- only this status
	  AND	i.ComputerID = c.ComputerID		-- On this computer
	  AND	c.ComputerOUID = c_ou.OUID		-- which is this OU
	  AND NOT EXISTS(				-- no policy for install
		SELECT *
		FROM	PackageApplies AS pa
		WHERE	pa.TargetTypeID = @TargetTypeID -- Computer policy type
		  AND	pa.TargetOUID = i.OrganizationID -- for this OU
		  AND	pa.TargetID = i.ComputerID	-- Installing computer
		  AND	pa.PackagePathID = pp.PackagePathID
	    )
	  AND NOT EXISTS(				-- no policy for install
		SELECT *
		FROM	PackageApplies AS pa,
			Member AS m,
			Computer AS c
		WHERE	pa.TargetTypeID = 3 -- RSOP Group
		  AND	m.GroupID = pa.TargetID -- Member of group
		  AND	m.TargetTypeID = @TargetTypeID -- Computer policy type
		  AND	m.TargetID = i.ComputerID	-- Installing computer
		  AND	pa.PackagePathID = pp.PackagePathID
		  AND	c.ComputerOUID = i.OrganizationID -- for this OU
	    )
	  AND (
		@actionMatch IS NULL
		OR i.[Action] = @actionMatch
		OR (@actionMatch = 'install'
		   AND LEFT(i.[Action], 7) = 'install')
		OR (@actionMatch = 'redundant'
		   AND i.[Action] = 'installex')
	  )
	ORDER BY pp.PackageFullName, pv.Version, dbo.OUName(c_ou.OUID), ComputerCN
GO

CopyPermission 'SecurityPatchInstallationNonPolicyComputerMatchOU', 'mgsOSBreakdown'
GO

/*
 * Enumerate Successful Policy-applications/out-of-policy-installs in OU
 *
 * TargetTypeName must be 'Computer' or 'User' (or any other value
 * which may have been inserted into the TargetTypes table).
 *
 * oudn is one of the OU field values from the SDOU table, or a wildcard:
 *
 * ouMatch is non-zero if the oudn string is to be matched with wildcards,
 * then any wild-card characters must be escaped to be matched normally.
 *
 * PackageName and Version are the short-name and version of the package(s) to
 * be matched. Wildcards are allowed.
 *
 * The returned ResultSet contains ...
 */

IF EXISTS (
	SELECT * FROM dbo.sysobjects
	WHERE [name] = 'SecurityPatchInstallationSuccess' AND xtype = 'P'
)
	DROP PROCEDURE SecurityPatchInstallationSuccess
GO

CREATE PROCEDURE [SecurityPatchInstallationSuccess]
	@TargetTypeName VARCHAR(256),
	@oudn		VARCHAR(800),
	@ouMatch	INT = 0,		-- actually boolean
	@pkgName	VARCHAR(128) = '%',
	@pkgVer		VARCHAR(32)= '%',
	@pkgFName	VARCHAR(256) = '%',
	@installPolicy	VARCHAR(16) = NULL,
	@actionMatch VARCHAR(10) = NULL
AS
	CREATE TABLE #Organization(OUID int PRIMARY KEY)
	EXEC OrganizationIdentifyDescendentsByOUDN @oudn, @ouMatch, 0

    IF (@installPolicy IS NULL	-- see SecurityPatchInstallationSummary
     OR @installPolicy <> 'out of policy')
    BEGIN
			IF (@TargetTypeName = 'Computer')
			EXECUTE SecurityPatchInstallationDetailComputerMatchOU
					@pkgName,
					@pkgVer,
					@pkgFName,
					@installPolicy,
					'success'
			--ELSE case @TargetTypeName = 'User' doesnot exist for Patches

		END
    ELSE
    BEGIN
			IF (@TargetTypeName = 'Computer')
			EXECUTE SecurityPatchInstallationNonPolicyComputerMatchOU
					@pkgName,
					@pkgVer,
					@pkgFName,
					'success',
					@actionMatch
			--ELSE case @TargetTypeName = 'User' doesnot exist for Patches

    END


GO

CopyPermission 'SecurityPatchInstallationSuccess', 'mgsOSBreakdown'
GO

/*
 * Enumerate Not Required Policy-applications/out-of-policy-installs in OU
 *
 * TargetTypeName must be 'Computer' or 'User' (or any other value
 * which may have been inserted into the TargetTypes table).
 *
 * oudn is one of the OU field values from the SDOU table, or a wildcard:
 *
 * ouMatch is non-zero if the oudn string is to be matched with wildcards,
 * then any wild-card characters must be escaped to be matched normally.
 *
 * PackageName and Version are the short-name and version of the package(s) to
 * be matched. Wildcards are allowed.
 *
 * The returned ResultSet contains ...
 */
IF EXISTS (
	SELECT * FROM dbo.sysobjects
	WHERE [name] = 'SecurityPatchInstallationNotrequired' AND xtype = 'P'
)
	DROP PROCEDURE SecurityPatchInstallationNotrequired
GO

CREATE PROCEDURE [SecurityPatchInstallationNotrequired]
	@TargetTypeName VARCHAR(256),
	@oudn		VARCHAR(800),
	@ouMatch	INT = 0,		-- actually boolean
	@pkgName	VARCHAR(128) = '%',
	@pkgVer		VARCHAR(32)= '%',
	@pkgFName	VARCHAR(256) = '%',
	@installPolicy	VARCHAR(16) = NULL,
	@actionMatch VARCHAR(10) = NULL
AS
	CREATE TABLE #Organization(OUID int PRIMARY KEY)
	EXEC OrganizationIdentifyDescendentsByOUDN @oudn, @ouMatch, 0

    IF (@installPolicy IS NULL	-- see SecurityPatchInstallationSummary
     OR @installPolicy <> 'out of policy')
    BEGIN
	    IF (@TargetTypeName = 'Computer')
		EXECUTE SecurityPatchInstallationDetailComputerMatchOU
				@pkgName,
				@pkgVer,
				@pkgFName,
				@installPolicy,
				'notrequired'
	    --ELSE case @TargetTypeName = 'User' doesnot exist for Patches

    END
   -- ELSE ... do not show NotRequired items when Out of Policy

GO

CopyPermission 'SecurityPatchInstallationNotrequired', 'mgsOSBreakdown'
GO

/*
 * Enumerate Failed Policy-applications/out-of-policy-installs in OU
 *
 * TargetTypeName must be 'Computer' or 'User' (or any other value
 * which may have been inserted into the TargetTypes table).
 *
 * oudn is one of the OU field values from the SDOU table, or a wildcard:
 *
 * ouMatch is non-zero if the oudn string is to be matched with wildcards,
 * then any wild-card characters must be escaped to be matched normally.
 *
 * PackageName and Version are the short-name and version of the package(s) to
 * be matched. Wildcards are allowed.
 *
 * The returned ResultSet contains ...
 */

IF EXISTS (
	SELECT * FROM dbo.sysobjects
	WHERE [name] = 'SecurityPatchInstallationDetails' AND xtype = 'P'
)
	DROP PROCEDURE SecurityPatchInstallationDetails
GO

CREATE PROCEDURE [SecurityPatchInstallationDetails]
	@TargetTypeName VARCHAR(256),
	@oudn		VARCHAR(800),
	@ouMatch	BIT = 0,		-- actually boolean
	@pkgName	VARCHAR(128) = '%',
	@pkgVer		VARCHAR(32)= '%',
	@pkgFName	VARCHAR(256) = '%',
	@installPolicy	VARCHAR(16) = NULL,
	@status		VARCHAR(16) = 'failure'
AS
	CREATE TABLE #Organization(OUID int PRIMARY KEY)
	EXEC OrganizationIdentifyDescendentsByOUDN @oudn, @ouMatch, 0

    IF (@installPolicy IS NULL	-- see SecurityPatchInstallationSummary
     OR @installPolicy <> 'out of policy')
    BEGIN
	    IF (@TargetTypeName = 'Computer')
		EXECUTE SecurityPatchInstallationDetailComputerMatchOU
				@pkgName,
				@pkgVer,
				@pkgFName,
				@installPolicy,
				@status

	    --ELSE case @TargetTypeName = 'User' doesnot exist for Patches

    END
    ELSE
    BEGIN
	    IF (@TargetTypeName = 'Computer')
		EXECUTE SecurityPatchInstallationNonPolicyComputerMatchOU
				@pkgName,
				@pkgVer,
				@pkgFName,
				@status

	    --ELSE case @TargetTypeName = 'User' doesnot exist for Patches

    END


GO

CopyPermission 'SecurityPatchInstallationDetails', 'mgsOSBreakdown'
GO
/*
 * $Id: SecurityPatchInstallationPending.sql 84480 2007-07-24 06:34:27Z pca $
 *
 * Stored procedures to report all pending TargetedPackage (RSOP)
 * Installations
 */


-- USE MANAGESOFT
GO

/*
 * Enumerate the pending applications of Policy
 * for packages which are selected in #Packages matching @pkgVer
 * on computers in an OU matching oudn
 *
 * TargetTypeID must be the value for 'Computer'
 */

IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'SecurityPatchInstallationPendingComputerMatchOU' AND xtype = 'P'
)
        DROP PROCEDURE SecurityPatchInstallationPendingComputerMatchOU
GO

CREATE PROCEDURE [SecurityPatchInstallationPendingComputerMatchOU]
	@pkgName	VARCHAR(128) = '%',
	@pkgVer		VARCHAR(32) = '%',
	@pkgFName	VARCHAR(256) = '%',
	@installPolicy	VARCHAR(16) = ''
AS 
	DECLARE @TargetTypeID	INT		-- TargetTypeId of 'Computer'
	SET @TargetTypeID =
		(SELECT TargetTypeID FROM TargetType
		 WHERE TargetTypeName = 'Computer')

	SELECT	pp.PackageFullName,
		pf.PackageName,
		pv.Version,
		case
			when ad.[Action] is null then 'Null'
			else ad.[Action]
		end as [InstallPolicy],
		dbo.OUName(c_ou.OUID) AS UserOU,
		'SYSTEM' AS UserCN,
		dbo.OUName(c_ou.OUID) AS ComputerOU,
		c.ComputerCN AS ComputerCN,
		ad.EffectiveFrom,
		ad.EffectiveFromIsLocal
	FROM	PackageApplies AS pa,
		AllocationDetails AS ad,
		PackagePath AS pp,
		PackageFamily AS pf,
		PackageVersion AS pv,
		Computer AS c,
		#Organization AS c_ou
	WHERE 	pa.TargetTypeID = @TargetTypeID		-- Computer policy type
	  AND	pa.TargetOUID = c.ComputerOUID		-- Computer OU
	  AND	c.ComputerOUID = c_ou.OUID
	  AND	pa.TargetID = c.ComputerID		-- Target computer
	  AND	pa.AllocationDetailsID = ad.AllocationDetailsID
	  AND	pa.PackagePathID = pp.PackagePathID	-- Package in policy
	  AND	pp.PackagePathID = pv.PackagePathID	-- Package in policy
	  AND	pf.PackageFamilyID = pv.PackageFamilyID	-- in this family
	  AND	pf.PackageName LIKE @pkgName		-- desired package
	  AND	pp.PackageFullName LIKE @pkgFName	-- desired path
	  AND	pv.Version LIKE @pkgVer			-- desired version
	  AND NOT EXISTS(
	    	SELECT * FROM Installation AS i
		WHERE	pa.TargetOUID = i.OrganizationID-- Matching installed OU
		  AND	pa.TargetID = i.ComputerID	-- Installing computer
		  AND	pv.PackageVersionID = i.PackageVersionID
		  AND	i.UserID = 1			-- Computer install
	    )
	  AND	(
	  	@installPolicy IS NULL
		OR (	@installPolicy = 'install'
			AND ad.Action = 'install'
		)
		OR (	@installPolicy = 'choose'
			AND (	ad.Action = 'choose'
				OR (	ad.Action = 'alwaysupdate'
					AND NOT EXISTS (
						SELECT	*
						FROM	Installation i
							INNER JOIN PackageVersion pv2
								ON i.PackageVersionID = pv2.PackageVersionID
						WHERE i.Result = 'success'
						AND pv2.PackageFamilyID = pf.PackageFamilyID
						AND pv2.PackagePathID <> pa.PackagePathID
						AND i.ComputerID = c.ComputerID
						AND i.UserID = 1
						AND i.OrganizationID = c.ComputerOUID
					)
				)
			)
		)
		OR (	@installPolicy = 'alwaysupdate'
			AND ad.Action = 'alwaysupdate'
			AND EXISTS (
				SELECT	*
				FROM	Installation i
					INNER JOIN PackageVersion pv2
						ON i.PackageVersionID = pv2.PackageVersionID
				WHERE i.Result = 'success'
				AND pv2.PackageFamilyID = pf.PackageFamilyID
				AND pv2.PackagePathID <> pa.PackagePathID
				AND i.ComputerID = c.ComputerID
				AND i.UserID = 1
				AND i.OrganizationID = c.ComputerOUID
			)
		)
	  )

	UNION

	SELECT	pp.PackageFullName,
		pf.PackageName,
		pv.Version,
		case
			when ad.[Action] is null then 'Null'
			else ad.[Action]
		end as [InstallPolicy],
		dbo.OUName(c_ou.OUID) AS UserOU,
		'SYSTEM' AS UserCN,
		dbo.OUName(c_ou.OUID) AS ComputerOU,
		c.ComputerCN AS ComputerCN,
		ad.EffectiveFrom,
		ad.EffectiveFromIsLocal
	FROM	PackageApplies AS pa,
		Member AS m,
		AllocationDetails AS ad,
		PackagePath AS pp,
		PackageFamily AS pf,
		PackageVersion AS pv,
		Computer AS c,
		#Organization AS c_ou
	WHERE 	pa.TargetTypeID = 3			-- RSOP Group
	  AND	m.GroupID = pa.TargetID			-- Member of RSOP Group
	  AND	m.TargetTypeID = @TargetTypeID		-- Computer policy type
	  AND	m.TargetID = c.ComputerID		-- Target computer
	  AND	c.ComputerOUID = c_ou.OUID		-- This OU
	  AND	pa.AllocationDetailsID = ad.AllocationDetailsID
	  AND	pa.PackagePathID = pp.PackagePathID	-- Package in policy
	  AND	pp.PackagePathID = pv.PackagePathID	-- Package in policy
	  AND	pf.PackageFamilyID = pv.PackageFamilyID	-- in this family
	  AND	pf.PackageName LIKE @pkgName		-- desired package
	  AND	pp.PackageFullName LIKE @pkgFName	-- desired path
	  AND	pv.Version LIKE @pkgVer			-- desired version
	  AND NOT EXISTS(
	    	SELECT * FROM Installation AS i
		WHERE	c.ComputerOUID = i.OrganizationID-- Matching installed OU
		  AND	m.TargetID = i.ComputerID	-- Installing computer
		  AND	pv.PackageVersionID = i.PackageVersionID
		  AND	i.UserID = 1			-- Computer install
	    )
	  AND	(
	  	@installPolicy IS NULL
		OR (	@installPolicy = 'install'
			AND ad.Action = 'install'
		)
		OR (	@installPolicy = 'choose'
			AND (	ad.Action = 'choose'
				OR (	ad.Action = 'alwaysupdate'
					AND NOT EXISTS (
						SELECT	*
						FROM	Installation i
							INNER JOIN PackageVersion pv2
								ON i.PackageVersionID = pv2.PackageVersionID
						WHERE i.Result = 'success'
						AND pv2.PackageFamilyID = pf.PackageFamilyID
						AND pv2.PackagePathID <> pa.PackagePathID
						AND i.ComputerID = c.ComputerID
						AND i.UserID = 1
						AND i.OrganizationID = c.ComputerOUID
					)
				)
			)
		)
		OR (	@installPolicy = 'alwaysupdate'
			AND ad.Action = 'alwaysupdate'
			AND EXISTS (
				SELECT	*
				FROM	Installation i
					INNER JOIN PackageVersion pv2
						ON i.PackageVersionID = pv2.PackageVersionID
				WHERE i.Result = 'success'
				AND pv2.PackageFamilyID = pf.PackageFamilyID
				AND pv2.PackagePathID <> pa.PackagePathID
				AND i.ComputerID = c.ComputerID
				AND i.UserID = 1
				AND i.OrganizationID = c.ComputerOUID
			)
		)
	  )
	ORDER BY pp.PackageFullName, pv.Version, dbo.OUName(c_ou.OUID), ComputerCN
	
GO

CopyPermission 'SecurityPatchInstallationPendingComputerMatchOU', 'mgsOSBreakdown'
GO

/*
 * Enumerate Pending Policy applications in OU
 *
 * TargetTypeName must be 'Computer' or 'User' (or any other value
 * which may have been inserted into the TargetTypes table).
 *
 * oudn is one of the OU field values from the SDOU table, or a wildcard:
 *
 * ouMatch is non-zero if the oudn string is to be matched with wildcards,
 * then any wild-card characters must be escaped to be matched normally.
 *
 * PackageName and Version are the short-name and version of the package(s) to
 * be matched. Wildcards are allowed.
 *
 * The returned ResultSet contains ...
 */

IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'SecurityPatchInstallationPending' AND xtype = 'P'
)
        DROP PROCEDURE SecurityPatchInstallationPending
GO

CREATE PROCEDURE [SecurityPatchInstallationPending]
	@TargetTypeName	VARCHAR(256),
	@oudn		VARCHAR(800),
	@ouMatch	INT = 0,		-- actually boolean
	@pkgName	VARCHAR(128) = '%',
	@pkgVer		VARCHAR(32)= '%',
	@pkgFName	VARCHAR(256) = '%',
	@installPolicy	VARCHAR(16) = NULL
AS 
	IF (@installPolicy = 'choose')
		SELECT @installPolicy = 'alwaysupdate'
		
		CREATE TABLE #Organization(OUID int PRIMARY KEY)
		EXEC OrganizationIdentifyDescendentsByOUDN @oudn, @ouMatch, 0

	    IF (@TargetTypeName = 'Computer')
		EXECUTE SecurityPatchInstallationPendingComputerMatchOU
				@pkgName,
				@pkgVer,
				@pkgFName,
				@installPolicy

	    --ELSE case @TargetTypeName = 'User' doesnot exist for Patches

GO

CopyPermission 'SecurityPatchInstallationPending', 'mgsOSBreakdown'
GO

-- USE MANAGESOFT
GO



IF EXISTS (
        SELECT * FROM dbo.sysobjects
        WHERE [name] = 'SecurityPatchInstallationSummary' AND xtype = 'P'
)
        DROP PROCEDURE SecurityPatchInstallationSummary
GO


CREATE PROCEDURE [SecurityPatchInstallationSummary]
	@TargetTypeName	VARCHAR(256),
	@oudn		VARCHAR(800),
	@ouMatch	INT = 0,		-- actually boolean
	@pkgName	VARCHAR(128) = '%', -- (size=64*2 --to take into acct encoded chars)
	@pkgVer	VARCHAR(32)= '%',
	@pkgFName	VARCHAR(256) = '%'
AS 
--NOTE: TargetTypeName='User' (@TargetTypeID=2) doesnot exist for Patches

IF EXISTS (SELECT [Property],[Value],[Created],[LastUpdate]  FROM DatabaseConfiguration WHERE [Property] = 'PrecalculateSummary' AND Value = 'True') 
-- GET PRECALCULATED DATA
BEGIN


SELECT  [PackageName]
      ,[Version]
      ,[BulletinID]
      ,[PolicyAction]
      ,[TargetTypeName]
      ,SUM([Success]) as [Success]
      ,SUM([Pending]) as [Pending]
      ,SUM([Postponed]) as [Postponed]
      ,SUM([NotRequired]) as [NotRequired]
      ,SUM([Failure]) as [Failure]
      ,SUM([Scheduled]) as [Scheduled]
      ,SUM([RemovalPending]) as [Removal Pending]
      ,SUM([RebootPending]) as [Reboot Pending]
      ,SUM([Staged]) as [Staged]
      ,SUM([Total]) as [Total]
	  ,[PackageFullName]
FROM Reporting_SecurityPatchInstallationSummary
	   LEFT JOIN Organization ON Reporting_SecurityPatchInstallationSummary.OUID = Organization.OrganizationID
	     LEFT JOIN Domain ON Organization.DomainID = Domain.OrganizationID
  
  WHERE TargetTypeName LIKE @TargetTypeName  AND PackageName LIKE @pkgName  AND [Version] LIKE @pkgVer  AND PackageFullName LIKE @pkgFName
		AND   
  ( ISNULL(Organization.RDN + ',' + Domain.DN, Domain.DN)   LIKE @oudn
    OR
   SUBSTRING(@oudn,0,4) = 'DC=' AND Domain.DN  LIKE @oudn )

  GROUP BY  [PackageName], [Version],  [BulletinID], [PolicyAction],   [TargetTypeName], [PackageFullName]

  ORDER BY [PackageName], [Version],  [BulletinID], [PackageFullName]


END

ELSE
BEGIN

CREATE TABLE #Organization(OUID int PRIMARY KEY)
EXEC OrganizationIdentifyDescendentsByOUDN @oudn, @ouMatch, 0

create table #Packages
(
	PackageFullName nvarchar(256),
	PackageVersionID INT,
	PackageFamilyID INT,
	PackageName nvarchar(64),
	Version nvarchar(32),
	BulletinID nvarchar(32)
)

INSERT INTO #Packages
SELECT pp.PackageFullName, pv.PackageVersionID, pf.PackageFamilyID, pf.PackageName, pv.Version, sp.BulletinID
FROM PackageFamily pf
	INNER JOIN PackageVersion pv
		ON pf.PackageFamilyID = pv.PackageFamilyID
	INNER JOIN PackagePath pp
		ON pp.PackagePathID = pv.PackagePathID
	INNER JOIN SecurityPatchToPackageVersion sppv
		ON sppv.PackageFullName = pp.PackageFullName
	INNER JOIN SecurityPatch sp
		ON sp.PatchID = sppv.PatchID
WHERE pf.PackageName LIKE @pkgName
	AND pp.PackageFullName LIKE @pkgFName
	AND pv.Version LIKE @pkgVer
	AND NOT EXISTS(
	      -- Only where there isn't another Warehouse version of this pkg
	      SELECT *
	      FROM	PackageVersion AS alt_pv,
		      MediaContainsPackageVersion AS mcp
	      WHERE	pv.PackagePathID = alt_pv.PackagePathID	-- Same path
		AND	pv.PackageVersionID != alt_pv.PackageVersionID --Not same
		AND	alt_pv.PackageVersionID = mcp.PackageVersionID
		AND	mcp.MediaID = 1				-- In Warehouse
	      )

select	pkg.PackageName as PackageName,
	pkg.Version,
	pkg.BulletinID,
	'' as PolicyAction,
	'Computer' as TargetTypeName,
	summary.Success,
	summary.Pending,
	summary.Postponed,
	summary.NotRequired,
	summary.Failure,
	summary.Scheduled,
	summary.[Removal Pending],
	summary.[Reboot Pending],
	summary.Staged,
	summary.Total,
	pkg.PackageFullName
from
(
	select 	isnull(pkginfo.PackageVersionID, installinfo.PackageVersionID) as PackageVersionID,
		isnull(installinfo.Success, 0) as Success,
		isnull(pkginfo.Pending, 0) as Pending,
		isnull(installinfo.Postponed, 0) as Postponed,
		isnull(installinfo.NotRequired, 0) as NotRequired,
		isnull(installinfo.Failure, 0) as Failure,
		isnull(pkginfo.Scheduled, 0) as Scheduled,
		isnull(installinfo.[Removal Pending], 0) as [Removal Pending],
		isnull(installinfo.[Reboot Pending], 0) as [Reboot Pending],
		isnull(installinfo.Staged, 0) as Staged,
		(isnull(installinfo.Total, 0) + isnull(pkginfo.Pending, 0) + isnull(pkginfo.Scheduled, 0)) as Total

	from	(
			select pv.PackageVersionID,
				sum(case when (ad.EffectiveFrom is null) or (ad.EffectiveFrom <= (case when ad.EffectiveFromIsLocal = 1 then dateadd(hour, -12, getutcdate()) else getutcdate() end)) then 1 else 0 end) as Pending,
				sum(case when (ad.EffectiveFrom is not null) and (ad.EffectiveFrom > (case when ad.EffectiveFromIsLocal = 1 then dateadd(hour, -12, getutcdate()) else getutcdate() end)) then 1 else 0 end) as Scheduled
			from 	PackageApplies as pa
				left outer join Member as memb
					on pa.TargetTypeID = 3 and memb.GroupID = pa.TargetID
					and memb.TargetTypeID = 1
				join PackageVersion as pv on pv.PackagePathID = pa.PackagePathID
				join AllocationDetails ad on ad.AllocationDetailsID = pa.AllocationDetailsID
			where	((
					(pa.TargetTypeID = 1) -- Computers
					and not exists(
							select	ComputerID
							from	installation as i
							where	UserID = 1	-- Computers
								and i.ComputerID = pa.TargetID
								and i.PackageVersionID = pv.PackageVersionID
							)
					and exists(select OUID from #Organization where OUID = pa.TargetOUID)
				)
				or (
					(pa.TargetTypeID = 3) -- RSOP
					and not exists (
							select	i.ComputerID
							from	installation as i
							where	i.UserID = 1	-- Computers
								and i.ComputerID = memb.TargetID
								and i.PackageVersionID = pv.PackageVersionID
							)
					and exists(select OUID from #Organization where OUID in (
							select	c.ComputerOUID
							from	Computer as c
							where	memb.TargetID = c.ComputerID
						)
					)
				))
				and exists(select PackageVersionID from #Packages where PackageVersionID = pv.PackageVersionID)
			group by pv.PackageVersionID
		) as pkginfo
		full outer join
		(
			select	b.PackageVersionID,
				sum(case when b.Result = 'success' AND b.InstallAction <> 'redundant' then b.Total else 0 end) as Success,
				sum(case when b.Result = 'postponed' AND b.InstallAction <> 'redundant' then b.Total else 0 end) as Postponed,
				sum(case when b.Result = 'notrequired' AND b.InstallAction <> 'redundant' then b.Total else 0 end) as NotRequired, 
			      	sum(case when b.Result = 'failure' AND b.InstallAction <> 'redundant' then b.Total else 0 end) as Failure,
				-- Note; doesn't count case where install hasn't yet been
				-- marked as redundant (after removal from policy; infrequent)
				sum(case when b.InstallAction = 'redundant' then b.Total else 0 end) as [Removal Pending], 
			      	sum(case when b.Result = 'rebootrequired' AND b.InstallAction <> 'redundant' then b.Total else 0 end) as [Reboot Pending], 
			     	sum(case when b.Result = 'staged' AND b.InstallAction <> 'redundant' then b.Total else 0 end) as Staged,
				sum(b.Total) as Total
			from
			(
				select	i.PackageVersionID,
					i.[Action] as InstallAction,
					i.Result,
					count(*) as Total
				from	#Organization as o join installation as i on i.OrganizationID = o.OUID
				where (i.UserID = 1) 		-- Computers
					and exists(select PackageVersionID from #Packages where PackageVersionID = i.PackageVersionID)
				group by i.PackageVersionID, i.[Action], i.Result
			) as b
			group by b.PackageVersionID
		) as installinfo on installinfo.PackageVersionID = pkginfo.PackageVersionID
) as summary
left outer join #Packages as pkg on pkg.PackageVersionID = summary.PackageVersionID
order by pkg.PackageName, pkg.Version, pkg.BulletinID, pkg.PackageFullName
END
GO

CopyPermission 'SecurityPatchInstallationSummary', 'mgsOSBreakdown'
GO





 

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'FillReportTable_SecurityPatchInstallationSummary') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [FillReportTable_SecurityPatchInstallationSummary]
GO

CREATE PROCEDURE [FillReportTable_SecurityPatchInstallationSummary]
	@TargetTypeName	VARCHAR(256),
	@oudn		VARCHAR(800),
	@ouMatch	INT = 0,		-- actually boolean
	@pkgName	VARCHAR(128) = '%', -- (size=64*2 --to take into acct encoded chars)
	@pkgVer	VARCHAR(32)= '%',
	@pkgFName	VARCHAR(256) = '%'
AS 
--NOTE: TargetTypeName='User' (@TargetTypeID=2) doesnot exist for Patches
IF EXISTS (SELECT [Property],[Value],[Created],[LastUpdate]  FROM DatabaseConfiguration WHERE [Property] = 'PrecalculateSummary' AND Value = 'True') 
-- GET PRECALCULATED DATA
BEGIN

CREATE TABLE #Organization(OUID int PRIMARY KEY)
EXEC OrganizationIdentifyDescendentsByOUDN @oudn, @ouMatch, 0

create table #Packages
(
	PackageFullName nvarchar(256),
	PackageVersionID INT,
	PackageFamilyID INT,
	PackageName nvarchar(64),
	Version nvarchar(32),
	BulletinID nvarchar(32)
)

INSERT INTO #Packages
SELECT pp.PackageFullName, pv.PackageVersionID, pf.PackageFamilyID, pf.PackageName, pv.Version, sp.BulletinID
FROM PackageFamily pf
	INNER JOIN PackageVersion pv ON pf.PackageFamilyID = pv.PackageFamilyID
	INNER JOIN PackagePath pp    ON pp.PackagePathID = pv.PackagePathID
	INNER JOIN SecurityPatchToPackageVersion sppv ON sppv.PackageFullName = pp.PackageFullName
	INNER JOIN SecurityPatch sp  ON sp.PatchID = sppv.PatchID
WHERE pf.PackageName LIKE @pkgName
	AND pp.PackageFullName LIKE @pkgFName
	AND pv.Version LIKE @pkgVer
	AND NOT EXISTS(
	      -- Only where there isn't another Warehouse version of this pkg
	      SELECT *
	      FROM	PackageVersion AS alt_pv,
		      MediaContainsPackageVersion AS mcp
	      WHERE	pv.PackagePathID = alt_pv.PackagePathID	-- Same path
		AND	pv.PackageVersionID != alt_pv.PackageVersionID --Not same
		AND	alt_pv.PackageVersionID = mcp.PackageVersionID
		AND	mcp.MediaID = 1				-- In Warehouse
	      )

 CREATE TABLE #SecurityPatchInstallationSummary
 (
	[PackageName] [nvarchar](64) NULL,
	[Version] [nvarchar](32) NULL,
	[BulletinID] [nvarchar](32) NULL,
	[PolicyAction] [varchar](1) NULL,
	[TargetTypeName] [varchar](8) NULL,
	[OUID] [int] NULL,
	[Success] [int] NULL,
	[Pending] [int] NULL,
	[Postponed] [int] NULL,
	[NotRequired] [int] NULL,
	[Failure] [int] NULL,
	[Scheduled] [int] NULL,
	[Removal Pending] [int] NULL,
	[Reboot Pending] [int] NULL,
	[Staged] [int] NULL,
	[Total] [int] NULL,
	[PackageFullName] [nvarchar](256) NULL
)


INSERT INTO #SecurityPatchInstallationSummary
select	pkg.PackageName as PackageName,
	pkg.Version,
	pkg.BulletinID,
	'' as PolicyAction,
	'Computer' as TargetTypeName,
    summary.TargetOUID,
	summary.Success,
	summary.Pending,
	summary.Postponed,
	summary.NotRequired,
	summary.Failure,
	summary.Scheduled,
	summary.[Removal Pending],
	summary.[Reboot Pending],
	summary.Staged,
	isnull(summary.Success,0) + 
	isnull(summary.Pending,0) + 
	isnull(summary.Postponed,0) + 
	isnull(summary.NotRequired,0) + 
	isnull(summary.Failure,0) + 
	isnull(summary.Scheduled,0) + 
	isnull(summary.[Removal Pending],0) + 
	isnull(summary.[Reboot Pending],0) + 
	isnull(summary.Staged,0) 
	as
	  Total,
	pkg.PackageFullName
from
(
	select 	
			pkginfo.PackageVersionID, 
	 	0 as Success,
	    isnull(pkginfo.Pending, 0) as Pending,
	 	0 as Postponed,
	 	0 as NotRequired,
	 	0 as Failure,
	    0 as Scheduled,
	 	0 as [Removal Pending],
	 	0 as [Reboot Pending],
	 	0 as Staged,
	     isnull( pkginfo.ComputerOUID, pkginfo.TargetOUID) as TargetOUID

	from	(
			select pv.PackageVersionID,
				sum(case when (ad.EffectiveFrom is null) or (ad.EffectiveFrom <= (case when ad.EffectiveFromIsLocal = 1 then dateadd(hour, -12, getutcdate()) else getutcdate() end)) then 1 else 0 end) as Pending,
				sum(case when (ad.EffectiveFrom is not null) and (ad.EffectiveFrom > (case when ad.EffectiveFromIsLocal = 1 then dateadd(hour, -12, getutcdate()) else getutcdate() end)) then 1 else 0 end) as Scheduled
				, pa.TargetOUID
				, c2.ComputerOUID
			from 	PackageApplies as pa
				left outer join Member as memb
					on pa.TargetTypeID = 3 and memb.GroupID = pa.TargetID
					and memb.TargetTypeID = 1
				join PackageVersion as pv on pv.PackagePathID = pa.PackagePathID
				join AllocationDetails ad on ad.AllocationDetailsID = pa.AllocationDetailsID
				left join Computer as c2 ON	memb.TargetID = c2.ComputerID
			where	((
					(pa.TargetTypeID = 1) -- Computers
					and not exists(
							select	ComputerID
							from	installation as i
							where	UserID = 1	-- Computers
								and i.ComputerID = pa.TargetID
								and i.PackageVersionID = pv.PackageVersionID
							)
					and exists(select OUID from #Organization where OUID = pa.TargetOUID)
				)
				or (
					(pa.TargetTypeID = 3) -- RSOP
					and not exists (
							select	i.ComputerID
							from	installation as i
							where	i.UserID = 1	-- Computers
								and i.ComputerID = memb.TargetID
								and i.PackageVersionID = pv.PackageVersionID
							)
					and exists(select OUID from #Organization where OUID in (
							select	c.ComputerOUID
							from	Computer as c
							where	memb.TargetID = c.ComputerID
						)
					)
				))
				and exists(select PackageVersionID from #Packages where PackageVersionID = pv.PackageVersionID)
			group by pv.PackageVersionID, pa.TargetOUID, c2.ComputerOUID
		) as pkginfo
  UNION ALL
  select 
		installinfo.PackageVersionID, 
	 	isnull(installinfo.Success, 0) as Success,
	    0 as Pending,
	 	isnull(installinfo.Postponed, 0) as Postponed,
	 	isnull(installinfo.NotRequired, 0) as NotRequired,
	 	isnull(installinfo.Failure, 0) as Failure,
	    0 as Scheduled ,
	 	isnull(installinfo.[Removal Pending], 0) as [Removal Pending],
	 	isnull(installinfo.[Reboot Pending], 0) as [Reboot Pending],
	 	isnull(installinfo.Staged, 0) as Staged,
	    installinfo.OrganizationID
	from	

		(
		select	b.PackageVersionID,
				sum(case when b.Result = 'success' AND b.InstallAction <> 'redundant' then b.Total else 0 end) as Success,
				sum(case when b.Result = 'postponed' AND b.InstallAction <> 'redundant' then b.Total else 0 end) as Postponed,
				sum(case when b.Result = 'notrequired' AND b.InstallAction <> 'redundant' then b.Total else 0 end) as NotRequired, 
			      	sum(case when b.Result = 'failure' AND b.InstallAction <> 'redundant' then b.Total else 0 end) as Failure,
				sum(case when b.InstallAction = 'redundant' then b.Total else 0 end) as [Removal Pending], 
			      	sum(case when b.Result = 'rebootrequired' AND b.InstallAction <> 'redundant' then b.Total else 0 end) as [Reboot Pending], 
			     	sum(case when b.Result = 'staged' AND b.InstallAction <> 'redundant' then b.Total else 0 end) as Staged,
				sum(b.Total) as Total,
				OrganizationID
			from
			(
				select	i.PackageVersionID,
					i.[Action] as InstallAction,
					i.Result,
					count(*) as Total,
					i.OrganizationID
				from	#Organization as o join installation as i on i.OrganizationID = o.OUID
				where (i.UserID = 1) 	 and exists(select PackageVersionID from #Packages where PackageVersionID = i.PackageVersionID)
				group by i.PackageVersionID, i.[Action], i.Result, i.OrganizationID
			) as b
			group by b.PackageVersionID, b.OrganizationID
		) as installinfo  
) as summary
left outer join #Packages as pkg on pkg.PackageVersionID = summary.PackageVersionID
order by pkg.PackageName, pkg.Version, pkg.BulletinID, pkg.PackageFullName


TRUNCATE TABLE Reporting_SecurityPatchInstallationSummary

INSERT INTO Reporting_SecurityPatchInstallationSummary
SELECT * FROM #SecurityPatchInstallationSummary

DROP TABLE #SecurityPatchInstallationSummary

END

GO

/*
 * $Header$
 *
 * DESCRIPTION: Stored Procedure: NameMapDelete
 *	Input:
 * 	- @computerName: name of the computer to remove from the mapping
 *	- @computerDomain: domain the computerName
 *
 *	Returns:
 *	- nothing - removes the name mapping from the table
 *
 * Protected by US patent 6,006,034; patents pending.
 * Copyright 2011 Flexera Software LLC
 * Reproduction, adaptation, or translation without prior permission
 * is prohibited.
 */
 
-- USE MANAGESOFT
GO


IF  EXISTS (SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinsRequiredByEnvironment')
	DROP PROCEDURE SecurityBulletinsRequiredByEnvironment
GO
CREATE PROCEDURE SecurityBulletinsRequiredByEnvironment
AS
	SELECT BulletinID
	FROM SecurityPatch
	Where PatchID IN(			  
		
		SELECT SecurityPatchAnalysis.SecurityPatchID 
		FROM SecurityPatchAnalysis 
		WHERE Status IN (1) and SecurityPatchAnalysis.SecurityPatchID != 0
	 ) 
	 
	Order By BulletinID
GO

IF  EXISTS (SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityPatchesRequiredByEnvironment')
	DROP PROCEDURE SecurityPatchesRequiredByEnvironment
GO
CREATE PROCEDURE SecurityPatchesRequiredByEnvironment
AS
	SELECT SecurityPatch.PatchName
	FROM SecurityPatchAnalysis 
		INNER JOIN SecurityPatch ON SecurityPatch.PatchID = SecurityPatchAnalysis.SecurityPatchID 
	WHERE Status IN (1) and SecurityPatchAnalysis.SecurityPatchID != 0
	
	Order By SecurityPatchAnalysis.SecurityPatchID
GO

IF  EXISTS (SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinRequiredCountByEnvironment')
	DROP PROCEDURE SecurityBulletinRequiredCountByEnvironment
GO
CREATE PROCEDURE SecurityBulletinRequiredCountByEnvironment
AS
	SELECT BulletinID, BulletinCount
	FROM (
		SELECT BulletinID, 
			(
				Select COUNT(*) as bcounter
				FROM 
				(
					SELECT BulletinID, ComputerID
					FROM [SecurityPatchAnalysis] spa
					WHERE spa.BulletinID = sb.BulletinID AND Status IN (1)
					Group by BulletinID, ComputerID
				) AS bc
			) as BulletinCount
		FROM SecurityBulletin as sb) as SecurityBulletinCountTemp
	WHERE SecurityBulletinCountTemp.BulletinCount != 0
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetNewOrUpdated')
	DROP PROCEDURE SecurityBulletinGetNewOrUpdated
GO
CREATE PROCEDURE SecurityBulletinGetNewOrUpdated
AS
	SELECT	
		sb.SecurityBulletinID,
		sb.Severity,
		ss.Description AS State,
		sus.Description AS UIState,
		sb.BulletinID,
		sb.HelpUrl,
		spb.Title,
		spb.Summary,
		sb.DatePosted,
		sb.DateRevised,
		sb.UpdateAvailable,
		sb.Errata,
		spb.Supported,
		sb.Ignore
	FROM
		SecurityBulletin AS sb, SecPatch_Bulletin AS spb,
		SecurityState AS ss, SecurityUIState AS sus
	WHERE
		sb.BulletinID = spb.BulletinID
	  AND	sus.UIStateID = sb.UIStateID
	  AND	sus.Description = 'NewOrUpdated'
	  AND	sb.Ignore = 0
	  AND	ss.StateID = sb.State
	ORDER BY
		sb.BulletinID
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetNewOrUpdatedProducts')
	DROP PROCEDURE SecurityBulletinGetNewOrUpdatedProducts
GO
CREATE PROCEDURE SecurityBulletinGetNewOrUpdatedProducts
AS
	SELECT
		sb.SecurityBulletinID,
		sppro.Name
	FROM
		SecurityBulletin AS sb, SecPatch_Bulletin AS spb,
		SecurityUIState AS sus, SecPatch_Patch AS sppat,
		SecPatch_AffectedProduct AS spaff, SecPatch_Product AS sppro
	WHERE
		sb.BulletinID = spb.BulletinID
	  AND	sus.UIStateID = sb.UIStateID
	  AND	sus.Description = 'NewOrUpdated'
	  AND	sppat.BulletinID = sb.BulletinID
	  AND	spaff.PatchID = sppat.PatchID
	  AND	sppro.ProductID = spaff.ProductID
	ORDER BY
		sb.BulletinID
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
	  AND name = 'SecurityBulletinGetProductGroups')
	DROP PROCEDURE SecurityBulletinGetProductGroups
GO
CREATE PROCEDURE SecurityBulletinGetProductGroups
AS
	SELECT DISTINCT
		sb.SecurityBulletinID,
		pg.GroupName,
		pg.Product
	FROM
		SecurityBulletin AS sb, SecPatch_Bulletin AS spb,
		SecurityUIState AS sus, SecPatch_Patch AS sppat,
		SecPatch_AffectedProduct AS spaff, SecPatch_Product AS sppro,
		SecurityPatchUIProductGroup AS pg
	WHERE
		sb.BulletinID = spb.BulletinID
	  AND	sus.UIStateID = sb.UIStateID
	  AND	sppat.BulletinID = sb.BulletinID
	  AND	spaff.PatchID = sppat.PatchID
	  AND	sppro.ProductID = spaff.ProductID
	  AND	pg.Product = sppro.Name
	ORDER BY
		sb.SecurityBulletinID
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetNewOrUpdatedProductGroups')
	DROP PROCEDURE SecurityBulletinGetNewOrUpdatedProductGroups
GO
CREATE PROCEDURE SecurityBulletinGetNewOrUpdatedProductGroups
AS
	SELECT DISTINCT
		sb.SecurityBulletinID,
		pg.GroupName,
		pg.Product
	FROM
		SecurityBulletin AS sb, SecPatch_Bulletin AS spb,
		SecurityUIState AS sus, SecPatch_Patch AS sppat,
		SecPatch_AffectedProduct AS spaff, SecPatch_Product AS sppro,
		SecurityPatchUIProductGroup AS pg
	WHERE
		sb.BulletinID = spb.BulletinID
	  AND	sus.UIStateID = sb.UIStateID
	  AND	sus.Description = 'NewOrUpdated'
	  AND	sppat.BulletinID = sb.BulletinID
	  AND	spaff.PatchID = sppat.PatchID
	  AND	sppro.ProductID = spaff.ProductID
	  AND	pg.Product = sppro.Name
	ORDER BY
		sb.SecurityBulletinID
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetNewOrUpdatedUserStates')
	DROP PROCEDURE SecurityBulletinGetNewOrUpdatedUserStates
GO
CREATE PROCEDURE SecurityBulletinGetNewOrUpdatedUserStates
AS
	SELECT
		sb.SecurityBulletinID,
		sus.Description,
		sbus.Certified
	FROM
		SecurityBulletin AS sb, SecPatch_Bulletin AS spb,
		SecurityUserState AS sus, SecurityBulletinToUserState AS sbus,
		SecurityUIState AS suis
	WHERE
		sb.BulletinID = spb.BulletinID
	  AND	sb.SecurityBulletinID = sbus.SecurityBulletinID
	  AND	sus.UserStateID = sbus.UserStateID
	  AND	sb.UIStateID = suis.UIStateID
	  AND	suis.Description = 'NewOrUpdated'
	ORDER BY
		sb.SecurityBulletinID
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetInProgress')
	DROP PROCEDURE SecurityBulletinGetInProgress
GO
CREATE PROCEDURE SecurityBulletinGetInProgress
AS
	SELECT
		sb.SecurityBulletinID,
		sb.Severity,
		ss.Description AS State,
		sus.Description AS UIState,
		sb.BulletinID,
		sb.HelpUrl,
		spb.Title,
		spb.Summary,
		sb.DatePosted,
		sb.DateRevised,
		sb.UpdateAvailable,
		sb.Errata,
		spb.Supported,
		sb.Ignore
	FROM
		SecurityBulletin AS sb, SecPatch_Bulletin AS spb,
		SecurityState AS ss, SecurityUIState AS sus
	WHERE
		sb.BulletinID = spb.BulletinID
	  AND	sus.UIStateID = sb.UIStateID
	  AND	(sus.Description = 'Downloaded' OR sus.Description = 'InProgress')
	  AND	sb.Ignore = 0
	  AND	ss.StateID = sb.State
	ORDER BY
		sb.BulletinID
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetInProgressProducts')
	DROP PROCEDURE SecurityBulletinGetInProgressProducts
GO
CREATE PROCEDURE SecurityBulletinGetInProgressProducts
AS
	SELECT
		sb.SecurityBulletinID,
		sppro.Name
	FROM
		SecurityBulletin AS sb, SecPatch_Bulletin AS spb,
		SecurityUIState AS sus, SecPatch_Patch AS sppat,
		SecPatch_AffectedProduct AS spaff, SecPatch_Product AS sppro
	WHERE
		sb.BulletinID = spb.BulletinID
	  AND	sus.UIStateID = sb.UIStateID
	  AND	(sus.Description = 'Downloaded' OR sus.Description = 'InProgress')
	  AND	sppat.BulletinID = sb.BulletinID
	  AND	spaff.PatchID = sppat.PatchID
	  AND	sppro.ProductID = spaff.ProductID
	ORDER BY
		sb.BulletinID
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetInProgressProductGroups')
	DROP PROCEDURE SecurityBulletinGetInProgressProductGroups
GO
CREATE PROCEDURE SecurityBulletinGetInProgressProductGroups
AS
	SELECT DISTINCT
		sb.SecurityBulletinID,
		pg.GroupName,
		pg.Product
	FROM
		SecurityBulletin AS sb, SecPatch_Bulletin AS spb,
		SecurityUIState AS sus, SecPatch_Patch AS sppat,
		SecPatch_AffectedProduct AS spaff, SecPatch_Product AS sppro,
		SecurityPatchUIProductGroup AS pg
	WHERE
		sb.BulletinID = spb.BulletinID
	  AND	sus.UIStateID = sb.UIStateID
	  AND	(sus.Description = 'Downloaded' OR sus.Description = 'InProgress')
	  AND	sppat.BulletinID = sb.BulletinID
	  AND	spaff.PatchID = sppat.PatchID
	  AND	sppro.ProductID = spaff.ProductID
	  AND	pg.Product = sppro.Name
	ORDER BY
		sb.SecurityBulletinID
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetInProgressUserStates')
	DROP PROCEDURE SecurityBulletinGetInProgressUserStates
GO
CREATE PROCEDURE SecurityBulletinGetInProgressUserStates
AS
	SELECT
		sb.SecurityBulletinID,
		sus.Description,
		sbus.Certified
	FROM
		SecurityBulletin AS sb, SecPatch_Bulletin AS spb,
		SecurityUserState AS sus, SecurityBulletinToUserState AS sbus,
		SecurityUIState AS suis
	WHERE
		sb.BulletinID = spb.BulletinID
	  AND	sb.SecurityBulletinID = sbus.SecurityBulletinID
	  AND	sus.UserStateID = sbus.UserStateID
	  AND	sb.UIStateID = suis.UIStateID
	  AND	(suis.Description = 'Downloaded' OR suis.Description = 'InProgress')
	ORDER BY
		sb.SecurityBulletinID
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetReleased')
	DROP PROCEDURE SecurityBulletinGetReleased
GO
CREATE PROCEDURE SecurityBulletinGetReleased
AS
	SELECT
		sb.SecurityBulletinID,
		sb.Severity,
		ss.Description AS State,
		sus.Description AS UIState,
		sb.BulletinID,
		sb.HelpUrl,
		spb.Title,
		spb.Summary,
		sb.DatePosted,
		sb.DateRevised,
		sb.UpdateAvailable,
		sb.Errata,
		spb.Supported,
		sb.Ignore
	FROM
		SecurityBulletin AS sb, SecPatch_Bulletin AS spb,
		SecurityState AS ss, SecurityUIState AS sus
	WHERE
		sb.BulletinID = spb.BulletinID
	  AND	sus.UIStateID = sb.UIStateID
	  AND	sus.Description = 'Released'
	  AND	ss.StateID = sb.State
	  AND	sb.Ignore = 0
	ORDER BY
		sb.BulletinID
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetReleasedProducts')
	DROP PROCEDURE SecurityBulletinGetReleasedProducts
GO
CREATE PROCEDURE SecurityBulletinGetReleasedProducts
AS
	SELECT
		sb.SecurityBulletinID,
		sppro.Name
	FROM
		SecurityBulletin AS sb, SecPatch_Bulletin AS spb,
		SecurityUIState AS sus, SecPatch_Patch AS sppat,
		SecPatch_AffectedProduct AS spaff, SecPatch_Product AS sppro
	WHERE
		sb.BulletinID = spb.BulletinID
	  AND	sus.UIStateID = sb.UIStateID
	  AND	sus.Description = 'Released'
	  AND	sppat.BulletinID = sb.BulletinID
	  AND	spaff.PatchID = sppat.PatchID
	  AND	sppro.ProductID = spaff.ProductID
	ORDER BY
		sb.BulletinID
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetReleasedProductGroups')
	DROP PROCEDURE SecurityBulletinGetReleasedProductGroups
GO
CREATE PROCEDURE SecurityBulletinGetReleasedProductGroups
AS
	SELECT DISTINCT
		sb.SecurityBulletinID,
		pg.GroupName,
		pg.Product
	FROM
		SecurityBulletin AS sb, SecPatch_Bulletin AS spb,
		SecurityUIState AS sus, SecPatch_Patch AS sppat,
		SecPatch_AffectedProduct AS spaff, SecPatch_Product AS sppro,
		SecurityPatchUIProductGroup AS pg
	WHERE
		sb.BulletinID = spb.BulletinID
	  AND	sus.UIStateID = sb.UIStateID
	  AND	sus.Description = 'Released'
	  AND	sppat.BulletinID = sb.BulletinID
	  AND	spaff.PatchID = sppat.PatchID
	  AND	sppro.ProductID = spaff.ProductID
	  AND	pg.Product = sppro.Name
	ORDER BY
		sb.SecurityBulletinID
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetReleasedUserStates')
	DROP PROCEDURE SecurityBulletinGetReleasedUserStates
GO
CREATE PROCEDURE SecurityBulletinGetReleasedUserStates
AS
	SELECT
		sb.SecurityBulletinID,
		sus.Description,
		sbus.Certified
	FROM
		SecurityBulletin AS sb, SecPatch_Bulletin AS spb,
		SecurityUserState AS sus, SecurityBulletinToUserState AS sbus,
		SecurityUIState AS suis
	WHERE
		sb.BulletinID = spb.BulletinID
	  AND	sb.SecurityBulletinID = sbus.SecurityBulletinID
	  AND	sus.UserStateID = sbus.UserStateID
	  AND	sb.UIStateID = suis.UIStateID
	  AND	suis.Description = 'Released'
	ORDER BY
		sb.SecurityBulletinID
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetSuppressed')
	DROP PROCEDURE SecurityBulletinGetSuppressed
GO
CREATE PROCEDURE SecurityBulletinGetSuppressed
AS
	SELECT
		sb.SecurityBulletinID,
		sb.Severity,
		ss.Description AS State,
		sus.Description AS UIState,
		sb.BulletinID,
		sb.HelpUrl,
		spb.Title,
		spb.Summary,
		sb.DatePosted,
		sb.DateRevised,
		sb.UpdateAvailable,
		sb.Errata,
		spb.Supported,
		sb.Ignore
	FROM
		SecurityBulletin AS sb, SecPatch_Bulletin AS spb,
		SecurityState AS ss, SecurityUIState AS sus
	WHERE
		sb.BulletinID = spb.BulletinID
	  AND	sus.UIStateID = sb.UIStateID
	  AND	(sus.Description = 'Hidden' OR sb.Ignore=1)
	  AND	ss.StateID = sb.State
	ORDER BY
		sb.BulletinID
GO
IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinTableGetAll')
	DROP PROCEDURE SecurityBulletinTableGetAll
GO

CREATE PROCEDURE SecurityBulletinTableGetAll
AS

	SELECT distinct
		sb.SecurityBulletinID,
		sb.Severity,
		sb.BulletinID,
		sb.HelpUrl,
		sb.DatePosted,
		sb.DateRevised,
		sb.UpdateAvailable,
		sb.Errata,
		sb.Ignore,
		sb.UIStateID
	FROM
		SecurityBulletin AS sb
Go


IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetAllExceptSuppressed')
	DROP PROCEDURE SecurityBulletinGetAllExceptSuppressed
GO
CREATE PROCEDURE SecurityBulletinGetAllExceptSuppressed
AS
	SELECT
		sb.SecurityBulletinID,
		sb.Severity,
		ss.Description AS State,
		sus.Description AS UIState,
		sb.BulletinID,
		sb.HelpUrl,
		spb.Title,
		spb.Summary,
		sb.DatePosted,
		sb.DateRevised,
		sb.UpdateAvailable,
		sb.Errata,
		spb.Supported,
		sb.Ignore
	FROM
		SecurityBulletin AS sb, SecPatch_Bulletin AS spb,
		SecurityState AS ss, SecurityUIState AS sus
	WHERE
		sb.BulletinID = spb.BulletinID
	  AND	sus.UIStateID = sb.UIStateID
	  AND	sus.Description != 'Hidden'
	  AND	ss.StateID = sb.State
	ORDER BY
		sb.BulletinID
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityPatchGetPatchesAndAffectedProducts')
	DROP PROCEDURE SecurityPatchGetPatchesAndAffectedProducts
GO
CREATE PROCEDURE SecurityPatchGetPatchesAndAffectedProducts
AS
	SELECT 
		sp.PatchID, 
		spUI.SecurityPatchUIProductGroupID, 
		sp.PatchName, 
		spUI.Product 
	FROM  
		SecurityPatch as sp, 
		SecPatch_Patch as spp, 
		SecPatch_AffectedProduct as spap, 
		SecPatch_Product as sppr, 
		SecurityPatchUIProductGroup as spUI
	WHERE 
		sp.PatchID = spp.SecurityPatchID
	  AND	spp.PatchID = spap.PatchID
	  AND	spap.ProductID = sppr.ProductID
	  AND	sppr.Name = spUI.Product
	ORDER BY 
		sp.PatchID
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetSuppressedProducts')
	DROP PROCEDURE SecurityBulletinGetSuppressedProducts
GO
CREATE PROCEDURE SecurityBulletinGetSuppressedProducts
AS
	SELECT
		sb.SecurityBulletinID,
		sppro.Name
	FROM
		SecurityBulletin AS sb, SecPatch_Bulletin AS spb,
		SecurityUIState AS sus, SecPatch_Patch AS sppat,
		SecPatch_AffectedProduct AS spaff, SecPatch_Product AS sppro
	WHERE
		sb.BulletinID = spb.BulletinID
	  AND	sus.UIStateID = sb.UIStateID
	  AND	(sus.Description = 'Hidden' OR sb.Ignore = 1)
	  AND	sppat.BulletinID = sb.BulletinID
	  AND	spaff.PatchID = sppat.PatchID
	  AND	sppro.ProductID = spaff.ProductID
	ORDER BY
		sb.BulletinID
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetAllExceptSuppressedProducts')
	DROP PROCEDURE SecurityBulletinGetAllExceptSuppressedProducts
GO
CREATE PROCEDURE SecurityBulletinGetAllExceptSuppressedProducts
AS
	SELECT
		sb.SecurityBulletinID,
		sppro.Name
	FROM
		SecurityBulletin AS sb, SecPatch_Bulletin AS spb,
		SecurityUIState AS sus, SecPatch_Patch AS sppat,
		SecPatch_AffectedProduct AS spaff, SecPatch_Product AS sppro
	WHERE
		sb.BulletinID = spb.BulletinID
	  AND	sus.UIStateID = sb.UIStateID
	  AND	sus.Description != 'Hidden'
	  AND	sppat.BulletinID = sb.BulletinID
	  AND	spaff.PatchID = sppat.PatchID
	  AND	sppro.ProductID = spaff.ProductID
	ORDER BY
		sb.BulletinID
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetSuppressedProductGroups')
	DROP PROCEDURE SecurityBulletinGetSuppressedProductGroups
GO
CREATE PROCEDURE SecurityBulletinGetSuppressedProductGroups
AS
	SELECT DISTINCT
		sb.SecurityBulletinID,
		pg.GroupName,
		pg.Product
	FROM
		SecurityBulletin AS sb, SecPatch_Bulletin AS spb,
		SecurityUIState AS sus, SecPatch_Patch AS sppat,
		SecPatch_AffectedProduct AS spaff, SecPatch_Product AS sppro,
		SecurityPatchUIProductGroup AS pg
	WHERE
		sb.BulletinID = spb.BulletinID
	  AND	sus.UIStateID = sb.UIStateID
	  AND	(sus.Description = 'Hidden' OR sb.Ignore = 1)
	  AND	sppat.BulletinID = sb.BulletinID
	  AND	spaff.PatchID = sppat.PatchID
	  AND	sppro.ProductID = spaff.ProductID
	  AND	pg.Product = sppro.Name
	ORDER BY
		sb.SecurityBulletinID
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetAllExceptSuppressedProductGroups')
	DROP PROCEDURE SecurityBulletinGetAllExceptSuppressedProductGroups
GO
CREATE PROCEDURE SecurityBulletinGetAllExceptSuppressedProductGroups
AS
	SELECT DISTINCT
		sb.SecurityBulletinID,
		pg.GroupName,
		pg.Product
	FROM
		SecurityBulletin AS sb, SecPatch_Bulletin AS spb,
		SecurityUIState AS sus, SecPatch_Patch AS sppat,
		SecPatch_AffectedProduct AS spaff, SecPatch_Product AS sppro,
		SecurityPatchUIProductGroup AS pg
	WHERE
		sb.BulletinID = spb.BulletinID
	  AND	sus.UIStateID = sb.UIStateID
	  AND	sus.Description != 'Hidden'
	  AND	sppat.BulletinID = sb.BulletinID
	  AND	spaff.PatchID = sppat.PatchID
	  AND	sppro.ProductID = spaff.ProductID
	  AND	pg.Product = sppro.Name
	ORDER BY
		sb.SecurityBulletinID
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetSuppressedUserStates')
	DROP PROCEDURE SecurityBulletinGetSuppressedUserStates
GO
CREATE PROCEDURE SecurityBulletinGetSuppressedUserStates
AS
	SELECT
		sb.SecurityBulletinID,
		sus.Description,
		sbus.Certified
	FROM
		SecurityBulletin AS sb, SecPatch_Bulletin AS spb,
		SecurityUserState AS sus, SecurityBulletinToUserState AS sbus,
		SecurityUIState AS suis
	WHERE
		sb.BulletinID = spb.BulletinID
	  AND	sb.SecurityBulletinID = sbus.SecurityBulletinID
	  AND	sus.UserStateID = sbus.UserStateID
	  AND	sb.UIStateID = suis.UIStateID
	  AND	(suis.Description = 'Hidden' OR sb.Ignore = 1)
	ORDER BY
		sb.SecurityBulletinID
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetAllExceptSuppressedUserStates')
	DROP PROCEDURE SecurityBulletinGetAllExceptSuppressedUserStates
GO
CREATE PROCEDURE SecurityBulletinGetAllExceptSuppressedUserStates
AS
	SELECT
		sb.SecurityBulletinID,
		sus.Description,
		sbus.Certified
	FROM
		SecurityBulletin AS sb, SecPatch_Bulletin AS spb,
		SecurityUserState AS sus, SecurityBulletinToUserState AS sbus,
		SecurityUIState AS suis
	WHERE
		sb.BulletinID = spb.BulletinID
	  AND	sb.SecurityBulletinID = sbus.SecurityBulletinID
	  AND	sus.UserStateID = sbus.UserStateID
	  AND	sb.UIStateID = suis.UIStateID
	  AND	suis.Description != 'Hidden'
	ORDER BY
		sb.SecurityBulletinID
GO

--
-- Stored procedures for obtaining bulletin counts, for alerts and summary pages
--

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetAlerts')
	DROP PROCEDURE SecurityBulletinGetAlerts
GO
CREATE PROCEDURE SecurityBulletinGetAlerts
AS
	DECLARE @numNewCritical int
	DECLARE @numNewNonCritical int
	DECLARE @numUpdatedApproved int
	DECLARE @numUpdatedNonApproved int

	SELECT	@numNewCritical = COUNT(*)
	FROM	SecurityBulletin AS sb, SecurityUIState AS sus
	WHERE	sb.UIStateID = sus.UIStateID
	  AND	sb.Severity = 4
	  AND	(sus.Description = 'NewOrUpdated' AND sb.Ignore = 0)
	  AND	sb.SecurityBulletinID <> 0

	SELECT	@numNewNonCritical = COUNT(*)
	FROM	SecurityBulletin AS sb, SecurityUIState AS sus
	WHERE	sb.UIStateID = sus.UIStateID
	  AND	sb.Severity < 4
	  AND	(sus.Description = 'NewOrUpdated' AND sb.Ignore = 0)
	  AND	sb.SecurityBulletinID <> 0

	SELECT	@numUpdatedApproved = COUNT(*)
	FROM	SecurityBulletin AS sb, SecurityState AS ss
	WHERE	sb.State = ss.StateID
	  AND	sb.UpdateAvailable = 1
	  AND	(ss.Description = 'Released' AND sb.Ignore = 0)
	  AND	sb.SecurityBulletinID <> 0

	SELECT	@numUpdatedNonApproved = COUNT(*)
	FROM	SecurityBulletin AS sb, SecurityState AS ss
	WHERE	sb.State = ss.StateID
	  AND	sb.UpdateAvailable = 1
	  AND	(NOT(ss.Description = 'Released') AND sb.Ignore = 0)
	  AND	sb.SecurityBulletinID <> 0

	SELECT	NumNewCritical = @numNewCritical,
		NumNewNonCritical = @numNewNonCritical,
		NumUpdatedApproved = @numUpdatedApproved,
		NumUpdatedNonApproved = @numUpdatedNonApproved
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetCountByUIState')
	DROP PROCEDURE SecurityBulletinGetCountByUIState
GO
CREATE PROCEDURE SecurityBulletinGetCountByUIState
	@Description	nvarchar(32)
AS
	SELECT	COUNT(*)
	FROM	SecurityBulletin AS sb, SecurityUIState AS sus
	WHERE	sb.UIStateID = sus.UIStateID
	  AND	sus.Description = @Description
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetAllUIStateCount')
	DROP PROCEDURE SecurityBulletinGetAllUIStateCount
GO
CREATE PROCEDURE SecurityBulletinGetAllUIStateCount
AS
	DECLARE @numNewOrUpdated int
	DECLARE @numInProgress int
	DECLARE @numReleased int
	DECLARE @numHidden int

	SELECT @numNewOrUpdated = COUNT(*)
	FROM	SecurityBulletin AS sb, SecurityUIState AS sus
	WHERE	sb.UIStateID = sus.UIStateID
	  AND	(sus.Description = 'NewOrUpdated' AND sb.Ignore = 0)
	  AND	sb.SecurityBulletinID <> 0

	SELECT @numInProgress = COUNT(*)
	FROM	SecurityBulletin AS sb, SecurityUIState AS sus
	WHERE	sb.UIStateID = sus.UIStateID
	  AND	(sus.Description = 'InProgress' AND sb.Ignore = 0)
	  AND	sb.SecurityBulletinID <> 0

	SELECT @numReleased = COUNT(*)
	FROM	SecurityBulletin AS sb, SecurityUIState AS sus
	WHERE	sb.UIStateID = sus.UIStateID
	  AND	(sus.Description = 'Released' AND sb.Ignore = 0)
	  AND	sb.SecurityBulletinID <> 0

	SELECT @numHidden = COUNT(*)
	FROM	SecurityBulletin AS sb, SecurityUIState AS sus
	WHERE	sb.UIStateID = sus.UIStateID
	  AND	(sus.Description = 'Hidden' OR sb.Ignore = 1)
	  AND	sb.SecurityBulletinID <> 0

	SELECT	NumNewOrUpdated = @numNewOrUpdated,
		NumInProgress = @numInProgress,
		NumReleased = @numReleased,
		NumHidden = @numHidden
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityStateGetIDByDescription')
	DROP PROCEDURE SecurityStateGetIDByDescription
GO
CREATE PROCEDURE SecurityStateGetIDByDescription
	@Description	nvarchar(64),
	@StateID	int OUTPUT
AS
BEGIN
	SELECT	@StateID = StateID
	FROM	SecurityState
	WHERE	Description = @Description
END
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityUIStateGetIDByDescription')
	DROP PROCEDURE SecurityUIStateGetIDByDescription
GO
CREATE PROCEDURE SecurityUIStateGetIDByDescription
	@Description	nvarchar(32),
	@UIStateID	int OUTPUT
AS
BEGIN
	SELECT	@UIStateID = UIStateID
	FROM	SecurityUIState
	WHERE	Description = @Description
END
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinUpdateEmergencyByBulletinID')
	DROP PROCEDURE SecurityBulletinUpdateEmergencyByBulletinID
GO
CREATE PROCEDURE SecurityBulletinUpdateEmergencyByBulletinID
	@BulletinID	nvarchar(32)
AS
	DECLARE @StateID int
	SELECT	@StateID = StateID
	FROM	SecurityState
	WHERE	Description = 'Released'

	DECLARE @UIStateID int
	SELECT	@UIStateID = UIStateID
	FROM	SecurityUIState
	WHERE	Description = 'Released'

	UPDATE	SecurityBulletin
	SET	State = @StateID,
		UIStateID = @UIStateID
	WHERE BulletinID = @BulletinID
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinUpdateHideByBulletinID')
	DROP PROCEDURE SecurityBulletinUpdateHideByBulletinID
GO
CREATE PROCEDURE SecurityBulletinUpdateHideByBulletinID
	@BulletinID	nvarchar(32)
AS
	UPDATE	SecurityBulletin
	SET	[Ignore] = 1
	WHERE BulletinID = @BulletinID
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinUpdateHideByBulletinIDManual')
	DROP PROCEDURE SecurityBulletinUpdateHideByBulletinIDManual
GO
CREATE PROCEDURE SecurityBulletinUpdateHideByBulletinIDManual
	@BulletinID	nvarchar(32)
AS
	DECLARE @UIStateID int
	SELECT	@UIStateID = UIStateID
	FROM	SecurityUIState
	WHERE	Description = 'Hidden'

	UPDATE	SecurityBulletin
	SET	UIStateID = @UIStateID
	WHERE BulletinID = @BulletinID
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinUpdateUnhideByBulletinIDManual')
	DROP PROCEDURE SecurityBulletinUpdateUnhideByBulletinIDManual
GO
CREATE PROCEDURE SecurityBulletinUpdateUnhideByBulletinIDManual
	@BulletinID	nvarchar(32)
AS
BEGIN
	DECLARE @SecurityBulletinID int
	DECLARE @StateID int
	DECLARE @UpdateAvailable int
	DECLARE @NewUIStateID int

	DECLARE @StatePosted int
	DECLARE @StateDownloaded int
	DECLARE @StatePackaged int
	DECLARE @StateReleased int

	DECLARE @UIStateNewOrUpdated int
	DECLARE @UIStateInProgress int
	DECLARE @UIStateReleased int

	EXEC SecurityStateGetIDByDescription 'Posted', @StatePosted OUTPUT
	EXEC SecurityStateGetIDByDescription 'Downloaded', @StateDownloaded OUTPUT
	EXEC SecurityStateGetIDByDescription 'Packaged', @StatePackaged OUTPUT
	EXEC SecurityStateGetIDByDescription 'Released', @StateReleased OUTPUT

	EXEC SecurityUIStateGetIDByDescription 'NewOrUpdated', @UIStateNewOrUpdated OUTPUT
	EXEC SecurityUIStateGetIDByDescription 'InProgress', @UIStateInProgress OUTPUT
	EXEC SecurityUIStateGetIDByDescription 'Released', @UIStateReleased OUTPUT

	SELECT	@SecurityBulletinID = SecurityBulletinID,
		@StateID = State,
		@UpdateAvailable = UpdateAvailable
	FROM	SecurityBulletin
	WHERE	BulletinID = @BulletinID

	IF (@StateID = @StatePosted OR @UpdateAvailable = 1)
		SET @NewUIStateID = @UIStateNewOrUpdated
	ELSE IF (@StateID = @StateDownloaded OR @StateID = @StatePackaged)
		SET @NewUIStateID = @UIStateInProgress
	ELSE
		SET @NewUIStateID = @UIStateReleased

	UPDATE	SecurityBulletin
	SET	UIStateID = @NewUIStateID
	WHERE BulletinID = @BulletinID
END
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinUpdateUnhideByBulletinID')
	DROP PROCEDURE SecurityBulletinUpdateUnhideByBulletinID
GO
CREATE PROCEDURE SecurityBulletinUpdateUnhideByBulletinID
	@BulletinID	nvarchar(32)
AS
BEGIN
	DECLARE @SecurityBulletinID int
	DECLARE @StateID int
	DECLARE @UpdateAvailable int
	DECLARE @NewUIStateID int

	DECLARE @StatePosted int
	DECLARE @StateDownloaded int
	DECLARE @StatePackaged int
	DECLARE @StateReleased int

	DECLARE @UIStateNewOrUpdated int
	DECLARE @UIStateInProgress int
	DECLARE @UIStateReleased int

	EXEC SecurityStateGetIDByDescription 'Posted', @StatePosted OUTPUT
	EXEC SecurityStateGetIDByDescription 'Downloaded', @StateDownloaded OUTPUT
	EXEC SecurityStateGetIDByDescription 'Packaged', @StatePackaged OUTPUT
	EXEC SecurityStateGetIDByDescription 'Released', @StateReleased OUTPUT

	EXEC SecurityUIStateGetIDByDescription 'NewOrUpdated', @UIStateNewOrUpdated OUTPUT
	EXEC SecurityUIStateGetIDByDescription 'InProgress', @UIStateInProgress OUTPUT
	EXEC SecurityUIStateGetIDByDescription 'Released', @UIStateReleased OUTPUT

	SELECT	@SecurityBulletinID = SecurityBulletinID,
		@StateID = State,
		@UpdateAvailable = UpdateAvailable
	FROM	SecurityBulletin
	WHERE	BulletinID = @BulletinID

	IF (@StateID = @StatePosted OR @UpdateAvailable = 1)
		SET @NewUIStateID = @UIStateNewOrUpdated
	ELSE IF (@StateID = @StateDownloaded OR @StateID = @StatePackaged)
		SET @NewUIStateID = @UIStateInProgress
	ELSE
		SET @NewUIStateID = @UIStateReleased

	UPDATE	SecurityBulletin
	SET	[Ignore] = 0
	WHERE BulletinID = @BulletinID
END
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinUpdateHideAllSuperceded')
	DROP PROCEDURE SecurityBulletinUpdateHideAllSuperceded
GO
CREATE PROCEDURE SecurityBulletinUpdateHideAllSuperceded
AS
	UPDATE	SecurityBulletin
	SET	UIStateID = 4
	WHERE EXISTS
	(
		SELECT	sp.PatchID
		FROM	SecurityPatch AS sp,
			SecurityPatchSupersede AS sps
		WHERE	sp.PatchID = sps.OldSecurityPatchID
		  AND	sp.BulletinID = SecurityBulletin.BulletinID
	)
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetAffectedProducts')
	DROP PROCEDURE SecurityBulletinGetAffectedProducts
GO
CREATE PROCEDURE SecurityBulletinGetAffectedProducts
	@bulletinId		nvarchar(64),
	@affectedProducts	nvarchar(2048) OUTPUT
AS
	DECLARE @name nvarchar(256)
	DECLARE prodcur CURSOR FOR
		SELECT	prod.[Name]
		FROM	SecPatch_Product AS prod,
			SecPatch_AffectedProduct AS affprod,
			SecPatch_Patch AS patch,
			SecPatch_Bulletin as bull
		WHERE	bull.BulletinID = @bulletinId
		  AND	patch.BulletinID = bull.BulletinID
		  AND	affprod.PatchID = patch.PatchID
		  AND	prod.ProductID = affprod.ProductID

	OPEN prodcur

	SET @affectedProducts = ''
	FETCH NEXT FROM prodcur INTO @name
	WHILE @@FETCH_STATUS = 0
	BEGIN
		SET @affectedProducts = @affectedProducts + '"' + @name + '"'
		FETCH NEXT FROM prodcur INTO @name
		IF @@FETCH_STATUS = 0
			SET @affectedProducts = @affectedProducts + ', '
	END
	CLOSE prodcur
	DEALLOCATE prodcur
	RETURN
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityPatchGetAffectedProducts')
	DROP PROCEDURE SecurityPatchGetAffectedProducts
GO
CREATE PROCEDURE SecurityPatchGetAffectedProducts
	@patchid		int,
	@affectedProducts	nvarchar(2048) OUTPUT
AS
	DECLARE @name nvarchar(256)
	DECLARE prodcur CURSOR FOR
		SELECT	prod.[Name]
		FROM	SecPatch_Product AS prod,
			SecPatch_AffectedProduct AS affprod,
			SecPatch_Patch AS patch
		WHERE	patch.PatchID = @patchid
		  AND	affprod.PatchID = patch.PatchID
		  AND	prod.ProductID = affprod.ProductID

	OPEN prodcur

	SET @affectedProducts = ''
	FETCH NEXT FROM prodcur INTO @name
	WHILE @@FETCH_STATUS = 0
	BEGIN
		SET @affectedProducts = @affectedProducts + @name
		FETCH NEXT FROM prodcur INTO @name
		IF @@FETCH_STATUS = 0
			SET @affectedProducts = @affectedProducts + '|'
	END
	CLOSE prodcur
	DEALLOCATE prodcur
	RETURN
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetPackaged')
	DROP PROCEDURE SecurityBulletinGetPackaged
GO
CREATE PROCEDURE SecurityBulletinGetPackaged
	@all bit = 0
AS
	DECLARE @bulletinId nvarchar(64)
	DECLARE @products nvarchar(2048)
	DECLARE bullcur CURSOR FOR
		SELECT	sb.BulletinID as BulletinID
		FROM	SecurityBulletin AS sb
		WHERE	sb.State = 4

	OPEN bullcur

	CREATE TABLE #BulletinProducts(
		BulletinID nvarchar(64) COLLATE database_default,
		AffectedProducts nvarchar(2048) COLLATE database_default
	);

	FETCH NEXT FROM bullcur INTO @bulletinId
	WHILE @@FETCH_STATUS = 0
	BEGIN
		EXEC SecurityBulletinGetAffectedProducts @bulletinId, @affectedProducts = @products OUTPUT
		INSERT INTO #BulletinProducts VALUES (@bulletinId, @products)
		FETCH NEXT FROM bullcur INTO @bulletinId
	END
	CLOSE bullcur
	DEALLOCATE bullcur

	SELECT	sb.BulletinID as BulletinID,
		sb.Severity as Severity,
		sb.State as State,
		spb.Title as Title,
		spb.Summary as Summary,
		sb.HelpURL as HelpURL,
		sb.DatePosted as DatePosted,
		sb.DateRevised as DateRevised,
		bp.AffectedProducts as AffectedProducts
	FROM	SecurityBulletin AS sb,
		SecPatch_Bulletin AS spb,
		#BulletinProducts AS bp
	WHERE	sb.BulletinID = spb.BulletinID
	AND	sb.BulletinID = bp.BulletinID
	AND	sb.State = 4
	AND	(@all = 1 OR sb.Hidden = 0)
	AND	(
			SELECT	COUNT(sppv.PackageFullName)
			FROM	SecurityPatchToPackageVersion AS sppv,
				SecurityPatch AS sp
			WHERE	sp.BulletinID = sb.BulletinID
			  AND	sppv.PatchID = sp.PatchID
		) > 0
	AND	EXISTS (
			SELECT	sp3.PatchID
			FROM	SecurityPatch AS sp3
			WHERE	sp3.BulletinID=sb.BulletinID
		)
	ORDER BY sb.DatePosted, sb.BulletinID

	DROP TABLE #BulletinProducts

	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetDependenciesBySecurityBulletinID')
	DROP PROCEDURE SecurityBulletinGetDependenciesBySecurityBulletinID
GO
CREATE PROCEDURE SecurityBulletinGetDependenciesBySecurityBulletinID
	@SecurityBulletinID	int
AS
	SELECT
		sb.SecurityBulletinID,
		sb.BulletinID,
		spb.Title
	FROM
		SecurityBulletinRequires AS sbr,
		SecurityBulletin AS sb,
		SecPatch_Bulletin AS spb
	WHERE
		sbr.SecurityBulletinID = @SecurityBulletinID
	  AND	sbr.RequiredBulletinID = sb.SecurityBulletinID
	  AND	spb.BulletinID = sb.BulletinID
	ORDER BY
		sb.BulletinID
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetAllDetailed')
	DROP PROCEDURE SecurityBulletinGetAllDetailed
GO

CREATE PROCEDURE [dbo].[SecurityBulletinGetAllDetailed]
AS
	SELECT
 sb.SecurityBulletinID,
 sb.BulletinID,                     
 Title,                          
 Severity,                       
 State,                          
 Comments,                       
 HelpUrl,                        
 sb.DatePosted,                     
 sb.DateRevised,                    
 Version,                        
 UpdateAvailable,               
 UIStateID,                     
 Hidden,                        
 PackageVersionID,              
 Errata,                        
 Ignore,
 SupersedeStatus,
 sb.CustomID,
 sb.RequiredCount,
(select TOP (1) UserStateID   from SecurityBulletinToUserState WHERE SecurityBulletinID = sb.SecurityBulletinID
order by DateChanged DESC) as UserStateID
,
(select TOP (1) Certified   from SecurityBulletinToUserState WHERE SecurityBulletinID = sb.SecurityBulletinID
order by DateChanged DESC) as Certified

,(	SELECT nm  + '|' as 'data()' FROM
(
SELECT	DISTINCT  spprod.Name as nm 
	FROM	SecPatch_Patch AS spp2
	INNER JOIN SecPatch_AffectedProduct AS spa
	ON	spa.PatchID = spp2.PatchID
	INNER JOIN SecPatch_Product AS spprod
	ON	spprod.ProductID = spa.ProductID
 	WHERE spp2.BulletinID =   sb.BulletinID
) AS A
ORDER BY nm for xml path('')
) Products
	FROM SecurityBulletin AS sb
	INNER JOIN SecPatch_Bulletin AS spb ON sb.BulletinID = spb.BulletinID
	 
	ORDER BY
		sb.BulletinID

GO


IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetAllProducts')
	DROP PROCEDURE SecurityBulletinGetAllProducts
GO

CREATE PROCEDURE SecurityBulletinGetAllProducts
 
AS
	SELECT	spp.BulletinID, spprod.Name
	FROM	SecPatch_Patch AS spp
	INNER JOIN SecPatch_AffectedProduct AS spa
	ON	spa.PatchID = spp.PatchID
	INNER JOIN SecPatch_Product AS spprod
	ON	spprod.ProductID = spa.ProductID
 
 


GO









IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetPatches')
	DROP PROCEDURE SecurityBulletinGetPatches
GO
CREATE PROCEDURE SecurityBulletinGetPatches
	@bulletinid nvarchar(64)
AS
	SELECT	pp.PackageFullName,
		pf.PackageName,
		pv.Version,
		pv.[Size] / 1024 AS [Size]
	FROM	SecurityPatch AS sp,
		SecurityPatchToPackageVersion AS sppv,
		PackageVersion AS pv,
		PackagePath AS pp,
		PackageFamily AS pf
	WHERE	sp.BulletinID = @bulletinID
	AND	sppv.PatchID = sp.PatchID
	AND	pp.PackageFullName = sppv.PackageFullName
	AND	pv.PackagePathID = pp.PackagePathID
	AND	pv.PackageFamilyID = pf.PackageFamilyID
	AND pv.Version = sppv.Version
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinHide')
	DROP PROCEDURE SecurityBulletinHide
GO
CREATE PROCEDURE SecurityBulletinHide
	@bulletinid nvarchar(64)
AS
	UPDATE SecurityBulletin SET Hidden = 1 WHERE BulletinID = @bulletinid
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityPatchGetPolicies')
	DROP PROCEDURE SecurityPatchGetPolicies
GO
CREATE PROCEDURE SecurityPatchGetPolicies
	@patchId	int
AS
	SELECT	DISTINCT (d.DN + ' - ' + p.DisplayName) AS PolicyName
	FROM	Policy AS p,
		Domain AS d,
		PackageApplies AS pa,
		PackagePath AS pp,
		SecurityPatchToPackageVersion AS sppv
	WHERE	sppv.PatchID = @patchId
	  AND	pa.PackagePathID = pp.PackagePathID
	  AND	pa.PolicyGUID = p.GUID
	  AND	p.DomainID = d.OrganizationID
	  AND	pp.PackageFullName = sppv.PackageFullName

	RETURN	@@ROWCOUNT
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetTargetedPatches')
	DROP PROCEDURE SecurityBulletinGetTargetedPatches
GO
CREATE PROCEDURE SecurityBulletinGetTargetedPatches
	@bulletinId	nvarchar(64)
AS
	SELECT	DISTINCT	sp.PatchID,
				sppv.PackageName,
				sppv.PackageFullName,
				sppv.Version
	FROM	SecurityBulletin AS sb,
		SecurityPatch AS sp,
		SecurityPatchToPackageVersion AS sppv
	WHERE	sp.BulletinID = sb.BulletinID
	  AND	sp.PatchID = sppv.PatchID
	  AND	(
			EXISTS (
				SELECT	TOP 1 *
				FROM	DistributedPackage AS dp,
					PackageVersion AS pv,
					PackagePath AS pp
				WHERE	dp.RequestedVersionID = pv.PackageVersionID
				  AND	pv.PackagePathID = pp.PackagePathID
				  AND	sppv.PackageFullName = pp.PackageFullName
			)
		  OR	EXISTS (
				SELECT	TOP 1 *
				FROM	PackageApplies AS pa1,
					PackagePath AS pp
				WHERE	pa1.PackagePathID = pp.PackagePathID
				  AND	sppv.PackageFullName = pp.PackageFullName
			)
		  OR	EXISTS (
				SELECT	TOP 1 *
				FROM	PackageAllocation AS pa2,
					PackagePath AS pp
				WHERE	pa2.PackagePathID = pp.PackagePathID
				  AND	sppv.PackageFullName = pp.PackageFullName
			)
		)
	  AND	sb.State = 4
	  AND	sb.BulletinID = @bulletinId

	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetTargeted')
	DROP PROCEDURE SecurityBulletinGetTargeted
GO
CREATE PROCEDURE SecurityBulletinGetTargeted
AS
	SELECT	DISTINCT	sb.BulletinID,
				spb.Title,
				spb.DatePosted,
				CAST(spb.Summary AS nvarchar(4000)) AS Summary
	FROM	SecurityBulletin AS sb,
		SecurityPatch AS sp,
		SecurityPatchToPackageVersion AS sppv,
		SecPatch_Bulletin AS spb
	WHERE	sp.BulletinID = sb.BulletinID
	  AND	spb.BulletinID = sb.BulletinID
	  AND	sp.PatchID = sppv.PatchID
	  AND	(
			EXISTS (
				SELECT	TOP 1 *
				FROM	DistributedPackage AS dp,
					PackageVersion AS pv,
					PackagePath AS pp
				WHERE	dp.RequestedVersionID = pv.PackageVersionID
				  AND	pv.PackagePathID = pp.PackagePathID
				  AND	sppv.PackageFullName = pp.PackageFullName
			)
		  OR	EXISTS (
				SELECT	TOP 1 *
				FROM	PackageApplies AS pa1,
					PackagePath AS pp
				WHERE	pa1.PackagePathID = pp.PackagePathID
				  AND	sppv.PackageFullName = pp.PackageFullName
			)
		  OR	EXISTS (
				SELECT	TOP 1 *
				FROM	PackageAllocation AS pa2,
					PackagePath AS pp
				WHERE	pa2.PackagePathID = pp.PackagePathID
				  AND	sppv.PackageFullName = pp.PackageFullName
			)
		)
	  AND	sb.State = 4

	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityPatchSupercededBy')
	DROP PROCEDURE SecurityPatchSupercededBy
GO
CREATE PROCEDURE SecurityPatchSupercededBy
	@patchid int
AS
	SELECT	sp.patchid, sp.PatchName, sp.BulletinID, sp.PatchLocationID, sp.SQNumber, sp.SecurityPatchID
	FROM	SecPatch_Patch AS sp,
		SecurityPatchSupersede as sps
	WHERE	sps.OldSecurityPatchID = @patchid
	  AND	sp.SecurityPatchID = sps.NewSecurityPatchID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityPatchSupercedes')
	DROP PROCEDURE SecurityPatchSupercedes
GO
CREATE PROCEDURE SecurityPatchSupercedes
	@patchid int
AS
	SELECT	sp.patchid, sp.PatchName, sp.BulletinID, sp.PatchLocationID, sp.SQNumber, sp.SecurityPatchID
	FROM	SecPatch_Patch AS sp,
		SecurityPatchSupersede as sps
	WHERE	sps.NewSecurityPatchID = @patchid
	  AND	sp.SecurityPatchID = sps.OldSecurityPatchID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityPatchUIProductGroupGetGroupNames')
	DROP PROCEDURE SecurityPatchUIProductGroupGetGroupNames
GO
CREATE PROCEDURE SecurityPatchUIProductGroupGetGroupNames
AS
	SELECT DISTINCT GroupName FROM SecurityPatchUIProductGroup
GO

PRINT 'Creating procedure to get current PackageVersion by PackageFullName'
IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
	AND name = 'PackageVersionGetCurrent'
)
	DROP PROCEDURE PackageVersionGetCurrent
GO
CREATE PROCEDURE PackageVersionGetCurrent
	@PackageFullName		nvarchar(256)
AS BEGIN
	SELECT 	pv.* 
	FROM 	PackageVersion as pv,
		PackagePath as pp,
		MediaContainsPackageVersion as mcpv
	WHERE 	pp.PackageFullName = @PackageFullName
	  AND	pp.PackagePathID = pv.PackagePathID 
	  AND	pv.PackageVersionID = mcpv.PackageVersionID
	  AND	mcpv.MediaID = 1	-- Local Warehouse
	RETURN @@ROWCOUNT
END
GO

PRINT 'Creating procedure to delete resource by LanguageID'
IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
	AND name = 'ResourcesDeleteByLanguageID'
)
	DROP PROCEDURE ResourcesDeleteByLanguageID
GO
CREATE PROCEDURE ResourcesDeleteByLanguageID
	@LanguageID		nvarchar(6)
AS BEGIN

	DELETE 	SecurityPatchResource 
	FROM	SecurityPatchResource as spr,
		SecurityPatch as sp
	WHERE 	sp.PatchID = spr.SecurityPatchID
	  AND  	spr.LanguageID = @LanguageID
	  AND	(
	  	   sp.State = 1 OR
	   	   spr.Incorporate = 0
		)

	DELETE SecurityPatch
	WHERE NOT EXISTS (
		SELECT SecurityPatchID FROM SecurityPatchResource 
		WHERE SecurityPatchID = SecurityPatch.PatchID
	)
	AND BulletinID <> 'Unknown'
	
END
GO

PRINT 'Creating procedure to remove SecPatch Bulletin data by ErrataID'
IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
	AND name = 'SecPatchBulletinRemoveByErrataID'
)
	DROP PROCEDURE SecPatchBulletinRemoveByErrataID
GO
CREATE PROCEDURE SecPatchBulletinRemoveByErrataID
	@ErrataID NVARCHAR(64) = NULL
AS
BEGIN

	DELETE SecPatch_Bulletin 
	FROM SecPatch_Bulletin as spb
		INNER JOIN SecurityBulletin ON SecurityBulletin.BulletinID = spb.BulletinID
	WHERE SecurityBulletin.Errata = @ErrataID

END
GO

PRINT 'Creating procedure to remove Threats by name'
IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'ThreatRemoveByName'
)
	DROP PROCEDURE ThreatRemoveByName
GO
CREATE PROCEDURE ThreatRemoveByName
	@Name			nvarchar(128)
AS
BEGIN
	DELETE	Threat
	FROM	Threat
	WHERE	[Name] = @Name
END
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetAllDependenciesBySecurityBulletinID')
	DROP PROCEDURE SecurityBulletinGetAllDependenciesBySecurityBulletinID
GO
CREATE PROCEDURE SecurityBulletinGetAllDependenciesBySecurityBulletinID
	@SecurityBulletinID	int
AS
	SELECT
		sb.*
	FROM
		SecurityBulletinRequires AS sbr,
		SecurityBulletin AS sb
	WHERE
		sbr.SecurityBulletinID = @SecurityBulletinID
	  AND	sbr.RequiredBulletinID = sb.SecurityBulletinID
	ORDER BY
		sb.BulletinID
GO
-- USE ManageSoft
IF NOT EXISTS(SELECT * FROM Threat WHERE ThreatTypeID = 3)
BEGIN
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('Administrators', 'Administrators', 3, 2, 'Windows', 1, 'This check identifies and lists the individual user accounts that belong to the local Administrators group. If more than two individual administrator accounts are detected, Microsoft Baseline Security Analyzer will list the account names and flag the check as a potential vulnerability. In general, we recommend keeping the number of administrators to a minimum, because administrators essentially have complete control over the computer.')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('Auditing', 'Auditing', 3, 1, 'Windows', 1, 'This check determines whether auditing is enabled on the scanned computer. Microsoft Windows has an auditing feature that tracks and logs specific events on your system, such as successful and failed logon attempts. By monitoring your system''s event log, you can help identify potential security issues and malicious activity.

Additional Resources
Chapter3 - Audit Policy (Threats and Countermeasures Guide)
Chapter9 - Auditing and Intrusion Detection (Securing Windows2000 Server)

Windows Server2003: Auditing Security Events Best Practices')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('Autologon', 'Autologon', 3, 4, 'Windows', 1, 'This check determines whether the Auto Logon feature is enabled on the scanned computer, and if the logon password is encrypted in the registry or stored in plaintext. If Auto Logon is enabled and the logon password is stored as plaintext, the security report reflects this as a high-level vulnerability.

If Auto Logon is enabled and the password is encrypted in the registry, the security report reports this as a potential vulnerability.

Note:

If you get the message Error Reading Registry, the Remote Registry service might not be enabled.

Auto Logon stores your logon name and password in the registry, allowing you to automatically log on to Microsoft Windows Server2003, WindowsXP, Windows2000, or WindowsNT without typing your user name or password in the logon user interface. However, Auto Logon could also enable other users to access your files and use your name to commit malicious acts on the system. (For example, anyone with physical access to the computer can boot the operating system and automatically be logged on.) If you have Auto Logon enabled and you do not want to change it, make sure that you do not store any sensitive information on the computer.

You can store the password that you use for automatic logon as plaintext in the registry or you can encrypt it as a Local Security Authority (LSA) secret.

Additional Information

The credentials used to log on by default during automatic logon are located under the following registry key:

HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\WindowsNT\CurrentVersion\Winlogon

AutoAdminLogon REG_SZ 0 or 1 - Must be zero to remove this feature.

When you use AutoAdminLogon, Windows automatically logs on the specified user when the system is started, bypassing the CTRL+ALT+DEL logon dialog box. This is a serious security problem because anyone can gain access to your computer.

DefaultUserName REG_SZ Username
DefaultPassword REG_SZ Password

Specifies the password for the user listed under DefaultUserName.

If the password that you use for automatic logon is stored programmatically by using the LsaStorePrivateData API, it is encrypted and stored under the following registry keys:

HKEY_LOCAL_MACHINE\SECURITY\Policy\Secrets\DefaultPassword\CurrVal
HKEY_LOCAL_MACHINE\SECURITY\Policy\Secrets\DefaultPassword\OldVal

By encrypting the password as an LSA secret, you prevent remote users from reading a plaintext password that is stored under the Winlogon registry key. However, anyone with physical access to the computer can boot the system and automatically log on, whether the password is encrypted or in plaintext, which poses a security risk. ')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('Automatic Updates', 'Automatic Updates', 3, 3, 'Windows', 1, 'This check identifies whether the Automatic Updates feature is enabled on the scanned machine and if so, how it is configured. Automatic Updates can keep your computer up-to-date automatically with the latest updates from Microsoft by delivering them directly to your computer from the Windows Update site (or from a local Software Update Services (SUS) server if you are in a managed environment). Automatic Updates is available on Windows2000 SP3 machines and higher.

Automatic Updates can be configured to automatically download and install updates on a machine, automatically download but notify the user of updates before installing, or notify the user before both downloading and installing updates on a machine.

Additional Information

The Latest Improvements in Automatic Updates (for users running Windows 2000 Service Pack 3 and later)
Description of the Automatic Updates Feature in Windows
Software Update Services Deployment White Paper')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('CmdExec role', 'CmdExec role', 3, 2, 'SQL Server', 1, 'This check ensures that CmdExec rights are restricted to Sysadmin only. All other accounts that have CmdExec rights are listed on the security report.

Microsoft SQL Server Agent is a service available on Microsoft Windows Server2003, WindowsXP, Windows2000, and WindowsNT that executes jobs, monitors SQL Server, and sends alerts.  With SQL Server Agent, you can automate certain administrative tasks by using scripted job steps. A job is a specified series of operations performed sequentially by SQL Server Agent. A job can perform a wide range of activities, including running Transact-SQL scripts, command-line applications, and Microsoft ActiveX scripts. Jobs can be created to run tasks that are often repeated or scheduled, and they can automatically notify users of job status by generating alerts.

Note:

You must start the SQL Server Agent service before your local or multiserver administrative tasks can run automatically. SQL Server Agent is also supported on the Windows98 operating system, but SQL Server Agent cannot be used with Windows Authentication when you run it on Windows98.

Additional Information

SQL Server Agent Properties')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('Domain Controller Test - SQL Server', 'Domain Controller Test - SQL Server', 3, 2, 'SQL Server', 1, 'This check determines whether Microsoft SQL Server is running on a system that is a domain controller.

We recommend that you do not run SQL Server on a domain controller. Domain controllers contain sensitive data, such as user account information, and they should not be used in another role. If you run a SQL Server database on a domain controller, you increase the complexity involved in securing the server and protecting against attack.')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('Domain Controller Test - IIS', 'Domain Controller Test - IIS', 3, 2, 'IIS', 1, 'This check determines whether Internet Information Services (IIS) is running on a system that is a domain controller. This is flagged in the scan report as a high-level vulnerability, unless the computer being scanned is running Small Business Server.

We recommend that you do not run an IIS Web server on a domain controller. Domain controllers contain sensitive data, such as user account information, and they should not be used in another role. If you run a Web server on a domain controller, you increase the complexity involved in securing the server and preventing attacks.')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('Exposed SQL Server/MSDE Password', 'Exposed SQL Server/MSDE Password', 3, 4, 'SQL Server', 1, 'This check determines whether Microsoft SQL Server7.0 Service Pack1 (SP1), SQL Server7.0 SP2, or SQL Server7.0 SP3 sa (system administrator) account passwords are written in plaintext to the Setup.iss, Sqlstp.log, or SqlspX.log files in the %windir% and %windir%\%temp% directories. The Splstp.log or SqlspX.log file is also checked on SQL Server2000 if domain credentials are used in starting SQL Server services.

If Mixed Mode authentication is used while setting up SQL Server, the sa password is saved in plaintext format in the Setup.iss and Sqlstp.log files for SQL Server7.0 SP1, SQL Server7.0 SP2, and SQL Server7.0 SP3. Administrators using Windows Authentication Mode (which is the recommended mode) would only have credentials at risk if they chose to provide a domain credential to be used when starting the SQL Server services automatically.

Additional Information

Microsoft Security Bulletin MS02-035

FIX: Service Pack Installation May Save Standard Security Password in File (263968)

Microsoft Security Bulletin (MS00-035): Frequently Asked Questions')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('File System', 'File System', 3, 4, 'Windows', 1, 'This check determines the file system of each hard drive, to ensure that the NTFS file system is being used. NTFS is a secured file system that allows you to control or restrict access to individual files or directories. For example, if you want to allow your coworkers to view your files, but not change them, you can do this by using the access control lists (ACLs) provided by NTFS.

Note:

For this check to succeed, the drive must be shared using administrative drive shares.

Additional Information

Choosing between NTFS, FAT, and FAT32

How to Restore the Default NTFS Permissions for Windows2000')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('Folder Permissions', 'Folder Permissions', 3, 2, 'SQL Server', 1, 'This check verifies that the following Microsoft SQL Server directories have limited access to SQL Server service accounts and local Administrators only:

  Program Files\Microsoft SQL Server\MSSQL$InstanceName\Binn
  Program Files\Microsoft SQL Server\MSSQL$InstanceName\Data
  Program Files\Microsoft SQL Server\MSSQL\Binn
  Program Files\Microsoft SQL Server\MSSQL\Data

The tool scans the access control list (ACL) on each of these folders and enumerates the users contained in the ACL. If any other users (that is, aside from the SQL Server service accounts and Administrators) have access to read or modify these folders, the tool marks this check as a vulnerability in the security report.

Additional Resources

SQL Server7.0 Security

Microsoft SQL Server2000 Security')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('Guest Account - Windows', 'Guest Account - Windows', 3, 3, 'Windows', 1, 'This check determines whether the built-in Guest account is enabled on the scanned computer.

The Guest account is a built-in account used to log on to a computer running Microsoft Windows Server2003, WindowsXP, Windows2000, or WindowsNT, when a user does not have an account on the computer or domain, or in any of the domains trusted by the computer''s domain. Computers running WindowsXP map incoming user connections from across a network to the local Guest account (ForceGuest) when simple file sharing is enabled. This feature is configured under the ForceGuest registry setting. If the Guest account is enabled on computers running WindowsNT, Windows2000, Windows Server2003, or WindowsXP (not using simple file sharing; ForceGuest registry setting is disabled), it will be flagged in the security report as a vulnerability. If the Guest account is enabled on computers running WindowsXP that use simple file sharing (ForceGuest registry setting is enabled), it will not be flagged as a vulnerability.

Note:

The Guest account is disabled by default in WindowsXP Home Edition. However, only the guest''s ability to log on locally is affected. The account itself is not disabled for incoming user connections from across the network and can still be used with simple file sharing.

Additional Information

Description of File Sharing and Permissions in WindowsXP

What''s New in Security for WindowsXP Professional and WindowsXP Home Edition

Users overview
How to Set Security in Windows XP Professional That Is Installed in a Workgroup')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('Guest Account - SQL Server', 'Guest Account - SQL Server', 3, 3, 'SQL Server', 1, 'This check determines whether the Microsoft SQL Server Guest account has access to databases 
(excluding master, tempdb, and msdb). All databases to which the account has 
access are listed in the security report.

Note

    If you get the No permissions to access database error message, you might not have permissions to the master database.

In SQL Server, a user logon account must be authorized to access a database and its objects in one of the following ways:

  The logon account can be specified as a database user.
  The logon account can use a Guest account in the database.
  A Windows group logon can be mapped to a database role. Individual Windows accounts that are members of that group can then connect to the database.

      
Members of the db_owner or db_accessadmin database roles, or the Sysadmin fixed server role, create the database user account roles. An account can include several parameters: the SQL Server logon ID, database user name (optional), and up to one role name (optional). The database user name does not have to be the same as the user''s logon ID. If a database user name is not provided, the user''s logon ID and database user name are identical. After creating the database user, the user can be assigned to as many roles as necessary. If a role name is not provided, the database user is only a member of the public role.

Members of the db_owner, db_accessadmin, or Sysadmin roles can also create a Guest account. The Guest account allows any valid SQL Server logon account to access a database, even without a database user account. By default, the Guest account inherits any privileges that have been assigned to the public role. However, these privileges can be changed to be greater or less than that of the public role.
      
Additional Information

SQL Server Security Strategies

Establishing Application Security and Application Roles')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('IE Enhanced Security Configuration for Administrators', 'IE Enhanced Security Configuration for Administrators', 3, 5, 'Windows', 1, 'This check identifies whether the Internet Explorer Enhanced Security Configuration for Administrators has been enabled on computers running Microsoft Windows Server2003. If the Internet Explorer Enhanced Security Configuration for Administrators has been installed, this check will also identify Administrators who have the Internet Explorer Enhanced Security Configuration disabled.

The Windows Server2003 Internet Explorer Enhanced Security Configuration component (also known as Microsoft Internet Explorer hardening) reduces a servers vulnerability to attacks from Web content by applying more restrictive Internet Explorer security settings. Internet Explorer Enhanced Security Configuration places your server and Microsoft Internet Explorer in a configuration that decreases the exposure of your server to potential attacks that can occur through Web content and application scripts. Internet Explorer Enhanced Security Configuration is enabled on Windows Server2003 by default. It is possible to install Internet Explorer Enhanced Security Configuration individually for Administrators and for all other users. This check verifies that it is installed and enabled for all Administrators, but does not flag if individual settings with the configuration have been altered.

Installing Internet Explorer Enhanced Security Configuration for Administrators will enable the Internet Explorer Enhanced Security Configuration by default for all Administrators. It is, however, possible for individual Administrators or malicious software running with proper credentials to disable the Internet Explorer Enhanced Security Configuration by editing the registry. If the Internet Explorer Enhanced Security Configuration for Administrators has been installed, this check will identify those Administrators who have the Internet Explorer Enhanced Security Configuration disabled.

Additional Information

Managing Internet Explorer Enhanced Security Configuration')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('IE Enhanced Security Configuration for Non-Administrators', 'IE Enhanced Security Configuration for Non-Administrators', 3, 4, 'Windows', 1, 'This check identifies whether the Internet Explorer Enhanced Security Configuration for users other than Administrators has been enabled on computers running Microsoft Windows Server2003. If the Internet Explorer Enhanced Security Configuration for non-Administrators has been installed, this check will also identify non-Administrators who have the Internet Explorer Enhanced Security Configuration disabled.

The Windows Server2003 Internet Explorer Enhanced Security Configuration component (also known as Microsoft Internet Explorer hardening) reduces a servers vulnerability to attacks from Web content by applying more restrictive Internet Explorer security settings. Internet Explorer Enhanced Security Configuration places your server and Microsoft Internet Explorer in a configuration that decreases the exposure of your server to potential attacks that can occur through Web content and application scripts. Internet Explorer Enhanced Security Configuration is enabled on Windows Server2003 by default. It is possible to install Internet Explorer Enhanced Security Configuration individually for Administrators and for all other users. This check verifies that it is installed and enabled for all non-Administrators, but does not flag if individual settings with the configuration have been altered by the user.

Installing Internet Explorer Enhanced Security Configuration for non-Administrators will enable the Internet Explorer Enhanced Security Configuration by default for all non-Administrators. It is however, possible for individual Administrators or malicious software running with proper credentials to disable the Internet Explorer Enhanced Security Configuration by editing the registry. If the Internet Explorer Enhanced Security Configuration for non-Administrators has been installed, this check will identify those non-Administrators who have the Internet Explorer Enhanced Security Configuration disabled.

Additional Information

Managing Internet Explorer Enhanced Security Configuration')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('IE Zones', 'IE Zones', 3, 2, 'Windows', 1, 'This check lists the current and recommended security settings for the Microsoft Internet Explorer zones for each local user on the scanned computer.

When the security level is customized or when individual settings have been modified through means other than the Internet Options dialog box, individual settings that are set below the recommended level will be identified.

Note:

If you get the message Error Reading Registry, the Remote Registry service might not be enabled.

The Microsoft Internet Explorer Web content zones divide the Internet or intranet into zones with different levels of security. This capability permits you to set global default settings for the browser, to allow all content on trusted sites or to disallow certain types of content, such as Java applets or ActiveXcontrols, depending on the Web site of origin.

The Internet Explorer browsing software comes with four predefined Web content zones: Internet, Local intranet, Trusted sites, and Restricted sites.

In the Internet Options dialog box, you can set the security options you want for each zone, and then add or remove sites from any zone (except Internet), depending on your level of trust in the site. In corporate environments, administrators can set up zones for users. They can also add or remove (in advance) the authentication certificates of software publishers that they do or do not trust, so that users do not have to make security decisions while they are using the Internet.

For each security zone, you can choose a high, medium, medium-low, low, or custom security setting. The high setting is recommended for sites in zones of uncertain trustworthiness. The custom choice provides advanced users and administrators with more control over all security options, including the following:

  Access to files, ActiveX controls, and scripts.
  Level of capabilities given to Java applets.
  Site identity designation with Secure Sockets Layer (SSL) authentication.
  Password protection with NTLM authentication. (Depending on which zone a server is in, Internet Explorer can send password information automatically, prompt the user for user and password information, or deny any logon request.)

On systems that have Internet Explorer Enhanced Security Configuration installed, the settings are checked against the default recommended levels for this configuration.

Additional Information

About URL Security Zones Templates

How to Use Security Zones in Internet Explorer (174360)

Managing Internet Explorer Enhanced Security Configuration')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('IIS Lockdown Tool', 'IIS Lockdown Tool', 3, 5, 'IIS', 1, 'This check determines whether version2.1 of the Internet Information Services (IIS) Lockdown tool, part of the Microsoft Security Tool Kit, has been run on the scanned computer.

The IIS Lockdown tool works by turning off unnecessary features in IIS, thereby reducing the attack surface available to attackers. Using the IIS Lockdown tool should be one of the first steps administrators take in securing their Web servers.

Note:

The IIS Lockdown tool was developed for IIS4.0, 5.0, and 5.1, and is not needed for new Microsoft Windows Server2003 installations running IIS6.0. If an upgrade is being performed from IIS5.0 to IIS6.0, then the lockdown tool should be run.

Additional Resources

IIS Lockdown Tool')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('IIS Logging Enabled', 'IIS Logging Enabled', 3, 4, 'IIS', 1, 'This check determines whether Internet Information Services (IIS) logging is enabled, and if the W3C Extended Log File Format is used.

IIS logging goes beyond the scope of the event logging or performance monitoring features of Windows. The logs can include information, such as who has visited your site, what the visitor viewed, and when the information was viewed last. You can monitor attempts, either successful or unsuccessful, to access your Web sites, virtual folders, or files. This includes events such as reading the file or writing to the file. You can choose which events you want to audit for any site, virtual folder, or file. By regularly reviewing these files, you can detect areas of your server or your sites that may be subject to attacks or other security problems. You can enable logging for individual Web sites and choose the log format. When logging is enabled, it is enabled for all the site''s folders, but you can disable it for specific directories.

Additional Information

HOW TO: Enable IIS Logging Site Activity (300390)')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('IIS Status', 'IIS Status', 3, 4, 'IIS', 1, '')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('IISAdmin Virtual Directory', 'IIS Admin Virtual Directory', 3, 3, 'IIS', 1, 'This check determines whether the IISADMPWD directory is installed on the scanned computer.

Internet Information Server (IIS)4.0 enables users to change their Windows passwords and to notify users that their passwords are about to expire. The IISADMPWD virtual directory that installs as part of the default Web site in IIS4.0 contains files that are used by this feature. This feature is implemented as a set of .htr files located in the system\System32\Inetsrv\Iisadmpwd directory and an ISAPI extension named Ism.dll.

Additional Information

How to Change WindowsNT Account Passwords Using Internet Information Server (IIS)4.0 (184619)

IISADMPWD Virtual Directory Is Not Created During Clean Install of IIS5.0 (269082)')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('Local Account Password Test', 'Local Account Password Test', 3, 5, 'Password', 1, 'This check identifies any blank or simple passwords for each local user account on the computer. This check is not performed on domain controllers. Microsoft Windows Server2003, WindowsXP, Windows2000, and WindowsNT operating systems all require user authentication through passwords. In general, users are permitted to choose their own passwords. The security of their account depends on the choice of the password. This check enumerates all user accounts and checks for the following password conditions:

Password is blank.
Password is the same as the user account name.
Password is the same as the machine name.
Password uses the word password.
Password uses the word admin or administrator.

This check also notifies you of any accounts that have been disabled or are currently locked out.

For WindowsXP machines that use simple file sharing (includes WindowsXP Home Edition and WindowsXP Professional machines not joined to a domain), MBSA will not flag local accounts with blank passwords. To help protect users who do not password-protect their accounts, WindowsXP Professional accounts without passwords can only be used to log on at the physical computer console. By default, accounts with blank passwords can no longer be used to log on to the computer remotely over the network, or for any other logon activity except at the main physical console logon screen.

Note:

Microsoft Baseline Security Analyzer does not attempt to crack passwords during this check, and instead attempts a password change request using each condition in the preceding list. Account lockout policy counts will be reset if in effect on the scanned machine.

Additional Resources

What''s New in Security for WindowsXP Professional and WindowsXP Home Edition

Creating Strong Passwords

How to Enable Strong Password Functionality in WindowsNT')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('Macro Security', 'Macro Security', 3, 3, 'Windows', 1, 'This check determines the security level for Microsoft OfficeSystem2003, OfficeXP, Office2000, and Office97 macro protection on a user-by-user basis. The following Office products are checked: PowerPoint, Word, Excel, and Outlook.

Macros automate repetitive tasks. They can be time-saving tools, but macros can also be used to transmit viruses when a user opens an infected document containing a malicious macro. Opening or sharing an infected document can enable the malicious macro to spread to other documents on your system, or to other users.

Additional Resources

WD: Frequently Asked Questions About Word Macro Viruses (187243)')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('MSADC and Scripts Virtual Directories', 'MSADC and Scripts Virtual Directories', 3, 4, 'IIS', 1, 'This check determines whether the MSADC (sample data access scripts) and Scripts virtual directories are installed on a scanned server running Internet Information Services (IIS). These directories typically contain scripts that, if not required, should be removed to help reduce the attack surface of the computer.

Additional Resources

IIS Lockdown Tool')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('Outlook Zones', 'Outlook Zones', 3, 3, 'Windows', 1, '')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('Parent Paths', 'Parent Paths', 3, 2, 'IIS', 1, 'This check determines whether the AspEnableParentPaths setting is enabled on the scanned computer.

By enabling parent paths on Microsoft Internet Information Services (IIS), pages in Active Server Pages (ASP) can use relative paths to the parent directory of the current directory (that is, paths that use the .. syntax).

Additional Information

AspEnableParentPaths MetaBase Property Should Be Set To False (184717)')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('Password Expiration', 'Password Expiration', 3, 5, 'Password', 1, 'This check determines whether any local accounts have passwords that do not expire.

Each local user account that has a password that does not expire will be listed in the security scan report, with the exception of any user accounts specified in the NoExpireOk.txt file in the MBSA installation folder.

Passwords should be changed regularly to prevent password attacks.')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('Registry Permissions', 'Registry Permissions', 3, 5, 'SQL Server', 1, 'This check ensures that the Everyone group is restricted to Read permission for the following registry keys:

HKLM\Software\Microsoft\Microsoft SQL Server
HKLM\Software\Microsoft\MSSQLServer

If the Everyone group has more than Read permission to these keys, it will be flagged in the security scan report as a high-level vulnerability.

Additional Information

SQL Server7.0 Security

Microsoft SQL Server2000 Security')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('Restrict Anonymous', 'Restrict Anonymous', 3, 4, 'Windows', 1, 'This check determines whether the RestrictAnonymous registry setting is used to restrict anonymous connections on the scanned computer.

Anonymous users can list certain types of system information, including user names and details, account policies, and share names. Users who want enhanced security can restrict this function so that anonymous users cannot access this information.

Additional Information

The RestrictAnonymous registry setting controls the level of enumeration that is granted to an anonymous user. You can set this to any of the following values:

0 - None. Rely on default permissions.
1 - Do not allow enumeration of Security Accounts Manager (SAM) accounts and names.
2 - No access without explicit anonymous permissions (not available on Microsoft WindowsNT4.0).

We do not recommend setting RestrictAnonymous to 2 on domain controllers or on computers running Small Business Server (SBS) unless they are in pure Windows2000 environments and have been tested for application compatibility. For more details on configuring RestrictAnonymous on domain controllers and in Windows2000 environments, and to better understand potential compatibility issues when using this setting, refer to the Microsoft Knowledge Base articles that are listed later in this document.

Note:

In WindowsXP, there is a new registry setting (EveryoneIncludesAnonymous) that controls whether permissions given to the built-in Everyone group apply to anonymous users. By default, permissions granted to the Everyone group do not apply to anonymous users in WindowsXP, which therefore provides the same level of anonymous user restrictions as the RestrictAnonymous setting in previous Windows operating systems.

Additional Resources

Restricting Information Available to Anonymous Logon Users (143474) (WindowsNT4.0)

How to Use the RestrictAnonymous Registry Value in Windows2000 (246261)')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('Sample Applications', 'Sample Applications', 3, 2, 'IIS', 1, 'This check determines whether the following Internet Information Services (IIS) sample file directories are installed on the scanned computer:

  \Inetpub\iissamples
  \Winnt\help\iishelp
  \Program Files\common files\system\msadc

The sample applications typically installed with IIS illustrate dynamic HTML (DHTML) and Active Server Pages (ASP) scripting, and provide online documentation.')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('Service Accounts', 'Service Accounts', 3, 4, 'SQL Server', 1, 'This check determines whether the Microsoft SQL Server service accounts are members of the local Administrators or Domain Admins groups on the scanned computer, or whether any SQL Server service accounts are running under the LocalSystem context.

The MSSQLServer and SQLServerAgent service accounts are checked on the scanned computer.

Note:

If you receive the No permissions to access database error message, you might not have permissions to the master database.

Additional Resources

SQL Server7.0 Security

Microsoft SQL Server2000 Security')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('Services', 'Services', 3, 4, 'Windows', 1, 'This check determines whether any services contained in the Services.txt file are installed on the scanned computer, and lists the files with their current state (enabled or disabled). The Services.txt file is a configurable list of services to be checked on the scanned computers. The Services.txt file, installed by default with the tool, contains the following services:

MSFTPSVC (FTP)
TlntSvr (Telnet)
W3SVC (WWW)
SMTPSVC (SMTP)

In Microsoft WindowsXP, Windows2000 and WindowsNT4.0, a service is a program that runs in the background whenever the computer is running the operating system. It does not require a user to be logged on. Services are needed to perform user-independent tasks, such as a fax service that waits for incoming faxes.')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('Shares', 'Shares', 3, 4, 'Windows', 1, '')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('SQL Server/MSDE Account Password Test', 'SQL Server/MSDE Account Password Test', 3, 5, 'SQL Server', 1, 'This check identifies any blank or simple passwords for each local Microsoft SQL Server account on the computer.

Microsoft WindowsServer 2003, Windows XP, Windows2000, and WindowsNT operating systems all require user authentication through passwords. In general, users are permitted to choose their own passwords. The security of their account depends on the choice of the password. This check enumerates all user accounts and checks for the following password conditions:

Password is blank.
Password is the same as the user account name.
Password is the same as the machine name.
Password uses the word password.
Password uses the word sa.
Password uses the word admin or administrator.

This check also notifies you of any accounts that have been disabled or are currently locked out.

Note:

Microsoft Baseline Security Analyzer does not attempt to crack passwords during this check, and instead attempts a password change request using each condition in the preceding list. Account lockout policy counts will be reset if in effect on the scanned machine.

Additional Information

Implementing Guidelines for Strong Passwords

Assigning an sa Password')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('SQL Server/MSDE Installed', 'SQL Server/MSDE Installed', 3, 2, 'SQL Server', 1, '')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('SQL Server/MSDE Security Mode', 'SQL Server/MSDE Security Mode', 3, 3, 'SQL Server', 1, 'This check determines the authentication mode used on the computer running Microsoft SQL Server that is being scanned.

SQL Server provides two modes for securing access to the server: Windows Authentication Mode and Mixed Mode.

In Windows Authentication Mode, SQL Server relies solely on the Windows authentication of the user. Windows users or groups are then granted access to the computer running SQL Server. In Mixed Mode, users may be authenticated by Windows or by SQL Server. Users that are authenticated by SQL Server have their user name and password pairs maintained within the computer running SQL Server.

Windows Authentication Mode

This security mode allows SQL Server to rely on Windows to authenticate users in the same way as other applications. Connections made to the server using this mode are called trusted connections.

When you use Windows Authentication Mode, the database administrator allows users to access the computer running SQL Server by granting them the right to log on to SQL Server. Windows security identifiers (SIDs) are used to track Windows authenticated users. As Windows SIDs are used, the database administrator can grant access directly to Windows users or groups.

Mixed Mode

In SQL Server, Mixed Mode relies on Windows to authenticate users when the client and server are capable of using NTLM or Kerberos logon authentication protocols. If either party is incapable of using a standard Windows logon, SQL Server requires a user name and password pair, and compares this pair against those stored in its system tables. Connections that rely on user name and password pairs are called non-trusted.

Mixed Mode is supplied for two reasons:

Backward compatibility with older versions of SQL Server
Compatibility when SQL Server is installed on Windows95 and Windows98 operating systems (Trusted connections are not supported on computers running Windows95 or Windows98 when they are acting as the server.)

Additional Information

SQL Server7.0 Security

Microsoft SQL Server2000 Security

Microsoft Security Bulletin (MS00-035): Frequently Asked Questions')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('SQL Server/MSDE Status', 'SQL Server/MSDE Status', 3, 1, 'SQL Server', 1, '')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('SQL Server/MSDE Version', 'SQL Server/MSDE Version', 3, 1, 'SQL Server', 1, '')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('Sysadmin role members', 'Sysadmin role members', 3, 4, 'SQL Server', 1, 'This check determines whether the built-in Administrators group is listed as a member of the Sysadmin role on Microsoft SQL Server.

Note:

If you get the No permissions to access database error message, you might not have permissions to the master database.

A SQL Server role is a security account that is a collection of other security accounts. It can be treated as a single unit when you are managing permissions. A role can contain SQL Server logon permissions, other roles, and Windows user accounts or groups.

Fixed server roles have a server-wide scope. They exist outside of the databases. Each member of a fixed server role is able to add other logons to that same role. All members of the Windows BUILTIN\Administrators group (the local Administrators group) are members of the Sysadmin role by default, which gives them full access to all of your databases.

Additional Information

SQL Server7.0 Security

Microsoft SQL Server2000 Security')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('Sysadmins', 'Sysadmins', 3, 2, 'SQL Server', 1, 'This check determines the number of members of the Sysadmin role and displays the results in the security report.

Microsoft SQL Server roles are used to group together logons that have the same rights to perform operations. The fixed server role, Sysadmin, gives system administrator rights to all of its members.

Note:

If you get the No permissions to access database error message, you might not have permissions to the master database.

Additional Information

SQL Server7.0 Security

Microsoft SQL Server2000 Security')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('Windows Firewall', 'Windows Firewall', 3, 5, 'Windows', 1, 'This check identifies whether Internet Connection Firewall (ICF) is enabled on the scanned machine, for all active network connections, and whether any static inbound ports are open in the firewall. ICF is firewall software that provides protection for computers by controlling what information is communicated from your machine to and from the Internet or other machines on a network. ICF is included in WindowsXP and Windows Server2003 Standard Edition and Enterprise Edition.

Note:

This check is performed during local machine scans only. MBSA also does not detect whether another firewall (either hardware or software) is installed and protecting the scanned machine.

Additional Information

The Latest Improvements in the Windows Firewall (for users running Windows XP Service Pack 2 and later, or service packs for Windows Server 2003)

Using the Internet Connection Firewall in WindowsXP Home Edition

Using the Internet Connection Firewall in WindowsXP Professional

Learn About Firewalls')
	INSERT Threat (Name, Title, ThreatTypeID, ThreatRiskID, CategorySummary, State, Description) VALUES ('Windows Version', 'Windows Version', 3, 3, 'Windows', 1, 'This check determines which operating system is running on the scanned computer.

Microsoft Windows Server2003, WindowsXP, and Windows2000 introduced new levels of reliability and availability for all of your business operations, such as improved control over file permissions.

Additional Information

Windows Server2003

Windows2000 Server

Windows2000 Advanced Server

WindowsXP')
END
GO

IF NOT EXISTS(SELECT * FROM ThreatToCategory)
BEGIN
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (1, 1)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (1, 2)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (1, 3)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (1, 4)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (4, 5)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (4, 6)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (3, 7)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (4, 8)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (1, 9)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (4, 10)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (1, 11)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (4, 12)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (1, 13)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (1, 14)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (1, 15)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (3, 16)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (3, 17)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (3, 18)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (3, 19)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (2, 20)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (1, 21)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (3, 22)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (1, 23)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (3, 24)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (2, 25)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (4, 26)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (1, 27)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (3, 28)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (4, 29)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (1, 30)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (1, 31)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (4, 32)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (4, 33)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (4, 34)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (4, 35)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (4, 36)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (4, 37)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (4, 38)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (1, 39)
	INSERT INTO ThreatToCategory (ThreatCategoryID, ThreatID)
		VALUES (1, 40)
END
GO
-- USE ManageSoft

/*
 * $Id: Malware.sql 86710 2008-03-03 04:05:34Z smani $
 *
 * Stored procedures to produce reports on Malware info.
 */

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'ComputerCountByMalware')
	DROP PROCEDURE ComputerCountByMalware
GO
CREATE PROCEDURE ComputerCountByMalware
	@RDomDN              nvarchar(101) = '%',
	@ROUDN               nvarchar(401) = '%',
	@ComputerCN          nvarchar(64) = '%',
	@Name    	     nvarchar(128) = '%',
	@Type    	     nvarchar(128) = '%',
	@Severity            int = 0
AS
	SELECT	CASE WHEN threat.ThreatID IS NULL THEN 0 ELSE threat.ComputerCount END AS ComputerCount,
		t.Name,
		t.CategorySummary AS Type,
		UPPER(LEFT(tr.[Name],1)) + RIGHT(tr.[Name], LEN(tr.[Name]) - 1) AS Risk
	FROM	Threat AS t
	LEFT OUTER JOIN	ThreatRisk AS tr
	ON t.ThreatRiskID = tr.ThreatRiskID
	LEFT OUTER JOIN
	(
		SELECT	t.ThreatID,
			SUM(CASE WHEN tocc.ThreatID IS NULL THEN 0 ELSE 1 END) AS ComputerCount
		FROM	Threat AS t
		LEFT OUTER JOIN ThreatOccurrence AS tocc
		ON	tocc.ThreatID = t.ThreatID
		  AND	tocc.ThreatActionID IN (1, 3) -- threat is infection or quarantined
		INNER JOIN ComputerDirectory AS cd
		ON	cd.ComputerID = tocc.ComputerID
		WHERE	t.[Name] LIKE @Name
		  AND	(@Severity < 1 OR t.ThreatRiskID = @Severity)
		  AND	cd.DomainDNReverse LIKE @RDomDN
		  AND	dbo.LikeNullable(cd.OURDNReverse, @ROUDN) = 1
		  AND	cd.ComputerCN LIKE @ComputerCN
		GROUP BY t.ThreatID
	) AS threat
	ON threat.ThreatID = t.ThreatID
	WHERE	t.ThreatTypeID = 1 -- threat is malware
	  AND	t.Name LIKE @Name
	  AND	(@Severity < 1 OR t.ThreatRiskID = @Severity)
	  AND	t.CategorySummary LIKE '%' + @Type + '%'
	ORDER BY t.Name ASC

	RETURN @@ROWCOUNT
GO
CopyPermission 'ComputerCountByMalware', 'mgsOSBreakdown'
GO


IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'AllComputerByMalware')
	DROP PROCEDURE AllComputerByMalware
GO
CREATE PROCEDURE AllComputerByMalware
	@RDomDN              nvarchar(101) = '%',
	@ROUDN               nvarchar(401) = '%',
	@ComputerCN	     nvarchar(64) = '%',
	@Name    	     nvarchar(128) = '%'
AS
	--
	-- ComputerDirectory appends a comma to OURDNReverse, which cannot be passed through our
	-- reports infrastructure in a drill through (our RDL parser is not sophisticated enough
	-- to be able to parse the necessary script), so we have to explicitly add the a to
	-- the ROUDN coming into this procedure. This is dodgy!!
	--
	IF	@ROUDN IS NOT NULL
	  AND	NOT SUBSTRING(@ROUDN, LEN(@ROUDN), 1) = ','
	  AND	NOT SUBSTRING(@ROUDN, LEN(@ROUDN), 1) = '%'
	BEGIN
		SET @ROUDN = @ROUDN + ','
	END

	SELECT	cd.ComputerCN,
		cd.OURDNReverse AS OUDN,
		t.Name,
		t.CategorySummary AS Type,
		UPPER(LEFT(tr.[Name],1)) + RIGHT(tr.[Name], LEN(tr.[Name]) - 1) AS Risk,
		CASE tocc.ThreatActionID
			WHEN 1 THEN 'Infected'
			WHEN 3 THEN 'Quarantined'
		END As Status
	FROM	ComputerDirectory AS cd
	INNER JOIN ThreatOccurrence AS tocc
	ON	tocc.ComputerID = cd.ComputerID
	  AND	tocc.ThreatActionID IN (1, 3) -- threat is infection or quarantined
	INNER JOIN Threat AS t
	ON	t.ThreatID = tocc.ThreatID
	  AND	t.Name LIKE @Name
	  AND	t.ThreatTypeID = 1 -- threat is malware
	INNER JOIN ThreatRisk AS tr
	ON t.ThreatRiskID = tr.ThreatRiskID
	WHERE	cd.ComputerCN LIKE @ComputerCN
	  AND	cd.DomainDNReverse LIKE @RDomDN
	  AND	dbo.LikeNullable(cd.OURDNReverse, '%') = 1
GO
CopyPermission 'AllComputerByMalware', 'mgsOSBreakdown'
GO


IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'AllMalwareByComputer')
	DROP PROCEDURE AllMalwareByComputer
GO
CREATE PROCEDURE AllMalwareByComputer
	@RDomDN              nvarchar(101) = '%',
	@ROUDN               nvarchar(401) = '%',
	@ComputerCN	     nvarchar(64) = '%'
AS
	--
	-- ComputerDirectory appends a comma to OURDNReverse, which cannot be passed through our
	-- reports infrastructure in a drill through (our RDL parser is not sophisticated enough
	-- to be able to parse the necessary script), so we have to explicitly add the a to
	-- the ROUDN coming into this procedure. This is dodgy!!
	--
	IF	@ROUDN IS NOT NULL
	  AND	NOT SUBSTRING(@ROUDN, LEN(@ROUDN), 1) = ','
	  AND	NOT SUBSTRING(@ROUDN, LEN(@ROUDN), 1) = '%'
	BEGIN
		SET @ROUDN = @ROUDN + ','
	END

	SELECT	cd.ComputerCN,
		cd.OURDNReverse AS OUDN,
		t.Name,
		t.CategorySummary AS Type,
		UPPER(LEFT(tr.[Name],1)) + RIGHT(tr.[Name], LEN(tr.[Name]) - 1) AS Risk,
		CASE tocc.ThreatActionID
			WHEN 1 THEN 'Infected'
			WHEN 3 THEN 'Quarantined'
		END As Status
	FROM	ComputerDirectory AS cd
	INNER JOIN ThreatOccurrence AS tocc
	ON	tocc.ComputerID = cd.ComputerID
	  AND	tocc.ThreatActionID IN (1, 3) -- threat is infection or quarantined
	INNER JOIN Threat AS t
	ON	t.ThreatID = tocc.ThreatID
	  AND	t.ThreatTypeID = 1 -- threat is malware
	INNER JOIN ThreatRisk AS tr
	ON t.ThreatRiskID = tr.ThreatRiskID
	WHERE	cd.ComputerCN LIKE @ComputerCN
	  AND	cd.DomainDNReverse LIKE @RDomDN
	  AND	dbo.LikeNullable(cd.OURDNReverse, '%') = 1
GO
CopyPermission 'AllMalwareByComputer', 'mgsOSBreakdown'
GO


IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'ComputerCountByUnresolvedMalware')
	DROP PROCEDURE ComputerCountByUnresolvedMalware
GO
CREATE PROCEDURE ComputerCountByUnresolvedMalware
	@RDomDN              nvarchar(101) = '%',
	@ROUDN               nvarchar(401) = '%',
	@ComputerCN          nvarchar(64) = '%',
	@Name    	     nvarchar(128) = '%',
	@Type    	     nvarchar(128) = '%',
	@Severity            int = 0
AS
	SELECT	SUM(CASE WHEN tocc.ThreatID IS NULL THEN 0 ELSE 1 END) AS ComputerCount,
		t.Name,
		t.CategorySummary AS Type,
		UPPER(LEFT(tr.[Name],1)) + RIGHT(tr.[Name], LEN(tr.[Name]) - 1) AS Risk
	FROM	Threat AS t
	LEFT OUTER JOIN ThreatRisk AS tr
	ON	t.ThreatRiskID = tr.ThreatRiskID
	INNER JOIN ThreatOccurrence AS tocc
	ON	tocc.ThreatID = t.ThreatID
	  AND	tocc.ThreatActionID IN (1, 3) -- threat is infection or quarantined
	LEFT OUTER JOIN ComputerDirectory AS cd
	ON	cd.ComputerID = tocc.ComputerID
	  AND	cd.DomainDNReverse LIKE @RDomDN
	  AND	dbo.LikeNullable(cd.OURDNReverse, @ROUDN) = 1
	  AND	cd.ComputerCN LIKE @ComputerCN
	WHERE	t.Name LIKE @Name
	  AND	t.ThreatTypeID = 1 -- threat is malware
	  AND	(@Severity < 1 OR t.ThreatRiskID = @Severity)
	  AND	t.CategorySummary LIKE '%' + @Type + '%'
	GROUP BY t.Name,
		t.CategorySummary,
		tr.[Name]
	ORDER BY t.Name ASC
GO
CopyPermission 'ComputerCountByUnresolvedMalware', 'mgsOSBreakdown'
GO


IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'MalwareCountByComputer')
	DROP PROCEDURE MalwareCountByComputer
GO
CREATE PROCEDURE MalwareCountByComputer
	@RDomDN              nvarchar(101) = '%',
	@ROUDN               nvarchar(401) = '%',
	@ComputerCN          nvarchar(64) = '%'
AS
	SELECT	cd.ComputerCN,
		cd.OURDNReverse AS ROUDN,
		SUM(CASE WHEN tocc.ThreatID IS NULL THEN 0 ELSE 1 END) AS Occurrences
	FROM	ComputerDirectory AS cd
	INNER JOIN ThreatScan AS ts
	ON	ts.ComputerID = cd.ComputerID
	  AND	ts.ThreatTypeID = 1
	LEFT OUTER JOIN ThreatOccurrence AS tocc
	ON	tocc.ComputerID = cd.ComputerID
	  AND	tocc.ThreatTypeID = 1 -- threat is malware
	  AND	tocc.ThreatActionID IN (1, 3) -- threat is infection or quarantined
	WHERE	cd.DomainDNReverse LIKE @RDomDN
	  AND	dbo.LikeNullable(cd.OURDNReverse, @ROUDN) = 1
	  AND	cd.ComputerCN LIKE @ComputerCN
	GROUP BY cd.ComputerCN, cd.OURDNReverse
GO
CopyPermission 'MalwareCountByComputer', 'mgsOSBreakdown'
GO


IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'ComputerCountByVulnerability')
	DROP PROCEDURE ComputerCountByVulnerability
GO
CREATE PROCEDURE ComputerCountByVulnerability
	@RDomDN              nvarchar(101) = '%',
	@ROUDN               nvarchar(401) = '%',
	@ComputerCN          nvarchar(64) = '%',
	@Name    	     nvarchar(128) = '%',
	@Type    	     nvarchar(128) = '%',
	@Severity            int = 0, 
	@VulnerabilityState  int = 1
AS
	SELECT	SUM(CASE WHEN tocc.ThreatID IS NULL THEN 0 ELSE 1 END) AS ComputerCount,
		t.Name,
		t.CategorySummary AS Type,
		UPPER(LEFT(tr.[Name],1)) + RIGHT(tr.[Name], LEN(tr.[Name]) - 1) AS Risk
	FROM	Threat AS t
	LEFT OUTER JOIN ThreatRisk AS tr
	ON	t.ThreatRiskID = tr.ThreatRiskID
	LEFT OUTER JOIN ThreatOccurrence AS tocc
	ON	tocc.ThreatID = t.ThreatID
	  AND	tocc.ThreatOccurrenceRiskID > 2
	LEFT OUTER JOIN ComputerDirectory AS cd
	ON	cd.ComputerID = tocc.ComputerID
	  AND	cd.DomainDNReverse LIKE @RDomDN
	  AND	dbo.LikeNullable(cd.OURDNReverse, @ROUDN) = 1
	  AND	cd.ComputerCN LIKE @ComputerCN
	WHERE	t.Name LIKE @Name
	  AND	t.ThreatTypeID = 3 -- threat is vulnerability
	  AND (@Severity < 1 OR t.ThreatRiskID = @Severity)
	  AND (t.State = @VulnerabilityState)
	  AND t.CategorySummary LIKE '%' + @Type + '%'
	GROUP BY t.Name,
		t.CategorySummary,
		tr.[Name]
	ORDER BY t.Name ASC

	RETURN @@ROWCOUNT
GO
CopyPermission 'ComputerCountByVulnerability', 'mgsOSBreakdown'
GO


IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'ComputerCountByUnresolvedVulnerability')
	DROP PROCEDURE ComputerCountByUnresolvedVulnerability
GO
CREATE PROCEDURE ComputerCountByUnresolvedVulnerability
	@RDomDN              nvarchar(101) = '%',
	@ROUDN               nvarchar(401) = '%',
	@ComputerCN          nvarchar(64) = '%',
	@Name    	     nvarchar(128) = '%',
	@Type    	     nvarchar(128) = '%',
	@Severity            int = 0,
	@VulnerabilityState  int = 1
AS
	SELECT	SUM(CASE WHEN tocc.ThreatID IS NULL THEN 0 ELSE 1 END) AS ComputerCount,
		t.Name,
		t.CategorySummary AS Type,
		UPPER(LEFT(tr.[Name],1)) + RIGHT(tr.[Name], LEN(tr.[Name]) - 1) AS Risk
	FROM	Threat AS t
	LEFT OUTER JOIN ThreatRisk AS tr
		ON	t.ThreatRiskID = tr.ThreatRiskID
	LEFT OUTER JOIN ThreatOccurrence AS tocc
		ON	tocc.ThreatID = t.ThreatID
	LEFT OUTER JOIN ComputerDirectory AS cd
		ON	cd.ComputerID = tocc.ComputerID
	WHERE	t.Name LIKE @Name
		AND	t.ThreatTypeID = 3 -- threat is vulnerability
		AND (@Severity < 1 OR t.ThreatRiskID = @Severity)
		AND (t.State = @VulnerabilityState)
		AND t.CategorySummary LIKE '%' + @Type + '%'
		AND cd.DomainDNReverse LIKE @RDomDN
		AND dbo.LikeNullable(cd.OURDNReverse, @ROUDN) = 1
		AND cd.ComputerCN LIKE @ComputerCN
		AND tocc.ThreatOccurrenceRiskID > 2
	GROUP BY t.Name,
		t.CategorySummary,
		tr.[Name]
	ORDER BY t.Name ASC

	RETURN @@ROWCOUNT
GO
CopyPermission 'ComputerCountByUnresolvedVulnerability', 'mgsOSBreakdown'
GO


IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'AllComputersHavingVulnerability')
	DROP PROCEDURE AllComputersHavingVulnerability
GO
CREATE PROCEDURE AllComputersHavingVulnerability
	@RDomDN              nvarchar(101) = '%',
	@ROUDN               nvarchar(401) = '%',
	@ComputerCN          nvarchar(64) = '%',
	@Name    	     nvarchar(128) = '%',
	@Type    	     nvarchar(128) = '%',
	@Severity            int = 0, 
	@VulnerabilityState  int = 1
AS
	--
	-- ComputerDirectory appends a comma to OURDNReverse, which cannot be passed through our
	-- reports infrastructure in a drill through (our RDL parser is not sophisticated enough
	-- to be able to parse the necessary script), so we have to explicitly add the a to
	-- the ROUDN coming into this procedure. This is dodgy!!
	--
	IF	@ROUDN IS NOT NULL
	  AND	NOT SUBSTRING(@ROUDN, LEN(@ROUDN), 1) = ','
	  AND	NOT SUBSTRING(@ROUDN, LEN(@ROUDN), 1) = '%'
	BEGIN
		SET @ROUDN = @ROUDN + ','
	END

	SELECT	cd.ComputerCN AS ComputerCN,
		cd.OURDNReverse AS ROUDN,
		t.Name,
		t.CategorySummary AS Type,
		UPPER(LEFT(tr.[Name],1)) + RIGHT(tr.[Name], LEN(tr.[Name]) - 1) AS Risk,
		tocc.Details
	FROM	Threat AS t
	INNER JOIN ThreatOccurrence AS tocc
	ON	tocc.ThreatID = t.ThreatID
	INNER JOIN ThreatRisk AS tr
	ON	tocc.ThreatOccurrenceRiskID = tr.ThreatRiskID
	  AND	tocc.ThreatOccurrenceRiskID > 2
	INNER JOIN ComputerDirectory AS cd
	ON	cd.ComputerID = tocc.ComputerID
	  AND	cd.DomainDNReverse LIKE @RDomDN
	  AND	dbo.LikeNullable(cd.OURDNReverse, @ROUDN) = 1
	  AND	cd.ComputerCN LIKE @ComputerCN
	WHERE	t.Name LIKE @Name
		AND	t.ThreatTypeID = 3 -- threat is vulnerability
		AND (@Severity < 1 OR t.ThreatRiskID = @Severity)
		AND (t.State = @VulnerabilityState)
		AND t.CategorySummary LIKE '%' + @Type + '%'
	ORDER BY cd.ComputerCN, t.Name ASC

	RETURN @@ROWCOUNT
GO
CopyPermission 'AllComputersHavingVulnerability', 'mgsOSBreakdown'
GO


IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'AllVulnerabilitiesByComputer')
	DROP PROCEDURE AllVulnerabilitiesByComputer
GO
CREATE PROCEDURE AllVulnerabilitiesByComputer
	@RDomDN              nvarchar(101) = '%',
	@ROUDN               nvarchar(401) = '%',
	@ComputerCN          nvarchar(64) = '%',
	@VulnerabilityState  int = 1
AS
	--
	-- ComputerDirectory appends a comma to OURDNReverse, which cannot be passed through our
	-- reports infrastructure in a drill through (our RDL parser is not sophisticated enough
	-- to be able to parse the necessary script), so we have to explicitly add the a to
	-- the ROUDN coming into this procedure. This is dodgy!!
	--
	IF	@ROUDN IS NOT NULL
	  AND	NOT SUBSTRING(@ROUDN, LEN(@ROUDN), 1) = ','
	  AND	NOT SUBSTRING(@ROUDN, LEN(@ROUDN), 1) = '%'
	BEGIN
		SET @ROUDN = @ROUDN + ','
	END

	SELECT	cd.ComputerCN AS ComputerCN,
		cd.OURDNReverse AS ROUDN,
		t.Name,
		t.CategorySummary AS Type,
		UPPER(LEFT(tr.[Name],1)) + RIGHT(tr.[Name], LEN(tr.[Name]) - 1) AS Risk,
		tocc.Details
	FROM	Threat AS t
	INNER JOIN ThreatOccurrence AS tocc
	ON	tocc.ThreatID = t.ThreatID
	  AND	tocc.ThreatTypeID = 3 -- threat is vulnerability
	  AND	tocc.ThreatOccurrenceRiskID > 2
	INNER JOIN ThreatRisk AS tr
	ON	tocc.ThreatOccurrenceRiskID = tr.ThreatRiskID
	INNER JOIN ComputerDirectory AS cd
	ON	cd.ComputerID = tocc.ComputerID
	  AND	cd.DomainDNReverse LIKE @RDomDN
	  AND	dbo.LikeNullable(cd.OURDNReverse, @ROUDN) = 1
	  AND	cd.ComputerCN LIKE @ComputerCN
	  AND   t.State = @VulnerabilityState
	ORDER BY cd.ComputerCN, t.Name ASC

	RETURN @@ROWCOUNT
GO
CopyPermission 'AllVulnerabilitiesByComputer', 'mgsOSBreakdown'
GO


IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'VulnerabilityCountByComputer')
	DROP PROCEDURE VulnerabilityCountByComputer
GO
CREATE PROCEDURE VulnerabilityCountByComputer
	@RDomDN              nvarchar(101) = '%',
	@ROUDN               nvarchar(401) = '%',
	@ComputerCN          nvarchar(64) = '%'
AS
	SELECT	SUM(CASE WHEN tocc.ThreatID IS NULL THEN 0 ELSE 1 END) AS Occurrences,
		cd.ComputerCN,
		cd.OURDNReverse AS ROUDN
	FROM	ComputerDirectory AS cd
	INNER JOIN ThreatScan AS ts
	ON	ts.ComputerID = cd.ComputerID
	  AND	ts.ThreatTypeID = 3
	LEFT OUTER JOIN ThreatOccurrence AS tocc
	ON	tocc.ComputerID = cd.ComputerID
	  AND	tocc.ThreatTypeID = 3
	  AND	tocc.ThreatOccurrenceRiskID > 2
	WHERE	cd.DomainDNReverse LIKE @RDomDN
	  AND	dbo.LikeNullable(cd.OURDNReverse, @ROUDN) = 1
	  AND	cd.ComputerCN LIKE @ComputerCN
	GROUP BY cd.ComputerCN, cd.OURDNReverse
GO
CopyPermission 'VulnerabilityCountByComputer', 'mgsOSBreakdown'
GO


IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'MalwareUnresolvedCountByComputer')
	DROP PROCEDURE MalwareUnresolvedCountByComputer
GO
CREATE PROCEDURE MalwareUnresolvedCountByComputer
	@RDomDN              nvarchar(101) = '%',
	@ROUDN               nvarchar(401) = '%',
	@ComputerCN          nvarchar(64) = '%'
AS
	SELECT	cd.ComputerCN,
		cd.OURDNReverse AS ROUDN,
		SUM(CASE WHEN tocc.ThreatID IS NULL THEN 0 ELSE 1 END) AS Occurrences
	FROM	ComputerDirectory AS cd
	INNER JOIN ThreatOccurrence AS tocc
	ON	tocc.ComputerID = cd.ComputerID
	  AND	tocc.ThreatTypeID = 1 -- threat is malware
	  AND	tocc.ThreatActionID IN (1, 3) -- threat is infection or quarantined
	WHERE	cd.DomainDNReverse LIKE @RDomDN
	  AND	dbo.LikeNullable(cd.OURDNReverse, @ROUDN) = 1
	  AND	cd.ComputerCN LIKE @ComputerCN
	GROUP BY cd.ComputerCN, cd.OURDNReverse
GO
CopyPermission 'MalwareUnresolvedCountByComputer', 'mgsOSBreakdown'
GO


IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'VulnerabilityUnresolvedCountByComputer')
	DROP PROCEDURE VulnerabilityUnresolvedCountByComputer
GO
CREATE PROCEDURE VulnerabilityUnresolvedCountByComputer
	@RDomDN              nvarchar(101) = '%',
	@ROUDN               nvarchar(401) = '%',
	@ComputerCN          nvarchar(64) = '%'
AS
	SELECT	SUM(CASE WHEN tocc.ThreatID IS NULL THEN 0 ELSE 1 END) AS Occurrences,
		cd.ComputerCN,
		cd.OURDNReverse AS ROUDN
	FROM	ComputerDirectory AS cd
	INNER JOIN ThreatOccurrence AS tocc
	ON	tocc.ComputerID = cd.ComputerID
	  AND	tocc.ThreatTypeID = 3
	  AND	tocc.ThreatOccurrenceRiskID > 2
	WHERE	cd.DomainDNReverse LIKE @RDomDN
	  AND	dbo.LikeNullable(cd.OURDNReverse, @ROUDN) = 1
	  AND	cd.ComputerCN LIKE @ComputerCN
	GROUP BY cd.ComputerCN, cd.OURDNReverse
GO
CopyPermission 'VulnerabilityUnresolvedCountByComputer', 'mgsOSBreakdown'
GO


IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'ScanMalwareResultsByComputer')
	DROP PROCEDURE ScanMalwareResultsByComputer
GO
CREATE PROCEDURE ScanMalwareResultsByComputer
	@RDomDN              nvarchar(101) = '%',
	@ROUDN               nvarchar(401) = '%',
	@ComputerCN          nvarchar(64) = '%'
AS
	SELECT	cd.ComputerCN,
		cd.OURDNReverse AS ROUDN,
		DataSourceDate AS DataSourceDate,
		DataSourceVersion AS DataSourceVersion,
		ts.ScanStart,
		ts.ScanEnd
	FROM	ThreatScan AS ts
	INNER JOIN ComputerDirectory AS cd
	ON	cd.ComputerID = ts.ComputerID
		AND ts.ThreatScannerID > 0
		AND ts.ThreatTypeID = 1 -- threat is malware
	WHERE	cd.ComputerCN LIKE @ComputerCN
		AND cd.DomainDNReverse LIKE @RDomDN
		AND dbo.LikeNullable(cd.OURDNReverse, @ROUDN) = 1
	ORDER BY cd.ComputerCN ASC

	RETURN @@ROWCOUNT
GO
CopyPermission 'ScanMalwareResultsByComputer', 'mgsOSBreakdown'
GO


IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'ScanVulnerabilityResultsByComputer')
	DROP PROCEDURE ScanVulnerabilityResultsByComputer
GO
CREATE PROCEDURE ScanVulnerabilityResultsByComputer
	@RDomDN              nvarchar(101) = '%',
	@ROUDN               nvarchar(401) = '%',
	@ComputerCN          nvarchar(64) = '%'
AS
	SELECT	cd.ComputerCN,
		cd.OURDNReverse AS ROUDN,
		DataSourceDate AS DataSourceDate,
		DataSourceVersion AS DataSourceVersion,
		ScanStart AS ScanStart,
		ScanEnd AS ScanEnd
	FROM	ThreatScan AS ts
	INNER JOIN ComputerDirectory AS cd
	ON	cd.ComputerID = ts.ComputerID
	  AND	ts.ThreatScannerID > 0
	  AND	ts.ThreatTypeID = 3 -- threat is vulnerability
	WHERE	cd.ComputerCN LIKE @ComputerCN
	  AND	cd.DomainDNReverse LIKE @RDomDN
	  AND	dbo.LikeNullable(cd.OURDNReverse, @ROUDN) = 1
	ORDER BY cd.ComputerCN ASC

	RETURN @@ROWCOUNT
GO
CopyPermission 'ScanVulnerabilityResultsByComputer', 'mgsOSBreakdown'
GO
-- REVISIT: Need to remove this file from SM installer - replaced by rows in schema
Use ManageSoft
GO

PRINT 'Creating procedure to get DeviceEvent (Arrival/Removal) details for the report'
IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
	AND [name] = 'GetDeviceArriveRemoveEventReport')

	DROP PROCEDURE GetDeviceArriveRemoveEventReport
GO

CREATE PROCEDURE GetDeviceArriveRemoveEventReport
	@RDomDN		nvarchar(101) = '%',
	@ROUDN		nvarchar(401) = '%',
	@ComputerCN 	nvarchar(64) = '%'
AS
BEGIN

	SELECT	DeviceEvent.DeviceEventID AS DEID,
		DeviceEvent.DateTime,
		DeviceEvent.DeviceClass,
		DeviceEvent.Enabled, 
		cd.ComputerCN,
		EventClass.Name AS EventClass,
		CASE WHEN [User].UserCN IS NULL
			THEN 'PotentialDeviceUsers'
			ELSE [User].UserCN
		END AS UserCN,
		DeviceEvent.ComputerID, 
        	CASE WHEN DeviceEvent.UserID IS NULL
			THEN 1
			ELSE DeviceEvent.UserID
		END AS UserID
	FROM    
		(
		SELECT * FROM ComputerDirectory
		WHERE
			DomainDNReverse LIKE @RDomDN
			AND	dbo.LikeNullable(OURDNReverse, @ROUDN) = 1
			AND	dbo.LikeNullable(ComputerCN, @ComputerCN) = 1
		) AS cd
	INNER JOIN
        	DeviceEvent ON cd.ComputerID = DeviceEvent.ComputerID
	INNER JOIN
        	EventClass ON DeviceEvent.EventID = EventClass.EventClassID
	LEFT OUTER JOIN
        	[User] ON DeviceEvent.UserID = [User].UserID
	WHERE
		EventClass.EventClassID = 1 OR EventClass.EventClassID = 2

END
GO

CopyPermission 'GetDeviceArriveRemoveEventReport', 'mgsOSBreakdown'
GO

PRINT 'Creating procedure to get DeviceEvent (Override) details for the report'
IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
	AND [name] = 'GetDeviceOverrideEventReport')

	DROP PROCEDURE GetDeviceOverrideEventReport
GO

CREATE PROCEDURE GetDeviceOverrideEventReport 
	@RDomDN		nvarchar(101) = '%',
	@ROUDN		nvarchar(401) = '%',
	@ComputerCN 	nvarchar(64) = '%'
AS
BEGIN

	SELECT	DeviceEvent.DeviceEventID AS DEID,
		DeviceEvent.DateTime,
		DeviceEvent.DeviceClass,
		DeviceEvent.Enabled, 
		cd.ComputerCN,
		CASE WHEN [User].UserCN IS NULL
			THEN 'PotentialDeviceUsers'
			ELSE [User].UserCN
		END AS UserCN,
		DeviceEvent.ComputerID, 
        	CASE WHEN DeviceEvent.UserID IS NULL
			THEN 1
			ELSE DeviceEvent.UserID
		END AS UserID
	FROM    
		(
		SELECT * FROM ComputerDirectory
		WHERE
			DomainDNReverse LIKE @RDomDN
			AND	dbo.LikeNullable(OURDNReverse, @ROUDN) = 1
			AND	dbo.LikeNullable(ComputerCN, @ComputerCN) = 1
		) AS cd
	INNER JOIN
        	DeviceEvent ON cd.ComputerID = DeviceEvent.ComputerID
	INNER JOIN
        	EventClass ON DeviceEvent.EventID = EventClass.EventClassID
	LEFT OUTER JOIN
        	[User] ON DeviceEvent.UserID = [User].UserID
	WHERE
		EventClass.EventClassID = 3

END
GO

CopyPermission 'GetDeviceOverrideEventReport', 'mgsOSBreakdown'
GO

PRINT 'Creating procedure to get SessionStateEvent details for the report, parameters are optional'
IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
	AND [name] = 'GetSessionStateEventReport ')

	DROP PROCEDURE GetSessionStateEventReport 
GO

CREATE PROCEDURE GetSessionStateEventReport 
	@ComputerID int = NULL,
	@UserID int = NULL,
	@DateTime datetime = NULL
AS
BEGIN

	SELECT	sse.ComputerID,
		sse.UserID,
		Computer.ComputerCN,
		[User].UserCN,
		sse.[DateTime],
		EventClass.[Name] AS EventClass,
		sse.Client AS Client,
		sse.EventDescription
	FROM 	SessionStateEvent AS sse
	INNER JOIN
		EventClass ON 
		sse.EventID = EventClass.EventClassID
	INNER JOIN
		Computer ON 
		sse.ComputerID = Computer.ComputerID
	INNER JOIN
		[User] ON 
		sse.UserID = [User].UserID

	WHERE 
		(@ComputerID = NULL AND @UserID = NULL AND @DateTime = NULL)
		OR 
		(Computer.ComputerID = @ComputerID 
			AND ((([User].UserID = @UserID) AND (@UserID <> 1)) OR @UserID = 1)
			AND 
			((
				(sse.[DateTime] <= @DateTime AND EventClass.EventClassID = 10)
				AND
				NOT EXISTS (
					SELECT * FROM SessionStateEvent AS T
					WHERE
						T.ComputerID = Computer.ComputerID AND
						T.UserID = [User].UserID AND
						T.[DateTime] < @DateTime AND
						T.[DateTime] > sse.[DateTime] AND
						(T.EventID = 10 OR T.EventID = 11) AND
						T.Client = sse.Client
				)
			)
			OR
			(
				(sse.[DateTime] <= @DateTime AND EventClass.EventClassID = 14)
				AND
				NOT EXISTS (
					SELECT * FROM SessionStateEvent AS T
					WHERE
						T.ComputerID = Computer.ComputerID AND
						T.UserID = [User].UserID AND
						T.[DateTime] < @DateTime AND
						T.[DateTime] > sse.[DateTime] AND
						T.EventID = 14 AND
						T.Client = sse.Client		
				)
			)
			OR
			(
				(sse.[DateTime] > @DateTime AND EventClass.EventClassID = 14)
				AND
				NOT EXISTS (
					SELECT * FROM SessionStateEvent AS T
					WHERE
						T.ComputerID = Computer.ComputerID AND
						T.UserID = [User].UserID AND
						T.[DateTime] > @DateTime AND
						T.[DateTime] < sse.[DateTime] AND
						T.EventID = 14 AND
						T.Client = sse.Client		
				)
			)
			OR
			(
				(sse.[DateTime] <= @DateTime AND EventClass.EventClassID = 15)
				AND
				NOT EXISTS (
					SELECT * FROM SessionStateEvent AS T
					WHERE
						T.ComputerID = Computer.ComputerID AND
						T.UserID = [User].UserID AND
						T.[DateTime] < @DateTime AND
						T.[DateTime] > sse.[DateTime] AND
						T.EventID = 15 AND
						T.Client = sse.Client		
				)
			)
			OR
			(
				(sse.[DateTime] > @DateTime AND EventClass.EventClassID = 15)
				AND
				NOT EXISTS (
					SELECT * FROM SessionStateEvent AS T
					WHERE
						T.ComputerID = Computer.ComputerID AND
						T.UserID = [User].UserID AND
						T.[DateTime] > @DateTime AND
						T.[DateTime] < sse.[DateTime] AND
						T.EventID = 15 AND
						T.Client = sse.Client		
				)
			)

			)
		)		
END
GO

CopyPermission 'GetSessionStateEventReport', 'mgsOSBreakdown'
GO

PRINT 'Creating procedure to get DeviceEvent summmary details for the report'
IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
	AND [name] = 'GetDeviceEventSummaryReport')

	DROP PROCEDURE GetDeviceEventSummaryReport
GO

CREATE PROCEDURE GetDeviceEventSummaryReport
	@DEID int = NULL
AS	
		SELECT	'ComputerCN' AS Property,
			(SELECT Computer.ComputerCN
			 FROM	Computer 
				INNER JOIN DeviceEvent 
				ON Computer.ComputerID = DeviceEvent.ComputerID
			 WHERE	DeviceEvent.DeviceEventID = @DEID
			) AS Value

	UNION	SELECT	'UserCN' AS Property,
			(SELECT CASE WHEN [User].UserCN IS NULL 
				THEN 'UndeterminedUser' 
				ELSE [User].UserCN 
				END AS UserCN
			 FROM	DeviceEvent
				LEFT OUTER JOIN [User] 
				ON DeviceEvent.UserID = [User].UserID
			 WHERE	DeviceEvent.DeviceEventID = @DEID
			) AS Value

	UNION	SELECT	'DateTime' AS Property,
			(SELECT CONVERT(NVARCHAR, [DateTime])
			 FROM	DeviceEvent
			 WHERE	DeviceEvent.DeviceEventID = @DEID 		
			) AS Value

	UNION	SELECT	'DeviceName' AS Property,
			(SELECT	CASE WHEN DATALENGTH(RTRIM(DeviceName)) = 0 THEN 'Unavailable' ELSE DeviceName END AS DeviceName
			 FROM 	DeviceEvent
			 WHERE 	DeviceEvent.DeviceEventID = @DEID
			) AS Value

	UNION	SELECT	'DeviceClass' AS Property,
			(SELECT	CASE WHEN DATALENGTH(RTRIM(DeviceClass)) = 0 THEN 'Unavailable' ELSE DeviceClass END AS DeviceClass
			 FROM 	DeviceEvent
			 WHERE 	DeviceEvent.DeviceEventID = @DEID
			) AS Value

	UNION	SELECT	'DeviceID' AS Property,
			(SELECT	DeviceID
			 FROM 	DeviceEvent
			 WHERE 	DeviceEvent.DeviceEventID = @DEID
			) AS Value

	UNION	SELECT	'DeviceStatus' AS Property,
			(SELECT	CASE WHEN Enabled = 1 THEN 'Enabled' ELSE 'Disabled' END AS Enabled
			 FROM 	DeviceEvent
			 WHERE 	DeviceEvent.DeviceEventID = @DEID
			) AS Value

	UNION	SELECT	'EventClass' AS Property,
			(SELECT	EventClass.[Name]
			 FROM 	DeviceEvent
				INNER JOIN EventClass
				ON DeviceEvent.EventID = EventClass.EventClassID
			 WHERE 	DeviceEvent.DeviceEventID = @DEID
			) AS Value

	UNION	SELECT	'EventDescription' AS Property,
			(SELECT	CASE WHEN DATALENGTH(RTRIM(EventDescription)) = 0 THEN 'Unavailable' ELSE EventDescription END AS EventDescription
			 FROM 	DeviceEvent
			 WHERE 	DeviceEvent.DeviceEventID = @DEID
			) AS Value
	
	OPTION(ROBUST PLAN)

GO

CopyPermission 'GetDeviceEventSummaryReport', 'mgsOSBreakdown'
GO

