USE ManageSoft
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedProductGetByAffectedProductID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedProductGetByAffectedProductID]
GO
CREATE PROCEDURE [dbo].[SecPatch_AffectedProductGetByAffectedProductID]
	@AffectedProductID	int
AS
	SELECT	AffectedProductID,
		ProductID,
		FixedInSP,
		PatchID
	FROM	[dbo].[SecPatch_AffectedProduct]
	WHERE	AffectedProductID = @AffectedProductID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedProductGetAllByPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedProductGetAllByPatchID]
GO
CREATE PROCEDURE [dbo].[SecPatch_AffectedProductGetAllByPatchID]
	@PatchID		int
AS
	SELECT	AffectedProductID,
		ProductID,
		FixedInSP,
		PatchID
	FROM	[dbo].[SecPatch_AffectedProduct]
	WHERE	PatchID = @PatchID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedProductGetAllOrderedByPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedProductGetAllOrderedByPatchID]
GO
CREATE PROCEDURE [dbo].[SecPatch_AffectedProductGetAllOrderedByPatchID]
AS
	SELECT	AffectedProductID,
		ProductID,
		FixedInSP,
		PatchID
	FROM	[dbo].[SecPatch_AffectedProduct]
	ORDER BY PatchID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedProductGetByProductIDPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedProductGetByProductIDPatchID]
GO
CREATE PROCEDURE [dbo].[SecPatch_AffectedProductGetByProductIDPatchID]
	@ProductID		int,
	@PatchID		int
AS
	SELECT	AffectedProductID,
		ProductID,
		FixedInSP,
		PatchID
	FROM	[dbo].[SecPatch_AffectedProduct]
	WHERE	ProductID = @ProductID
	  AND	PatchID = @PatchID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedProductGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedProductGetAll]
GO
CREATE PROCEDURE [dbo].[SecPatch_AffectedProductGetAll]
AS
	SELECT	AffectedProductID,
		ProductID,
		FixedInSP,
		PatchID
	FROM	[dbo].[SecPatch_AffectedProduct]
	ORDER BY AffectedProductID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedProductAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedProductAdd]
GO
CREATE PROCEDURE [dbo].[SecPatch_AffectedProductAdd]
	@ProductID		int,
	@FixedInSP		int,
	@PatchID		int
AS
	INSERT INTO  dbo.SecPatch_AffectedProduct (
		ProductID,
		FixedInSP,
		PatchID
	)
	VALUES (
		@ProductID,
		@FixedInSP,
		@PatchID
	)
	RETURN SCOPE_IDENTITY()
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedProductBind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedProductBind]
GO
CREATE PROCEDURE [dbo].[SecPatch_AffectedProductBind]
	@ProductID		int,
	@FixedInSP		int,
	@PatchID		int
AS
	DECLARE	@ID	int

	SELECT	@ID = AffectedProductID
	FROM	[dbo].[SecPatch_AffectedProduct]
	WHERE	ProductID = @ProductID
	  AND	PatchID = @PatchID

	IF @ID IS NULL
		EXEC @ID = SecPatch_AffectedProductAdd @ProductID,
			@FixedInSP,
			@PatchID

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedProductSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedProductSchema]
GO
CREATE PROCEDURE [dbo].[SecPatch_AffectedProductSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecPatch_AffectedProduct'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecPatch_AffectedProduct (' + CAST(0x0A AS CHAR(1)) +
	'		AffectedProductID	int NULL,' + CAST(0x0A AS CHAR(1)) +
	'		ProductID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		FixedInSP		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		PatchID			int NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecPatch_AffectedProduct' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedProductTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedProductTempAdd]
GO
CREATE PROCEDURE dbo.[SecPatch_AffectedProductTempAdd]
	@AffectedProductID	int,
	@ProductID		int,
	@FixedInSP		int,
	@PatchID		int
AS
	INSERT INTO #SecPatch_AffectedProduct (
		AffectedProductID,
		ProductID,
		FixedInSP,
		PatchID
	)
	VALUES (
		@AffectedProductID,
		@ProductID,
		@FixedInSP,
		@PatchID
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedProductAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedProductAddBatch]
GO
CREATE PROCEDURE dbo.[SecPatch_AffectedProductAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecPatch_AffectedProduct (
		ProductID,
		FixedInSP,
		PatchID
	)
		SELECT	ProductID,
			FixedInSP,
			PatchID
		FROM #SecPatch_AffectedProduct
	SET @count = @@ROWCOUNT
	DROP TABLE #SecPatch_AffectedProduct	-- Drop temporary table
	RETURN @count
GO

/*
Add new SecPatch_AffectedProduct bound to
	SecPatch_Patch using BulletinID, PatchName with PatchLocationID, SQNumber, NoReboot, SecurityPatchID
	SecPatch_Product using Name
	with FixedInSP
*/

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedProductUpdateByAffectedProductID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedProductUpdateByAffectedProductID]
GO
CREATE PROCEDURE [dbo].[SecPatch_AffectedProductUpdateByAffectedProductID]
	@AffectedProductID	int,
	@ProductID		int,
	@FixedInSP		int,
	@PatchID		int
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[SecPatch_AffectedProduct]
	SET	@ID = AffectedProductID,
		ProductID = @ProductID,
		FixedInSP = @FixedInSP,
		PatchID = @PatchID
	WHERE	AffectedProductID = @AffectedProductID
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedProductUpdateBatchByAffectedProductID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedProductUpdateBatchByAffectedProductID]
GO
CREATE PROCEDURE dbo.[SecPatch_AffectedProductUpdateBatchByAffectedProductID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecPatch_AffectedProductAffectedProductID]
		ON #SecPatch_AffectedProduct (AffectedProductID)

	UPDATE	[dbo].[SecPatch_AffectedProduct]
	SET	ProductID = t.ProductID,
		FixedInSP = t.FixedInSP,
		PatchID = t.PatchID
	FROM	#SecPatch_AffectedProduct AS t
	WHERE	SecPatch_AffectedProduct.AffectedProductID = t.AffectedProductID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecPatch_AffectedProduct	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedProductUpdateByProductIDPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedProductUpdateByProductIDPatchID]
GO
CREATE PROCEDURE [dbo].[SecPatch_AffectedProductUpdateByProductIDPatchID]
	@ProductID		int,
	@PatchID		int,
	@FixedInSP		int
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[SecPatch_AffectedProduct]
	SET	@ID = AffectedProductID,
		FixedInSP = @FixedInSP
	WHERE	ProductID = @ProductID
	  AND	PatchID = @PatchID
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedProductUpdateBatchByProductIDPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedProductUpdateBatchByProductIDPatchID]
GO
CREATE PROCEDURE dbo.[SecPatch_AffectedProductUpdateBatchByProductIDPatchID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecPatch_AffectedProductProductIDPatchID]
		ON #SecPatch_AffectedProduct (ProductID, PatchID)

	UPDATE	[dbo].[SecPatch_AffectedProduct]
	SET	FixedInSP = t.FixedInSP
	FROM	#SecPatch_AffectedProduct AS t
	WHERE	SecPatch_AffectedProduct.ProductID = t.ProductID
	  AND	SecPatch_AffectedProduct.PatchID = t.PatchID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecPatch_AffectedProduct	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedProductPutByProductIDPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedProductPutByProductIDPatchID]
GO
CREATE PROCEDURE [dbo].[SecPatch_AffectedProductPutByProductIDPatchID]
	@ProductID		int,
	@PatchID		int,
	@FixedInSP		int
AS
	DECLARE @ID	int

	SELECT	@ID = AffectedProductID
	FROM	SecPatch_AffectedProduct
	WHERE	ProductID = @ProductID
	  AND	PatchID = @PatchID

	IF @ID IS NULL
		EXEC @ID = SecPatch_AffectedProductAdd @ProductID,
			@FixedInSP,
			@PatchID
	ELSE
		EXEC SecPatch_AffectedProductUpdateByProductIDPatchID @ProductID,
			@PatchID,
			@FixedInSP

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedProductPutBatchByProductIDPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedProductPutBatchByProductIDPatchID]
GO
CREATE PROCEDURE [dbo].[SecPatch_AffectedProductPutBatchByProductIDPatchID]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecPatch_AffectedProductProductIDPatchID]
		ON #SecPatch_AffectedProduct (ProductID, PatchID)

	BEGIN TRANSACTION
	UPDATE [dbo].[SecPatch_AffectedProduct]
		SET	FixedInSP = t.FixedInSP
		FROM	#SecPatch_AffectedProduct AS t
		WHERE	SecPatch_AffectedProduct.ProductID = t.ProductID
		  AND	SecPatch_AffectedProduct.PatchID = t.PatchID
	SET @count = @@ROWCOUNT

	INSERT [dbo].[SecPatch_AffectedProduct] (
		ProductID,
		FixedInSP,
		PatchID
	)
		SELECT	ProductID,
			FixedInSP,
			PatchID
		FROM	#SecPatch_AffectedProduct AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecPatch_AffectedProduct]
			WHERE	SecPatch_AffectedProduct.ProductID = t.ProductID
			  AND	SecPatch_AffectedProduct.PatchID = t.PatchID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecPatch_AffectedProduct	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedProductRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedProductRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecPatch_AffectedProductRemoveBatch]
AS

	CREATE INDEX [TempSecPatch_AffectedProductSecPatch_AffectedProductRemoveBatch]
		ON #SecPatch_AffectedProduct (AffectedProductID)	

	-- Delete records from SecPatch_AffectedProduct identified by fields of [TempSecPatch_AffectedProductSecPatch_AffectedProductRemoveBatch]
	DELETE [dbo].[SecPatch_AffectedProduct]
	WHERE EXISTS(
			SELECT * FROM #SecPatch_AffectedProduct AS t
			WHERE	SecPatch_AffectedProduct.AffectedProductID = t.AffectedProductID
		)
	DROP TABLE #SecPatch_AffectedProduct      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedProductRemoveAllByPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedProductRemoveAllByPatchID]
GO
CREATE PROCEDURE [dbo].[SecPatch_AffectedProductRemoveAllByPatchID]
	@PatchID		int
AS
	DELETE	[dbo].[SecPatch_AffectedProduct]
	WHERE	PatchID = @PatchID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedProductRemoveByProductIDPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedProductRemoveByProductIDPatchID]
GO
CREATE PROCEDURE [dbo].[SecPatch_AffectedProductRemoveByProductIDPatchID]
	@ProductID		int,
	@PatchID		int
AS
	-- SecPatch_AffectedProduct deletes cascade to:
	--	SecPatch_AffectedServicePack by FK_AffectedServicePack_AffectedProduct
	DELETE	[dbo].[SecPatch_AffectedProduct]
	WHERE	ProductID = @ProductID
	  AND	PatchID = @PatchID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedProductRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedProductRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecPatch_AffectedProductRemoveAll]
	
AS
	DELETE	[dbo].[SecPatch_AffectedProduct]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedServicePackGetByAffectedServicePackID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedServicePackGetByAffectedServicePackID]
GO
CREATE PROCEDURE [dbo].[SecPatch_AffectedServicePackGetByAffectedServicePackID]
	@AffectedServicePackID	int
AS
	SELECT	AffectedServicePackID,
		AffectedProductID,
		ServicePackID
	FROM	[dbo].[SecPatch_AffectedServicePack]
	WHERE	AffectedServicePackID = @AffectedServicePackID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedServicePackGetAllOrderedByAffectedServicePackID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedServicePackGetAllOrderedByAffectedServicePackID]
GO
CREATE PROCEDURE [dbo].[SecPatch_AffectedServicePackGetAllOrderedByAffectedServicePackID]
AS
	SELECT	AffectedServicePackID,
		AffectedProductID,
		ServicePackID
	FROM	[dbo].[SecPatch_AffectedServicePack]
	ORDER BY AffectedServicePackID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedServicePackGetByAffectedProductIDServicePackID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedServicePackGetByAffectedProductIDServicePackID]
GO
CREATE PROCEDURE [dbo].[SecPatch_AffectedServicePackGetByAffectedProductIDServicePackID]
	@AffectedProductID	int,
	@ServicePackID		int
AS
	SELECT	AffectedServicePackID,
		AffectedProductID,
		ServicePackID
	FROM	[dbo].[SecPatch_AffectedServicePack]
	WHERE	AffectedProductID = @AffectedProductID
	  AND	ServicePackID = @ServicePackID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedServicePackGetAllByAffectedProductID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedServicePackGetAllByAffectedProductID]
GO
CREATE PROCEDURE [dbo].[SecPatch_AffectedServicePackGetAllByAffectedProductID]
	@AffectedProductID	int
AS
	SELECT	AffectedServicePackID,
		AffectedProductID,
		ServicePackID
	FROM	[dbo].[SecPatch_AffectedServicePack]
	WHERE	AffectedProductID = @AffectedProductID
	ORDER BY ServicePackID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedServicePackGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedServicePackGetAll]
GO
CREATE PROCEDURE [dbo].[SecPatch_AffectedServicePackGetAll]
AS
	SELECT	AffectedServicePackID,
		AffectedProductID,
		ServicePackID
	FROM	[dbo].[SecPatch_AffectedServicePack]
	ORDER BY AffectedProductID, ServicePackID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedServicePackAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedServicePackAdd]
GO
CREATE PROCEDURE [dbo].[SecPatch_AffectedServicePackAdd]
	@AffectedProductID	int,
	@ServicePackID		int
AS
	INSERT INTO  dbo.SecPatch_AffectedServicePack (
		AffectedProductID,
		ServicePackID
	)
	VALUES (
		@AffectedProductID,
		@ServicePackID
	)
	RETURN SCOPE_IDENTITY()
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedServicePackBind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedServicePackBind]
GO
CREATE PROCEDURE [dbo].[SecPatch_AffectedServicePackBind]
	@AffectedProductID	int,
	@ServicePackID		int
AS
	DECLARE	@ID	int

	SELECT	@ID = AffectedServicePackID
	FROM	[dbo].[SecPatch_AffectedServicePack]
	WHERE	AffectedProductID = @AffectedProductID
	  AND	ServicePackID = @ServicePackID

	IF @ID IS NULL
		EXEC @ID = SecPatch_AffectedServicePackAdd @AffectedProductID,
			@ServicePackID

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedServicePackSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedServicePackSchema]
GO
CREATE PROCEDURE [dbo].[SecPatch_AffectedServicePackSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecPatch_AffectedServicePack'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecPatch_AffectedServicePack (' + CAST(0x0A AS CHAR(1)) +
	'		AffectedServicePackID	int NULL,' + CAST(0x0A AS CHAR(1)) +
	'		AffectedProductID	int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		ServicePackID		int NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecPatch_AffectedServicePack' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedServicePackTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedServicePackTempAdd]
GO
CREATE PROCEDURE dbo.[SecPatch_AffectedServicePackTempAdd]
	@AffectedServicePackID	int,
	@AffectedProductID	int,
	@ServicePackID		int
AS
	INSERT INTO #SecPatch_AffectedServicePack (
		AffectedServicePackID,
		AffectedProductID,
		ServicePackID
	)
	VALUES (
		@AffectedServicePackID,
		@AffectedProductID,
		@ServicePackID
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedServicePackAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedServicePackAddBatch]
GO
CREATE PROCEDURE dbo.[SecPatch_AffectedServicePackAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecPatch_AffectedServicePack (
		AffectedProductID,
		ServicePackID
	)
		SELECT	AffectedProductID,
			ServicePackID
		FROM #SecPatch_AffectedServicePack
	SET @count = @@ROWCOUNT
	DROP TABLE #SecPatch_AffectedServicePack	-- Drop temporary table
	RETURN @count
GO

/*
Add new SecPatch_AffectedServicePack bound to
	SecPatch_AffectedProduct using ProductID, PatchID with FixedInSP
	with ServicePackID
*/

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedServicePackUpdateByAffectedServicePackID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedServicePackUpdateByAffectedServicePackID]
GO
CREATE PROCEDURE [dbo].[SecPatch_AffectedServicePackUpdateByAffectedServicePackID]
	@AffectedServicePackID	int,
	@AffectedProductID	int,
	@ServicePackID		int
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[SecPatch_AffectedServicePack]
	SET	@ID = AffectedServicePackID,
		AffectedProductID = @AffectedProductID,
		ServicePackID = @ServicePackID
	WHERE	AffectedServicePackID = @AffectedServicePackID
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedServicePackUpdateBatchByAffectedServicePackID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedServicePackUpdateBatchByAffectedServicePackID]
GO
CREATE PROCEDURE dbo.[SecPatch_AffectedServicePackUpdateBatchByAffectedServicePackID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecPatch_AffectedServicePackAffectedServicePackID]
		ON #SecPatch_AffectedServicePack (AffectedServicePackID)

	UPDATE	[dbo].[SecPatch_AffectedServicePack]
	SET	AffectedProductID = t.AffectedProductID,
		ServicePackID = t.ServicePackID
	FROM	#SecPatch_AffectedServicePack AS t
	WHERE	SecPatch_AffectedServicePack.AffectedServicePackID = t.AffectedServicePackID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecPatch_AffectedServicePack	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedServicePackPutByAffectedProductIDServicePackID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedServicePackPutByAffectedProductIDServicePackID]
GO
CREATE PROCEDURE [dbo].[SecPatch_AffectedServicePackPutByAffectedProductIDServicePackID]
	@AffectedProductID	int,
	@ServicePackID		int
AS
	DECLARE @ID	int

	SELECT	@ID = AffectedServicePackID
	FROM	SecPatch_AffectedServicePack
	WHERE	AffectedProductID = @AffectedProductID
	  AND	ServicePackID = @ServicePackID

	IF @ID IS NULL
		EXEC @ID = SecPatch_AffectedServicePackAdd @AffectedProductID,
			@ServicePackID

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedServicePackPutBatchByAffectedProductIDServicePackID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedServicePackPutBatchByAffectedProductIDServicePackID]
GO
CREATE PROCEDURE [dbo].[SecPatch_AffectedServicePackPutBatchByAffectedProductIDServicePackID]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecPatch_AffectedServicePackAffectedProductIDServicePackID]
		ON #SecPatch_AffectedServicePack (AffectedProductID, ServicePackID)

	BEGIN TRANSACTION

	INSERT [dbo].[SecPatch_AffectedServicePack] (
		AffectedProductID,
		ServicePackID
	)
		SELECT	AffectedProductID,
			ServicePackID
		FROM	#SecPatch_AffectedServicePack AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecPatch_AffectedServicePack]
			WHERE	SecPatch_AffectedServicePack.AffectedProductID = t.AffectedProductID
			  AND	SecPatch_AffectedServicePack.ServicePackID = t.ServicePackID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecPatch_AffectedServicePack	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedServicePackRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedServicePackRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecPatch_AffectedServicePackRemoveBatch]
AS

	CREATE INDEX [TempSecPatch_AffectedServicePackSecPatch_AffectedServicePackRemoveBatch]
		ON #SecPatch_AffectedServicePack (AffectedServicePackID)	

	-- Delete records from SecPatch_AffectedServicePack identified by fields of [TempSecPatch_AffectedServicePackSecPatch_AffectedServicePackRemoveBatch]
	DELETE [dbo].[SecPatch_AffectedServicePack]
	WHERE EXISTS(
			SELECT * FROM #SecPatch_AffectedServicePack AS t
			WHERE	SecPatch_AffectedServicePack.AffectedServicePackID = t.AffectedServicePackID
		)
	DROP TABLE #SecPatch_AffectedServicePack      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedServicePackRemoveByAffectedServicePackID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedServicePackRemoveByAffectedServicePackID]
GO
CREATE PROCEDURE [dbo].[SecPatch_AffectedServicePackRemoveByAffectedServicePackID]
	@AffectedServicePackID	int
AS
	DELETE	[dbo].[SecPatch_AffectedServicePack]
	WHERE	AffectedServicePackID = @AffectedServicePackID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedServicePackRemoveByAffectedProductIDServicePackID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedServicePackRemoveByAffectedProductIDServicePackID]
GO
CREATE PROCEDURE [dbo].[SecPatch_AffectedServicePackRemoveByAffectedProductIDServicePackID]
	@AffectedProductID	int,
	@ServicePackID		int
AS
	DELETE	[dbo].[SecPatch_AffectedServicePack]
	WHERE	AffectedProductID = @AffectedProductID
	  AND	ServicePackID = @ServicePackID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedServicePackRemoveAllByAffectedProductID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedServicePackRemoveAllByAffectedProductID]
GO
CREATE PROCEDURE [dbo].[SecPatch_AffectedServicePackRemoveAllByAffectedProductID]
	@AffectedProductID	int
AS
	DELETE	[dbo].[SecPatch_AffectedServicePack]
	WHERE	AffectedProductID = @AffectedProductID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_AffectedServicePackRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_AffectedServicePackRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecPatch_AffectedServicePackRemoveAll]
	
AS
	DELETE	[dbo].[SecPatch_AffectedServicePack]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_CommentGetByCommentID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_CommentGetByCommentID]
GO
CREATE PROCEDURE [dbo].[SecPatch_CommentGetByCommentID]
	@CommentID		int
AS
	SELECT	CommentID,
		Text
	FROM	[dbo].[SecPatch_Comment]
	WHERE	CommentID = @CommentID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_CommentGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_CommentGetAll]
GO
CREATE PROCEDURE [dbo].[SecPatch_CommentGetAll]
AS
	SELECT	CommentID,
		Text
	FROM	[dbo].[SecPatch_Comment]
	ORDER BY CommentID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_CommentAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_CommentAdd]
GO
CREATE PROCEDURE [dbo].[SecPatch_CommentAdd]
	@CommentID		int,
	@Text			ntext
AS
	INSERT INTO  dbo.SecPatch_Comment (
		CommentID,
		Text
	)
	VALUES (
		@CommentID,
		@Text
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_CommentSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_CommentSchema]
GO
CREATE PROCEDURE [dbo].[SecPatch_CommentSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecPatch_Comment'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecPatch_Comment (' + CAST(0x0A AS CHAR(1)) +
	'		CommentID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Text			ntext COLLATE database_default NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecPatch_Comment' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_CommentTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_CommentTempAdd]
GO
CREATE PROCEDURE dbo.[SecPatch_CommentTempAdd]
	@CommentID		int,
	@Text			ntext
AS
	INSERT INTO #SecPatch_Comment (
		CommentID,
		Text
	)
	VALUES (
		@CommentID,
		@Text
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_CommentAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_CommentAddBatch]
GO
CREATE PROCEDURE dbo.[SecPatch_CommentAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecPatch_Comment (
		CommentID,
		Text
	)
		SELECT	CommentID,
			Text
		FROM #SecPatch_Comment
	SET @count = @@ROWCOUNT
	DROP TABLE #SecPatch_Comment	-- Drop temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_CommentUpdateByCommentID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_CommentUpdateByCommentID]
GO
CREATE PROCEDURE [dbo].[SecPatch_CommentUpdateByCommentID]
	@CommentID		int,
	@Text			ntext
AS
	UPDATE	[dbo].[SecPatch_Comment]
	SET	Text = @Text
	WHERE	CommentID = @CommentID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_CommentUpdateBatchByCommentID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_CommentUpdateBatchByCommentID]
GO
CREATE PROCEDURE dbo.[SecPatch_CommentUpdateBatchByCommentID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecPatch_CommentCommentID]
		ON #SecPatch_Comment (CommentID)

	UPDATE	[dbo].[SecPatch_Comment]
	SET	Text = t.Text
	FROM	#SecPatch_Comment AS t
	WHERE	SecPatch_Comment.CommentID = t.CommentID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecPatch_Comment	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_CommentPutByCommentID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_CommentPutByCommentID]
GO
CREATE PROCEDURE [dbo].[SecPatch_CommentPutByCommentID]
	@CommentID		int,
	@Text			ntext
AS
	IF NOT EXISTS(
		SELECT	1
		FROM	dbo.SecPatch_Comment
		WHERE	CommentID = @CommentID
	)
		EXEC SecPatch_CommentAdd @CommentID,
			@Text
	ELSE
		EXEC SecPatch_CommentUpdateByCommentID @CommentID,
			@Text
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_CommentPutBatchByCommentID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_CommentPutBatchByCommentID]
GO
CREATE PROCEDURE [dbo].[SecPatch_CommentPutBatchByCommentID]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecPatch_CommentCommentID]
		ON #SecPatch_Comment (CommentID)

	BEGIN TRANSACTION
	UPDATE [dbo].[SecPatch_Comment]
		SET	Text = t.Text
		FROM	#SecPatch_Comment AS t
		WHERE	SecPatch_Comment.CommentID = t.CommentID
	SET @count = @@ROWCOUNT

	INSERT [dbo].[SecPatch_Comment] (
		CommentID,
		Text
	)
		SELECT	CommentID,
			Text
		FROM	#SecPatch_Comment AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecPatch_Comment]
			WHERE	SecPatch_Comment.CommentID = t.CommentID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecPatch_Comment	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_CommentRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_CommentRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecPatch_CommentRemoveBatch]
AS

	CREATE INDEX [TempSecPatch_CommentSecPatch_CommentRemoveBatch]
		ON #SecPatch_Comment (CommentID)	

	-- Delete records from SecPatch_Comment identified by fields of [TempSecPatch_CommentSecPatch_CommentRemoveBatch]
	DELETE [dbo].[SecPatch_Comment]
	WHERE EXISTS(
			SELECT * FROM #SecPatch_Comment AS t
			WHERE	SecPatch_Comment.CommentID = t.CommentID
		)
	DROP TABLE #SecPatch_Comment      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_CommentRemoveByCommentID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_CommentRemoveByCommentID]
GO
CREATE PROCEDURE [dbo].[SecPatch_CommentRemoveByCommentID]
	@CommentID		int
AS
	-- SecPatch_Comment deletes cascade to:
	--	SecPatch_BulletinComment by FK_BulletinComment_Comment
	--	SecPatch_PatchComment by FK_PatchComment_Comment
	DELETE	[dbo].[SecPatch_Comment]
	WHERE	CommentID = @CommentID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_CommentRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_CommentRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecPatch_CommentRemoveAll]
	
AS
	DELETE	[dbo].[SecPatch_Comment]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_LocationGetByLocationID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_LocationGetByLocationID]
GO
CREATE PROCEDURE [dbo].[SecPatch_LocationGetByLocationID]
	@LocationID		int
AS
	SELECT	LocationID,
		Path,
		AbsolutePath
	FROM	[dbo].[SecPatch_Location]
	WHERE	LocationID = @LocationID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_LocationGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_LocationGetAll]
GO
CREATE PROCEDURE [dbo].[SecPatch_LocationGetAll]
AS
	SELECT	LocationID,
		Path,
		AbsolutePath
	FROM	[dbo].[SecPatch_Location]
	ORDER BY LocationID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_LocationAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_LocationAdd]
GO
CREATE PROCEDURE [dbo].[SecPatch_LocationAdd]
	@LocationID		int,
	@Path			nvarchar(256),
	@AbsolutePath		nvarchar(6)
AS
	INSERT INTO  dbo.SecPatch_Location (
		LocationID,
		Path,
		AbsolutePath
	)
	VALUES (
		@LocationID,
		@Path,
		@AbsolutePath
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_LocationSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_LocationSchema]
GO
CREATE PROCEDURE [dbo].[SecPatch_LocationSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecPatch_Location'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecPatch_Location (' + CAST(0x0A AS CHAR(1)) +
	'		LocationID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Path			nvarchar(256) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		AbsolutePath		nvarchar(6) COLLATE database_default NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecPatch_Location' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_LocationTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_LocationTempAdd]
GO
CREATE PROCEDURE dbo.[SecPatch_LocationTempAdd]
	@LocationID		int,
	@Path			nvarchar(256),
	@AbsolutePath		nvarchar(6)
AS
	INSERT INTO #SecPatch_Location (
		LocationID,
		Path,
		AbsolutePath
	)
	VALUES (
		@LocationID,
		@Path,
		@AbsolutePath
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_LocationAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_LocationAddBatch]
GO
CREATE PROCEDURE dbo.[SecPatch_LocationAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecPatch_Location (
		LocationID,
		Path,
		AbsolutePath
	)
		SELECT	LocationID,
			Path,
			AbsolutePath
		FROM #SecPatch_Location
	SET @count = @@ROWCOUNT
	DROP TABLE #SecPatch_Location	-- Drop temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_LocationUpdateByLocationID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_LocationUpdateByLocationID]
GO
CREATE PROCEDURE [dbo].[SecPatch_LocationUpdateByLocationID]
	@LocationID		int,
	@Path			nvarchar(256),
	@AbsolutePath		nvarchar(6)
AS
	UPDATE	[dbo].[SecPatch_Location]
	SET	Path = @Path,
		AbsolutePath = @AbsolutePath
	WHERE	LocationID = @LocationID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_LocationUpdateBatchByLocationID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_LocationUpdateBatchByLocationID]
GO
CREATE PROCEDURE dbo.[SecPatch_LocationUpdateBatchByLocationID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecPatch_LocationLocationID]
		ON #SecPatch_Location (LocationID)

	UPDATE	[dbo].[SecPatch_Location]
	SET	Path = t.Path,
		AbsolutePath = t.AbsolutePath
	FROM	#SecPatch_Location AS t
	WHERE	SecPatch_Location.LocationID = t.LocationID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecPatch_Location	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_LocationPutByLocationID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_LocationPutByLocationID]
GO
CREATE PROCEDURE [dbo].[SecPatch_LocationPutByLocationID]
	@LocationID		int,
	@Path			nvarchar(256),
	@AbsolutePath		nvarchar(6)
AS
	IF NOT EXISTS(
		SELECT	1
		FROM	dbo.SecPatch_Location
		WHERE	LocationID = @LocationID
	)
		EXEC SecPatch_LocationAdd @LocationID,
			@Path,
			@AbsolutePath
	ELSE
		EXEC SecPatch_LocationUpdateByLocationID @LocationID,
			@Path,
			@AbsolutePath
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_LocationPutBatchByLocationID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_LocationPutBatchByLocationID]
GO
CREATE PROCEDURE [dbo].[SecPatch_LocationPutBatchByLocationID]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecPatch_LocationLocationID]
		ON #SecPatch_Location (LocationID)

	BEGIN TRANSACTION
	UPDATE [dbo].[SecPatch_Location]
		SET	Path = t.Path,
			AbsolutePath = t.AbsolutePath
		FROM	#SecPatch_Location AS t
		WHERE	SecPatch_Location.LocationID = t.LocationID
	SET @count = @@ROWCOUNT

	INSERT [dbo].[SecPatch_Location] (
		LocationID,
		Path,
		AbsolutePath
	)
		SELECT	LocationID,
			Path,
			AbsolutePath
		FROM	#SecPatch_Location AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecPatch_Location]
			WHERE	SecPatch_Location.LocationID = t.LocationID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecPatch_Location	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_LocationRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_LocationRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecPatch_LocationRemoveBatch]
AS

	CREATE INDEX [TempSecPatch_LocationSecPatch_LocationRemoveBatch]
		ON #SecPatch_Location (LocationID)	

	-- Delete records from SecPatch_Location identified by fields of [TempSecPatch_LocationSecPatch_LocationRemoveBatch]
	DELETE [dbo].[SecPatch_Location]
	WHERE EXISTS(
			SELECT * FROM #SecPatch_Location AS t
			WHERE	SecPatch_Location.LocationID = t.LocationID
		)
	DROP TABLE #SecPatch_Location      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_LocationRemoveByLocationID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_LocationRemoveByLocationID]
GO
CREATE PROCEDURE [dbo].[SecPatch_LocationRemoveByLocationID]
	@LocationID		int
AS
	-- SecPatch_Location deletes cascade to:
	--	SecPatch_Patch by FK_Patch_Location
	--		SecPatch_AffectedProduct by FK_AffectedProduct_Patch
	--			SecPatch_AffectedServicePack by FK_AffectedServicePack_AffectedProduct
	--		SecPatch_PatchComment by FK_PatchComment_Patch
	-- SecPatch_Location deletes may fail due to non-cascading FKs:
	--	SecPatch_Bulletin by FK_Bulletin_Location
	--	SecPatch_Bulletin by FK_Bulletin_Location1
	DELETE	[dbo].[SecPatch_Location]
	WHERE	LocationID = @LocationID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_LocationRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_LocationRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecPatch_LocationRemoveAll]
	
AS
	DELETE	[dbo].[SecPatch_Location]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductGetByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductGetByName]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductGetByName]
	@Name			nvarchar(80)
AS
	SELECT	ProductID,
		[Name],
		MinimumSupportedServicePackID,
		CurrentServicePackID,
		CurrentVersion
	FROM	[dbo].[SecPatch_Product]
	WHERE	[Name] = @Name
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductGetAllOrderedByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductGetAllOrderedByName]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductGetAllOrderedByName]
AS
	SELECT	ProductID,
		[Name],
		MinimumSupportedServicePackID,
		CurrentServicePackID,
		CurrentVersion
	FROM	[dbo].[SecPatch_Product]
	ORDER BY [Name]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductGetByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductGetByID]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductGetByID]
	@ProductID		int
AS
	SELECT	ProductID,
		[Name],
		MinimumSupportedServicePackID,
		CurrentServicePackID,
		CurrentVersion
	FROM	[dbo].[SecPatch_Product]
	WHERE	ProductID = @ProductID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductGetAll]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductGetAll]
AS
	SELECT	ProductID,
		[Name],
		MinimumSupportedServicePackID,
		CurrentServicePackID,
		CurrentVersion
	FROM	[dbo].[SecPatch_Product]
	ORDER BY ProductID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductAdd]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductAdd]
	@Name			nvarchar(80),
	@MinimumSupportedServicePackID int = NULL,
	@CurrentServicePackID	int = NULL,
	@CurrentVersion		nvarchar(50) = NULL
AS
	INSERT INTO  dbo.SecPatch_Product (
		[Name],
		MinimumSupportedServicePackID,
		CurrentServicePackID,
		CurrentVersion
	)
	VALUES (
		@Name,
		@MinimumSupportedServicePackID,
		@CurrentServicePackID,
		@CurrentVersion
	)
	RETURN SCOPE_IDENTITY()
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductBind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductBind]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductBind]
	@Name			nvarchar(80),
	@MinimumSupportedServicePackID int = NULL,
	@CurrentServicePackID	int = NULL,
	@CurrentVersion		nvarchar(50) = NULL
AS
	DECLARE	@ID	int

	SELECT	@ID = ProductID
	FROM	[dbo].[SecPatch_Product]
	WHERE	[Name] = @Name

	IF @ID IS NULL
		EXEC @ID = SecPatch_ProductAdd @Name,
			@MinimumSupportedServicePackID,
			@CurrentServicePackID,
			@CurrentVersion

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductSchema]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecPatch_Product'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecPatch_Product (' + CAST(0x0A AS CHAR(1)) +
	'		ProductID		int NULL,' + CAST(0x0A AS CHAR(1)) +
	'		[Name]			nvarchar(80) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		MinimumSupportedServicePackID int NULL,' + CAST(0x0A AS CHAR(1)) +
	'		CurrentServicePackID	int NULL,' + CAST(0x0A AS CHAR(1)) +
	'		CurrentVersion		nvarchar(50) COLLATE database_default NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecPatch_Product' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductTempAdd]
GO
CREATE PROCEDURE dbo.[SecPatch_ProductTempAdd]
	@ProductID		int,
	@Name			nvarchar(80),
	@MinimumSupportedServicePackID int = NULL,
	@CurrentServicePackID	int = NULL,
	@CurrentVersion		nvarchar(50) = NULL
AS
	INSERT INTO #SecPatch_Product (
		ProductID,
		[Name],
		MinimumSupportedServicePackID,
		CurrentServicePackID,
		CurrentVersion
	)
	VALUES (
		@ProductID,
		@Name,
		@MinimumSupportedServicePackID,
		@CurrentServicePackID,
		@CurrentVersion
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductAddBatch]
GO
CREATE PROCEDURE dbo.[SecPatch_ProductAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecPatch_Product (
		[Name],
		MinimumSupportedServicePackID,
		CurrentServicePackID,
		CurrentVersion
	)
		SELECT	[Name],
			MinimumSupportedServicePackID,
			CurrentServicePackID,
			CurrentVersion
		FROM #SecPatch_Product
	SET @count = @@ROWCOUNT
	DROP TABLE #SecPatch_Product	-- Drop temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductUpdateByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductUpdateByID]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductUpdateByID]
	@ProductID		int,
	@Name			nvarchar(80),
	@MinimumSupportedServicePackID int = NULL,
	@CurrentServicePackID	int = NULL,
	@CurrentVersion		nvarchar(50) = NULL
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[SecPatch_Product]
	SET	@ID = ProductID,
		[Name] = @Name,
		MinimumSupportedServicePackID = @MinimumSupportedServicePackID,
		CurrentServicePackID = @CurrentServicePackID,
		CurrentVersion = @CurrentVersion
	WHERE	ProductID = @ProductID
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductUpdateBatchByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductUpdateBatchByID]
GO
CREATE PROCEDURE dbo.[SecPatch_ProductUpdateBatchByID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecPatch_ProductID]
		ON #SecPatch_Product (ProductID)

	UPDATE	[dbo].[SecPatch_Product]
	SET	[Name] = t.[Name],
		MinimumSupportedServicePackID = t.MinimumSupportedServicePackID,
		CurrentServicePackID = t.CurrentServicePackID,
		CurrentVersion = t.CurrentVersion
	FROM	#SecPatch_Product AS t
	WHERE	SecPatch_Product.ProductID = t.ProductID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecPatch_Product	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductUpdateByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductUpdateByName]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductUpdateByName]
	@Name			nvarchar(80),
	@MinimumSupportedServicePackID int = NULL,
	@CurrentServicePackID	int = NULL,
	@CurrentVersion		nvarchar(50) = NULL
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[SecPatch_Product]
	SET	@ID = ProductID,
		MinimumSupportedServicePackID = @MinimumSupportedServicePackID,
		CurrentServicePackID = @CurrentServicePackID,
		CurrentVersion = @CurrentVersion
	WHERE	[Name] = @Name
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductUpdateBatchByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductUpdateBatchByName]
GO
CREATE PROCEDURE dbo.[SecPatch_ProductUpdateBatchByName]
AS
	DECLARE @count int

	CREATE INDEX [TempSecPatch_ProductName]
		ON #SecPatch_Product ([Name])

	UPDATE	[dbo].[SecPatch_Product]
	SET	MinimumSupportedServicePackID = t.MinimumSupportedServicePackID,
		CurrentServicePackID = t.CurrentServicePackID,
		CurrentVersion = t.CurrentVersion
	FROM	#SecPatch_Product AS t
	WHERE	SecPatch_Product.[Name] = t.[Name]
	SET @count = @@ROWCOUNT
	DROP TABLE #SecPatch_Product	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductPutByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductPutByName]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductPutByName]
	@Name			nvarchar(80),
	@MinimumSupportedServicePackID int = NULL,
	@CurrentServicePackID	int = NULL,
	@CurrentVersion		nvarchar(50) = NULL
AS
	DECLARE @ID	int

	SELECT	@ID = ProductID
	FROM	SecPatch_Product
	WHERE	[Name] = @Name

	IF @ID IS NULL
		EXEC @ID = SecPatch_ProductAdd @Name,
			@MinimumSupportedServicePackID,
			@CurrentServicePackID,
			@CurrentVersion
	ELSE
		EXEC SecPatch_ProductUpdateByName @Name,
			@MinimumSupportedServicePackID,
			@CurrentServicePackID,
			@CurrentVersion

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductPutBatchByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductPutBatchByName]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductPutBatchByName]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecPatch_ProductName]
		ON #SecPatch_Product ([Name])

	BEGIN TRANSACTION
	UPDATE [dbo].[SecPatch_Product]
		SET	MinimumSupportedServicePackID = t.MinimumSupportedServicePackID,
			CurrentServicePackID = t.CurrentServicePackID,
			CurrentVersion = t.CurrentVersion
		FROM	#SecPatch_Product AS t
		WHERE	SecPatch_Product.[Name] = t.[Name]
	SET @count = @@ROWCOUNT

	INSERT [dbo].[SecPatch_Product] (
		[Name],
		MinimumSupportedServicePackID,
		CurrentServicePackID,
		CurrentVersion
	)
		SELECT	[Name],
			MinimumSupportedServicePackID,
			CurrentServicePackID,
			CurrentVersion
		FROM	#SecPatch_Product AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecPatch_Product]
			WHERE	SecPatch_Product.[Name] = t.[Name]
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecPatch_Product	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecPatch_ProductRemoveBatch]
AS

	CREATE INDEX [TempSecPatch_ProductSecPatch_ProductRemoveBatch]
		ON #SecPatch_Product (ProductID)	

	-- Delete records from SecPatch_Product identified by fields of [TempSecPatch_ProductSecPatch_ProductRemoveBatch]
	DELETE [dbo].[SecPatch_Product]
	WHERE EXISTS(
			SELECT * FROM #SecPatch_Product AS t
			WHERE	SecPatch_Product.ProductID = t.ProductID
		)
	DROP TABLE #SecPatch_Product      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductRemoveByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductRemoveByName]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductRemoveByName]
	@Name			nvarchar(80)
AS
	-- SecPatch_Product deletes cascade to:
	--	SecPatch_AffectedProduct by FK_AffectedProduct_Product
	--		SecPatch_AffectedServicePack by FK_AffectedServicePack_AffectedProduct
	--	SecPatch_ProductProductFamily by FK_ProductProductFamily_Product
	DELETE	[dbo].[SecPatch_Product]
	WHERE	[Name] = @Name
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductRemoveAll]
	
AS
	DELETE	[dbo].[SecPatch_Product]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ServicePackGetByServicePackID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ServicePackGetByServicePackID]
GO
CREATE PROCEDURE [dbo].[SecPatch_ServicePackGetByServicePackID]
	@ServicePackID		int
AS
	SELECT	ServicePackID,
		[Name],
		URL,
		ReleaseDate
	FROM	[dbo].[SecPatch_ServicePack]
	WHERE	ServicePackID = @ServicePackID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ServicePackGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ServicePackGetAll]
GO
CREATE PROCEDURE [dbo].[SecPatch_ServicePackGetAll]
AS
	SELECT	ServicePackID,
		[Name],
		URL,
		ReleaseDate
	FROM	[dbo].[SecPatch_ServicePack]
	ORDER BY ServicePackID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ServicePackAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ServicePackAdd]
GO
CREATE PROCEDURE [dbo].[SecPatch_ServicePackAdd]
	@ServicePackID		int,
	@Name			nvarchar(50),
	@URL			nvarchar(256) = NULL,
	@ReleaseDate		datetime = NULL
AS
	INSERT INTO  dbo.SecPatch_ServicePack (
		ServicePackID,
		[Name],
		URL,
		ReleaseDate
	)
	VALUES (
		@ServicePackID,
		@Name,
		@URL,
		@ReleaseDate
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ServicePackSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ServicePackSchema]
GO
CREATE PROCEDURE [dbo].[SecPatch_ServicePackSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecPatch_ServicePack'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecPatch_ServicePack (' + CAST(0x0A AS CHAR(1)) +
	'		ServicePackID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		[Name]			nvarchar(50) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		URL			nvarchar(256) COLLATE database_default NULL,' + CAST(0x0A AS CHAR(1)) +
	'		ReleaseDate		datetime NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecPatch_ServicePack' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ServicePackTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ServicePackTempAdd]
GO
CREATE PROCEDURE dbo.[SecPatch_ServicePackTempAdd]
	@ServicePackID		int,
	@Name			nvarchar(50),
	@URL			nvarchar(256) = NULL,
	@ReleaseDate		datetime = NULL
AS
	INSERT INTO #SecPatch_ServicePack (
		ServicePackID,
		[Name],
		URL,
		ReleaseDate
	)
	VALUES (
		@ServicePackID,
		@Name,
		@URL,
		@ReleaseDate
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ServicePackAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ServicePackAddBatch]
GO
CREATE PROCEDURE dbo.[SecPatch_ServicePackAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecPatch_ServicePack (
		ServicePackID,
		[Name],
		URL,
		ReleaseDate
	)
		SELECT	ServicePackID,
			[Name],
			URL,
			ReleaseDate
		FROM #SecPatch_ServicePack
	SET @count = @@ROWCOUNT
	DROP TABLE #SecPatch_ServicePack	-- Drop temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ServicePackUpdateByServicePackID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ServicePackUpdateByServicePackID]
GO
CREATE PROCEDURE [dbo].[SecPatch_ServicePackUpdateByServicePackID]
	@ServicePackID		int,
	@Name			nvarchar(50),
	@URL			nvarchar(256) = NULL,
	@ReleaseDate		datetime = NULL
AS
	UPDATE	[dbo].[SecPatch_ServicePack]
	SET	[Name] = @Name,
		URL = @URL,
		ReleaseDate = @ReleaseDate
	WHERE	ServicePackID = @ServicePackID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ServicePackUpdateBatchByServicePackID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ServicePackUpdateBatchByServicePackID]
GO
CREATE PROCEDURE dbo.[SecPatch_ServicePackUpdateBatchByServicePackID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecPatch_ServicePackServicePackID]
		ON #SecPatch_ServicePack (ServicePackID)

	UPDATE	[dbo].[SecPatch_ServicePack]
	SET	[Name] = t.[Name],
		URL = t.URL,
		ReleaseDate = t.ReleaseDate
	FROM	#SecPatch_ServicePack AS t
	WHERE	SecPatch_ServicePack.ServicePackID = t.ServicePackID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecPatch_ServicePack	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ServicePackPutByServicePackID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ServicePackPutByServicePackID]
GO
CREATE PROCEDURE [dbo].[SecPatch_ServicePackPutByServicePackID]
	@ServicePackID		int,
	@Name			nvarchar(50),
	@URL			nvarchar(256) = NULL,
	@ReleaseDate		datetime = NULL
AS
	IF NOT EXISTS(
		SELECT	1
		FROM	dbo.SecPatch_ServicePack
		WHERE	ServicePackID = @ServicePackID
	)
		EXEC SecPatch_ServicePackAdd @ServicePackID,
			@Name,
			@URL,
			@ReleaseDate
	ELSE
		EXEC SecPatch_ServicePackUpdateByServicePackID @ServicePackID,
			@Name,
			@URL,
			@ReleaseDate
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ServicePackPutBatchByServicePackID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ServicePackPutBatchByServicePackID]
GO
CREATE PROCEDURE [dbo].[SecPatch_ServicePackPutBatchByServicePackID]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecPatch_ServicePackServicePackID]
		ON #SecPatch_ServicePack (ServicePackID)

	BEGIN TRANSACTION
	UPDATE [dbo].[SecPatch_ServicePack]
		SET	[Name] = t.[Name],
			URL = t.URL,
			ReleaseDate = t.ReleaseDate
		FROM	#SecPatch_ServicePack AS t
		WHERE	SecPatch_ServicePack.ServicePackID = t.ServicePackID
	SET @count = @@ROWCOUNT

	INSERT [dbo].[SecPatch_ServicePack] (
		ServicePackID,
		[Name],
		URL,
		ReleaseDate
	)
		SELECT	ServicePackID,
			[Name],
			URL,
			ReleaseDate
		FROM	#SecPatch_ServicePack AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecPatch_ServicePack]
			WHERE	SecPatch_ServicePack.ServicePackID = t.ServicePackID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecPatch_ServicePack	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ServicePackRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ServicePackRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecPatch_ServicePackRemoveBatch]
AS

	CREATE INDEX [TempSecPatch_ServicePackSecPatch_ServicePackRemoveBatch]
		ON #SecPatch_ServicePack (ServicePackID)	

	-- Delete records from SecPatch_ServicePack identified by fields of [TempSecPatch_ServicePackSecPatch_ServicePackRemoveBatch]
	DELETE [dbo].[SecPatch_ServicePack]
	WHERE EXISTS(
			SELECT * FROM #SecPatch_ServicePack AS t
			WHERE	SecPatch_ServicePack.ServicePackID = t.ServicePackID
		)
	DROP TABLE #SecPatch_ServicePack      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ServicePackRemoveByServicePackID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ServicePackRemoveByServicePackID]
GO
CREATE PROCEDURE [dbo].[SecPatch_ServicePackRemoveByServicePackID]
	@ServicePackID		int
AS
	-- SecPatch_ServicePack deletes cascade to:
	--	SecPatch_AffectedServicePack by FK_AffectedServicePack_ServicePack
	DELETE	[dbo].[SecPatch_ServicePack]
	WHERE	ServicePackID = @ServicePackID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ServicePackRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ServicePackRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecPatch_ServicePackRemoveAll]
	
AS
	DELETE	[dbo].[SecPatch_ServicePack]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_SeverityGetBySeverityID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_SeverityGetBySeverityID]
GO
CREATE PROCEDURE [dbo].[SecPatch_SeverityGetBySeverityID]
	@SeverityID		char(10)
AS
	SELECT	SeverityID,
		Description
	FROM	[dbo].[SecPatch_Severity]
	WHERE	SeverityID = @SeverityID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_SeverityGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_SeverityGetAll]
GO
CREATE PROCEDURE [dbo].[SecPatch_SeverityGetAll]
AS
	SELECT	SeverityID,
		Description
	FROM	[dbo].[SecPatch_Severity]
	ORDER BY SeverityID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_SeverityAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_SeverityAdd]
GO
CREATE PROCEDURE [dbo].[SecPatch_SeverityAdd]
	@SeverityID		char(10),
	@Description		nvarchar(50) = NULL
AS
	INSERT INTO  dbo.SecPatch_Severity (
		SeverityID,
		Description
	)
	VALUES (
		@SeverityID,
		@Description
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_SeveritySchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_SeveritySchema]
GO
CREATE PROCEDURE [dbo].[SecPatch_SeveritySchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecPatch_Severity'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecPatch_Severity (' + CAST(0x0A AS CHAR(1)) +
	'		SeverityID		char(10) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Description		nvarchar(50) COLLATE database_default NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecPatch_Severity' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_SeverityTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_SeverityTempAdd]
GO
CREATE PROCEDURE dbo.[SecPatch_SeverityTempAdd]
	@SeverityID		char(10),
	@Description		nvarchar(50) = NULL
AS
	INSERT INTO #SecPatch_Severity (
		SeverityID,
		Description
	)
	VALUES (
		@SeverityID,
		@Description
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_SeverityAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_SeverityAddBatch]
GO
CREATE PROCEDURE dbo.[SecPatch_SeverityAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecPatch_Severity (
		SeverityID,
		Description
	)
		SELECT	SeverityID,
			Description
		FROM #SecPatch_Severity
	SET @count = @@ROWCOUNT
	DROP TABLE #SecPatch_Severity	-- Drop temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_SeverityUpdateBySeverityID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_SeverityUpdateBySeverityID]
GO
CREATE PROCEDURE [dbo].[SecPatch_SeverityUpdateBySeverityID]
	@SeverityID		char(10),
	@Description		nvarchar(50) = NULL
AS
	UPDATE	[dbo].[SecPatch_Severity]
	SET	Description = @Description
	WHERE	SeverityID = @SeverityID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_SeverityUpdateBatchBySeverityID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_SeverityUpdateBatchBySeverityID]
GO
CREATE PROCEDURE dbo.[SecPatch_SeverityUpdateBatchBySeverityID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecPatch_SeveritySeverityID]
		ON #SecPatch_Severity (SeverityID)

	UPDATE	[dbo].[SecPatch_Severity]
	SET	Description = t.Description
	FROM	#SecPatch_Severity AS t
	WHERE	SecPatch_Severity.SeverityID = t.SeverityID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecPatch_Severity	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_SeverityPutBySeverityID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_SeverityPutBySeverityID]
GO
CREATE PROCEDURE [dbo].[SecPatch_SeverityPutBySeverityID]
	@SeverityID		char(10),
	@Description		nvarchar(50) = NULL
AS
	IF NOT EXISTS(
		SELECT	1
		FROM	dbo.SecPatch_Severity
		WHERE	SeverityID = @SeverityID
	)
		EXEC SecPatch_SeverityAdd @SeverityID,
			@Description
	ELSE
		EXEC SecPatch_SeverityUpdateBySeverityID @SeverityID,
			@Description
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_SeverityPutBatchBySeverityID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_SeverityPutBatchBySeverityID]
GO
CREATE PROCEDURE [dbo].[SecPatch_SeverityPutBatchBySeverityID]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecPatch_SeveritySeverityID]
		ON #SecPatch_Severity (SeverityID)

	BEGIN TRANSACTION
	UPDATE [dbo].[SecPatch_Severity]
		SET	Description = t.Description
		FROM	#SecPatch_Severity AS t
		WHERE	SecPatch_Severity.SeverityID = t.SeverityID
	SET @count = @@ROWCOUNT

	INSERT [dbo].[SecPatch_Severity] (
		SeverityID,
		Description
	)
		SELECT	SeverityID,
			Description
		FROM	#SecPatch_Severity AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecPatch_Severity]
			WHERE	SecPatch_Severity.SeverityID = t.SeverityID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecPatch_Severity	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_SeverityRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_SeverityRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecPatch_SeverityRemoveBatch]
AS

	CREATE INDEX [TempSecPatch_SeveritySecPatch_SeverityRemoveBatch]
		ON #SecPatch_Severity (SeverityID)	

	-- Delete records from SecPatch_Severity identified by fields of [TempSecPatch_SeveritySecPatch_SeverityRemoveBatch]
	DELETE [dbo].[SecPatch_Severity]
	WHERE EXISTS(
			SELECT * FROM #SecPatch_Severity AS t
			WHERE	SecPatch_Severity.SeverityID = t.SeverityID
		)
	DROP TABLE #SecPatch_Severity      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_SeverityRemoveBySeverityID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_SeverityRemoveBySeverityID]
GO
CREATE PROCEDURE [dbo].[SecPatch_SeverityRemoveBySeverityID]
	@SeverityID		char(10)
AS
	DELETE	[dbo].[SecPatch_Severity]
	WHERE	SeverityID = @SeverityID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_SeverityRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_SeverityRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecPatch_SeverityRemoveAll]
	
AS
	DELETE	[dbo].[SecPatch_Severity]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchSupersedeGetByNewSecurityPatchIDOldSecurityPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchSupersedeGetByNewSecurityPatchIDOldSecurityPatchID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchSupersedeGetByNewSecurityPatchIDOldSecurityPatchID]
	@NewSecurityPatchID	int,
	@OldSecurityPatchID	int
AS
	SELECT	NewSecurityPatchID,
		OldSecurityPatchID
	FROM	[dbo].[SecurityPatchSupersede]
	WHERE	NewSecurityPatchID = @NewSecurityPatchID
	  AND	OldSecurityPatchID = @OldSecurityPatchID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchSupersedeGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchSupersedeGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchSupersedeGetAll]
AS
	SELECT	NewSecurityPatchID,
		OldSecurityPatchID
	FROM	[dbo].[SecurityPatchSupersede]
	ORDER BY NewSecurityPatchID, OldSecurityPatchID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchSupersedeAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchSupersedeAdd]
GO
CREATE PROCEDURE [dbo].[SecurityPatchSupersedeAdd]
	@NewSecurityPatchID	int,
	@OldSecurityPatchID	int
AS
	INSERT INTO  dbo.SecurityPatchSupersede (
		NewSecurityPatchID,
		OldSecurityPatchID
	)
	VALUES (
		@NewSecurityPatchID,
		@OldSecurityPatchID
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchSupersedeSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchSupersedeSchema]
GO
CREATE PROCEDURE [dbo].[SecurityPatchSupersedeSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecurityPatchSupersede'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecurityPatchSupersede (' + CAST(0x0A AS CHAR(1)) +
	'		NewSecurityPatchID	int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		OldSecurityPatchID	int NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecurityPatchSupersede' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchSupersedeTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchSupersedeTempAdd]
GO
CREATE PROCEDURE dbo.[SecurityPatchSupersedeTempAdd]
	@NewSecurityPatchID	int,
	@OldSecurityPatchID	int
AS
	INSERT INTO #SecurityPatchSupersede (
		NewSecurityPatchID,
		OldSecurityPatchID
	)
	VALUES (
		@NewSecurityPatchID,
		@OldSecurityPatchID
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchSupersedeAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchSupersedeAddBatch]
GO
CREATE PROCEDURE dbo.[SecurityPatchSupersedeAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecurityPatchSupersede (
		NewSecurityPatchID,
		OldSecurityPatchID
	)
		SELECT	NewSecurityPatchID,
			OldSecurityPatchID
		FROM #SecurityPatchSupersede
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchSupersede	-- Drop temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchSupersedePutByNewSecurityPatchIDOldSecurityPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchSupersedePutByNewSecurityPatchIDOldSecurityPatchID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchSupersedePutByNewSecurityPatchIDOldSecurityPatchID]
	@NewSecurityPatchID	int,
	@OldSecurityPatchID	int
AS
	IF NOT EXISTS(
		SELECT	1
		FROM	dbo.SecurityPatchSupersede
		WHERE	NewSecurityPatchID = @NewSecurityPatchID
		  AND	OldSecurityPatchID = @OldSecurityPatchID
	)
		EXEC SecurityPatchSupersedeAdd @NewSecurityPatchID,
			@OldSecurityPatchID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchSupersedePutBatchByNewSecurityPatchIDOldSecurityPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchSupersedePutBatchByNewSecurityPatchIDOldSecurityPatchID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchSupersedePutBatchByNewSecurityPatchIDOldSecurityPatchID]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecurityPatchSupersedeNewSecurityPatchIDOldSecurityPatchID]
		ON #SecurityPatchSupersede (NewSecurityPatchID, OldSecurityPatchID)

	BEGIN TRANSACTION

	INSERT [dbo].[SecurityPatchSupersede] (
		NewSecurityPatchID,
		OldSecurityPatchID
	)
		SELECT	NewSecurityPatchID,
			OldSecurityPatchID
		FROM	#SecurityPatchSupersede AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecurityPatchSupersede]
			WHERE	SecurityPatchSupersede.NewSecurityPatchID = t.NewSecurityPatchID
			  AND	SecurityPatchSupersede.OldSecurityPatchID = t.OldSecurityPatchID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecurityPatchSupersede	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchSupersedeRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchSupersedeRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecurityPatchSupersedeRemoveBatch]
AS

	CREATE INDEX [TempSecurityPatchSupersedeSecurityPatchSupersedeRemoveBatch]
		ON #SecurityPatchSupersede (NewSecurityPatchID, OldSecurityPatchID)	

	-- Delete records from SecurityPatchSupersede identified by fields of [TempSecurityPatchSupersedeSecurityPatchSupersedeRemoveBatch]
	DELETE [dbo].[SecurityPatchSupersede]
	WHERE EXISTS(
			SELECT * FROM #SecurityPatchSupersede AS t
			WHERE	SecurityPatchSupersede.NewSecurityPatchID = t.NewSecurityPatchID
			  AND	SecurityPatchSupersede.OldSecurityPatchID = t.OldSecurityPatchID
		)
	DROP TABLE #SecurityPatchSupersede      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchSupersedeRemoveByNewSecurityPatchIDOldSecurityPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchSupersedeRemoveByNewSecurityPatchIDOldSecurityPatchID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchSupersedeRemoveByNewSecurityPatchIDOldSecurityPatchID]
	@NewSecurityPatchID	int,
	@OldSecurityPatchID	int
AS
	DELETE	[dbo].[SecurityPatchSupersede]
	WHERE	NewSecurityPatchID = @NewSecurityPatchID
	  AND	OldSecurityPatchID = @OldSecurityPatchID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchSupersedeRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchSupersedeRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchSupersedeRemoveAll]
	
AS
	DELETE	[dbo].[SecurityPatchSupersede]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductFamilyGetByProductFamilyID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductFamilyGetByProductFamilyID]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductFamilyGetByProductFamilyID]
	@ProductFamilyID	int
AS
	SELECT	ProductFamilyID,
		[Name],
		RecentProductVersionID
	FROM	[dbo].[SecPatch_ProductFamily]
	WHERE	ProductFamilyID = @ProductFamilyID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductFamilyGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductFamilyGetAll]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductFamilyGetAll]
AS
	SELECT	ProductFamilyID,
		[Name],
		RecentProductVersionID
	FROM	[dbo].[SecPatch_ProductFamily]
	ORDER BY ProductFamilyID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductFamilyAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductFamilyAdd]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductFamilyAdd]
	@ProductFamilyID	int,
	@Name			nvarchar(50),
	@RecentProductVersionID	int = NULL
AS
	INSERT INTO  dbo.SecPatch_ProductFamily (
		ProductFamilyID,
		[Name],
		RecentProductVersionID
	)
	VALUES (
		@ProductFamilyID,
		@Name,
		@RecentProductVersionID
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductFamilySchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductFamilySchema]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductFamilySchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecPatch_ProductFamily'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecPatch_ProductFamily (' + CAST(0x0A AS CHAR(1)) +
	'		ProductFamilyID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		[Name]			nvarchar(50) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		RecentProductVersionID	int NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecPatch_ProductFamily' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductFamilyTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductFamilyTempAdd]
GO
CREATE PROCEDURE dbo.[SecPatch_ProductFamilyTempAdd]
	@ProductFamilyID	int,
	@Name			nvarchar(50),
	@RecentProductVersionID	int = NULL
AS
	INSERT INTO #SecPatch_ProductFamily (
		ProductFamilyID,
		[Name],
		RecentProductVersionID
	)
	VALUES (
		@ProductFamilyID,
		@Name,
		@RecentProductVersionID
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductFamilyAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductFamilyAddBatch]
GO
CREATE PROCEDURE dbo.[SecPatch_ProductFamilyAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecPatch_ProductFamily (
		ProductFamilyID,
		[Name],
		RecentProductVersionID
	)
		SELECT	ProductFamilyID,
			[Name],
			RecentProductVersionID
		FROM #SecPatch_ProductFamily
	SET @count = @@ROWCOUNT
	DROP TABLE #SecPatch_ProductFamily	-- Drop temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductFamilyUpdateByProductFamilyID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductFamilyUpdateByProductFamilyID]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductFamilyUpdateByProductFamilyID]
	@ProductFamilyID	int,
	@Name			nvarchar(50),
	@RecentProductVersionID	int = NULL
AS
	UPDATE	[dbo].[SecPatch_ProductFamily]
	SET	[Name] = @Name,
		RecentProductVersionID = @RecentProductVersionID
	WHERE	ProductFamilyID = @ProductFamilyID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductFamilyUpdateBatchByProductFamilyID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductFamilyUpdateBatchByProductFamilyID]
GO
CREATE PROCEDURE dbo.[SecPatch_ProductFamilyUpdateBatchByProductFamilyID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecPatch_ProductFamilyProductFamilyID]
		ON #SecPatch_ProductFamily (ProductFamilyID)

	UPDATE	[dbo].[SecPatch_ProductFamily]
	SET	[Name] = t.[Name],
		RecentProductVersionID = t.RecentProductVersionID
	FROM	#SecPatch_ProductFamily AS t
	WHERE	SecPatch_ProductFamily.ProductFamilyID = t.ProductFamilyID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecPatch_ProductFamily	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductFamilyPutByProductFamilyID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductFamilyPutByProductFamilyID]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductFamilyPutByProductFamilyID]
	@ProductFamilyID	int,
	@Name			nvarchar(50),
	@RecentProductVersionID	int = NULL
AS
	IF NOT EXISTS(
		SELECT	1
		FROM	dbo.SecPatch_ProductFamily
		WHERE	ProductFamilyID = @ProductFamilyID
	)
		EXEC SecPatch_ProductFamilyAdd @ProductFamilyID,
			@Name,
			@RecentProductVersionID
	ELSE
		EXEC SecPatch_ProductFamilyUpdateByProductFamilyID @ProductFamilyID,
			@Name,
			@RecentProductVersionID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductFamilyPutBatchByProductFamilyID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductFamilyPutBatchByProductFamilyID]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductFamilyPutBatchByProductFamilyID]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecPatch_ProductFamilyProductFamilyID]
		ON #SecPatch_ProductFamily (ProductFamilyID)

	BEGIN TRANSACTION
	UPDATE [dbo].[SecPatch_ProductFamily]
		SET	[Name] = t.[Name],
			RecentProductVersionID = t.RecentProductVersionID
		FROM	#SecPatch_ProductFamily AS t
		WHERE	SecPatch_ProductFamily.ProductFamilyID = t.ProductFamilyID
	SET @count = @@ROWCOUNT

	INSERT [dbo].[SecPatch_ProductFamily] (
		ProductFamilyID,
		[Name],
		RecentProductVersionID
	)
		SELECT	ProductFamilyID,
			[Name],
			RecentProductVersionID
		FROM	#SecPatch_ProductFamily AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecPatch_ProductFamily]
			WHERE	SecPatch_ProductFamily.ProductFamilyID = t.ProductFamilyID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecPatch_ProductFamily	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductFamilyRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductFamilyRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecPatch_ProductFamilyRemoveBatch]
AS

	CREATE INDEX [TempSecPatch_ProductFamilySecPatch_ProductFamilyRemoveBatch]
		ON #SecPatch_ProductFamily (ProductFamilyID)	

	-- Delete records from SecPatch_ProductFamily identified by fields of [TempSecPatch_ProductFamilySecPatch_ProductFamilyRemoveBatch]
	DELETE [dbo].[SecPatch_ProductFamily]
	WHERE EXISTS(
			SELECT * FROM #SecPatch_ProductFamily AS t
			WHERE	SecPatch_ProductFamily.ProductFamilyID = t.ProductFamilyID
		)
	DROP TABLE #SecPatch_ProductFamily      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductFamilyRemoveByProductFamilyID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductFamilyRemoveByProductFamilyID]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductFamilyRemoveByProductFamilyID]
	@ProductFamilyID	int
AS
	-- SecPatch_ProductFamily deletes cascade to:
	--	SecPatch_ProductProductFamily by FK_ProductProductFamily_ProductFamily
	DELETE	[dbo].[SecPatch_ProductFamily]
	WHERE	ProductFamilyID = @ProductFamilyID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductFamilyRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductFamilyRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductFamilyRemoveAll]
	
AS
	DELETE	[dbo].[SecPatch_ProductFamily]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductProductFamilyGetByProductIDProductFamilyID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductProductFamilyGetByProductIDProductFamilyID]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductProductFamilyGetByProductIDProductFamilyID]
	@ProductID		int,
	@ProductFamilyID	int
AS
	SELECT	ProductProductFamilyID,
		ProductID,
		ProductFamilyID
	FROM	[dbo].[SecPatch_ProductProductFamily]
	WHERE	ProductID = @ProductID
	  AND	ProductFamilyID = @ProductFamilyID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductProductFamilyGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductProductFamilyGetAll]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductProductFamilyGetAll]
AS
	SELECT	ProductProductFamilyID,
		ProductID,
		ProductFamilyID
	FROM	[dbo].[SecPatch_ProductProductFamily]
	ORDER BY ProductID, ProductFamilyID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductProductFamilyAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductProductFamilyAdd]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductProductFamilyAdd]
	@ProductID		int,
	@ProductFamilyID	int
AS
	INSERT INTO  dbo.SecPatch_ProductProductFamily (
		ProductID,
		ProductFamilyID
	)
	VALUES (
		@ProductID,
		@ProductFamilyID
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductProductFamilyBind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductProductFamilyBind]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductProductFamilyBind]
	@ProductID		int,
	@ProductFamilyID	int
AS
	DECLARE	@ID	int

	SELECT	@ID = ProductProductFamilyID
	FROM	[dbo].[SecPatch_ProductProductFamily]
	WHERE	ProductID = @ProductID
	  AND	ProductFamilyID = @ProductFamilyID

	IF @@ROWCOUNT = 0
	BEGIN
		EXEC SecPatch_ProductProductFamilyAdd @ProductID,
			@ProductFamilyID

		SELECT	@ID = ProductProductFamilyID
		FROM	[dbo].[SecPatch_ProductProductFamily]
		WHERE	ProductID = @ProductID
		  AND	ProductFamilyID = @ProductFamilyID
	END

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductProductFamilySchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductProductFamilySchema]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductProductFamilySchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecPatch_ProductProductFamily'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecPatch_ProductProductFamily (' + CAST(0x0A AS CHAR(1)) +
	'		ProductID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		ProductFamilyID		int NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecPatch_ProductProductFamily' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductProductFamilyTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductProductFamilyTempAdd]
GO
CREATE PROCEDURE dbo.[SecPatch_ProductProductFamilyTempAdd]
	@ProductID		int,
	@ProductFamilyID	int
AS
	INSERT INTO #SecPatch_ProductProductFamily (
		ProductID,
		ProductFamilyID
	)
	VALUES (
		@ProductID,
		@ProductFamilyID
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductProductFamilyAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductProductFamilyAddBatch]
GO
CREATE PROCEDURE dbo.[SecPatch_ProductProductFamilyAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecPatch_ProductProductFamily (
		ProductID,
		ProductFamilyID
	)
		SELECT	ProductID,
			ProductFamilyID
		FROM #SecPatch_ProductProductFamily
	SET @count = @@ROWCOUNT
	DROP TABLE #SecPatch_ProductProductFamily	-- Drop temporary table
	RETURN @count
GO

/*
Add new SecPatch_ProductProductFamily bound to
	SecPatch_Product using Name
	with ProductFamilyID
*/

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductProductFamilyPutByProductIDProductFamilyID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductProductFamilyPutByProductIDProductFamilyID]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductProductFamilyPutByProductIDProductFamilyID]
	@ProductID		int,
	@ProductFamilyID	int
AS
	IF NOT EXISTS(
		SELECT	1
		FROM	dbo.SecPatch_ProductProductFamily
		WHERE	ProductID = @ProductID
		  AND	ProductFamilyID = @ProductFamilyID
	)
		EXEC SecPatch_ProductProductFamilyAdd @ProductID,
			@ProductFamilyID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductProductFamilyPutBatchByProductIDProductFamilyID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductProductFamilyPutBatchByProductIDProductFamilyID]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductProductFamilyPutBatchByProductIDProductFamilyID]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecPatch_ProductProductFamilyProductIDProductFamilyID]
		ON #SecPatch_ProductProductFamily (ProductID, ProductFamilyID)

	BEGIN TRANSACTION

	INSERT [dbo].[SecPatch_ProductProductFamily] (
		ProductID,
		ProductFamilyID
	)
		SELECT	ProductID,
			ProductFamilyID
		FROM	#SecPatch_ProductProductFamily AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecPatch_ProductProductFamily]
			WHERE	SecPatch_ProductProductFamily.ProductID = t.ProductID
			  AND	SecPatch_ProductProductFamily.ProductFamilyID = t.ProductFamilyID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecPatch_ProductProductFamily	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductProductFamilyRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductProductFamilyRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecPatch_ProductProductFamilyRemoveBatch]
AS

	CREATE INDEX [TempSecPatch_ProductProductFamilySecPatch_ProductProductFamilyRemoveBatch]
		ON #SecPatch_ProductProductFamily (ProductID, ProductFamilyID)	

	-- Delete records from SecPatch_ProductProductFamily identified by fields of [TempSecPatch_ProductProductFamilySecPatch_ProductProductFamilyRemoveBatch]
	DELETE [dbo].[SecPatch_ProductProductFamily]
	WHERE EXISTS(
			SELECT * FROM #SecPatch_ProductProductFamily AS t
			WHERE	SecPatch_ProductProductFamily.ProductID = t.ProductID
			  AND	SecPatch_ProductProductFamily.ProductFamilyID = t.ProductFamilyID
		)
	DROP TABLE #SecPatch_ProductProductFamily      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductProductFamilyRemoveByProductIDProductFamilyID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductProductFamilyRemoveByProductIDProductFamilyID]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductProductFamilyRemoveByProductIDProductFamilyID]
	@ProductID		int,
	@ProductFamilyID	int
AS
	DELETE	[dbo].[SecPatch_ProductProductFamily]
	WHERE	ProductID = @ProductID
	  AND	ProductFamilyID = @ProductFamilyID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_ProductProductFamilyRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_ProductProductFamilyRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecPatch_ProductProductFamilyRemoveAll]
	
AS
	DELETE	[dbo].[SecPatch_ProductProductFamily]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_BulletinCommentGetByBulletinCommentID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_BulletinCommentGetByBulletinCommentID]
GO
CREATE PROCEDURE [dbo].[SecPatch_BulletinCommentGetByBulletinCommentID]
	@BulletinCommentID	int
AS
	SELECT	BulletinCommentID,
		CommentID,
		BulletinID
	FROM	[dbo].[SecPatch_BulletinComment]
	WHERE	BulletinCommentID = @BulletinCommentID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_BulletinCommentGetByCommentIDBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_BulletinCommentGetByCommentIDBulletinID]
GO
CREATE PROCEDURE [dbo].[SecPatch_BulletinCommentGetByCommentIDBulletinID]
	@CommentID		int,
	@BulletinID		nvarchar(50)
AS
	SELECT	BulletinCommentID,
		CommentID,
		BulletinID
	FROM	[dbo].[SecPatch_BulletinComment]
	WHERE	CommentID = @CommentID
	  AND	BulletinID = @BulletinID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_BulletinCommentGetAllByCommentID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_BulletinCommentGetAllByCommentID]
GO
CREATE PROCEDURE [dbo].[SecPatch_BulletinCommentGetAllByCommentID]
	@CommentID		int
AS
	SELECT	BulletinCommentID,
		CommentID,
		BulletinID
	FROM	[dbo].[SecPatch_BulletinComment]
	WHERE	CommentID = @CommentID
	ORDER BY BulletinID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_BulletinCommentGetAllOrderedByCommentID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_BulletinCommentGetAllOrderedByCommentID]
GO
CREATE PROCEDURE [dbo].[SecPatch_BulletinCommentGetAllOrderedByCommentID]
AS
	SELECT	BulletinCommentID,
		CommentID,
		BulletinID
	FROM	[dbo].[SecPatch_BulletinComment]
	ORDER BY CommentID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_BulletinCommentGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_BulletinCommentGetAll]
GO
CREATE PROCEDURE [dbo].[SecPatch_BulletinCommentGetAll]
AS
	SELECT	BulletinCommentID,
		CommentID,
		BulletinID
	FROM	[dbo].[SecPatch_BulletinComment]
	ORDER BY BulletinCommentID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_BulletinCommentAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_BulletinCommentAdd]
GO
CREATE PROCEDURE [dbo].[SecPatch_BulletinCommentAdd]
	@CommentID		int,
	@BulletinID		nvarchar(50)
AS
	INSERT INTO  dbo.SecPatch_BulletinComment (
		CommentID,
		BulletinID
	)
	VALUES (
		@CommentID,
		@BulletinID
	)
	RETURN SCOPE_IDENTITY()
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_BulletinCommentBind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_BulletinCommentBind]
GO
CREATE PROCEDURE [dbo].[SecPatch_BulletinCommentBind]
	@CommentID		int,
	@BulletinID		nvarchar(50)
AS
	DECLARE	@ID	int

	SELECT	@ID = BulletinCommentID
	FROM	[dbo].[SecPatch_BulletinComment]
	WHERE	CommentID = @CommentID
	  AND	BulletinID = @BulletinID

	IF @ID IS NULL
		EXEC @ID = SecPatch_BulletinCommentAdd @CommentID,
			@BulletinID

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_BulletinCommentSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_BulletinCommentSchema]
GO
CREATE PROCEDURE [dbo].[SecPatch_BulletinCommentSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecPatch_BulletinComment'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecPatch_BulletinComment (' + CAST(0x0A AS CHAR(1)) +
	'		BulletinCommentID	int NULL,' + CAST(0x0A AS CHAR(1)) +
	'		CommentID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		BulletinID		nvarchar(50) COLLATE database_default NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecPatch_BulletinComment' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_BulletinCommentTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_BulletinCommentTempAdd]
GO
CREATE PROCEDURE dbo.[SecPatch_BulletinCommentTempAdd]
	@BulletinCommentID	int,
	@CommentID		int,
	@BulletinID		nvarchar(50)
AS
	INSERT INTO #SecPatch_BulletinComment (
		BulletinCommentID,
		CommentID,
		BulletinID
	)
	VALUES (
		@BulletinCommentID,
		@CommentID,
		@BulletinID
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_BulletinCommentAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_BulletinCommentAddBatch]
GO
CREATE PROCEDURE dbo.[SecPatch_BulletinCommentAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecPatch_BulletinComment (
		CommentID,
		BulletinID
	)
		SELECT	CommentID,
			BulletinID
		FROM #SecPatch_BulletinComment
	SET @count = @@ROWCOUNT
	DROP TABLE #SecPatch_BulletinComment	-- Drop temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_BulletinCommentUpdateByBulletinCommentID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_BulletinCommentUpdateByBulletinCommentID]
GO
CREATE PROCEDURE [dbo].[SecPatch_BulletinCommentUpdateByBulletinCommentID]
	@BulletinCommentID	int,
	@CommentID		int,
	@BulletinID		nvarchar(50)
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[SecPatch_BulletinComment]
	SET	@ID = BulletinCommentID,
		CommentID = @CommentID,
		BulletinID = @BulletinID
	WHERE	BulletinCommentID = @BulletinCommentID
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_BulletinCommentUpdateBatchByBulletinCommentID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_BulletinCommentUpdateBatchByBulletinCommentID]
GO
CREATE PROCEDURE dbo.[SecPatch_BulletinCommentUpdateBatchByBulletinCommentID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecPatch_BulletinCommentBulletinCommentID]
		ON #SecPatch_BulletinComment (BulletinCommentID)

	UPDATE	[dbo].[SecPatch_BulletinComment]
	SET	CommentID = t.CommentID,
		BulletinID = t.BulletinID
	FROM	#SecPatch_BulletinComment AS t
	WHERE	SecPatch_BulletinComment.BulletinCommentID = t.BulletinCommentID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecPatch_BulletinComment	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_BulletinCommentPutByCommentIDBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_BulletinCommentPutByCommentIDBulletinID]
GO
CREATE PROCEDURE [dbo].[SecPatch_BulletinCommentPutByCommentIDBulletinID]
	@CommentID		int,
	@BulletinID		nvarchar(50)
AS
	DECLARE @ID	int

	SELECT	@ID = BulletinCommentID
	FROM	SecPatch_BulletinComment
	WHERE	CommentID = @CommentID
	  AND	BulletinID = @BulletinID

	IF @ID IS NULL
		EXEC @ID = SecPatch_BulletinCommentAdd @CommentID,
			@BulletinID

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_BulletinCommentPutBatchByCommentIDBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_BulletinCommentPutBatchByCommentIDBulletinID]
GO
CREATE PROCEDURE [dbo].[SecPatch_BulletinCommentPutBatchByCommentIDBulletinID]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecPatch_BulletinCommentCommentIDBulletinID]
		ON #SecPatch_BulletinComment (CommentID, BulletinID)

	BEGIN TRANSACTION

	INSERT [dbo].[SecPatch_BulletinComment] (
		CommentID,
		BulletinID
	)
		SELECT	CommentID,
			BulletinID
		FROM	#SecPatch_BulletinComment AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecPatch_BulletinComment]
			WHERE	SecPatch_BulletinComment.CommentID = t.CommentID
			  AND	SecPatch_BulletinComment.BulletinID = t.BulletinID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecPatch_BulletinComment	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_BulletinCommentRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_BulletinCommentRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecPatch_BulletinCommentRemoveBatch]
AS

	CREATE INDEX [TempSecPatch_BulletinCommentSecPatch_BulletinCommentRemoveBatch]
		ON #SecPatch_BulletinComment (BulletinCommentID)	

	-- Delete records from SecPatch_BulletinComment identified by fields of [TempSecPatch_BulletinCommentSecPatch_BulletinCommentRemoveBatch]
	DELETE [dbo].[SecPatch_BulletinComment]
	WHERE EXISTS(
			SELECT * FROM #SecPatch_BulletinComment AS t
			WHERE	SecPatch_BulletinComment.BulletinCommentID = t.BulletinCommentID
		)
	DROP TABLE #SecPatch_BulletinComment      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_BulletinCommentRemoveByCommentIDBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_BulletinCommentRemoveByCommentIDBulletinID]
GO
CREATE PROCEDURE [dbo].[SecPatch_BulletinCommentRemoveByCommentIDBulletinID]
	@CommentID		int,
	@BulletinID		nvarchar(50)
AS
	DELETE	[dbo].[SecPatch_BulletinComment]
	WHERE	CommentID = @CommentID
	  AND	BulletinID = @BulletinID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_BulletinCommentRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_BulletinCommentRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecPatch_BulletinCommentRemoveAll]
	
AS
	DELETE	[dbo].[SecPatch_BulletinComment]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_QNumberGetByqNumber]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_QNumberGetByqNumber]
GO
CREATE PROCEDURE [dbo].[SecPatch_QNumberGetByqNumber]
	@qNumber		nvarchar(50)
AS
	SELECT	qNumber,
		BulletinID
	FROM	[dbo].[SecPatch_QNumber]
	WHERE	qNumber = @qNumber
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_QNumberGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_QNumberGetAll]
GO
CREATE PROCEDURE [dbo].[SecPatch_QNumberGetAll]
AS
	SELECT	qNumber,
		BulletinID
	FROM	[dbo].[SecPatch_QNumber]
	ORDER BY qNumber
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_QNumberAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_QNumberAdd]
GO
CREATE PROCEDURE [dbo].[SecPatch_QNumberAdd]
	@qNumber		nvarchar(50),
	@BulletinID		nvarchar(50)
AS
	INSERT INTO  dbo.SecPatch_QNumber (
		qNumber,
		BulletinID
	)
	VALUES (
		@qNumber,
		@BulletinID
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_QNumberSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_QNumberSchema]
GO
CREATE PROCEDURE [dbo].[SecPatch_QNumberSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecPatch_QNumber'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecPatch_QNumber (' + CAST(0x0A AS CHAR(1)) +
	'		qNumber			nvarchar(50) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		BulletinID		nvarchar(50) COLLATE database_default NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecPatch_QNumber' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_QNumberTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_QNumberTempAdd]
GO
CREATE PROCEDURE dbo.[SecPatch_QNumberTempAdd]
	@qNumber		nvarchar(50),
	@BulletinID		nvarchar(50)
AS
	INSERT INTO #SecPatch_QNumber (
		qNumber,
		BulletinID
	)
	VALUES (
		@qNumber,
		@BulletinID
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_QNumberAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_QNumberAddBatch]
GO
CREATE PROCEDURE dbo.[SecPatch_QNumberAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecPatch_QNumber (
		qNumber,
		BulletinID
	)
		SELECT	qNumber,
			BulletinID
		FROM #SecPatch_QNumber
	SET @count = @@ROWCOUNT
	DROP TABLE #SecPatch_QNumber	-- Drop temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_QNumberUpdateByqNumber]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_QNumberUpdateByqNumber]
GO
CREATE PROCEDURE [dbo].[SecPatch_QNumberUpdateByqNumber]
	@qNumber		nvarchar(50),
	@BulletinID		nvarchar(50)
AS
	UPDATE	[dbo].[SecPatch_QNumber]
	SET	BulletinID = @BulletinID
	WHERE	qNumber = @qNumber
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_QNumberUpdateBatchByqNumber]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_QNumberUpdateBatchByqNumber]
GO
CREATE PROCEDURE dbo.[SecPatch_QNumberUpdateBatchByqNumber]
AS
	DECLARE @count int

	CREATE INDEX [TempSecPatch_QNumberqNumber]
		ON #SecPatch_QNumber (qNumber)

	UPDATE	[dbo].[SecPatch_QNumber]
	SET	BulletinID = t.BulletinID
	FROM	#SecPatch_QNumber AS t
	WHERE	SecPatch_QNumber.qNumber = t.qNumber
	SET @count = @@ROWCOUNT
	DROP TABLE #SecPatch_QNumber	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_QNumberPutByqNumber]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_QNumberPutByqNumber]
GO
CREATE PROCEDURE [dbo].[SecPatch_QNumberPutByqNumber]
	@qNumber		nvarchar(50),
	@BulletinID		nvarchar(50)
AS
	IF NOT EXISTS(
		SELECT	1
		FROM	dbo.SecPatch_QNumber
		WHERE	qNumber = @qNumber
	)
		EXEC SecPatch_QNumberAdd @qNumber,
			@BulletinID
	ELSE
		EXEC SecPatch_QNumberUpdateByqNumber @qNumber,
			@BulletinID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_QNumberPutBatchByqNumber]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_QNumberPutBatchByqNumber]
GO
CREATE PROCEDURE [dbo].[SecPatch_QNumberPutBatchByqNumber]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecPatch_QNumberqNumber]
		ON #SecPatch_QNumber (qNumber)

	BEGIN TRANSACTION
	UPDATE [dbo].[SecPatch_QNumber]
		SET	BulletinID = t.BulletinID
		FROM	#SecPatch_QNumber AS t
		WHERE	SecPatch_QNumber.qNumber = t.qNumber
	SET @count = @@ROWCOUNT

	INSERT [dbo].[SecPatch_QNumber] (
		qNumber,
		BulletinID
	)
		SELECT	qNumber,
			BulletinID
		FROM	#SecPatch_QNumber AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecPatch_QNumber]
			WHERE	SecPatch_QNumber.qNumber = t.qNumber
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecPatch_QNumber	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_QNumberRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_QNumberRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecPatch_QNumberRemoveBatch]
AS

	CREATE INDEX [TempSecPatch_QNumberSecPatch_QNumberRemoveBatch]
		ON #SecPatch_QNumber (qNumber)	

	-- Delete records from SecPatch_QNumber identified by fields of [TempSecPatch_QNumberSecPatch_QNumberRemoveBatch]
	DELETE [dbo].[SecPatch_QNumber]
	WHERE EXISTS(
			SELECT * FROM #SecPatch_QNumber AS t
			WHERE	SecPatch_QNumber.qNumber = t.qNumber
		)
	DROP TABLE #SecPatch_QNumber      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_QNumberRemoveByqNumber]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_QNumberRemoveByqNumber]
GO
CREATE PROCEDURE [dbo].[SecPatch_QNumberRemoveByqNumber]
	@qNumber		nvarchar(50)
AS
	DELETE	[dbo].[SecPatch_QNumber]
	WHERE	qNumber = @qNumber
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_QNumberRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_QNumberRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecPatch_QNumberRemoveAll]
	
AS
	DELETE	[dbo].[SecPatch_QNumber]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchGetByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchGetByID]
GO
CREATE PROCEDURE [dbo].[SecPatch_PatchGetByID]
	@PatchID		int
AS
	SELECT	PatchID,
		PatchName,
		BulletinID,
		PatchLocationID,
		SQNumber,
		NoReboot,
		SecurityPatchID
	FROM	[dbo].[SecPatch_Patch]
	WHERE	PatchID = @PatchID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchGetByBulletinIDPatchName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchGetByBulletinIDPatchName]
GO
CREATE PROCEDURE [dbo].[SecPatch_PatchGetByBulletinIDPatchName]
	@BulletinID		nvarchar(50),
	@PatchName		nvarchar(128)
AS
	SELECT	PatchID,
		PatchName,
		BulletinID,
		PatchLocationID,
		SQNumber,
		NoReboot,
		SecurityPatchID
	FROM	[dbo].[SecPatch_Patch]
	WHERE	BulletinID = @BulletinID
	  AND	PatchName = @PatchName
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchGetAllByBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchGetAllByBulletinID]
GO
CREATE PROCEDURE [dbo].[SecPatch_PatchGetAllByBulletinID]
	@BulletinID		nvarchar(50)
AS
	SELECT	PatchID,
		PatchName,
		BulletinID,
		PatchLocationID,
		SQNumber,
		NoReboot,
		SecurityPatchID
	FROM	[dbo].[SecPatch_Patch]
	WHERE	BulletinID = @BulletinID
	ORDER BY PatchName
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchGetAllOrderedByBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchGetAllOrderedByBulletinID]
GO
CREATE PROCEDURE [dbo].[SecPatch_PatchGetAllOrderedByBulletinID]
AS
	SELECT	PatchID,
		PatchName,
		BulletinID,
		PatchLocationID,
		SQNumber,
		NoReboot,
		SecurityPatchID
	FROM	[dbo].[SecPatch_Patch]
	ORDER BY BulletinID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchGetBySecurityPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchGetBySecurityPatchID]
GO
CREATE PROCEDURE [dbo].[SecPatch_PatchGetBySecurityPatchID]
	@SecurityPatchID	int
AS
	SELECT	PatchID,
		PatchName,
		BulletinID,
		PatchLocationID,
		SQNumber,
		NoReboot,
		SecurityPatchID
	FROM	[dbo].[SecPatch_Patch]
	WHERE	SecurityPatchID = @SecurityPatchID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchGetAllOrderedBySecurityPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchGetAllOrderedBySecurityPatchID]
GO
CREATE PROCEDURE [dbo].[SecPatch_PatchGetAllOrderedBySecurityPatchID]
AS
	SELECT	PatchID,
		PatchName,
		BulletinID,
		PatchLocationID,
		SQNumber,
		NoReboot,
		SecurityPatchID
	FROM	[dbo].[SecPatch_Patch]
	ORDER BY SecurityPatchID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchGetAll]
GO
CREATE PROCEDURE [dbo].[SecPatch_PatchGetAll]
AS
	SELECT	PatchID,
		PatchName,
		BulletinID,
		PatchLocationID,
		SQNumber,
		NoReboot,
		SecurityPatchID
	FROM	[dbo].[SecPatch_Patch]
	ORDER BY PatchID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchAdd]
GO
CREATE PROCEDURE [dbo].[SecPatch_PatchAdd]
	@PatchName		nvarchar(128),
	@BulletinID		nvarchar(50),
	@PatchLocationID	int,
	@SQNumber		nvarchar(50),
	@NoReboot		int,
	@SecurityPatchID	int
AS
	INSERT INTO  dbo.SecPatch_Patch (
		PatchName,
		BulletinID,
		PatchLocationID,
		SQNumber,
		NoReboot,
		SecurityPatchID
	)
	VALUES (
		@PatchName,
		@BulletinID,
		@PatchLocationID,
		@SQNumber,
		@NoReboot,
		@SecurityPatchID
	)
	RETURN SCOPE_IDENTITY()
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchBind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchBind]
GO
CREATE PROCEDURE [dbo].[SecPatch_PatchBind]
	@PatchName		nvarchar(128),
	@BulletinID		nvarchar(50),
	@PatchLocationID	int,
	@SQNumber		nvarchar(50),
	@NoReboot		int,
	@SecurityPatchID	int
AS
	DECLARE	@ID	int

	SELECT	@ID = PatchID
	FROM	[dbo].[SecPatch_Patch]
	WHERE	BulletinID = @BulletinID
	  AND	PatchName = @PatchName

	IF @ID IS NULL
		EXEC @ID = SecPatch_PatchAdd @PatchName,
			@BulletinID,
			@PatchLocationID,
			@SQNumber,
			@NoReboot,
			@SecurityPatchID

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchSchema]
GO
CREATE PROCEDURE [dbo].[SecPatch_PatchSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecPatch_Patch'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecPatch_Patch (' + CAST(0x0A AS CHAR(1)) +
	'		PatchID			int NULL,' + CAST(0x0A AS CHAR(1)) +
	'		PatchName		nvarchar(128) COLLATE Latin1_General_CS_AS NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		BulletinID		nvarchar(50) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		PatchLocationID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		SQNumber		nvarchar(50) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		NoReboot		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		SecurityPatchID		int NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecPatch_Patch' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchTempAdd]
GO
CREATE PROCEDURE dbo.[SecPatch_PatchTempAdd]
	@PatchID		int,
	@PatchName		nvarchar(128),
	@BulletinID		nvarchar(50),
	@PatchLocationID	int,
	@SQNumber		nvarchar(50),
	@NoReboot		int,
	@SecurityPatchID	int
AS
	INSERT INTO #SecPatch_Patch (
		PatchID,
		PatchName,
		BulletinID,
		PatchLocationID,
		SQNumber,
		NoReboot,
		SecurityPatchID
	)
	VALUES (
		@PatchID,
		@PatchName,
		@BulletinID,
		@PatchLocationID,
		@SQNumber,
		@NoReboot,
		@SecurityPatchID
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchAddBatch]
GO
CREATE PROCEDURE dbo.[SecPatch_PatchAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecPatch_Patch (
		PatchName,
		BulletinID,
		PatchLocationID,
		SQNumber,
		NoReboot,
		SecurityPatchID
	)
		SELECT	PatchName,
			BulletinID,
			PatchLocationID,
			SQNumber,
			NoReboot,
			SecurityPatchID
		FROM #SecPatch_Patch
	SET @count = @@ROWCOUNT
	DROP TABLE #SecPatch_Patch	-- Drop temporary table
	RETURN @count
GO

/*
Add new SecPatch_Patch bound to
	SecurityPatch using BulletinID, PatchName with Title, QNumber
	with PatchName, BulletinID, PatchLocationID, SQNumber, NoReboot
*/

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchUpdateByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchUpdateByID]
GO
CREATE PROCEDURE [dbo].[SecPatch_PatchUpdateByID]
	@PatchID		int,
	@PatchName		nvarchar(128),
	@BulletinID		nvarchar(50),
	@PatchLocationID	int,
	@SQNumber		nvarchar(50),
	@NoReboot		int,
	@SecurityPatchID	int
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[SecPatch_Patch]
	SET	@ID = PatchID,
		PatchName = @PatchName,
		BulletinID = @BulletinID,
		PatchLocationID = @PatchLocationID,
		SQNumber = @SQNumber,
		NoReboot = @NoReboot,
		SecurityPatchID = @SecurityPatchID
	WHERE	PatchID = @PatchID
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchUpdateBatchByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchUpdateBatchByID]
GO
CREATE PROCEDURE dbo.[SecPatch_PatchUpdateBatchByID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecPatch_PatchID]
		ON #SecPatch_Patch (PatchID)

	UPDATE	[dbo].[SecPatch_Patch]
	SET	PatchName = t.PatchName,
		BulletinID = t.BulletinID,
		PatchLocationID = t.PatchLocationID,
		SQNumber = t.SQNumber,
		NoReboot = t.NoReboot,
		SecurityPatchID = t.SecurityPatchID
	FROM	#SecPatch_Patch AS t
	WHERE	SecPatch_Patch.PatchID = t.PatchID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecPatch_Patch	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchUpdateByBulletinIDPatchName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchUpdateByBulletinIDPatchName]
GO
CREATE PROCEDURE [dbo].[SecPatch_PatchUpdateByBulletinIDPatchName]
	@BulletinID		nvarchar(50),
	@PatchName		nvarchar(128),
	@PatchLocationID	int,
	@SQNumber		nvarchar(50),
	@NoReboot		int,
	@SecurityPatchID	int
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[SecPatch_Patch]
	SET	@ID = PatchID,
		PatchLocationID = @PatchLocationID,
		SQNumber = @SQNumber,
		NoReboot = @NoReboot,
		SecurityPatchID = @SecurityPatchID
	WHERE	BulletinID = @BulletinID
	  AND	PatchName = @PatchName
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchUpdateBatchByBulletinIDPatchName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchUpdateBatchByBulletinIDPatchName]
GO
CREATE PROCEDURE dbo.[SecPatch_PatchUpdateBatchByBulletinIDPatchName]
AS
	DECLARE @count int

	CREATE INDEX [TempSecPatch_PatchBulletinIDPatchName]
		ON #SecPatch_Patch (BulletinID, PatchName)

	UPDATE	[dbo].[SecPatch_Patch]
	SET	PatchLocationID = t.PatchLocationID,
		SQNumber = t.SQNumber,
		NoReboot = t.NoReboot,
		SecurityPatchID = t.SecurityPatchID
	FROM	#SecPatch_Patch AS t
	WHERE	SecPatch_Patch.BulletinID = t.BulletinID
	  AND	SecPatch_Patch.PatchName = t.PatchName
	SET @count = @@ROWCOUNT
	DROP TABLE #SecPatch_Patch	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchPutByBulletinIDPatchName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchPutByBulletinIDPatchName]
GO
CREATE PROCEDURE [dbo].[SecPatch_PatchPutByBulletinIDPatchName]
	@BulletinID		nvarchar(50),
	@PatchName		nvarchar(128),
	@PatchLocationID	int,
	@SQNumber		nvarchar(50),
	@NoReboot		int,
	@SecurityPatchID	int
AS
	DECLARE @ID	int

	SELECT	@ID = PatchID
	FROM	SecPatch_Patch
	WHERE	BulletinID = @BulletinID
	  AND	PatchName = @PatchName

	IF @ID IS NULL
		EXEC @ID = SecPatch_PatchAdd @PatchName,
			@BulletinID,
			@PatchLocationID,
			@SQNumber,
			@NoReboot,
			@SecurityPatchID
	ELSE
		EXEC SecPatch_PatchUpdateByBulletinIDPatchName @BulletinID,
			@PatchName,
			@PatchLocationID,
			@SQNumber,
			@NoReboot,
			@SecurityPatchID

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchPutBatchByBulletinIDPatchName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchPutBatchByBulletinIDPatchName]
GO
CREATE PROCEDURE [dbo].[SecPatch_PatchPutBatchByBulletinIDPatchName]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecPatch_PatchBulletinIDPatchName]
		ON #SecPatch_Patch (BulletinID, PatchName)

	BEGIN TRANSACTION
	UPDATE [dbo].[SecPatch_Patch]
		SET	PatchLocationID = t.PatchLocationID,
			SQNumber = t.SQNumber,
			NoReboot = t.NoReboot,
			SecurityPatchID = t.SecurityPatchID
		FROM	#SecPatch_Patch AS t
		WHERE	SecPatch_Patch.BulletinID = t.BulletinID
		  AND	SecPatch_Patch.PatchName = t.PatchName
	SET @count = @@ROWCOUNT

	INSERT [dbo].[SecPatch_Patch] (
		PatchName,
		BulletinID,
		PatchLocationID,
		SQNumber,
		NoReboot,
		SecurityPatchID
	)
		SELECT	PatchName,
			BulletinID,
			PatchLocationID,
			SQNumber,
			NoReboot,
			SecurityPatchID
		FROM	#SecPatch_Patch AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecPatch_Patch]
			WHERE	SecPatch_Patch.BulletinID = t.BulletinID
			  AND	SecPatch_Patch.PatchName = t.PatchName
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecPatch_Patch	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecPatch_PatchRemoveBatch]
AS

	CREATE INDEX [TempSecPatch_PatchSecPatch_PatchRemoveBatch]
		ON #SecPatch_Patch (PatchID)	

	-- Delete records from SecPatch_Patch identified by fields of [TempSecPatch_PatchSecPatch_PatchRemoveBatch]
	DELETE [dbo].[SecPatch_Patch]
	WHERE EXISTS(
			SELECT * FROM #SecPatch_Patch AS t
			WHERE	SecPatch_Patch.PatchID = t.PatchID
		)
	DROP TABLE #SecPatch_Patch      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchRemoveByBulletinIDPatchName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchRemoveByBulletinIDPatchName]
GO
CREATE PROCEDURE [dbo].[SecPatch_PatchRemoveByBulletinIDPatchName]
	@BulletinID		nvarchar(50),
	@PatchName		nvarchar(128)
AS
	-- SecPatch_Patch deletes cascade to:
	--	SecPatch_AffectedProduct by FK_AffectedProduct_Patch
	--		SecPatch_AffectedServicePack by FK_AffectedServicePack_AffectedProduct
	--	SecPatch_PatchComment by FK_PatchComment_Patch
	DELETE	[dbo].[SecPatch_Patch]
	WHERE	BulletinID = @BulletinID
	  AND	PatchName = @PatchName
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchRemoveAllByBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchRemoveAllByBulletinID]
GO
CREATE PROCEDURE [dbo].[SecPatch_PatchRemoveAllByBulletinID]
	@BulletinID		nvarchar(50)
AS
	DELETE	[dbo].[SecPatch_Patch]
	WHERE	BulletinID = @BulletinID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchRemoveBySecurityPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchRemoveBySecurityPatchID]
GO
CREATE PROCEDURE [dbo].[SecPatch_PatchRemoveBySecurityPatchID]
	@SecurityPatchID	int
AS
	-- SecPatch_Patch deletes cascade to:
	--	SecPatch_AffectedProduct by FK_AffectedProduct_Patch
	--		SecPatch_AffectedServicePack by FK_AffectedServicePack_AffectedProduct
	--	SecPatch_PatchComment by FK_PatchComment_Patch
	DELETE	[dbo].[SecPatch_Patch]
	WHERE	SecurityPatchID = @SecurityPatchID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecPatch_PatchRemoveAll]
	
AS
	DELETE	[dbo].[SecPatch_Patch]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchCommentGetByPatchCommentID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchCommentGetByPatchCommentID]
GO
CREATE PROCEDURE [dbo].[SecPatch_PatchCommentGetByPatchCommentID]
	@PatchCommentID		int
AS
	SELECT	PatchCommentID,
		CommentID,
		PatchID
	FROM	[dbo].[SecPatch_PatchComment]
	WHERE	PatchCommentID = @PatchCommentID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchCommentGetByCommentIDPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchCommentGetByCommentIDPatchID]
GO
CREATE PROCEDURE [dbo].[SecPatch_PatchCommentGetByCommentIDPatchID]
	@CommentID		int,
	@PatchID		int
AS
	SELECT	PatchCommentID,
		CommentID,
		PatchID
	FROM	[dbo].[SecPatch_PatchComment]
	WHERE	CommentID = @CommentID
	  AND	PatchID = @PatchID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchCommentGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchCommentGetAll]
GO
CREATE PROCEDURE [dbo].[SecPatch_PatchCommentGetAll]
AS
	SELECT	PatchCommentID,
		CommentID,
		PatchID
	FROM	[dbo].[SecPatch_PatchComment]
	ORDER BY PatchCommentID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchCommentAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchCommentAdd]
GO
CREATE PROCEDURE [dbo].[SecPatch_PatchCommentAdd]
	@CommentID		int,
	@PatchID		int
AS
	INSERT INTO  dbo.SecPatch_PatchComment (
		CommentID,
		PatchID
	)
	VALUES (
		@CommentID,
		@PatchID
	)
	RETURN SCOPE_IDENTITY()
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchCommentBind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchCommentBind]
GO
CREATE PROCEDURE [dbo].[SecPatch_PatchCommentBind]
	@CommentID		int,
	@PatchID		int
AS
	DECLARE	@ID	int

	SELECT	@ID = PatchCommentID
	FROM	[dbo].[SecPatch_PatchComment]
	WHERE	CommentID = @CommentID
	  AND	PatchID = @PatchID

	IF @ID IS NULL
		EXEC @ID = SecPatch_PatchCommentAdd @CommentID,
			@PatchID

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchCommentSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchCommentSchema]
GO
CREATE PROCEDURE [dbo].[SecPatch_PatchCommentSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecPatch_PatchComment'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecPatch_PatchComment (' + CAST(0x0A AS CHAR(1)) +
	'		PatchCommentID		int NULL,' + CAST(0x0A AS CHAR(1)) +
	'		CommentID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		PatchID			int NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecPatch_PatchComment' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchCommentTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchCommentTempAdd]
GO
CREATE PROCEDURE dbo.[SecPatch_PatchCommentTempAdd]
	@PatchCommentID		int,
	@CommentID		int,
	@PatchID		int
AS
	INSERT INTO #SecPatch_PatchComment (
		PatchCommentID,
		CommentID,
		PatchID
	)
	VALUES (
		@PatchCommentID,
		@CommentID,
		@PatchID
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchCommentAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchCommentAddBatch]
GO
CREATE PROCEDURE dbo.[SecPatch_PatchCommentAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecPatch_PatchComment (
		CommentID,
		PatchID
	)
		SELECT	CommentID,
			PatchID
		FROM #SecPatch_PatchComment
	SET @count = @@ROWCOUNT
	DROP TABLE #SecPatch_PatchComment	-- Drop temporary table
	RETURN @count
GO

/*
Add new SecPatch_PatchComment bound to
	SecPatch_Patch using BulletinID, PatchName with PatchLocationID, SQNumber, NoReboot, SecurityPatchID
	with CommentID
*/

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchCommentUpdateByPatchCommentID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchCommentUpdateByPatchCommentID]
GO
CREATE PROCEDURE [dbo].[SecPatch_PatchCommentUpdateByPatchCommentID]
	@PatchCommentID		int,
	@CommentID		int,
	@PatchID		int
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[SecPatch_PatchComment]
	SET	@ID = PatchCommentID,
		CommentID = @CommentID,
		PatchID = @PatchID
	WHERE	PatchCommentID = @PatchCommentID
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchCommentUpdateBatchByPatchCommentID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchCommentUpdateBatchByPatchCommentID]
GO
CREATE PROCEDURE dbo.[SecPatch_PatchCommentUpdateBatchByPatchCommentID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecPatch_PatchCommentPatchCommentID]
		ON #SecPatch_PatchComment (PatchCommentID)

	UPDATE	[dbo].[SecPatch_PatchComment]
	SET	CommentID = t.CommentID,
		PatchID = t.PatchID
	FROM	#SecPatch_PatchComment AS t
	WHERE	SecPatch_PatchComment.PatchCommentID = t.PatchCommentID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecPatch_PatchComment	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchCommentPutByCommentIDPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchCommentPutByCommentIDPatchID]
GO
CREATE PROCEDURE [dbo].[SecPatch_PatchCommentPutByCommentIDPatchID]
	@CommentID		int,
	@PatchID		int
AS
	DECLARE @ID	int

	SELECT	@ID = PatchCommentID
	FROM	SecPatch_PatchComment
	WHERE	CommentID = @CommentID
	  AND	PatchID = @PatchID

	IF @ID IS NULL
		EXEC @ID = SecPatch_PatchCommentAdd @CommentID,
			@PatchID

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchCommentPutBatchByCommentIDPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchCommentPutBatchByCommentIDPatchID]
GO
CREATE PROCEDURE [dbo].[SecPatch_PatchCommentPutBatchByCommentIDPatchID]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecPatch_PatchCommentCommentIDPatchID]
		ON #SecPatch_PatchComment (CommentID, PatchID)

	BEGIN TRANSACTION

	INSERT [dbo].[SecPatch_PatchComment] (
		CommentID,
		PatchID
	)
		SELECT	CommentID,
			PatchID
		FROM	#SecPatch_PatchComment AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecPatch_PatchComment]
			WHERE	SecPatch_PatchComment.CommentID = t.CommentID
			  AND	SecPatch_PatchComment.PatchID = t.PatchID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecPatch_PatchComment	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchCommentRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchCommentRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecPatch_PatchCommentRemoveBatch]
AS

	CREATE INDEX [TempSecPatch_PatchCommentSecPatch_PatchCommentRemoveBatch]
		ON #SecPatch_PatchComment (PatchCommentID)	

	-- Delete records from SecPatch_PatchComment identified by fields of [TempSecPatch_PatchCommentSecPatch_PatchCommentRemoveBatch]
	DELETE [dbo].[SecPatch_PatchComment]
	WHERE EXISTS(
			SELECT * FROM #SecPatch_PatchComment AS t
			WHERE	SecPatch_PatchComment.PatchCommentID = t.PatchCommentID
		)
	DROP TABLE #SecPatch_PatchComment      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchCommentRemoveByCommentIDPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchCommentRemoveByCommentIDPatchID]
GO
CREATE PROCEDURE [dbo].[SecPatch_PatchCommentRemoveByCommentIDPatchID]
	@CommentID		int,
	@PatchID		int
AS
	DELETE	[dbo].[SecPatch_PatchComment]
	WHERE	CommentID = @CommentID
	  AND	PatchID = @PatchID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_PatchCommentRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_PatchCommentRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecPatch_PatchCommentRemoveAll]
	
AS
	DELETE	[dbo].[SecPatch_PatchComment]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_BulletinGetByBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_BulletinGetByBulletinID]
GO
CREATE PROCEDURE [dbo].[SecPatch_BulletinGetByBulletinID]
	@BulletinID		nvarchar(50)
AS
	SELECT	BulletinID,
		BulletinLocationID,
		FAQLocationID,
		Title,
		DatePosted,
		DateRevised,
		Supported,
		Summary,
		Issue,
		ImpactSeverityID,
		PreReqSeverityID,
		MitigationSeverityID,
		PopularitySeverityID
	FROM	[dbo].[SecPatch_Bulletin]
	WHERE	BulletinID = @BulletinID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_BulletinGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_BulletinGetAll]
GO
CREATE PROCEDURE [dbo].[SecPatch_BulletinGetAll]
AS
	SELECT	BulletinID,
		BulletinLocationID,
		FAQLocationID,
		Title,
		DatePosted,
		DateRevised,
		Supported,
		Summary,
		Issue,
		ImpactSeverityID,
		PreReqSeverityID,
		MitigationSeverityID,
		PopularitySeverityID
	FROM	[dbo].[SecPatch_Bulletin]
	ORDER BY BulletinID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_BulletinAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_BulletinAdd]
GO
CREATE PROCEDURE [dbo].[SecPatch_BulletinAdd]
	@BulletinID		nvarchar(50),
	@BulletinLocationID	int,
	@FAQLocationID		int = NULL,
	@Title			nvarchar(128) = NULL,
	@DatePosted		datetime = NULL,
	@DateRevised		datetime = NULL,
	@Supported		nvarchar(10),
	@Summary		ntext = NULL,
	@Issue			ntext = NULL,
	@ImpactSeverityID	char(10),
	@PreReqSeverityID	char(10),
	@MitigationSeverityID	char(10),
	@PopularitySeverityID	char(10)
AS
	INSERT INTO  dbo.SecPatch_Bulletin (
		BulletinID,
		BulletinLocationID,
		FAQLocationID,
		Title,
		DatePosted,
		DateRevised,
		Supported,
		Summary,
		Issue,
		ImpactSeverityID,
		PreReqSeverityID,
		MitigationSeverityID,
		PopularitySeverityID
	)
	VALUES (
		@BulletinID,
		@BulletinLocationID,
		@FAQLocationID,
		@Title,
		@DatePosted,
		@DateRevised,
		@Supported,
		@Summary,
		@Issue,
		@ImpactSeverityID,
		@PreReqSeverityID,
		@MitigationSeverityID,
		@PopularitySeverityID
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_BulletinSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_BulletinSchema]
GO
CREATE PROCEDURE [dbo].[SecPatch_BulletinSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecPatch_Bulletin'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecPatch_Bulletin (' + CAST(0x0A AS CHAR(1)) +
	'		BulletinID		nvarchar(50) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		BulletinLocationID	int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		FAQLocationID		int NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Title			nvarchar(128) COLLATE database_default NULL,' + CAST(0x0A AS CHAR(1)) +
	'		DatePosted		datetime NULL,' + CAST(0x0A AS CHAR(1)) +
	'		DateRevised		datetime NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Supported		nvarchar(10) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Summary			ntext COLLATE database_default NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Issue			ntext COLLATE database_default NULL,' + CAST(0x0A AS CHAR(1)) +
	'		ImpactSeverityID	char(10) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		PreReqSeverityID	char(10) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		MitigationSeverityID	char(10) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		PopularitySeverityID	char(10) COLLATE database_default NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecPatch_Bulletin' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_BulletinTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_BulletinTempAdd]
GO
CREATE PROCEDURE dbo.[SecPatch_BulletinTempAdd]
	@BulletinID		nvarchar(50),
	@BulletinLocationID	int,
	@FAQLocationID		int = NULL,
	@Title			nvarchar(128) = NULL,
	@DatePosted		datetime = NULL,
	@DateRevised		datetime = NULL,
	@Supported		nvarchar(10),
	@Summary		ntext = NULL,
	@Issue			ntext = NULL,
	@ImpactSeverityID	char(10),
	@PreReqSeverityID	char(10),
	@MitigationSeverityID	char(10),
	@PopularitySeverityID	char(10)
AS
	INSERT INTO #SecPatch_Bulletin (
		BulletinID,
		BulletinLocationID,
		FAQLocationID,
		Title,
		DatePosted,
		DateRevised,
		Supported,
		Summary,
		Issue,
		ImpactSeverityID,
		PreReqSeverityID,
		MitigationSeverityID,
		PopularitySeverityID
	)
	VALUES (
		@BulletinID,
		@BulletinLocationID,
		@FAQLocationID,
		@Title,
		@DatePosted,
		@DateRevised,
		@Supported,
		@Summary,
		@Issue,
		@ImpactSeverityID,
		@PreReqSeverityID,
		@MitigationSeverityID,
		@PopularitySeverityID
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_BulletinAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_BulletinAddBatch]
GO
CREATE PROCEDURE dbo.[SecPatch_BulletinAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecPatch_Bulletin (
		BulletinID,
		BulletinLocationID,
		FAQLocationID,
		Title,
		DatePosted,
		DateRevised,
		Supported,
		Summary,
		Issue,
		ImpactSeverityID,
		PreReqSeverityID,
		MitigationSeverityID,
		PopularitySeverityID
	)
		SELECT	BulletinID,
			BulletinLocationID,
			FAQLocationID,
			Title,
			DatePosted,
			DateRevised,
			Supported,
			Summary,
			Issue,
			ImpactSeverityID,
			PreReqSeverityID,
			MitigationSeverityID,
			PopularitySeverityID
		FROM #SecPatch_Bulletin
	SET @count = @@ROWCOUNT
	DROP TABLE #SecPatch_Bulletin	-- Drop temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_BulletinUpdateByBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_BulletinUpdateByBulletinID]
GO
CREATE PROCEDURE [dbo].[SecPatch_BulletinUpdateByBulletinID]
	@BulletinID		nvarchar(50),
	@BulletinLocationID	int,
	@FAQLocationID		int = NULL,
	@Title			nvarchar(128) = NULL,
	@DatePosted		datetime = NULL,
	@DateRevised		datetime = NULL,
	@Supported		nvarchar(10),
	@Summary		ntext = NULL,
	@Issue			ntext = NULL,
	@ImpactSeverityID	char(10),
	@PreReqSeverityID	char(10),
	@MitigationSeverityID	char(10),
	@PopularitySeverityID	char(10)
AS
	UPDATE	[dbo].[SecPatch_Bulletin]
	SET	BulletinLocationID = @BulletinLocationID,
		FAQLocationID = @FAQLocationID,
		Title = @Title,
		DatePosted = @DatePosted,
		DateRevised = @DateRevised,
		Supported = @Supported,
		Summary = @Summary,
		Issue = @Issue,
		ImpactSeverityID = @ImpactSeverityID,
		PreReqSeverityID = @PreReqSeverityID,
		MitigationSeverityID = @MitigationSeverityID,
		PopularitySeverityID = @PopularitySeverityID
	WHERE	BulletinID = @BulletinID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_BulletinUpdateBatchByBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_BulletinUpdateBatchByBulletinID]
GO
CREATE PROCEDURE dbo.[SecPatch_BulletinUpdateBatchByBulletinID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecPatch_BulletinBulletinID]
		ON #SecPatch_Bulletin (BulletinID)

	UPDATE	[dbo].[SecPatch_Bulletin]
	SET	BulletinLocationID = t.BulletinLocationID,
		FAQLocationID = t.FAQLocationID,
		Title = t.Title,
		DatePosted = t.DatePosted,
		DateRevised = t.DateRevised,
		Supported = t.Supported,
		Summary = t.Summary,
		Issue = t.Issue,
		ImpactSeverityID = t.ImpactSeverityID,
		PreReqSeverityID = t.PreReqSeverityID,
		MitigationSeverityID = t.MitigationSeverityID,
		PopularitySeverityID = t.PopularitySeverityID
	FROM	#SecPatch_Bulletin AS t
	WHERE	SecPatch_Bulletin.BulletinID = t.BulletinID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecPatch_Bulletin	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_BulletinPutByBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_BulletinPutByBulletinID]
GO
CREATE PROCEDURE [dbo].[SecPatch_BulletinPutByBulletinID]
	@BulletinID		nvarchar(50),
	@BulletinLocationID	int,
	@FAQLocationID		int = NULL,
	@Title			nvarchar(128) = NULL,
	@DatePosted		datetime = NULL,
	@DateRevised		datetime = NULL,
	@Supported		nvarchar(10),
	@Summary		ntext = NULL,
	@Issue			ntext = NULL,
	@ImpactSeverityID	char(10),
	@PreReqSeverityID	char(10),
	@MitigationSeverityID	char(10),
	@PopularitySeverityID	char(10)
AS
	IF NOT EXISTS(
		SELECT	1
		FROM	dbo.SecPatch_Bulletin
		WHERE	BulletinID = @BulletinID
	)
		EXEC SecPatch_BulletinAdd @BulletinID,
			@BulletinLocationID,
			@FAQLocationID,
			@Title,
			@DatePosted,
			@DateRevised,
			@Supported,
			@Summary,
			@Issue,
			@ImpactSeverityID,
			@PreReqSeverityID,
			@MitigationSeverityID,
			@PopularitySeverityID
	ELSE
		EXEC SecPatch_BulletinUpdateByBulletinID @BulletinID,
			@BulletinLocationID,
			@FAQLocationID,
			@Title,
			@DatePosted,
			@DateRevised,
			@Supported,
			@Summary,
			@Issue,
			@ImpactSeverityID,
			@PreReqSeverityID,
			@MitigationSeverityID,
			@PopularitySeverityID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_BulletinPutBatchByBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_BulletinPutBatchByBulletinID]
GO
CREATE PROCEDURE [dbo].[SecPatch_BulletinPutBatchByBulletinID]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecPatch_BulletinBulletinID]
		ON #SecPatch_Bulletin (BulletinID)

	BEGIN TRANSACTION
	UPDATE [dbo].[SecPatch_Bulletin]
		SET	BulletinLocationID = t.BulletinLocationID,
			FAQLocationID = t.FAQLocationID,
			Title = t.Title,
			DatePosted = t.DatePosted,
			DateRevised = t.DateRevised,
			Supported = t.Supported,
			Summary = t.Summary,
			Issue = t.Issue,
			ImpactSeverityID = t.ImpactSeverityID,
			PreReqSeverityID = t.PreReqSeverityID,
			MitigationSeverityID = t.MitigationSeverityID,
			PopularitySeverityID = t.PopularitySeverityID
		FROM	#SecPatch_Bulletin AS t
		WHERE	SecPatch_Bulletin.BulletinID = t.BulletinID
	SET @count = @@ROWCOUNT

	INSERT [dbo].[SecPatch_Bulletin] (
		BulletinID,
		BulletinLocationID,
		FAQLocationID,
		Title,
		DatePosted,
		DateRevised,
		Supported,
		Summary,
		Issue,
		ImpactSeverityID,
		PreReqSeverityID,
		MitigationSeverityID,
		PopularitySeverityID
	)
		SELECT	BulletinID,
			BulletinLocationID,
			FAQLocationID,
			Title,
			DatePosted,
			DateRevised,
			Supported,
			Summary,
			Issue,
			ImpactSeverityID,
			PreReqSeverityID,
			MitigationSeverityID,
			PopularitySeverityID
		FROM	#SecPatch_Bulletin AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecPatch_Bulletin]
			WHERE	SecPatch_Bulletin.BulletinID = t.BulletinID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecPatch_Bulletin	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_BulletinRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_BulletinRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecPatch_BulletinRemoveBatch]
AS

	CREATE INDEX [TempSecPatch_BulletinSecPatch_BulletinRemoveBatch]
		ON #SecPatch_Bulletin (BulletinID)	

	-- Delete records from SecPatch_Bulletin identified by fields of [TempSecPatch_BulletinSecPatch_BulletinRemoveBatch]
	DELETE [dbo].[SecPatch_Bulletin]
	WHERE EXISTS(
			SELECT * FROM #SecPatch_Bulletin AS t
			WHERE	SecPatch_Bulletin.BulletinID = t.BulletinID
		)
	DROP TABLE #SecPatch_Bulletin      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_BulletinRemoveByBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_BulletinRemoveByBulletinID]
GO
CREATE PROCEDURE [dbo].[SecPatch_BulletinRemoveByBulletinID]
	@BulletinID		nvarchar(50)
AS
	-- SecPatch_Bulletin deletes cascade to:
	--	SecPatch_BulletinComment by FK_BulletinComment_Bulletin
	--	SecPatch_QNumber by FK_qNumber_Bulletin
	--	SecPatch_Patch by FK_Patch_Bulletin
	--		SecPatch_AffectedProduct by FK_AffectedProduct_Patch
	--			SecPatch_AffectedServicePack by FK_AffectedServicePack_AffectedProduct
	--		SecPatch_PatchComment by FK_PatchComment_Patch
	DELETE	[dbo].[SecPatch_Bulletin]
	WHERE	BulletinID = @BulletinID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecPatch_BulletinRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecPatch_BulletinRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecPatch_BulletinRemoveAll]
	
AS
	DELETE	[dbo].[SecPatch_Bulletin]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinGetByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinGetByID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinGetByID]
	@SecurityBulletinID	int
AS
	SELECT	SecurityBulletinID,
		BulletinID,
		Severity,
		State,
		Comments,
		HelpUrl,
		DatePosted,
		DateRevised,
		Version,
		UpdateAvailable,
		UIStateID,
		Hidden,
		PackageVersionID,
		Errata,
		Ignore,
		SupersedeStatus,
		CustomID,
		RequiredCount
	FROM	[dbo].[SecurityBulletin]
	WHERE	SecurityBulletinID = @SecurityBulletinID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinGetByBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinGetByBulletinID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinGetByBulletinID]
	@BulletinID		nvarchar(32)
AS
	SELECT	SecurityBulletinID,
		BulletinID,
		Severity,
		State,
		Comments,
		HelpUrl,
		DatePosted,
		DateRevised,
		Version,
		UpdateAvailable,
		UIStateID,
		Hidden,
		PackageVersionID,
		Errata,
		Ignore,
		SupersedeStatus,
		CustomID,
		RequiredCount
	FROM	[dbo].[SecurityBulletin]
	WHERE	BulletinID = @BulletinID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinGetAllOrderedByBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinGetAllOrderedByBulletinID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinGetAllOrderedByBulletinID]
AS
	SELECT	SecurityBulletinID,
		BulletinID,
		Severity,
		State,
		Comments,
		HelpUrl,
		DatePosted,
		DateRevised,
		Version,
		UpdateAvailable,
		UIStateID,
		Hidden,
		PackageVersionID,
		Errata,
		Ignore,
		SupersedeStatus,
		CustomID,
		RequiredCount
	FROM	[dbo].[SecurityBulletin]
	ORDER BY BulletinID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinGetAllByErrata]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinGetAllByErrata]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinGetAllByErrata]
	@Errata			nvarchar(64) = NULL
AS
	SELECT	SecurityBulletinID,
		BulletinID,
		Severity,
		State,
		Comments,
		HelpUrl,
		DatePosted,
		DateRevised,
		Version,
		UpdateAvailable,
		UIStateID,
		Hidden,
		PackageVersionID,
		Errata,
		Ignore,
		SupersedeStatus,
		CustomID,
		RequiredCount
	FROM	[dbo].[SecurityBulletin]
	WHERE	(Errata = @Errata OR (Errata IS NULL AND @Errata IS NULL))
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinGetAllOrderedByErrata]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinGetAllOrderedByErrata]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinGetAllOrderedByErrata]
AS
	SELECT	SecurityBulletinID,
		BulletinID,
		Severity,
		State,
		Comments,
		HelpUrl,
		DatePosted,
		DateRevised,
		Version,
		UpdateAvailable,
		UIStateID,
		Hidden,
		PackageVersionID,
		Errata,
		Ignore,
		SupersedeStatus,
		CustomID,
		RequiredCount
	FROM	[dbo].[SecurityBulletin]
	ORDER BY Errata
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinGetAll]
AS
	SELECT	SecurityBulletinID,
		BulletinID,
		Severity,
		State,
		Comments,
		HelpUrl,
		DatePosted,
		DateRevised,
		Version,
		UpdateAvailable,
		UIStateID,
		Hidden,
		PackageVersionID,
		Errata,
		Ignore,
		SupersedeStatus,
		CustomID,
		RequiredCount
	FROM	[dbo].[SecurityBulletin]
	ORDER BY SecurityBulletinID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinAdd]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinAdd]
	@BulletinID		nvarchar(32),
	@Severity		int,
	@State			int = 1,
	@Comments		ntext = NULL,
	@HelpUrl		nvarchar(256) = NULL,
	@DatePosted		datetime,
	@DateRevised		datetime,
	@Version		nvarchar(16) = '1,0,0,0',
	@UpdateAvailable	int = 0,
	@UIStateID		int = 1,
	@Hidden			int = 0,
	@PackageVersionID	int = NULL,
	@Errata			nvarchar(64) = NULL,
	@Ignore			int = 0,
	@SupersedeStatus	int = 1,
	@CustomID		nvarchar(25) = '',
	@RequiredCount		int = NULL
AS
	INSERT INTO  dbo.SecurityBulletin (
		BulletinID,
		Severity,
		State,
		Comments,
		HelpUrl,
		DatePosted,
		DateRevised,
		Version,
		UpdateAvailable,
		UIStateID,
		Hidden,
		PackageVersionID,
		Errata,
		Ignore,
		SupersedeStatus,
		CustomID,
		RequiredCount
	)
	VALUES (
		@BulletinID,
		@Severity,
		@State,
		@Comments,
		@HelpUrl,
		@DatePosted,
		@DateRevised,
		@Version,
		@UpdateAvailable,
		@UIStateID,
		@Hidden,
		@PackageVersionID,
		@Errata,
		@Ignore,
		@SupersedeStatus,
		@CustomID,
		@RequiredCount
	)
	RETURN SCOPE_IDENTITY()
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinBind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinBind]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinBind]
	@BulletinID		nvarchar(32),
	@Severity		int,
	@State			int = 1,
	@Comments		ntext = NULL,
	@HelpUrl		nvarchar(256) = NULL,
	@DatePosted		datetime,
	@DateRevised		datetime,
	@Version		nvarchar(16) = '1,0,0,0',
	@UpdateAvailable	int = 0,
	@UIStateID		int = 1,
	@Hidden			int = 0,
	@PackageVersionID	int = NULL,
	@Errata			nvarchar(64) = NULL,
	@Ignore			int = 0,
	@SupersedeStatus	int = 1,
	@CustomID		nvarchar(25) = '',
	@RequiredCount		int = NULL
AS
	DECLARE	@ID	int

	SELECT	@ID = SecurityBulletinID
	FROM	[dbo].[SecurityBulletin]
	WHERE	BulletinID = @BulletinID

	IF @ID IS NULL
		EXEC @ID = SecurityBulletinAdd @BulletinID,
			@Severity,
			@State,
			@Comments,
			@HelpUrl,
			@DatePosted,
			@DateRevised,
			@Version,
			@UpdateAvailable,
			@UIStateID,
			@Hidden,
			@PackageVersionID,
			@Errata,
			@Ignore,
			@SupersedeStatus,
			@CustomID,
			@RequiredCount

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinSchema]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecurityBulletin'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecurityBulletin (' + CAST(0x0A AS CHAR(1)) +
	'		SecurityBulletinID	int NULL,' + CAST(0x0A AS CHAR(1)) +
	'		BulletinID		nvarchar(32) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Severity		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		State			int NOT NULL DEFAULT 1,' + CAST(0x0A AS CHAR(1)) +
	'		Comments		ntext COLLATE database_default NULL,' + CAST(0x0A AS CHAR(1)) +
	'		HelpUrl			nvarchar(256) COLLATE database_default NULL,' + CAST(0x0A AS CHAR(1)) +
	'		DatePosted		datetime NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		DateRevised		datetime NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Version			nvarchar(16) COLLATE database_default NULL DEFAULT ''1,0,0,0'',' + CAST(0x0A AS CHAR(1)) +
	'		UpdateAvailable		int NOT NULL DEFAULT 0,' + CAST(0x0A AS CHAR(1)) +
	'		UIStateID		int NOT NULL DEFAULT 1,' + CAST(0x0A AS CHAR(1)) +
	'		Hidden			int NOT NULL DEFAULT 0,' + CAST(0x0A AS CHAR(1)) +
	'		PackageVersionID	int NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Errata			nvarchar(64) COLLATE database_default NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Ignore			int NOT NULL DEFAULT 0,' + CAST(0x0A AS CHAR(1)) +
	'		SupersedeStatus		int NULL DEFAULT 1,' + CAST(0x0A AS CHAR(1)) +
	'		CustomID		nvarchar(25) COLLATE database_default NOT NULL DEFAULT '''',' + CAST(0x0A AS CHAR(1)) +
	'		RequiredCount		int NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecurityBulletin' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinTempAdd]
GO
CREATE PROCEDURE dbo.[SecurityBulletinTempAdd]
	@SecurityBulletinID	int,
	@BulletinID		nvarchar(32),
	@Severity		int,
	@State			int = 1,
	@Comments		ntext = NULL,
	@HelpUrl		nvarchar(256) = NULL,
	@DatePosted		datetime,
	@DateRevised		datetime,
	@Version		nvarchar(16) = '1,0,0,0',
	@UpdateAvailable	int = 0,
	@UIStateID		int = 1,
	@Hidden			int = 0,
	@PackageVersionID	int = NULL,
	@Errata			nvarchar(64) = NULL,
	@Ignore			int = 0,
	@SupersedeStatus	int = 1,
	@CustomID		nvarchar(25) = '',
	@RequiredCount		int = NULL
AS
	INSERT INTO #SecurityBulletin (
		SecurityBulletinID,
		BulletinID,
		Severity,
		State,
		Comments,
		HelpUrl,
		DatePosted,
		DateRevised,
		Version,
		UpdateAvailable,
		UIStateID,
		Hidden,
		PackageVersionID,
		Errata,
		Ignore,
		SupersedeStatus,
		CustomID,
		RequiredCount
	)
	VALUES (
		@SecurityBulletinID,
		@BulletinID,
		@Severity,
		@State,
		@Comments,
		@HelpUrl,
		@DatePosted,
		@DateRevised,
		@Version,
		@UpdateAvailable,
		@UIStateID,
		@Hidden,
		@PackageVersionID,
		@Errata,
		@Ignore,
		@SupersedeStatus,
		@CustomID,
		@RequiredCount
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinAddBatch]
GO
CREATE PROCEDURE dbo.[SecurityBulletinAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecurityBulletin (
		BulletinID,
		Severity,
		State,
		Comments,
		HelpUrl,
		DatePosted,
		DateRevised,
		Version,
		UpdateAvailable,
		UIStateID,
		Hidden,
		PackageVersionID,
		Errata,
		Ignore,
		SupersedeStatus,
		CustomID,
		RequiredCount
	)
		SELECT	BulletinID,
			Severity,
			State,
			Comments,
			HelpUrl,
			DatePosted,
			DateRevised,
			Version,
			UpdateAvailable,
			UIStateID,
			Hidden,
			PackageVersionID,
			Errata,
			Ignore,
			SupersedeStatus,
			CustomID,
			RequiredCount
		FROM #SecurityBulletin
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityBulletin	-- Drop temporary table
	RETURN @count
GO

/*
Add new SecurityBulletin bound to
	SecurityState using Description
	PackageVersion using PackagePathID, Version, Update with PackageFamilyID
	with BulletinID, Severity, Comments, HelpUrl, DatePosted, DateRevised, Version, UpdateAvailable, UIStateID, Hidden, Errata, Ignore, SupersedeStatus, CustomID, RequiredCount
*/

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinUpdateByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinUpdateByID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinUpdateByID]
	@SecurityBulletinID	int,
	@BulletinID		nvarchar(32),
	@Severity		int,
	@State			int = 1,
	@Comments		ntext = NULL,
	@HelpUrl		nvarchar(256) = NULL,
	@DatePosted		datetime,
	@DateRevised		datetime,
	@Version		nvarchar(16) = '1,0,0,0',
	@UpdateAvailable	int = 0,
	@UIStateID		int = 1,
	@Hidden			int = 0,
	@PackageVersionID	int = NULL,
	@Errata			nvarchar(64) = NULL,
	@Ignore			int = 0,
	@SupersedeStatus	int = 1,
	@CustomID		nvarchar(25) = '',
	@RequiredCount		int = NULL
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[SecurityBulletin]
	SET	@ID = SecurityBulletinID,
		BulletinID = @BulletinID,
		Severity = @Severity,
		State = @State,
		Comments = @Comments,
		HelpUrl = @HelpUrl,
		DatePosted = @DatePosted,
		DateRevised = @DateRevised,
		Version = @Version,
		UpdateAvailable = @UpdateAvailable,
		UIStateID = @UIStateID,
		Hidden = @Hidden,
		PackageVersionID = @PackageVersionID,
		Errata = @Errata,
		Ignore = @Ignore,
		SupersedeStatus = @SupersedeStatus,
		CustomID = @CustomID,
		RequiredCount = @RequiredCount
	WHERE	SecurityBulletinID = @SecurityBulletinID
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinUpdateBatchByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinUpdateBatchByID]
GO
CREATE PROCEDURE dbo.[SecurityBulletinUpdateBatchByID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityBulletinID]
		ON #SecurityBulletin (SecurityBulletinID)

	UPDATE	[dbo].[SecurityBulletin]
	SET	BulletinID = t.BulletinID,
		Severity = t.Severity,
		State = t.State,
		Comments = t.Comments,
		HelpUrl = t.HelpUrl,
		DatePosted = t.DatePosted,
		DateRevised = t.DateRevised,
		Version = t.Version,
		UpdateAvailable = t.UpdateAvailable,
		UIStateID = t.UIStateID,
		Hidden = t.Hidden,
		PackageVersionID = t.PackageVersionID,
		Errata = t.Errata,
		Ignore = t.Ignore,
		SupersedeStatus = t.SupersedeStatus,
		CustomID = t.CustomID,
		RequiredCount = t.RequiredCount
	FROM	#SecurityBulletin AS t
	WHERE	SecurityBulletin.SecurityBulletinID = t.SecurityBulletinID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityBulletin	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinUpdateByBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinUpdateByBulletinID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinUpdateByBulletinID]
	@BulletinID		nvarchar(32),
	@Severity		int,
	@State			int = 1,
	@Comments		ntext = NULL,
	@HelpUrl		nvarchar(256) = NULL,
	@DatePosted		datetime,
	@DateRevised		datetime,
	@Version		nvarchar(16) = '1,0,0,0',
	@UpdateAvailable	int = 0,
	@UIStateID		int = 1,
	@Hidden			int = 0,
	@PackageVersionID	int = NULL,
	@Errata			nvarchar(64) = NULL,
	@Ignore			int = 0,
	@SupersedeStatus	int = 1,
	@CustomID		nvarchar(25) = '',
	@RequiredCount		int = NULL
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[SecurityBulletin]
	SET	@ID = SecurityBulletinID,
		Severity = @Severity,
		State = @State,
		Comments = @Comments,
		HelpUrl = @HelpUrl,
		DatePosted = @DatePosted,
		DateRevised = @DateRevised,
		Version = @Version,
		UpdateAvailable = @UpdateAvailable,
		UIStateID = @UIStateID,
		Hidden = @Hidden,
		PackageVersionID = @PackageVersionID,
		Errata = @Errata,
		Ignore = @Ignore,
		SupersedeStatus = @SupersedeStatus,
		CustomID = @CustomID,
		RequiredCount = @RequiredCount
	WHERE	BulletinID = @BulletinID
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinUpdateBatchByBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinUpdateBatchByBulletinID]
GO
CREATE PROCEDURE dbo.[SecurityBulletinUpdateBatchByBulletinID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityBulletinBulletinID]
		ON #SecurityBulletin (BulletinID)

	UPDATE	[dbo].[SecurityBulletin]
	SET	Severity = t.Severity,
		State = t.State,
		Comments = t.Comments,
		HelpUrl = t.HelpUrl,
		DatePosted = t.DatePosted,
		DateRevised = t.DateRevised,
		Version = t.Version,
		UpdateAvailable = t.UpdateAvailable,
		UIStateID = t.UIStateID,
		Hidden = t.Hidden,
		PackageVersionID = t.PackageVersionID,
		Errata = t.Errata,
		Ignore = t.Ignore,
		SupersedeStatus = t.SupersedeStatus,
		CustomID = t.CustomID,
		RequiredCount = t.RequiredCount
	FROM	#SecurityBulletin AS t
	WHERE	SecurityBulletin.BulletinID = t.BulletinID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityBulletin	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinPutByBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinPutByBulletinID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinPutByBulletinID]
	@BulletinID		nvarchar(32),
	@Severity		int,
	@State			int = 1,
	@Comments		ntext = NULL,
	@HelpUrl		nvarchar(256) = NULL,
	@DatePosted		datetime,
	@DateRevised		datetime,
	@Version		nvarchar(16) = '1,0,0,0',
	@UpdateAvailable	int = 0,
	@UIStateID		int = 1,
	@Hidden			int = 0,
	@PackageVersionID	int = NULL,
	@Errata			nvarchar(64) = NULL,
	@Ignore			int = 0,
	@SupersedeStatus	int = 1,
	@CustomID		nvarchar(25) = '',
	@RequiredCount		int = NULL
AS
	DECLARE @ID	int

	SELECT	@ID = SecurityBulletinID
	FROM	SecurityBulletin
	WHERE	BulletinID = @BulletinID

	IF @ID IS NULL
		EXEC @ID = SecurityBulletinAdd @BulletinID,
			@Severity,
			@State,
			@Comments,
			@HelpUrl,
			@DatePosted,
			@DateRevised,
			@Version,
			@UpdateAvailable,
			@UIStateID,
			@Hidden,
			@PackageVersionID,
			@Errata,
			@Ignore,
			@SupersedeStatus,
			@CustomID,
			@RequiredCount
	ELSE
		EXEC SecurityBulletinUpdateByBulletinID @BulletinID,
			@Severity,
			@State,
			@Comments,
			@HelpUrl,
			@DatePosted,
			@DateRevised,
			@Version,
			@UpdateAvailable,
			@UIStateID,
			@Hidden,
			@PackageVersionID,
			@Errata,
			@Ignore,
			@SupersedeStatus,
			@CustomID,
			@RequiredCount

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinPutBatchByBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinPutBatchByBulletinID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinPutBatchByBulletinID]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecurityBulletinBulletinID]
		ON #SecurityBulletin (BulletinID)

	BEGIN TRANSACTION
	UPDATE [dbo].[SecurityBulletin]
		SET	Severity = t.Severity,
			State = t.State,
			Comments = t.Comments,
			HelpUrl = t.HelpUrl,
			DatePosted = t.DatePosted,
			DateRevised = t.DateRevised,
			Version = t.Version,
			UpdateAvailable = t.UpdateAvailable,
			UIStateID = t.UIStateID,
			Hidden = t.Hidden,
			PackageVersionID = t.PackageVersionID,
			Errata = t.Errata,
			Ignore = t.Ignore,
			SupersedeStatus = t.SupersedeStatus,
			CustomID = t.CustomID,
			RequiredCount = t.RequiredCount
		FROM	#SecurityBulletin AS t
		WHERE	SecurityBulletin.BulletinID = t.BulletinID
	SET @count = @@ROWCOUNT

	INSERT [dbo].[SecurityBulletin] (
		BulletinID,
		Severity,
		State,
		Comments,
		HelpUrl,
		DatePosted,
		DateRevised,
		Version,
		UpdateAvailable,
		UIStateID,
		Hidden,
		PackageVersionID,
		Errata,
		Ignore,
		SupersedeStatus,
		CustomID,
		RequiredCount
	)
		SELECT	BulletinID,
			Severity,
			State,
			Comments,
			HelpUrl,
			DatePosted,
			DateRevised,
			Version,
			UpdateAvailable,
			UIStateID,
			Hidden,
			PackageVersionID,
			Errata,
			Ignore,
			SupersedeStatus,
			CustomID,
			RequiredCount
		FROM	#SecurityBulletin AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecurityBulletin]
			WHERE	SecurityBulletin.BulletinID = t.BulletinID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecurityBulletin	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecurityBulletinRemoveBatch]
AS

	CREATE INDEX [TempSecurityBulletinSecurityBulletinRemoveBatch]
		ON #SecurityBulletin (SecurityBulletinID)	

	-- Delete records from SecurityBulletin identified by fields of [TempSecurityBulletinSecurityBulletinRemoveBatch]
	DELETE [dbo].[SecurityBulletin]
	WHERE EXISTS(
			SELECT * FROM #SecurityBulletin AS t
			WHERE	SecurityBulletin.SecurityBulletinID = t.SecurityBulletinID
		)
	DROP TABLE #SecurityBulletin      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinRemoveByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinRemoveByID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinRemoveByID]
	@SecurityBulletinID	int
AS
	-- SecurityBulletin deletes cascade to:
	--	SecurityBulletinToUserState by FK_SecurityBulletinToUserState_SecurityBulletin
	--	SecurityPatch by FK_SecurityPatch_SecurityBulletin
	--		SecPatch_Patch by FK_Patch_SecurityPatch
	--			SecPatch_AffectedProduct by FK_AffectedProduct_Patch
	--				SecPatch_AffectedServicePack by FK_AffectedServicePack_AffectedProduct
	--			SecPatch_PatchComment by FK_PatchComment_Patch
	--		SecurityPatchAlias by FK_SecurityPatchAlias_SecurityPatch
	--		SecurityPatchRequires by FK_SecurityPatchRequires_SecurityPatch
	--		SecurityPatchToPackageVersion by FK_SecurityPatchToPackageVersion_SecurityPatch
	--		SecurityPatchAnalysis by FK_SecurityPatchAnalysis_SecurityPatch
	--		SecurityPatchUninstallValues by FK_SecurityPatchUninstallValues_SecurityPatch
	--		SecurityPatchResource by FK_SecurityPatchResource_SecurityPatchID
	--	SecurityStateChange by FK_SecurityStateChange_SecurityBulletin
	--	SecurityUserStateChange by FK_SecurityUserStateChange_SecurityBulletin
	-- SecurityBulletin deletes may fail due to non-cascading FKs:
	--	SecurityBulletinRequires by FK_SecurityBulletinRequires_SecurityBulletin
	--	SecurityBulletinRequires by FK_SecurityBulletinRequires2_SecurityBulletin
	--	(through SecurityPatch by FK_SecurityPatch_SecurityBulletin)
	--		SecurityPatchRequires by FK_SecurityPatchRequires2_SecurityPatch
	--	SecurityPatchAlias by FK_SecurityPatchAlias_SecurityBulletin
	--	SecurityPatchResource by FK_SecurityPatchResource_BulletinID
	DELETE	[dbo].[SecurityBulletin]
	WHERE	SecurityBulletinID = @SecurityBulletinID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinRemoveByBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinRemoveByBulletinID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinRemoveByBulletinID]
	@BulletinID		nvarchar(32)
AS
	-- SecurityBulletin deletes cascade to:
	--	SecurityBulletinToUserState by FK_SecurityBulletinToUserState_SecurityBulletin
	--	SecurityPatch by FK_SecurityPatch_SecurityBulletin
	--		SecPatch_Patch by FK_Patch_SecurityPatch
	--			SecPatch_AffectedProduct by FK_AffectedProduct_Patch
	--				SecPatch_AffectedServicePack by FK_AffectedServicePack_AffectedProduct
	--			SecPatch_PatchComment by FK_PatchComment_Patch
	--		SecurityPatchAlias by FK_SecurityPatchAlias_SecurityPatch
	--		SecurityPatchRequires by FK_SecurityPatchRequires_SecurityPatch
	--		SecurityPatchToPackageVersion by FK_SecurityPatchToPackageVersion_SecurityPatch
	--		SecurityPatchAnalysis by FK_SecurityPatchAnalysis_SecurityPatch
	--		SecurityPatchUninstallValues by FK_SecurityPatchUninstallValues_SecurityPatch
	--		SecurityPatchResource by FK_SecurityPatchResource_SecurityPatchID
	--	SecurityStateChange by FK_SecurityStateChange_SecurityBulletin
	--	SecurityUserStateChange by FK_SecurityUserStateChange_SecurityBulletin
	-- SecurityBulletin deletes may fail due to non-cascading FKs:
	--	SecurityBulletinRequires by FK_SecurityBulletinRequires_SecurityBulletin
	--	SecurityBulletinRequires by FK_SecurityBulletinRequires2_SecurityBulletin
	--	(through SecurityPatch by FK_SecurityPatch_SecurityBulletin)
	--		SecurityPatchRequires by FK_SecurityPatchRequires2_SecurityPatch
	--	SecurityPatchAlias by FK_SecurityPatchAlias_SecurityBulletin
	--	SecurityPatchResource by FK_SecurityPatchResource_BulletinID
	DELETE	[dbo].[SecurityBulletin]
	WHERE	BulletinID = @BulletinID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinRemoveAllByErrata]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinRemoveAllByErrata]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinRemoveAllByErrata]
	@Errata			nvarchar(64) = NULL
AS
	DELETE	[dbo].[SecurityBulletin]
	WHERE	(Errata = @Errata OR (Errata IS NULL AND @Errata IS NULL))
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinRemoveAll]
	
AS
	DELETE	[dbo].[SecurityBulletin]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinToUserStateGetBySecurityBulletinIDUserStateID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinToUserStateGetBySecurityBulletinIDUserStateID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinToUserStateGetBySecurityBulletinIDUserStateID]
	@SecurityBulletinID	int,
	@UserStateID		int
AS
	SELECT	SecurityBulletinID,
		UserStateID,
		DateChanged,
		Comment,
		Username,
		Certified
	FROM	[dbo].[SecurityBulletinToUserState]
	WHERE	SecurityBulletinID = @SecurityBulletinID
	  AND	UserStateID = @UserStateID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinToUserStateGetAllBySecurityBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinToUserStateGetAllBySecurityBulletinID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinToUserStateGetAllBySecurityBulletinID]
	@SecurityBulletinID	int
AS
	SELECT	SecurityBulletinID,
		UserStateID,
		DateChanged,
		Comment,
		Username,
		Certified
	FROM	[dbo].[SecurityBulletinToUserState]
	WHERE	SecurityBulletinID = @SecurityBulletinID
	ORDER BY UserStateID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinToUserStateGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinToUserStateGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinToUserStateGetAll]
AS
	SELECT	SecurityBulletinID,
		UserStateID,
		DateChanged,
		Comment,
		Username,
		Certified
	FROM	[dbo].[SecurityBulletinToUserState]
	ORDER BY SecurityBulletinID, UserStateID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinToUserStateAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinToUserStateAdd]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinToUserStateAdd]
	@SecurityBulletinID	int,
	@UserStateID		int,
	@DateChanged		datetime,
	@Comment		ntext = NULL,
	@Username		nvarchar(64),
	@Certified		int
AS
	INSERT INTO  dbo.SecurityBulletinToUserState (
		SecurityBulletinID,
		UserStateID,
		DateChanged,
		Comment,
		Username,
		Certified
	)
	VALUES (
		@SecurityBulletinID,
		@UserStateID,
		@DateChanged,
		@Comment,
		@Username,
		@Certified
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinToUserStateSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinToUserStateSchema]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinToUserStateSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecurityBulletinToUserState'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecurityBulletinToUserState (' + CAST(0x0A AS CHAR(1)) +
	'		SecurityBulletinID	int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		UserStateID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		DateChanged		datetime NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Comment			ntext COLLATE database_default NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Username		nvarchar(64) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Certified		int NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecurityBulletinToUserState' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinToUserStateTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinToUserStateTempAdd]
GO
CREATE PROCEDURE dbo.[SecurityBulletinToUserStateTempAdd]
	@SecurityBulletinID	int,
	@UserStateID		int,
	@DateChanged		datetime,
	@Comment		ntext = NULL,
	@Username		nvarchar(64),
	@Certified		int
AS
	INSERT INTO #SecurityBulletinToUserState (
		SecurityBulletinID,
		UserStateID,
		DateChanged,
		Comment,
		Username,
		Certified
	)
	VALUES (
		@SecurityBulletinID,
		@UserStateID,
		@DateChanged,
		@Comment,
		@Username,
		@Certified
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinToUserStateAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinToUserStateAddBatch]
GO
CREATE PROCEDURE dbo.[SecurityBulletinToUserStateAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecurityBulletinToUserState (
		SecurityBulletinID,
		UserStateID,
		DateChanged,
		Comment,
		Username,
		Certified
	)
		SELECT	SecurityBulletinID,
			UserStateID,
			DateChanged,
			Comment,
			Username,
			Certified
		FROM #SecurityBulletinToUserState
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityBulletinToUserState	-- Drop temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinToUserStateUpdateBySecurityBulletinIDUserStateID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinToUserStateUpdateBySecurityBulletinIDUserStateID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinToUserStateUpdateBySecurityBulletinIDUserStateID]
	@SecurityBulletinID	int,
	@UserStateID		int,
	@DateChanged		datetime,
	@Comment		ntext = NULL,
	@Username		nvarchar(64),
	@Certified		int
AS
	UPDATE	[dbo].[SecurityBulletinToUserState]
	SET	DateChanged = @DateChanged,
		Comment = @Comment,
		Username = @Username,
		Certified = @Certified
	WHERE	SecurityBulletinID = @SecurityBulletinID
	  AND	UserStateID = @UserStateID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinToUserStateUpdateBatchBySecurityBulletinIDUserStateID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinToUserStateUpdateBatchBySecurityBulletinIDUserStateID]
GO
CREATE PROCEDURE dbo.[SecurityBulletinToUserStateUpdateBatchBySecurityBulletinIDUserStateID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityBulletinToUserStateSecurityBulletinIDUserStateID]
		ON #SecurityBulletinToUserState (SecurityBulletinID, UserStateID)

	UPDATE	[dbo].[SecurityBulletinToUserState]
	SET	DateChanged = t.DateChanged,
		Comment = t.Comment,
		Username = t.Username,
		Certified = t.Certified
	FROM	#SecurityBulletinToUserState AS t
	WHERE	SecurityBulletinToUserState.SecurityBulletinID = t.SecurityBulletinID
	  AND	SecurityBulletinToUserState.UserStateID = t.UserStateID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityBulletinToUserState	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinToUserStatePutBySecurityBulletinIDUserStateID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinToUserStatePutBySecurityBulletinIDUserStateID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinToUserStatePutBySecurityBulletinIDUserStateID]
	@SecurityBulletinID	int,
	@UserStateID		int,
	@DateChanged		datetime,
	@Comment		ntext = NULL,
	@Username		nvarchar(64),
	@Certified		int
AS
	IF NOT EXISTS(
		SELECT	1
		FROM	dbo.SecurityBulletinToUserState
		WHERE	SecurityBulletinID = @SecurityBulletinID
		  AND	UserStateID = @UserStateID
	)
		EXEC SecurityBulletinToUserStateAdd @SecurityBulletinID,
			@UserStateID,
			@DateChanged,
			@Comment,
			@Username,
			@Certified
	ELSE
		EXEC SecurityBulletinToUserStateUpdateBySecurityBulletinIDUserStateID @SecurityBulletinID,
			@UserStateID,
			@DateChanged,
			@Comment,
			@Username,
			@Certified
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinToUserStatePutBatchBySecurityBulletinIDUserStateID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinToUserStatePutBatchBySecurityBulletinIDUserStateID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinToUserStatePutBatchBySecurityBulletinIDUserStateID]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecurityBulletinToUserStateSecurityBulletinIDUserStateID]
		ON #SecurityBulletinToUserState (SecurityBulletinID, UserStateID)

	BEGIN TRANSACTION
	UPDATE [dbo].[SecurityBulletinToUserState]
		SET	DateChanged = t.DateChanged,
			Comment = t.Comment,
			Username = t.Username,
			Certified = t.Certified
		FROM	#SecurityBulletinToUserState AS t
		WHERE	SecurityBulletinToUserState.SecurityBulletinID = t.SecurityBulletinID
		  AND	SecurityBulletinToUserState.UserStateID = t.UserStateID
	SET @count = @@ROWCOUNT

	INSERT [dbo].[SecurityBulletinToUserState] (
		SecurityBulletinID,
		UserStateID,
		DateChanged,
		Comment,
		Username,
		Certified
	)
		SELECT	SecurityBulletinID,
			UserStateID,
			DateChanged,
			Comment,
			Username,
			Certified
		FROM	#SecurityBulletinToUserState AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecurityBulletinToUserState]
			WHERE	SecurityBulletinToUserState.SecurityBulletinID = t.SecurityBulletinID
			  AND	SecurityBulletinToUserState.UserStateID = t.UserStateID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecurityBulletinToUserState	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinToUserStateRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinToUserStateRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecurityBulletinToUserStateRemoveBatch]
AS

	CREATE INDEX [TempSecurityBulletinToUserStateSecurityBulletinToUserStateRemoveBatch]
		ON #SecurityBulletinToUserState (SecurityBulletinID, UserStateID)	

	-- Delete records from SecurityBulletinToUserState identified by fields of [TempSecurityBulletinToUserStateSecurityBulletinToUserStateRemoveBatch]
	DELETE [dbo].[SecurityBulletinToUserState]
	WHERE EXISTS(
			SELECT * FROM #SecurityBulletinToUserState AS t
			WHERE	SecurityBulletinToUserState.SecurityBulletinID = t.SecurityBulletinID
			  AND	SecurityBulletinToUserState.UserStateID = t.UserStateID
		)
	DROP TABLE #SecurityBulletinToUserState      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinToUserStateRemoveBySecurityBulletinIDUserStateID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinToUserStateRemoveBySecurityBulletinIDUserStateID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinToUserStateRemoveBySecurityBulletinIDUserStateID]
	@SecurityBulletinID	int,
	@UserStateID		int
AS
	DELETE	[dbo].[SecurityBulletinToUserState]
	WHERE	SecurityBulletinID = @SecurityBulletinID
	  AND	UserStateID = @UserStateID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinToUserStateRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinToUserStateRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinToUserStateRemoveAll]
	
AS
	DELETE	[dbo].[SecurityBulletinToUserState]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinRequiresGetBySecurityBulletinIDRequiredBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinRequiresGetBySecurityBulletinIDRequiredBulletinID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinRequiresGetBySecurityBulletinIDRequiredBulletinID]
	@SecurityBulletinID	int,
	@RequiredBulletinID	int
AS
	SELECT	SecurityBulletinRequiresID,
		SecurityBulletinID,
		RequiredBulletinID,
		Strength
	FROM	[dbo].[SecurityBulletinRequires]
	WHERE	SecurityBulletinID = @SecurityBulletinID
	  AND	RequiredBulletinID = @RequiredBulletinID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinRequiresGetAllBySecurityBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinRequiresGetAllBySecurityBulletinID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinRequiresGetAllBySecurityBulletinID]
	@SecurityBulletinID	int
AS
	SELECT	SecurityBulletinRequiresID,
		SecurityBulletinID,
		RequiredBulletinID,
		Strength
	FROM	[dbo].[SecurityBulletinRequires]
	WHERE	SecurityBulletinID = @SecurityBulletinID
	ORDER BY RequiredBulletinID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinRequiresGetAllBySecurityBulletinIDStrength]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinRequiresGetAllBySecurityBulletinIDStrength]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinRequiresGetAllBySecurityBulletinIDStrength]
	@SecurityBulletinID	int,
	@Strength		int
AS
	SELECT	SecurityBulletinRequiresID,
		SecurityBulletinID,
		RequiredBulletinID,
		Strength
	FROM	[dbo].[SecurityBulletinRequires]
	WHERE	SecurityBulletinID = @SecurityBulletinID
	  AND	Strength = @Strength
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinRequiresGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinRequiresGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinRequiresGetAll]
AS
	SELECT	SecurityBulletinRequiresID,
		SecurityBulletinID,
		RequiredBulletinID,
		Strength
	FROM	[dbo].[SecurityBulletinRequires]
	ORDER BY SecurityBulletinID, Strength
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinRequiresAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinRequiresAdd]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinRequiresAdd]
	@SecurityBulletinID	int,
	@RequiredBulletinID	int,
	@Strength		int
AS
	INSERT INTO  dbo.SecurityBulletinRequires (
		SecurityBulletinID,
		RequiredBulletinID,
		Strength
	)
	VALUES (
		@SecurityBulletinID,
		@RequiredBulletinID,
		@Strength
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinRequiresBind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinRequiresBind]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinRequiresBind]
	@SecurityBulletinID	int,
	@RequiredBulletinID	int,
	@Strength		int
AS
	DECLARE	@ID	int

	SELECT	@ID = SecurityBulletinRequiresID
	FROM	[dbo].[SecurityBulletinRequires]
	WHERE	SecurityBulletinID = @SecurityBulletinID
	  AND	RequiredBulletinID = @RequiredBulletinID

	IF @@ROWCOUNT = 0
	BEGIN
		EXEC SecurityBulletinRequiresAdd @SecurityBulletinID,
			@RequiredBulletinID,
			@Strength

		SELECT	@ID = SecurityBulletinRequiresID
		FROM	[dbo].[SecurityBulletinRequires]
		WHERE	SecurityBulletinID = @SecurityBulletinID
		  AND	RequiredBulletinID = @RequiredBulletinID
	END

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinRequiresSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinRequiresSchema]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinRequiresSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecurityBulletinRequires'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecurityBulletinRequires (' + CAST(0x0A AS CHAR(1)) +
	'		SecurityBulletinID	int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		RequiredBulletinID	int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Strength		int NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecurityBulletinRequires' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinRequiresTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinRequiresTempAdd]
GO
CREATE PROCEDURE dbo.[SecurityBulletinRequiresTempAdd]
	@SecurityBulletinID	int,
	@RequiredBulletinID	int,
	@Strength		int
AS
	INSERT INTO #SecurityBulletinRequires (
		SecurityBulletinID,
		RequiredBulletinID,
		Strength
	)
	VALUES (
		@SecurityBulletinID,
		@RequiredBulletinID,
		@Strength
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinRequiresAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinRequiresAddBatch]
GO
CREATE PROCEDURE dbo.[SecurityBulletinRequiresAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecurityBulletinRequires (
		SecurityBulletinID,
		RequiredBulletinID,
		Strength
	)
		SELECT	SecurityBulletinID,
			RequiredBulletinID,
			Strength
		FROM #SecurityBulletinRequires
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityBulletinRequires	-- Drop temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinRequiresUpdateBySecurityBulletinIDRequiredBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinRequiresUpdateBySecurityBulletinIDRequiredBulletinID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinRequiresUpdateBySecurityBulletinIDRequiredBulletinID]
	@SecurityBulletinID	int,
	@RequiredBulletinID	int,
	@Strength		int
AS
	UPDATE	[dbo].[SecurityBulletinRequires]
	SET	Strength = @Strength
	WHERE	SecurityBulletinID = @SecurityBulletinID
	  AND	RequiredBulletinID = @RequiredBulletinID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinRequiresUpdateBatchBySecurityBulletinIDRequiredBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinRequiresUpdateBatchBySecurityBulletinIDRequiredBulletinID]
GO
CREATE PROCEDURE dbo.[SecurityBulletinRequiresUpdateBatchBySecurityBulletinIDRequiredBulletinID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityBulletinRequiresSecurityBulletinIDRequiredBulletinID]
		ON #SecurityBulletinRequires (SecurityBulletinID, RequiredBulletinID)

	UPDATE	[dbo].[SecurityBulletinRequires]
	SET	Strength = t.Strength
	FROM	#SecurityBulletinRequires AS t
	WHERE	SecurityBulletinRequires.SecurityBulletinID = t.SecurityBulletinID
	  AND	SecurityBulletinRequires.RequiredBulletinID = t.RequiredBulletinID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityBulletinRequires	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinRequiresPutBySecurityBulletinIDRequiredBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinRequiresPutBySecurityBulletinIDRequiredBulletinID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinRequiresPutBySecurityBulletinIDRequiredBulletinID]
	@SecurityBulletinID	int,
	@RequiredBulletinID	int,
	@Strength		int
AS
	IF NOT EXISTS(
		SELECT	1
		FROM	dbo.SecurityBulletinRequires
		WHERE	SecurityBulletinID = @SecurityBulletinID
		  AND	RequiredBulletinID = @RequiredBulletinID
	)
		EXEC SecurityBulletinRequiresAdd @SecurityBulletinID,
			@RequiredBulletinID,
			@Strength
	ELSE
		EXEC SecurityBulletinRequiresUpdateBySecurityBulletinIDRequiredBulletinID @SecurityBulletinID,
			@RequiredBulletinID,
			@Strength
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinRequiresPutBatchBySecurityBulletinIDRequiredBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinRequiresPutBatchBySecurityBulletinIDRequiredBulletinID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinRequiresPutBatchBySecurityBulletinIDRequiredBulletinID]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecurityBulletinRequiresSecurityBulletinIDRequiredBulletinID]
		ON #SecurityBulletinRequires (SecurityBulletinID, RequiredBulletinID)

	BEGIN TRANSACTION
	UPDATE [dbo].[SecurityBulletinRequires]
		SET	Strength = t.Strength
		FROM	#SecurityBulletinRequires AS t
		WHERE	SecurityBulletinRequires.SecurityBulletinID = t.SecurityBulletinID
		  AND	SecurityBulletinRequires.RequiredBulletinID = t.RequiredBulletinID
	SET @count = @@ROWCOUNT

	INSERT [dbo].[SecurityBulletinRequires] (
		SecurityBulletinID,
		RequiredBulletinID,
		Strength
	)
		SELECT	SecurityBulletinID,
			RequiredBulletinID,
			Strength
		FROM	#SecurityBulletinRequires AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecurityBulletinRequires]
			WHERE	SecurityBulletinRequires.SecurityBulletinID = t.SecurityBulletinID
			  AND	SecurityBulletinRequires.RequiredBulletinID = t.RequiredBulletinID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecurityBulletinRequires	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinRequiresRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinRequiresRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecurityBulletinRequiresRemoveBatch]
AS

	CREATE INDEX [TempSecurityBulletinRequiresSecurityBulletinRequiresRemoveBatch]
		ON #SecurityBulletinRequires (SecurityBulletinID, RequiredBulletinID)	

	-- Delete records from SecurityBulletinRequires identified by fields of [TempSecurityBulletinRequiresSecurityBulletinRequiresRemoveBatch]
	DELETE [dbo].[SecurityBulletinRequires]
	WHERE EXISTS(
			SELECT * FROM #SecurityBulletinRequires AS t
			WHERE	SecurityBulletinRequires.SecurityBulletinID = t.SecurityBulletinID
			  AND	SecurityBulletinRequires.RequiredBulletinID = t.RequiredBulletinID
		)
	DROP TABLE #SecurityBulletinRequires      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinRequiresRemoveBySecurityBulletinIDRequiredBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinRequiresRemoveBySecurityBulletinIDRequiredBulletinID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinRequiresRemoveBySecurityBulletinIDRequiredBulletinID]
	@SecurityBulletinID	int,
	@RequiredBulletinID	int
AS
	DELETE	[dbo].[SecurityBulletinRequires]
	WHERE	SecurityBulletinID = @SecurityBulletinID
	  AND	RequiredBulletinID = @RequiredBulletinID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinRequiresRemoveAllBySecurityBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinRequiresRemoveAllBySecurityBulletinID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinRequiresRemoveAllBySecurityBulletinID]
	@SecurityBulletinID	int
AS
	DELETE	[dbo].[SecurityBulletinRequires]
	WHERE	SecurityBulletinID = @SecurityBulletinID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinRequiresRemoveAllByRequiredBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinRequiresRemoveAllByRequiredBulletinID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinRequiresRemoveAllByRequiredBulletinID]
	@RequiredBulletinID	int
AS
	DELETE	[dbo].[SecurityBulletinRequires]
	WHERE	RequiredBulletinID = @RequiredBulletinID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinRequiresRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinRequiresRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinRequiresRemoveAll]
	
AS
	DELETE	[dbo].[SecurityBulletinRequires]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinRequiresReplaceSubsetBySecurityBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinRequiresReplaceSubsetBySecurityBulletinID]
GO
-- Replace the record subset selected by (@SecurityBulletinID)
-- using unique identifier (SecurityBulletinID, RequiredBulletinID)
-- updating fields (Strength)
CREATE PROCEDURE [dbo].[SecurityBulletinRequiresReplaceSubsetBySecurityBulletinID]
	@SecurityBulletinID	int
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecurityBulletinRequiresBySecurityBulletinID]
		ON #SecurityBulletinRequires (SecurityBulletinID, RequiredBulletinID)

	BEGIN TRANSACTION
	DELETE [SecurityBulletinRequires]
		WHERE	SecurityBulletinID = @SecurityBulletinID
		AND NOT EXISTS(		-- Replacement record doesn't exist
			SELECT * FROM #SecurityBulletinRequires AS t
			WHERE	SecurityBulletinRequires.SecurityBulletinID = t.SecurityBulletinID
			  AND	SecurityBulletinRequires.RequiredBulletinID = t.RequiredBulletinID
		)

	UPDATE [dbo].[SecurityBulletinRequires]
		SET	Strength = t.Strength
		FROM	#SecurityBulletinRequires AS t
		WHERE	SecurityBulletinRequires.SecurityBulletinID = t.SecurityBulletinID
		  AND	SecurityBulletinRequires.RequiredBulletinID = t.RequiredBulletinID
	SET @count = @@ROWCOUNT

	INSERT [SecurityBulletinRequires] (
		SecurityBulletinID,
		RequiredBulletinID,
		Strength
	)
		SELECT	SecurityBulletinID,
			RequiredBulletinID,
			Strength
		FROM	#SecurityBulletinRequires AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [SecurityBulletinRequires]
			WHERE	SecurityBulletinRequires.SecurityBulletinID = t.SecurityBulletinID
			  AND	SecurityBulletinRequires.RequiredBulletinID = t.RequiredBulletinID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecurityBulletinRequires	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchManagerLinkedServerGetByLinkedServerID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchManagerLinkedServerGetByLinkedServerID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchManagerLinkedServerGetByLinkedServerID]
	@LinkedServerID		int
AS
	SELECT	LinkedServerID,
		LinkedServerName,
		DatabaseName
	FROM	[dbo].[SecurityPatchManagerLinkedServer]
	WHERE	LinkedServerID = @LinkedServerID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchManagerLinkedServerGetByLinkedServerNameDatabaseName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchManagerLinkedServerGetByLinkedServerNameDatabaseName]
GO
CREATE PROCEDURE [dbo].[SecurityPatchManagerLinkedServerGetByLinkedServerNameDatabaseName]
	@LinkedServerName	nvarchar(128),
	@DatabaseName		nvarchar(128)
AS
	SELECT	LinkedServerID,
		LinkedServerName,
		DatabaseName
	FROM	[dbo].[SecurityPatchManagerLinkedServer]
	WHERE	LinkedServerName = @LinkedServerName
	  AND	DatabaseName = @DatabaseName
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchManagerLinkedServerGetAllByLinkedServerName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchManagerLinkedServerGetAllByLinkedServerName]
GO
CREATE PROCEDURE [dbo].[SecurityPatchManagerLinkedServerGetAllByLinkedServerName]
	@LinkedServerName	nvarchar(128)
AS
	SELECT	LinkedServerID,
		LinkedServerName,
		DatabaseName
	FROM	[dbo].[SecurityPatchManagerLinkedServer]
	WHERE	LinkedServerName = @LinkedServerName
	ORDER BY DatabaseName
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchManagerLinkedServerGetAllOrderedByLinkedServerName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchManagerLinkedServerGetAllOrderedByLinkedServerName]
GO
CREATE PROCEDURE [dbo].[SecurityPatchManagerLinkedServerGetAllOrderedByLinkedServerName]
AS
	SELECT	LinkedServerID,
		LinkedServerName,
		DatabaseName
	FROM	[dbo].[SecurityPatchManagerLinkedServer]
	ORDER BY LinkedServerName
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchManagerLinkedServerGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchManagerLinkedServerGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchManagerLinkedServerGetAll]
AS
	SELECT	LinkedServerID,
		LinkedServerName,
		DatabaseName
	FROM	[dbo].[SecurityPatchManagerLinkedServer]
	ORDER BY LinkedServerID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchManagerLinkedServerAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchManagerLinkedServerAdd]
GO
CREATE PROCEDURE [dbo].[SecurityPatchManagerLinkedServerAdd]
	@LinkedServerName	nvarchar(128),
	@DatabaseName		nvarchar(128)
AS
	INSERT INTO  dbo.SecurityPatchManagerLinkedServer (
		LinkedServerName,
		DatabaseName
	)
	VALUES (
		@LinkedServerName,
		@DatabaseName
	)
	RETURN SCOPE_IDENTITY()
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchManagerLinkedServerBind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchManagerLinkedServerBind]
GO
CREATE PROCEDURE [dbo].[SecurityPatchManagerLinkedServerBind]
	@LinkedServerName	nvarchar(128),
	@DatabaseName		nvarchar(128)
AS
	DECLARE	@ID	int

	SELECT	@ID = LinkedServerID
	FROM	[dbo].[SecurityPatchManagerLinkedServer]
	WHERE	LinkedServerName = @LinkedServerName
	  AND	DatabaseName = @DatabaseName

	IF @ID IS NULL
		EXEC @ID = SecurityPatchManagerLinkedServerAdd @LinkedServerName,
			@DatabaseName

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchManagerLinkedServerSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchManagerLinkedServerSchema]
GO
CREATE PROCEDURE [dbo].[SecurityPatchManagerLinkedServerSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecurityPatchManagerLinkedServer'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecurityPatchManagerLinkedServer (' + CAST(0x0A AS CHAR(1)) +
	'		LinkedServerID		int NULL,' + CAST(0x0A AS CHAR(1)) +
	'		LinkedServerName	nvarchar(128) COLLATE Latin1_General_CS_AS NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		DatabaseName		nvarchar(128) COLLATE database_default NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecurityPatchManagerLinkedServer' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchManagerLinkedServerTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchManagerLinkedServerTempAdd]
GO
CREATE PROCEDURE dbo.[SecurityPatchManagerLinkedServerTempAdd]
	@LinkedServerID		int,
	@LinkedServerName	nvarchar(128),
	@DatabaseName		nvarchar(128)
AS
	INSERT INTO #SecurityPatchManagerLinkedServer (
		LinkedServerID,
		LinkedServerName,
		DatabaseName
	)
	VALUES (
		@LinkedServerID,
		@LinkedServerName,
		@DatabaseName
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchManagerLinkedServerAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchManagerLinkedServerAddBatch]
GO
CREATE PROCEDURE dbo.[SecurityPatchManagerLinkedServerAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecurityPatchManagerLinkedServer (
		LinkedServerName,
		DatabaseName
	)
		SELECT	LinkedServerName,
			DatabaseName
		FROM #SecurityPatchManagerLinkedServer
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchManagerLinkedServer	-- Drop temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchManagerLinkedServerUpdateByLinkedServerID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchManagerLinkedServerUpdateByLinkedServerID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchManagerLinkedServerUpdateByLinkedServerID]
	@LinkedServerID		int,
	@LinkedServerName	nvarchar(128),
	@DatabaseName		nvarchar(128)
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[SecurityPatchManagerLinkedServer]
	SET	@ID = LinkedServerID,
		LinkedServerName = @LinkedServerName,
		DatabaseName = @DatabaseName
	WHERE	LinkedServerID = @LinkedServerID
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchManagerLinkedServerUpdateBatchByLinkedServerID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchManagerLinkedServerUpdateBatchByLinkedServerID]
GO
CREATE PROCEDURE dbo.[SecurityPatchManagerLinkedServerUpdateBatchByLinkedServerID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityPatchManagerLinkedServerLinkedServerID]
		ON #SecurityPatchManagerLinkedServer (LinkedServerID)

	UPDATE	[dbo].[SecurityPatchManagerLinkedServer]
	SET	LinkedServerName = t.LinkedServerName,
		DatabaseName = t.DatabaseName
	FROM	#SecurityPatchManagerLinkedServer AS t
	WHERE	SecurityPatchManagerLinkedServer.LinkedServerID = t.LinkedServerID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchManagerLinkedServer	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchManagerLinkedServerPutByLinkedServerNameDatabaseName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchManagerLinkedServerPutByLinkedServerNameDatabaseName]
GO
CREATE PROCEDURE [dbo].[SecurityPatchManagerLinkedServerPutByLinkedServerNameDatabaseName]
	@LinkedServerName	nvarchar(128),
	@DatabaseName		nvarchar(128)
AS
	DECLARE @ID	int

	SELECT	@ID = LinkedServerID
	FROM	SecurityPatchManagerLinkedServer
	WHERE	LinkedServerName = @LinkedServerName
	  AND	DatabaseName = @DatabaseName

	IF @ID IS NULL
		EXEC @ID = SecurityPatchManagerLinkedServerAdd @LinkedServerName,
			@DatabaseName

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchManagerLinkedServerPutBatchByLinkedServerNameDatabaseName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchManagerLinkedServerPutBatchByLinkedServerNameDatabaseName]
GO
CREATE PROCEDURE [dbo].[SecurityPatchManagerLinkedServerPutBatchByLinkedServerNameDatabaseName]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecurityPatchManagerLinkedServerLinkedServerNameDatabaseName]
		ON #SecurityPatchManagerLinkedServer (LinkedServerName, DatabaseName)

	BEGIN TRANSACTION

	INSERT [dbo].[SecurityPatchManagerLinkedServer] (
		LinkedServerName,
		DatabaseName
	)
		SELECT	LinkedServerName,
			DatabaseName
		FROM	#SecurityPatchManagerLinkedServer AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecurityPatchManagerLinkedServer]
			WHERE	SecurityPatchManagerLinkedServer.LinkedServerName = t.LinkedServerName
			  AND	SecurityPatchManagerLinkedServer.DatabaseName = t.DatabaseName
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecurityPatchManagerLinkedServer	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchManagerLinkedServerRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchManagerLinkedServerRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecurityPatchManagerLinkedServerRemoveBatch]
AS

	CREATE INDEX [TempSecurityPatchManagerLinkedServerSecurityPatchManagerLinkedServerRemoveBatch]
		ON #SecurityPatchManagerLinkedServer (LinkedServerID)	

	-- Delete records from SecurityPatchManagerLinkedServer identified by fields of [TempSecurityPatchManagerLinkedServerSecurityPatchManagerLinkedServerRemoveBatch]
	DELETE [dbo].[SecurityPatchManagerLinkedServer]
	WHERE EXISTS(
			SELECT * FROM #SecurityPatchManagerLinkedServer AS t
			WHERE	SecurityPatchManagerLinkedServer.LinkedServerID = t.LinkedServerID
		)
	DROP TABLE #SecurityPatchManagerLinkedServer      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchManagerLinkedServerRemoveByLinkedServerID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchManagerLinkedServerRemoveByLinkedServerID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchManagerLinkedServerRemoveByLinkedServerID]
	@LinkedServerID		int
AS
	DELETE	[dbo].[SecurityPatchManagerLinkedServer]
	WHERE	LinkedServerID = @LinkedServerID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchManagerLinkedServerRemoveByLinkedServerNameDatabaseName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchManagerLinkedServerRemoveByLinkedServerNameDatabaseName]
GO
CREATE PROCEDURE [dbo].[SecurityPatchManagerLinkedServerRemoveByLinkedServerNameDatabaseName]
	@LinkedServerName	nvarchar(128),
	@DatabaseName		nvarchar(128)
AS
	DELETE	[dbo].[SecurityPatchManagerLinkedServer]
	WHERE	LinkedServerName = @LinkedServerName
	  AND	DatabaseName = @DatabaseName
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchManagerLinkedServerRemoveAllByLinkedServerName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchManagerLinkedServerRemoveAllByLinkedServerName]
GO
CREATE PROCEDURE [dbo].[SecurityPatchManagerLinkedServerRemoveAllByLinkedServerName]
	@LinkedServerName	nvarchar(128)
AS
	DELETE	[dbo].[SecurityPatchManagerLinkedServer]
	WHERE	LinkedServerName = @LinkedServerName
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchManagerLinkedServerRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchManagerLinkedServerRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchManagerLinkedServerRemoveAll]
	
AS
	DELETE	[dbo].[SecurityPatchManagerLinkedServer]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityCookieGetByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityCookieGetByID]
GO
CREATE PROCEDURE [dbo].[SecurityCookieGetByID]
	@CookieID		int
AS
	SELECT	CookieID,
		[Name],
		Value,
		Domain
	FROM	[dbo].[SecurityCookie]
	WHERE	CookieID = @CookieID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityCookieGetByNameValueDomain]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityCookieGetByNameValueDomain]
GO
CREATE PROCEDURE [dbo].[SecurityCookieGetByNameValueDomain]
	@Name			nvarchar(128),
	@Value			nvarchar(128),
	@Domain			nvarchar(128)
AS
	SELECT	CookieID,
		[Name],
		Value,
		Domain
	FROM	[dbo].[SecurityCookie]
	WHERE	[Name] = @Name
	  AND	Value = @Value
	  AND	Domain = @Domain
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityCookieGetAllByNameValue]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityCookieGetAllByNameValue]
GO
CREATE PROCEDURE [dbo].[SecurityCookieGetAllByNameValue]
	@Name			nvarchar(128),
	@Value			nvarchar(128)
AS
	SELECT	CookieID,
		[Name],
		Value,
		Domain
	FROM	[dbo].[SecurityCookie]
	WHERE	[Name] = @Name
	  AND	Value = @Value
	ORDER BY Domain
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityCookieGetAllByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityCookieGetAllByName]
GO
CREATE PROCEDURE [dbo].[SecurityCookieGetAllByName]
	@Name			nvarchar(128)
AS
	SELECT	CookieID,
		[Name],
		Value,
		Domain
	FROM	[dbo].[SecurityCookie]
	WHERE	[Name] = @Name
	ORDER BY Value, Domain
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityCookieGetAllOrderedByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityCookieGetAllOrderedByName]
GO
CREATE PROCEDURE [dbo].[SecurityCookieGetAllOrderedByName]
AS
	SELECT	CookieID,
		[Name],
		Value,
		Domain
	FROM	[dbo].[SecurityCookie]
	ORDER BY [Name]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityCookieGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityCookieGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityCookieGetAll]
AS
	SELECT	CookieID,
		[Name],
		Value,
		Domain
	FROM	[dbo].[SecurityCookie]
	ORDER BY CookieID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityCookieAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityCookieAdd]
GO
CREATE PROCEDURE [dbo].[SecurityCookieAdd]
	@Name			nvarchar(128),
	@Value			nvarchar(128),
	@Domain			nvarchar(128)
AS
	INSERT INTO  dbo.SecurityCookie (
		[Name],
		Value,
		Domain
	)
	VALUES (
		@Name,
		@Value,
		@Domain
	)
	RETURN SCOPE_IDENTITY()
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityCookieBind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityCookieBind]
GO
CREATE PROCEDURE [dbo].[SecurityCookieBind]
	@Name			nvarchar(128),
	@Value			nvarchar(128),
	@Domain			nvarchar(128)
AS
	DECLARE	@ID	int

	SELECT	@ID = CookieID
	FROM	[dbo].[SecurityCookie]
	WHERE	[Name] = @Name
	  AND	Value = @Value
	  AND	Domain = @Domain

	IF @ID IS NULL
		EXEC @ID = SecurityCookieAdd @Name,
			@Value,
			@Domain

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityCookieSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityCookieSchema]
GO
CREATE PROCEDURE [dbo].[SecurityCookieSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecurityCookie'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecurityCookie (' + CAST(0x0A AS CHAR(1)) +
	'		CookieID		int NULL,' + CAST(0x0A AS CHAR(1)) +
	'		[Name]			nvarchar(128) COLLATE Latin1_General_CS_AS NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Value			nvarchar(128) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Domain			nvarchar(128) COLLATE database_default NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecurityCookie' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityCookieTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityCookieTempAdd]
GO
CREATE PROCEDURE dbo.[SecurityCookieTempAdd]
	@CookieID		int,
	@Name			nvarchar(128),
	@Value			nvarchar(128),
	@Domain			nvarchar(128)
AS
	INSERT INTO #SecurityCookie (
		CookieID,
		[Name],
		Value,
		Domain
	)
	VALUES (
		@CookieID,
		@Name,
		@Value,
		@Domain
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityCookieAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityCookieAddBatch]
GO
CREATE PROCEDURE dbo.[SecurityCookieAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecurityCookie (
		[Name],
		Value,
		Domain
	)
		SELECT	[Name],
			Value,
			Domain
		FROM #SecurityCookie
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityCookie	-- Drop temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityCookieUpdateByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityCookieUpdateByID]
GO
CREATE PROCEDURE [dbo].[SecurityCookieUpdateByID]
	@CookieID		int,
	@Name			nvarchar(128),
	@Value			nvarchar(128),
	@Domain			nvarchar(128)
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[SecurityCookie]
	SET	@ID = CookieID,
		[Name] = @Name,
		Value = @Value,
		Domain = @Domain
	WHERE	CookieID = @CookieID
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityCookieUpdateBatchByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityCookieUpdateBatchByID]
GO
CREATE PROCEDURE dbo.[SecurityCookieUpdateBatchByID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityCookieID]
		ON #SecurityCookie (CookieID)

	UPDATE	[dbo].[SecurityCookie]
	SET	[Name] = t.[Name],
		Value = t.Value,
		Domain = t.Domain
	FROM	#SecurityCookie AS t
	WHERE	SecurityCookie.CookieID = t.CookieID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityCookie	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityCookiePutByNameValueDomain]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityCookiePutByNameValueDomain]
GO
CREATE PROCEDURE [dbo].[SecurityCookiePutByNameValueDomain]
	@Name			nvarchar(128),
	@Value			nvarchar(128),
	@Domain			nvarchar(128)
AS
	DECLARE @ID	int

	SELECT	@ID = CookieID
	FROM	SecurityCookie
	WHERE	[Name] = @Name
	  AND	Value = @Value
	  AND	Domain = @Domain

	IF @ID IS NULL
		EXEC @ID = SecurityCookieAdd @Name,
			@Value,
			@Domain

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityCookiePutBatchByNameValueDomain]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityCookiePutBatchByNameValueDomain]
GO
CREATE PROCEDURE [dbo].[SecurityCookiePutBatchByNameValueDomain]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecurityCookieNameValueDomain]
		ON #SecurityCookie ([Name], Value, Domain)

	BEGIN TRANSACTION

	INSERT [dbo].[SecurityCookie] (
		[Name],
		Value,
		Domain
	)
		SELECT	[Name],
			Value,
			Domain
		FROM	#SecurityCookie AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecurityCookie]
			WHERE	SecurityCookie.[Name] = t.[Name]
			  AND	SecurityCookie.Value = t.Value
			  AND	SecurityCookie.Domain = t.Domain
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecurityCookie	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityCookieRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityCookieRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecurityCookieRemoveBatch]
AS

	CREATE INDEX [TempSecurityCookieSecurityCookieRemoveBatch]
		ON #SecurityCookie (CookieID)	

	-- Delete records from SecurityCookie identified by fields of [TempSecurityCookieSecurityCookieRemoveBatch]
	DELETE [dbo].[SecurityCookie]
	WHERE EXISTS(
			SELECT * FROM #SecurityCookie AS t
			WHERE	SecurityCookie.CookieID = t.CookieID
		)
	DROP TABLE #SecurityCookie      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityCookieRemoveByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityCookieRemoveByID]
GO
CREATE PROCEDURE [dbo].[SecurityCookieRemoveByID]
	@CookieID		int
AS
	DELETE	[dbo].[SecurityCookie]
	WHERE	CookieID = @CookieID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityCookieRemoveByNameValueDomain]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityCookieRemoveByNameValueDomain]
GO
CREATE PROCEDURE [dbo].[SecurityCookieRemoveByNameValueDomain]
	@Name			nvarchar(128),
	@Value			nvarchar(128),
	@Domain			nvarchar(128)
AS
	DELETE	[dbo].[SecurityCookie]
	WHERE	[Name] = @Name
	  AND	Value = @Value
	  AND	Domain = @Domain
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityCookieRemoveAllByNameValue]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityCookieRemoveAllByNameValue]
GO
CREATE PROCEDURE [dbo].[SecurityCookieRemoveAllByNameValue]
	@Name			nvarchar(128),
	@Value			nvarchar(128)
AS
	DELETE	[dbo].[SecurityCookie]
	WHERE	[Name] = @Name
	  AND	Value = @Value
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityCookieRemoveAllByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityCookieRemoveAllByName]
GO
CREATE PROCEDURE [dbo].[SecurityCookieRemoveAllByName]
	@Name			nvarchar(128)
AS
	DELETE	[dbo].[SecurityCookie]
	WHERE	[Name] = @Name
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityCookieRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityCookieRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecurityCookieRemoveAll]
	
AS
	DELETE	[dbo].[SecurityCookie]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchGetByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchGetByID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchGetByID]
	@PatchID		int
AS
	SELECT	PatchID,
		BulletinID,
		PatchName,
		Title,
		QNumber,
		State,
		InstallCommandLineOptions,
		UnInstallCommandLineOptions,
		StagedFile,
		Incorporate,
		Supported,
		Ignore,
		DefaultInstallCmdLineOptions,
		DefaultUnInstallCmdLineOptions,
		CookieID,
		UpdateAvailable,
		ModelID
	FROM	[dbo].[SecurityPatch]
	WHERE	PatchID = @PatchID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchGetByBulletinIDPatchName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchGetByBulletinIDPatchName]
GO
CREATE PROCEDURE [dbo].[SecurityPatchGetByBulletinIDPatchName]
	@BulletinID		nvarchar(32),
	@PatchName		nvarchar(128)
AS
	SELECT	PatchID,
		BulletinID,
		PatchName,
		Title,
		QNumber,
		State,
		InstallCommandLineOptions,
		UnInstallCommandLineOptions,
		StagedFile,
		Incorporate,
		Supported,
		Ignore,
		DefaultInstallCmdLineOptions,
		DefaultUnInstallCmdLineOptions,
		CookieID,
		UpdateAvailable,
		ModelID
	FROM	[dbo].[SecurityPatch]
	WHERE	BulletinID = @BulletinID
	  AND	PatchName = @PatchName
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchGetAllByBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchGetAllByBulletinID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchGetAllByBulletinID]
	@BulletinID		nvarchar(32)
AS
	SELECT	PatchID,
		BulletinID,
		PatchName,
		Title,
		QNumber,
		State,
		InstallCommandLineOptions,
		UnInstallCommandLineOptions,
		StagedFile,
		Incorporate,
		Supported,
		Ignore,
		DefaultInstallCmdLineOptions,
		DefaultUnInstallCmdLineOptions,
		CookieID,
		UpdateAvailable,
		ModelID
	FROM	[dbo].[SecurityPatch]
	WHERE	BulletinID = @BulletinID
	ORDER BY PatchName
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchGetAllOrderedByBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchGetAllOrderedByBulletinID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchGetAllOrderedByBulletinID]
AS
	SELECT	PatchID,
		BulletinID,
		PatchName,
		Title,
		QNumber,
		State,
		InstallCommandLineOptions,
		UnInstallCommandLineOptions,
		StagedFile,
		Incorporate,
		Supported,
		Ignore,
		DefaultInstallCmdLineOptions,
		DefaultUnInstallCmdLineOptions,
		CookieID,
		UpdateAvailable,
		ModelID
	FROM	[dbo].[SecurityPatch]
	ORDER BY BulletinID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchGetAllByCookieID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchGetAllByCookieID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchGetAllByCookieID]
	@CookieID		int = NULL
AS
	SELECT	PatchID,
		BulletinID,
		PatchName,
		Title,
		QNumber,
		State,
		InstallCommandLineOptions,
		UnInstallCommandLineOptions,
		StagedFile,
		Incorporate,
		Supported,
		Ignore,
		DefaultInstallCmdLineOptions,
		DefaultUnInstallCmdLineOptions,
		CookieID,
		UpdateAvailable,
		ModelID
	FROM	[dbo].[SecurityPatch]
	WHERE	(CookieID = @CookieID OR (CookieID IS NULL AND @CookieID IS NULL))
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchGetAllOrderedByCookieID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchGetAllOrderedByCookieID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchGetAllOrderedByCookieID]
AS
	SELECT	PatchID,
		BulletinID,
		PatchName,
		Title,
		QNumber,
		State,
		InstallCommandLineOptions,
		UnInstallCommandLineOptions,
		StagedFile,
		Incorporate,
		Supported,
		Ignore,
		DefaultInstallCmdLineOptions,
		DefaultUnInstallCmdLineOptions,
		CookieID,
		UpdateAvailable,
		ModelID
	FROM	[dbo].[SecurityPatch]
	ORDER BY CookieID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchGetAll]
AS
	SELECT	PatchID,
		BulletinID,
		PatchName,
		Title,
		QNumber,
		State,
		InstallCommandLineOptions,
		UnInstallCommandLineOptions,
		StagedFile,
		Incorporate,
		Supported,
		Ignore,
		DefaultInstallCmdLineOptions,
		DefaultUnInstallCmdLineOptions,
		CookieID,
		UpdateAvailable,
		ModelID
	FROM	[dbo].[SecurityPatch]
	ORDER BY PatchID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAdd]
GO
CREATE PROCEDURE [dbo].[SecurityPatchAdd]
	@BulletinID		nvarchar(32),
	@PatchName		nvarchar(128),
	@Title			nvarchar(256),
	@QNumber		nvarchar(32),
	@State			int = 1,
	@InstallCommandLineOptions nvarchar(256) = NULL,
	@UnInstallCommandLineOptions nvarchar(256) = NULL,
	@StagedFile		nvarchar(512) = NULL,
	@Incorporate		int = 1,
	@Supported		int = 0,
	@Ignore			int = 0,
	@DefaultInstallCmdLineOptions nvarchar(256) = NULL,
	@DefaultUnInstallCmdLineOptions nvarchar(256) = NULL,
	@CookieID		int = NULL,
	@UpdateAvailable	bit = 0,
	@ModelID		int = 0
AS
	INSERT INTO  dbo.SecurityPatch (
		BulletinID,
		PatchName,
		Title,
		QNumber,
		State,
		InstallCommandLineOptions,
		UnInstallCommandLineOptions,
		StagedFile,
		Incorporate,
		Supported,
		Ignore,
		DefaultInstallCmdLineOptions,
		DefaultUnInstallCmdLineOptions,
		CookieID,
		UpdateAvailable,
		ModelID
	)
	VALUES (
		@BulletinID,
		@PatchName,
		@Title,
		@QNumber,
		@State,
		@InstallCommandLineOptions,
		@UnInstallCommandLineOptions,
		@StagedFile,
		@Incorporate,
		@Supported,
		@Ignore,
		@DefaultInstallCmdLineOptions,
		@DefaultUnInstallCmdLineOptions,
		@CookieID,
		@UpdateAvailable,
		@ModelID
	)
	RETURN SCOPE_IDENTITY()
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchBind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchBind]
GO
CREATE PROCEDURE [dbo].[SecurityPatchBind]
	@BulletinID		nvarchar(32),
	@PatchName		nvarchar(128),
	@Title			nvarchar(256),
	@QNumber		nvarchar(32),
	@State			int = 1,
	@InstallCommandLineOptions nvarchar(256) = NULL,
	@UnInstallCommandLineOptions nvarchar(256) = NULL,
	@StagedFile		nvarchar(512) = NULL,
	@Incorporate		int = 1,
	@Supported		int = 0,
	@Ignore			int = 0,
	@DefaultInstallCmdLineOptions nvarchar(256) = NULL,
	@DefaultUnInstallCmdLineOptions nvarchar(256) = NULL,
	@CookieID		int = NULL,
	@UpdateAvailable	bit = 0,
	@ModelID		int = 0
AS
	DECLARE	@ID	int

	SELECT	@ID = PatchID
	FROM	[dbo].[SecurityPatch]
	WHERE	BulletinID = @BulletinID
	  AND	PatchName = @PatchName

	IF @ID IS NULL
		EXEC @ID = SecurityPatchAdd @BulletinID,
			@PatchName,
			@Title,
			@QNumber,
			@State,
			@InstallCommandLineOptions,
			@UnInstallCommandLineOptions,
			@StagedFile,
			@Incorporate,
			@Supported,
			@Ignore,
			@DefaultInstallCmdLineOptions,
			@DefaultUnInstallCmdLineOptions,
			@CookieID,
			@UpdateAvailable,
			@ModelID

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchSchema]
GO
CREATE PROCEDURE [dbo].[SecurityPatchSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecurityPatch'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecurityPatch (' + CAST(0x0A AS CHAR(1)) +
	'		PatchID			int NULL,' + CAST(0x0A AS CHAR(1)) +
	'		BulletinID		nvarchar(32) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		PatchName		nvarchar(128) COLLATE Latin1_General_CS_AS NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Title			nvarchar(256) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		QNumber			nvarchar(32) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		State			int NOT NULL DEFAULT 1,' + CAST(0x0A AS CHAR(1)) +
	'		InstallCommandLineOptions nvarchar(256) COLLATE database_default NULL,' + CAST(0x0A AS CHAR(1)) +
	'		UnInstallCommandLineOptions nvarchar(256) COLLATE database_default NULL,' + CAST(0x0A AS CHAR(1)) +
	'		StagedFile		nvarchar(512) COLLATE database_default NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Incorporate		int NOT NULL DEFAULT 1,' + CAST(0x0A AS CHAR(1)) +
	'		Supported		int NOT NULL DEFAULT 0,' + CAST(0x0A AS CHAR(1)) +
	'		Ignore			int NOT NULL DEFAULT 0,' + CAST(0x0A AS CHAR(1)) +
	'		DefaultInstallCmdLineOptions nvarchar(256) COLLATE database_default NULL,' + CAST(0x0A AS CHAR(1)) +
	'		DefaultUnInstallCmdLineOptions nvarchar(256) COLLATE database_default NULL,' + CAST(0x0A AS CHAR(1)) +
	'		CookieID		int NULL,' + CAST(0x0A AS CHAR(1)) +
	'		UpdateAvailable		bit NULL DEFAULT 0,' + CAST(0x0A AS CHAR(1)) +
	'		ModelID			int NOT NULL DEFAULT 0' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecurityPatch' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchTempAdd]
GO
CREATE PROCEDURE dbo.[SecurityPatchTempAdd]
	@PatchID		int,
	@BulletinID		nvarchar(32),
	@PatchName		nvarchar(128),
	@Title			nvarchar(256),
	@QNumber		nvarchar(32),
	@State			int = 1,
	@InstallCommandLineOptions nvarchar(256) = NULL,
	@UnInstallCommandLineOptions nvarchar(256) = NULL,
	@StagedFile		nvarchar(512) = NULL,
	@Incorporate		int = 1,
	@Supported		int = 0,
	@Ignore			int = 0,
	@DefaultInstallCmdLineOptions nvarchar(256) = NULL,
	@DefaultUnInstallCmdLineOptions nvarchar(256) = NULL,
	@CookieID		int = NULL,
	@UpdateAvailable	bit = 0,
	@ModelID		int = 0
AS
	INSERT INTO #SecurityPatch (
		PatchID,
		BulletinID,
		PatchName,
		Title,
		QNumber,
		State,
		InstallCommandLineOptions,
		UnInstallCommandLineOptions,
		StagedFile,
		Incorporate,
		Supported,
		Ignore,
		DefaultInstallCmdLineOptions,
		DefaultUnInstallCmdLineOptions,
		CookieID,
		UpdateAvailable,
		ModelID
	)
	VALUES (
		@PatchID,
		@BulletinID,
		@PatchName,
		@Title,
		@QNumber,
		@State,
		@InstallCommandLineOptions,
		@UnInstallCommandLineOptions,
		@StagedFile,
		@Incorporate,
		@Supported,
		@Ignore,
		@DefaultInstallCmdLineOptions,
		@DefaultUnInstallCmdLineOptions,
		@CookieID,
		@UpdateAvailable,
		@ModelID
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAddBatch]
GO
CREATE PROCEDURE dbo.[SecurityPatchAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecurityPatch (
		BulletinID,
		PatchName,
		Title,
		QNumber,
		State,
		InstallCommandLineOptions,
		UnInstallCommandLineOptions,
		StagedFile,
		Incorporate,
		Supported,
		Ignore,
		DefaultInstallCmdLineOptions,
		DefaultUnInstallCmdLineOptions,
		CookieID,
		UpdateAvailable,
		ModelID
	)
		SELECT	BulletinID,
			PatchName,
			Title,
			QNumber,
			State,
			InstallCommandLineOptions,
			UnInstallCommandLineOptions,
			StagedFile,
			Incorporate,
			Supported,
			Ignore,
			DefaultInstallCmdLineOptions,
			DefaultUnInstallCmdLineOptions,
			CookieID,
			UpdateAvailable,
			ModelID
		FROM #SecurityPatch
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatch	-- Drop temporary table
	RETURN @count
GO

/*
Add new SecurityPatch bound to
	SecurityState using Description
	with BulletinID, PatchName, Title, QNumber, InstallCommandLineOptions, UnInstallCommandLineOptions, StagedFile, Incorporate, Supported, Ignore, DefaultInstallCmdLineOptions, DefaultUnInstallCmdLineOptions, CookieID, UpdateAvailable, ModelID
*/

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUpdateByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUpdateByID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchUpdateByID]
	@PatchID		int,
	@BulletinID		nvarchar(32),
	@PatchName		nvarchar(128),
	@Title			nvarchar(256),
	@QNumber		nvarchar(32),
	@State			int = 1,
	@InstallCommandLineOptions nvarchar(256) = NULL,
	@UnInstallCommandLineOptions nvarchar(256) = NULL,
	@StagedFile		nvarchar(512) = NULL,
	@Incorporate		int = 1,
	@Supported		int = 0,
	@Ignore			int = 0,
	@DefaultInstallCmdLineOptions nvarchar(256) = NULL,
	@DefaultUnInstallCmdLineOptions nvarchar(256) = NULL,
	@CookieID		int = NULL,
	@UpdateAvailable	bit = 0,
	@ModelID		int = 0
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[SecurityPatch]
	SET	@ID = PatchID,
		BulletinID = @BulletinID,
		PatchName = @PatchName,
		Title = @Title,
		QNumber = @QNumber,
		State = @State,
		InstallCommandLineOptions = @InstallCommandLineOptions,
		UnInstallCommandLineOptions = @UnInstallCommandLineOptions,
		StagedFile = @StagedFile,
		Incorporate = @Incorporate,
		Supported = @Supported,
		Ignore = @Ignore,
		DefaultInstallCmdLineOptions = @DefaultInstallCmdLineOptions,
		DefaultUnInstallCmdLineOptions = @DefaultUnInstallCmdLineOptions,
		CookieID = @CookieID,
		UpdateAvailable = @UpdateAvailable,
		ModelID = @ModelID
	WHERE	PatchID = @PatchID
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUpdateBatchByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUpdateBatchByID]
GO
CREATE PROCEDURE dbo.[SecurityPatchUpdateBatchByID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityPatchID]
		ON #SecurityPatch (PatchID)

	UPDATE	[dbo].[SecurityPatch]
	SET	BulletinID = t.BulletinID,
		PatchName = t.PatchName,
		Title = t.Title,
		QNumber = t.QNumber,
		State = t.State,
		InstallCommandLineOptions = t.InstallCommandLineOptions,
		UnInstallCommandLineOptions = t.UnInstallCommandLineOptions,
		StagedFile = t.StagedFile,
		Incorporate = t.Incorporate,
		Supported = t.Supported,
		Ignore = t.Ignore,
		DefaultInstallCmdLineOptions = t.DefaultInstallCmdLineOptions,
		DefaultUnInstallCmdLineOptions = t.DefaultUnInstallCmdLineOptions,
		CookieID = t.CookieID,
		UpdateAvailable = t.UpdateAvailable,
		ModelID = t.ModelID
	FROM	#SecurityPatch AS t
	WHERE	SecurityPatch.PatchID = t.PatchID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatch	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUpdateByBulletinIDPatchName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUpdateByBulletinIDPatchName]
GO
CREATE PROCEDURE [dbo].[SecurityPatchUpdateByBulletinIDPatchName]
	@BulletinID		nvarchar(32),
	@PatchName		nvarchar(128),
	@Title			nvarchar(256),
	@QNumber		nvarchar(32),
	@State			int = 1,
	@InstallCommandLineOptions nvarchar(256) = NULL,
	@UnInstallCommandLineOptions nvarchar(256) = NULL,
	@StagedFile		nvarchar(512) = NULL,
	@Incorporate		int = 1,
	@Supported		int = 0,
	@Ignore			int = 0,
	@DefaultInstallCmdLineOptions nvarchar(256) = NULL,
	@DefaultUnInstallCmdLineOptions nvarchar(256) = NULL,
	@CookieID		int = NULL,
	@UpdateAvailable	bit = 0,
	@ModelID		int = 0
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[SecurityPatch]
	SET	@ID = PatchID,
		Title = @Title,
		QNumber = @QNumber,
		State = @State,
		InstallCommandLineOptions = @InstallCommandLineOptions,
		UnInstallCommandLineOptions = @UnInstallCommandLineOptions,
		StagedFile = @StagedFile,
		Incorporate = @Incorporate,
		Supported = @Supported,
		Ignore = @Ignore,
		DefaultInstallCmdLineOptions = @DefaultInstallCmdLineOptions,
		DefaultUnInstallCmdLineOptions = @DefaultUnInstallCmdLineOptions,
		CookieID = @CookieID,
		UpdateAvailable = @UpdateAvailable,
		ModelID = @ModelID
	WHERE	BulletinID = @BulletinID
	  AND	PatchName = @PatchName
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUpdateBatchByBulletinIDPatchName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUpdateBatchByBulletinIDPatchName]
GO
CREATE PROCEDURE dbo.[SecurityPatchUpdateBatchByBulletinIDPatchName]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityPatchBulletinIDPatchName]
		ON #SecurityPatch (BulletinID, PatchName)

	UPDATE	[dbo].[SecurityPatch]
	SET	Title = t.Title,
		QNumber = t.QNumber,
		State = t.State,
		InstallCommandLineOptions = t.InstallCommandLineOptions,
		UnInstallCommandLineOptions = t.UnInstallCommandLineOptions,
		StagedFile = t.StagedFile,
		Incorporate = t.Incorporate,
		Supported = t.Supported,
		Ignore = t.Ignore,
		DefaultInstallCmdLineOptions = t.DefaultInstallCmdLineOptions,
		DefaultUnInstallCmdLineOptions = t.DefaultUnInstallCmdLineOptions,
		CookieID = t.CookieID,
		UpdateAvailable = t.UpdateAvailable,
		ModelID = t.ModelID
	FROM	#SecurityPatch AS t
	WHERE	SecurityPatch.BulletinID = t.BulletinID
	  AND	SecurityPatch.PatchName = t.PatchName
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatch	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchPutByBulletinIDPatchName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchPutByBulletinIDPatchName]
GO
CREATE PROCEDURE [dbo].[SecurityPatchPutByBulletinIDPatchName]
	@BulletinID		nvarchar(32),
	@PatchName		nvarchar(128),
	@Title			nvarchar(256),
	@QNumber		nvarchar(32),
	@State			int = 1,
	@InstallCommandLineOptions nvarchar(256) = NULL,
	@UnInstallCommandLineOptions nvarchar(256) = NULL,
	@StagedFile		nvarchar(512) = NULL,
	@Incorporate		int = 1,
	@Supported		int = 0,
	@Ignore			int = 0,
	@DefaultInstallCmdLineOptions nvarchar(256) = NULL,
	@DefaultUnInstallCmdLineOptions nvarchar(256) = NULL,
	@CookieID		int = NULL,
	@UpdateAvailable	bit = 0,
	@ModelID		int = 0
AS
	DECLARE @ID	int

	SELECT	@ID = PatchID
	FROM	SecurityPatch
	WHERE	BulletinID = @BulletinID
	  AND	PatchName = @PatchName

	IF @ID IS NULL
		EXEC @ID = SecurityPatchAdd @BulletinID,
			@PatchName,
			@Title,
			@QNumber,
			@State,
			@InstallCommandLineOptions,
			@UnInstallCommandLineOptions,
			@StagedFile,
			@Incorporate,
			@Supported,
			@Ignore,
			@DefaultInstallCmdLineOptions,
			@DefaultUnInstallCmdLineOptions,
			@CookieID,
			@UpdateAvailable,
			@ModelID
	ELSE
		EXEC SecurityPatchUpdateByBulletinIDPatchName @BulletinID,
			@PatchName,
			@Title,
			@QNumber,
			@State,
			@InstallCommandLineOptions,
			@UnInstallCommandLineOptions,
			@StagedFile,
			@Incorporate,
			@Supported,
			@Ignore,
			@DefaultInstallCmdLineOptions,
			@DefaultUnInstallCmdLineOptions,
			@CookieID,
			@UpdateAvailable,
			@ModelID

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchPutBatchByBulletinIDPatchName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchPutBatchByBulletinIDPatchName]
GO
CREATE PROCEDURE [dbo].[SecurityPatchPutBatchByBulletinIDPatchName]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecurityPatchBulletinIDPatchName]
		ON #SecurityPatch (BulletinID, PatchName)

	BEGIN TRANSACTION
	UPDATE [dbo].[SecurityPatch]
		SET	Title = t.Title,
			QNumber = t.QNumber,
			State = t.State,
			InstallCommandLineOptions = t.InstallCommandLineOptions,
			UnInstallCommandLineOptions = t.UnInstallCommandLineOptions,
			StagedFile = t.StagedFile,
			Incorporate = t.Incorporate,
			Supported = t.Supported,
			Ignore = t.Ignore,
			DefaultInstallCmdLineOptions = t.DefaultInstallCmdLineOptions,
			DefaultUnInstallCmdLineOptions = t.DefaultUnInstallCmdLineOptions,
			CookieID = t.CookieID,
			UpdateAvailable = t.UpdateAvailable,
			ModelID = t.ModelID
		FROM	#SecurityPatch AS t
		WHERE	SecurityPatch.BulletinID = t.BulletinID
		  AND	SecurityPatch.PatchName = t.PatchName
	SET @count = @@ROWCOUNT

	INSERT [dbo].[SecurityPatch] (
		BulletinID,
		PatchName,
		Title,
		QNumber,
		State,
		InstallCommandLineOptions,
		UnInstallCommandLineOptions,
		StagedFile,
		Incorporate,
		Supported,
		Ignore,
		DefaultInstallCmdLineOptions,
		DefaultUnInstallCmdLineOptions,
		CookieID,
		UpdateAvailable,
		ModelID
	)
		SELECT	BulletinID,
			PatchName,
			Title,
			QNumber,
			State,
			InstallCommandLineOptions,
			UnInstallCommandLineOptions,
			StagedFile,
			Incorporate,
			Supported,
			Ignore,
			DefaultInstallCmdLineOptions,
			DefaultUnInstallCmdLineOptions,
			CookieID,
			UpdateAvailable,
			ModelID
		FROM	#SecurityPatch AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecurityPatch]
			WHERE	SecurityPatch.BulletinID = t.BulletinID
			  AND	SecurityPatch.PatchName = t.PatchName
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecurityPatch	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecurityPatchRemoveBatch]
AS

	CREATE INDEX [TempSecurityPatchSecurityPatchRemoveBatch]
		ON #SecurityPatch (PatchID)	

	-- Delete records from SecurityPatch identified by fields of [TempSecurityPatchSecurityPatchRemoveBatch]
	DELETE [dbo].[SecurityPatch]
	WHERE EXISTS(
			SELECT * FROM #SecurityPatch AS t
			WHERE	SecurityPatch.PatchID = t.PatchID
		)
	DROP TABLE #SecurityPatch      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchRemoveByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchRemoveByID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchRemoveByID]
	@PatchID		int
AS
	-- SecurityPatch deletes cascade to:
	--	SecPatch_Patch by FK_Patch_SecurityPatch
	--		SecPatch_AffectedProduct by FK_AffectedProduct_Patch
	--			SecPatch_AffectedServicePack by FK_AffectedServicePack_AffectedProduct
	--		SecPatch_PatchComment by FK_PatchComment_Patch
	--	SecurityPatchAlias by FK_SecurityPatchAlias_SecurityPatch
	--	SecurityPatchRequires by FK_SecurityPatchRequires_SecurityPatch
	--	SecurityPatchToPackageVersion by FK_SecurityPatchToPackageVersion_SecurityPatch
	--	SecurityPatchAnalysis by FK_SecurityPatchAnalysis_SecurityPatch
	--	SecurityPatchUninstallValues by FK_SecurityPatchUninstallValues_SecurityPatch
	--	SecurityPatchResource by FK_SecurityPatchResource_SecurityPatchID
	-- SecurityPatch deletes may fail due to non-cascading FKs:
	--	SecurityPatchRequires by FK_SecurityPatchRequires2_SecurityPatch
	DELETE	[dbo].[SecurityPatch]
	WHERE	PatchID = @PatchID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchRemoveByBulletinIDPatchName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchRemoveByBulletinIDPatchName]
GO
CREATE PROCEDURE [dbo].[SecurityPatchRemoveByBulletinIDPatchName]
	@BulletinID		nvarchar(32),
	@PatchName		nvarchar(128)
AS
	-- SecurityPatch deletes cascade to:
	--	SecPatch_Patch by FK_Patch_SecurityPatch
	--		SecPatch_AffectedProduct by FK_AffectedProduct_Patch
	--			SecPatch_AffectedServicePack by FK_AffectedServicePack_AffectedProduct
	--		SecPatch_PatchComment by FK_PatchComment_Patch
	--	SecurityPatchAlias by FK_SecurityPatchAlias_SecurityPatch
	--	SecurityPatchRequires by FK_SecurityPatchRequires_SecurityPatch
	--	SecurityPatchToPackageVersion by FK_SecurityPatchToPackageVersion_SecurityPatch
	--	SecurityPatchAnalysis by FK_SecurityPatchAnalysis_SecurityPatch
	--	SecurityPatchUninstallValues by FK_SecurityPatchUninstallValues_SecurityPatch
	--	SecurityPatchResource by FK_SecurityPatchResource_SecurityPatchID
	-- SecurityPatch deletes may fail due to non-cascading FKs:
	--	SecurityPatchRequires by FK_SecurityPatchRequires2_SecurityPatch
	DELETE	[dbo].[SecurityPatch]
	WHERE	BulletinID = @BulletinID
	  AND	PatchName = @PatchName
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchRemoveAllByBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchRemoveAllByBulletinID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchRemoveAllByBulletinID]
	@BulletinID		nvarchar(32)
AS
	DELETE	[dbo].[SecurityPatch]
	WHERE	BulletinID = @BulletinID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchRemoveAllByCookieID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchRemoveAllByCookieID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchRemoveAllByCookieID]
	@CookieID		int = NULL
AS
	DELETE	[dbo].[SecurityPatch]
	WHERE	(CookieID = @CookieID OR (CookieID IS NULL AND @CookieID IS NULL))
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchRemoveAll]
	
AS
	DELETE	[dbo].[SecurityPatch]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAliasGetByBulletinIDPatchName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAliasGetByBulletinIDPatchName]
GO
CREATE PROCEDURE [dbo].[SecurityPatchAliasGetByBulletinIDPatchName]
	@BulletinID		nvarchar(32),
	@PatchName		nvarchar(128)
AS
	SELECT	BulletinID,
		PatchName,
		SecurityPatchID
	FROM	[dbo].[SecurityPatchAlias]
	WHERE	BulletinID = @BulletinID
	  AND	PatchName = @PatchName
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAliasGetAllBySecurityPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAliasGetAllBySecurityPatchID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchAliasGetAllBySecurityPatchID]
	@SecurityPatchID	int
AS
	SELECT	BulletinID,
		PatchName,
		SecurityPatchID
	FROM	[dbo].[SecurityPatchAlias]
	WHERE	SecurityPatchID = @SecurityPatchID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAliasGetAllOrderedBySecurityPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAliasGetAllOrderedBySecurityPatchID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchAliasGetAllOrderedBySecurityPatchID]
AS
	SELECT	BulletinID,
		PatchName,
		SecurityPatchID
	FROM	[dbo].[SecurityPatchAlias]
	ORDER BY SecurityPatchID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAliasGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAliasGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchAliasGetAll]
AS
	SELECT	BulletinID,
		PatchName,
		SecurityPatchID
	FROM	[dbo].[SecurityPatchAlias]
	ORDER BY BulletinID, PatchName
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAliasAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAliasAdd]
GO
CREATE PROCEDURE [dbo].[SecurityPatchAliasAdd]
	@BulletinID		nvarchar(32),
	@PatchName		nvarchar(128),
	@SecurityPatchID	int
AS
	INSERT INTO  dbo.SecurityPatchAlias (
		BulletinID,
		PatchName,
		SecurityPatchID
	)
	VALUES (
		@BulletinID,
		@PatchName,
		@SecurityPatchID
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAliasSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAliasSchema]
GO
CREATE PROCEDURE [dbo].[SecurityPatchAliasSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecurityPatchAlias'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecurityPatchAlias (' + CAST(0x0A AS CHAR(1)) +
	'		BulletinID		nvarchar(32) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		PatchName		nvarchar(128) COLLATE Latin1_General_CS_AS NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		SecurityPatchID		int NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecurityPatchAlias' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAliasTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAliasTempAdd]
GO
CREATE PROCEDURE dbo.[SecurityPatchAliasTempAdd]
	@BulletinID		nvarchar(32),
	@PatchName		nvarchar(128),
	@SecurityPatchID	int
AS
	INSERT INTO #SecurityPatchAlias (
		BulletinID,
		PatchName,
		SecurityPatchID
	)
	VALUES (
		@BulletinID,
		@PatchName,
		@SecurityPatchID
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAliasAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAliasAddBatch]
GO
CREATE PROCEDURE dbo.[SecurityPatchAliasAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecurityPatchAlias (
		BulletinID,
		PatchName,
		SecurityPatchID
	)
		SELECT	BulletinID,
			PatchName,
			SecurityPatchID
		FROM #SecurityPatchAlias
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchAlias	-- Drop temporary table
	RETURN @count
GO

/*
Add new SecurityPatchAlias bound to
	SecurityPatch using BulletinID, PatchName with Title, QNumber
	with BulletinID, PatchName
*/

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAliasUpdateByBulletinIDPatchName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAliasUpdateByBulletinIDPatchName]
GO
CREATE PROCEDURE [dbo].[SecurityPatchAliasUpdateByBulletinIDPatchName]
	@BulletinID		nvarchar(32),
	@PatchName		nvarchar(128),
	@SecurityPatchID	int
AS
	UPDATE	[dbo].[SecurityPatchAlias]
	SET	SecurityPatchID = @SecurityPatchID
	WHERE	BulletinID = @BulletinID
	  AND	PatchName = @PatchName
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAliasUpdateBatchByBulletinIDPatchName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAliasUpdateBatchByBulletinIDPatchName]
GO
CREATE PROCEDURE dbo.[SecurityPatchAliasUpdateBatchByBulletinIDPatchName]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityPatchAliasBulletinIDPatchName]
		ON #SecurityPatchAlias (BulletinID, PatchName)

	UPDATE	[dbo].[SecurityPatchAlias]
	SET	SecurityPatchID = t.SecurityPatchID
	FROM	#SecurityPatchAlias AS t
	WHERE	SecurityPatchAlias.BulletinID = t.BulletinID
	  AND	SecurityPatchAlias.PatchName = t.PatchName
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchAlias	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAliasPutByBulletinIDPatchName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAliasPutByBulletinIDPatchName]
GO
CREATE PROCEDURE [dbo].[SecurityPatchAliasPutByBulletinIDPatchName]
	@BulletinID		nvarchar(32),
	@PatchName		nvarchar(128),
	@SecurityPatchID	int
AS
	IF NOT EXISTS(
		SELECT	1
		FROM	dbo.SecurityPatchAlias
		WHERE	BulletinID = @BulletinID
		  AND	PatchName = @PatchName
	)
		EXEC SecurityPatchAliasAdd @BulletinID,
			@PatchName,
			@SecurityPatchID
	ELSE
		EXEC SecurityPatchAliasUpdateByBulletinIDPatchName @BulletinID,
			@PatchName,
			@SecurityPatchID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAliasPutBatchByBulletinIDPatchName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAliasPutBatchByBulletinIDPatchName]
GO
CREATE PROCEDURE [dbo].[SecurityPatchAliasPutBatchByBulletinIDPatchName]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecurityPatchAliasBulletinIDPatchName]
		ON #SecurityPatchAlias (BulletinID, PatchName)

	BEGIN TRANSACTION
	UPDATE [dbo].[SecurityPatchAlias]
		SET	SecurityPatchID = t.SecurityPatchID
		FROM	#SecurityPatchAlias AS t
		WHERE	SecurityPatchAlias.BulletinID = t.BulletinID
		  AND	SecurityPatchAlias.PatchName = t.PatchName
	SET @count = @@ROWCOUNT

	INSERT [dbo].[SecurityPatchAlias] (
		BulletinID,
		PatchName,
		SecurityPatchID
	)
		SELECT	BulletinID,
			PatchName,
			SecurityPatchID
		FROM	#SecurityPatchAlias AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecurityPatchAlias]
			WHERE	SecurityPatchAlias.BulletinID = t.BulletinID
			  AND	SecurityPatchAlias.PatchName = t.PatchName
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecurityPatchAlias	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAliasRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAliasRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecurityPatchAliasRemoveBatch]
AS

	CREATE INDEX [TempSecurityPatchAliasSecurityPatchAliasRemoveBatch]
		ON #SecurityPatchAlias (BulletinID, PatchName)	

	-- Delete records from SecurityPatchAlias identified by fields of [TempSecurityPatchAliasSecurityPatchAliasRemoveBatch]
	DELETE [dbo].[SecurityPatchAlias]
	WHERE EXISTS(
			SELECT * FROM #SecurityPatchAlias AS t
			WHERE	SecurityPatchAlias.BulletinID = t.BulletinID
			  AND	SecurityPatchAlias.PatchName = t.PatchName
		)
	DROP TABLE #SecurityPatchAlias      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAliasRemoveByBulletinIDPatchName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAliasRemoveByBulletinIDPatchName]
GO
CREATE PROCEDURE [dbo].[SecurityPatchAliasRemoveByBulletinIDPatchName]
	@BulletinID		nvarchar(32),
	@PatchName		nvarchar(128)
AS
	DELETE	[dbo].[SecurityPatchAlias]
	WHERE	BulletinID = @BulletinID
	  AND	PatchName = @PatchName
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAliasRemoveAllBySecurityPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAliasRemoveAllBySecurityPatchID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchAliasRemoveAllBySecurityPatchID]
	@SecurityPatchID	int
AS
	DELETE	[dbo].[SecurityPatchAlias]
	WHERE	SecurityPatchID = @SecurityPatchID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAliasRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAliasRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchAliasRemoveAll]
	
AS
	DELETE	[dbo].[SecurityPatchAlias]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchRequiresGetByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchRequiresGetByID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchRequiresGetByID]
	@SecurityPatchRequiresID int
AS
	SELECT	SecurityPatchRequiresID,
		PatchID,
		RequiredPatchID,
		Strength
	FROM	[dbo].[SecurityPatchRequires]
	WHERE	SecurityPatchRequiresID = @SecurityPatchRequiresID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchRequiresGetAllByPatchIDStrength]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchRequiresGetAllByPatchIDStrength]
GO
CREATE PROCEDURE [dbo].[SecurityPatchRequiresGetAllByPatchIDStrength]
	@PatchID		int,
	@Strength		int
AS
	SELECT	SecurityPatchRequiresID,
		PatchID,
		RequiredPatchID,
		Strength
	FROM	[dbo].[SecurityPatchRequires]
	WHERE	PatchID = @PatchID
	  AND	Strength = @Strength
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchRequiresGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchRequiresGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchRequiresGetAll]
AS
	SELECT	SecurityPatchRequiresID,
		PatchID,
		RequiredPatchID,
		Strength
	FROM	[dbo].[SecurityPatchRequires]
	ORDER BY PatchID, Strength
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchRequiresAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchRequiresAdd]
GO
CREATE PROCEDURE [dbo].[SecurityPatchRequiresAdd]
	@PatchID		int,
	@RequiredPatchID	int,
	@Strength		int
AS
	INSERT INTO  dbo.SecurityPatchRequires (
		PatchID,
		RequiredPatchID,
		Strength
	)
	VALUES (
		@PatchID,
		@RequiredPatchID,
		@Strength
	)
	RETURN SCOPE_IDENTITY()
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchRequiresSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchRequiresSchema]
GO
CREATE PROCEDURE [dbo].[SecurityPatchRequiresSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecurityPatchRequires'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecurityPatchRequires (' + CAST(0x0A AS CHAR(1)) +
	'		SecurityPatchRequiresID	int NULL,' + CAST(0x0A AS CHAR(1)) +
	'		PatchID			int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		RequiredPatchID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Strength		int NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecurityPatchRequires' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchRequiresTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchRequiresTempAdd]
GO
CREATE PROCEDURE dbo.[SecurityPatchRequiresTempAdd]
	@SecurityPatchRequiresID int,
	@PatchID		int,
	@RequiredPatchID	int,
	@Strength		int
AS
	INSERT INTO #SecurityPatchRequires (
		SecurityPatchRequiresID,
		PatchID,
		RequiredPatchID,
		Strength
	)
	VALUES (
		@SecurityPatchRequiresID,
		@PatchID,
		@RequiredPatchID,
		@Strength
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchRequiresAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchRequiresAddBatch]
GO
CREATE PROCEDURE dbo.[SecurityPatchRequiresAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecurityPatchRequires (
		PatchID,
		RequiredPatchID,
		Strength
	)
		SELECT	PatchID,
			RequiredPatchID,
			Strength
		FROM #SecurityPatchRequires
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchRequires	-- Drop temporary table
	RETURN @count
GO

/*
Add new SecurityPatchRequires bound to
	SecurityPatch using BulletinID, PatchName with Title, QNumber
	SecurityPatch using BulletinID, PatchName with Title, QNumber
	with Strength
*/

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchRequiresUpdateByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchRequiresUpdateByID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchRequiresUpdateByID]
	@SecurityPatchRequiresID int,
	@PatchID		int,
	@RequiredPatchID	int,
	@Strength		int
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[SecurityPatchRequires]
	SET	@ID = SecurityPatchRequiresID,
		PatchID = @PatchID,
		RequiredPatchID = @RequiredPatchID,
		Strength = @Strength
	WHERE	SecurityPatchRequiresID = @SecurityPatchRequiresID
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchRequiresUpdateBatchByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchRequiresUpdateBatchByID]
GO
CREATE PROCEDURE dbo.[SecurityPatchRequiresUpdateBatchByID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityPatchRequiresID]
		ON #SecurityPatchRequires (SecurityPatchRequiresID)

	UPDATE	[dbo].[SecurityPatchRequires]
	SET	PatchID = t.PatchID,
		RequiredPatchID = t.RequiredPatchID,
		Strength = t.Strength
	FROM	#SecurityPatchRequires AS t
	WHERE	SecurityPatchRequires.SecurityPatchRequiresID = t.SecurityPatchRequiresID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchRequires	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchRequiresRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchRequiresRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecurityPatchRequiresRemoveBatch]
AS

	CREATE INDEX [TempSecurityPatchRequiresSecurityPatchRequiresRemoveBatch]
		ON #SecurityPatchRequires (SecurityPatchRequiresID)	

	-- Delete records from SecurityPatchRequires identified by fields of [TempSecurityPatchRequiresSecurityPatchRequiresRemoveBatch]
	DELETE [dbo].[SecurityPatchRequires]
	WHERE EXISTS(
			SELECT * FROM #SecurityPatchRequires AS t
			WHERE	SecurityPatchRequires.SecurityPatchRequiresID = t.SecurityPatchRequiresID
		)
	DROP TABLE #SecurityPatchRequires      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchRequiresRemoveByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchRequiresRemoveByID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchRequiresRemoveByID]
	@SecurityPatchRequiresID int
AS
	DELETE	[dbo].[SecurityPatchRequires]
	WHERE	SecurityPatchRequiresID = @SecurityPatchRequiresID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchRequiresRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchRequiresRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchRequiresRemoveAll]
	
AS
	DELETE	[dbo].[SecurityPatchRequires]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchToPackageVersionGetByPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchToPackageVersionGetByPatchID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchToPackageVersionGetByPatchID]
	@PatchID		int
AS
	SELECT	PatchID,
		PackageFullName,
		PackageName,
		Version
	FROM	[dbo].[SecurityPatchToPackageVersion]
	WHERE	PatchID = @PatchID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchToPackageVersionGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchToPackageVersionGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchToPackageVersionGetAll]
AS
	SELECT	PatchID,
		PackageFullName,
		PackageName,
		Version
	FROM	[dbo].[SecurityPatchToPackageVersion]
	ORDER BY PatchID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchToPackageVersionAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchToPackageVersionAdd]
GO
CREATE PROCEDURE [dbo].[SecurityPatchToPackageVersionAdd]
	@PatchID		int,
	@PackageFullName	nvarchar(256),
	@PackageName		nvarchar(64),
	@Version		nvarchar(32) = NULL
AS
	INSERT INTO  dbo.SecurityPatchToPackageVersion (
		PatchID,
		PackageFullName,
		PackageName,
		Version
	)
	VALUES (
		@PatchID,
		@PackageFullName,
		@PackageName,
		@Version
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchToPackageVersionSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchToPackageVersionSchema]
GO
CREATE PROCEDURE [dbo].[SecurityPatchToPackageVersionSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecurityPatchToPackageVersion'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecurityPatchToPackageVersion (' + CAST(0x0A AS CHAR(1)) +
	'		PatchID			int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		PackageFullName		nvarchar(256) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		PackageName		nvarchar(64) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Version			nvarchar(32) COLLATE database_default NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecurityPatchToPackageVersion' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchToPackageVersionTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchToPackageVersionTempAdd]
GO
CREATE PROCEDURE dbo.[SecurityPatchToPackageVersionTempAdd]
	@PatchID		int,
	@PackageFullName	nvarchar(256),
	@PackageName		nvarchar(64),
	@Version		nvarchar(32) = NULL
AS
	INSERT INTO #SecurityPatchToPackageVersion (
		PatchID,
		PackageFullName,
		PackageName,
		Version
	)
	VALUES (
		@PatchID,
		@PackageFullName,
		@PackageName,
		@Version
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchToPackageVersionAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchToPackageVersionAddBatch]
GO
CREATE PROCEDURE dbo.[SecurityPatchToPackageVersionAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecurityPatchToPackageVersion (
		PatchID,
		PackageFullName,
		PackageName,
		Version
	)
		SELECT	PatchID,
			PackageFullName,
			PackageName,
			Version
		FROM #SecurityPatchToPackageVersion
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchToPackageVersion	-- Drop temporary table
	RETURN @count
GO

/*
Add new SecurityPatchToPackageVersion bound to
	SecurityPatch using BulletinID, PatchName with Title, QNumber
	with PackageFullName, PackageName, Version
*/

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchToPackageVersionUpdateByPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchToPackageVersionUpdateByPatchID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchToPackageVersionUpdateByPatchID]
	@PatchID		int,
	@PackageFullName	nvarchar(256),
	@PackageName		nvarchar(64),
	@Version		nvarchar(32) = NULL
AS
	UPDATE	[dbo].[SecurityPatchToPackageVersion]
	SET	PackageFullName = @PackageFullName,
		PackageName = @PackageName,
		Version = @Version
	WHERE	PatchID = @PatchID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchToPackageVersionUpdateBatchByPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchToPackageVersionUpdateBatchByPatchID]
GO
CREATE PROCEDURE dbo.[SecurityPatchToPackageVersionUpdateBatchByPatchID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityPatchToPackageVersionPatchID]
		ON #SecurityPatchToPackageVersion (PatchID)

	UPDATE	[dbo].[SecurityPatchToPackageVersion]
	SET	PackageFullName = t.PackageFullName,
		PackageName = t.PackageName,
		Version = t.Version
	FROM	#SecurityPatchToPackageVersion AS t
	WHERE	SecurityPatchToPackageVersion.PatchID = t.PatchID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchToPackageVersion	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchToPackageVersionPutByPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchToPackageVersionPutByPatchID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchToPackageVersionPutByPatchID]
	@PatchID		int,
	@PackageFullName	nvarchar(256),
	@PackageName		nvarchar(64),
	@Version		nvarchar(32) = NULL
AS
	IF NOT EXISTS(
		SELECT	1
		FROM	dbo.SecurityPatchToPackageVersion
		WHERE	PatchID = @PatchID
	)
		EXEC SecurityPatchToPackageVersionAdd @PatchID,
			@PackageFullName,
			@PackageName,
			@Version
	ELSE
		EXEC SecurityPatchToPackageVersionUpdateByPatchID @PatchID,
			@PackageFullName,
			@PackageName,
			@Version
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchToPackageVersionPutBatchByPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchToPackageVersionPutBatchByPatchID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchToPackageVersionPutBatchByPatchID]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecurityPatchToPackageVersionPatchID]
		ON #SecurityPatchToPackageVersion (PatchID)

	BEGIN TRANSACTION
	UPDATE [dbo].[SecurityPatchToPackageVersion]
		SET	PackageFullName = t.PackageFullName,
			PackageName = t.PackageName,
			Version = t.Version
		FROM	#SecurityPatchToPackageVersion AS t
		WHERE	SecurityPatchToPackageVersion.PatchID = t.PatchID
	SET @count = @@ROWCOUNT

	INSERT [dbo].[SecurityPatchToPackageVersion] (
		PatchID,
		PackageFullName,
		PackageName,
		Version
	)
		SELECT	PatchID,
			PackageFullName,
			PackageName,
			Version
		FROM	#SecurityPatchToPackageVersion AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecurityPatchToPackageVersion]
			WHERE	SecurityPatchToPackageVersion.PatchID = t.PatchID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecurityPatchToPackageVersion	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchToPackageVersionRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchToPackageVersionRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecurityPatchToPackageVersionRemoveBatch]
AS

	CREATE INDEX [TempSecurityPatchToPackageVersionSecurityPatchToPackageVersionRemoveBatch]
		ON #SecurityPatchToPackageVersion (PatchID)	

	-- Delete records from SecurityPatchToPackageVersion identified by fields of [TempSecurityPatchToPackageVersionSecurityPatchToPackageVersionRemoveBatch]
	DELETE [dbo].[SecurityPatchToPackageVersion]
	WHERE EXISTS(
			SELECT * FROM #SecurityPatchToPackageVersion AS t
			WHERE	SecurityPatchToPackageVersion.PatchID = t.PatchID
		)
	DROP TABLE #SecurityPatchToPackageVersion      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchToPackageVersionRemoveByPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchToPackageVersionRemoveByPatchID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchToPackageVersionRemoveByPatchID]
	@PatchID		int
AS
	DELETE	[dbo].[SecurityPatchToPackageVersion]
	WHERE	PatchID = @PatchID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchToPackageVersionRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchToPackageVersionRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchToPackageVersionRemoveAll]
	
AS
	DELETE	[dbo].[SecurityPatchToPackageVersion]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityStateGetByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityStateGetByID]
GO
CREATE PROCEDURE [dbo].[SecurityStateGetByID]
	@StateID		int
AS
	SELECT	StateID,
		Description
	FROM	[dbo].[SecurityState]
	WHERE	StateID = @StateID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityStateGetByDescription]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityStateGetByDescription]
GO
CREATE PROCEDURE [dbo].[SecurityStateGetByDescription]
	@Description		nvarchar(64)
AS
	SELECT	StateID,
		Description
	FROM	[dbo].[SecurityState]
	WHERE	Description = @Description
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityStateGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityStateGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityStateGetAll]
AS
	SELECT	StateID,
		Description
	FROM	[dbo].[SecurityState]
	ORDER BY StateID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityStateBind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityStateBind]
GO
CREATE PROCEDURE [dbo].[SecurityStateBind]
	@Description		nvarchar(64)
AS
	DECLARE	@ID	int

	SELECT	@ID = StateID
	FROM	[dbo].[SecurityState]
	WHERE	Description = @Description

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityUserStateGetByUserStateID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityUserStateGetByUserStateID]
GO
CREATE PROCEDURE [dbo].[SecurityUserStateGetByUserStateID]
	@UserStateID		int
AS
	SELECT	UserStateID,
		Description
	FROM	[dbo].[SecurityUserState]
	WHERE	UserStateID = @UserStateID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityUserStateGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityUserStateGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityUserStateGetAll]
AS
	SELECT	UserStateID,
		Description
	FROM	[dbo].[SecurityUserState]
	ORDER BY UserStateID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityUIStateGetByUIStateID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityUIStateGetByUIStateID]
GO
CREATE PROCEDURE [dbo].[SecurityUIStateGetByUIStateID]
	@UIStateID		int
AS
	SELECT	UIStateID,
		Description
	FROM	[dbo].[SecurityUIState]
	WHERE	UIStateID = @UIStateID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityUIStateGetByDescription]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityUIStateGetByDescription]
GO
CREATE PROCEDURE [dbo].[SecurityUIStateGetByDescription]
	@Description		nvarchar(32)
AS
	SELECT	UIStateID,
		Description
	FROM	[dbo].[SecurityUIState]
	WHERE	Description = @Description
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityUIStateGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityUIStateGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityUIStateGetAll]
AS
	SELECT	UIStateID,
		Description
	FROM	[dbo].[SecurityUIState]
	ORDER BY UIStateID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityUIStateBind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityUIStateBind]
GO
CREATE PROCEDURE [dbo].[SecurityUIStateBind]
	@Description		nvarchar(32)
AS
	DECLARE	@ID	int

	SELECT	@ID = UIStateID
	FROM	[dbo].[SecurityUIState]
	WHERE	Description = @Description

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityStateChangeGetByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityStateChangeGetByID]
GO
CREATE PROCEDURE [dbo].[SecurityStateChangeGetByID]
	@SecurityStateChangeID	int
AS
	SELECT	SecurityStateChangeID,
		BulletinID,
		StateTo,
		StateFrom,
		DateChanged,
		Comment,
		Username
	FROM	[dbo].[SecurityStateChange]
	WHERE	SecurityStateChangeID = @SecurityStateChangeID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityStateChangeGetByBulletinIDDateChanged]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityStateChangeGetByBulletinIDDateChanged]
GO
CREATE PROCEDURE [dbo].[SecurityStateChangeGetByBulletinIDDateChanged]
	@BulletinID		nvarchar(32),
	@DateChanged		datetime
AS
	SELECT	SecurityStateChangeID,
		BulletinID,
		StateTo,
		StateFrom,
		DateChanged,
		Comment,
		Username
	FROM	[dbo].[SecurityStateChange]
	WHERE	BulletinID = @BulletinID
	  AND	DateChanged = @DateChanged
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityStateChangeGetAllByBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityStateChangeGetAllByBulletinID]
GO
CREATE PROCEDURE [dbo].[SecurityStateChangeGetAllByBulletinID]
	@BulletinID		nvarchar(32)
AS
	SELECT	SecurityStateChangeID,
		BulletinID,
		StateTo,
		StateFrom,
		DateChanged,
		Comment,
		Username
	FROM	[dbo].[SecurityStateChange]
	WHERE	BulletinID = @BulletinID
	ORDER BY DateChanged
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityStateChangeGetAllOrderedByBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityStateChangeGetAllOrderedByBulletinID]
GO
CREATE PROCEDURE [dbo].[SecurityStateChangeGetAllOrderedByBulletinID]
AS
	SELECT	SecurityStateChangeID,
		BulletinID,
		StateTo,
		StateFrom,
		DateChanged,
		Comment,
		Username
	FROM	[dbo].[SecurityStateChange]
	ORDER BY BulletinID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityStateChangeGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityStateChangeGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityStateChangeGetAll]
AS
	SELECT	SecurityStateChangeID,
		BulletinID,
		StateTo,
		StateFrom,
		DateChanged,
		Comment,
		Username
	FROM	[dbo].[SecurityStateChange]
	ORDER BY SecurityStateChangeID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityStateChangeAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityStateChangeAdd]
GO
CREATE PROCEDURE [dbo].[SecurityStateChangeAdd]
	@BulletinID		nvarchar(32),
	@StateTo		int,
	@StateFrom		int,
	@DateChanged		datetime,
	@Comment		ntext = NULL,
	@Username		nvarchar(64)
AS
	INSERT INTO  dbo.SecurityStateChange (
		BulletinID,
		StateTo,
		StateFrom,
		DateChanged,
		Comment,
		Username
	)
	VALUES (
		@BulletinID,
		@StateTo,
		@StateFrom,
		@DateChanged,
		@Comment,
		@Username
	)
	RETURN SCOPE_IDENTITY()
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityStateChangeBind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityStateChangeBind]
GO
CREATE PROCEDURE [dbo].[SecurityStateChangeBind]
	@BulletinID		nvarchar(32),
	@StateTo		int,
	@StateFrom		int,
	@DateChanged		datetime,
	@Comment		ntext = NULL,
	@Username		nvarchar(64)
AS
	DECLARE	@ID	int

	SELECT	@ID = SecurityStateChangeID
	FROM	[dbo].[SecurityStateChange]
	WHERE	BulletinID = @BulletinID
	  AND	DateChanged = @DateChanged

	IF @ID IS NULL
		EXEC @ID = SecurityStateChangeAdd @BulletinID,
			@StateTo,
			@StateFrom,
			@DateChanged,
			@Comment,
			@Username

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityStateChangeSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityStateChangeSchema]
GO
CREATE PROCEDURE [dbo].[SecurityStateChangeSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecurityStateChange'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecurityStateChange (' + CAST(0x0A AS CHAR(1)) +
	'		SecurityStateChangeID	int NULL,' + CAST(0x0A AS CHAR(1)) +
	'		BulletinID		nvarchar(32) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		StateTo			int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		StateFrom		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		DateChanged		datetime NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Comment			ntext COLLATE database_default NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Username		nvarchar(64) COLLATE database_default NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecurityStateChange' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityStateChangeTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityStateChangeTempAdd]
GO
CREATE PROCEDURE dbo.[SecurityStateChangeTempAdd]
	@SecurityStateChangeID	int,
	@BulletinID		nvarchar(32),
	@StateTo		int,
	@StateFrom		int,
	@DateChanged		datetime,
	@Comment		ntext = NULL,
	@Username		nvarchar(64)
AS
	INSERT INTO #SecurityStateChange (
		SecurityStateChangeID,
		BulletinID,
		StateTo,
		StateFrom,
		DateChanged,
		Comment,
		Username
	)
	VALUES (
		@SecurityStateChangeID,
		@BulletinID,
		@StateTo,
		@StateFrom,
		@DateChanged,
		@Comment,
		@Username
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityStateChangeAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityStateChangeAddBatch]
GO
CREATE PROCEDURE dbo.[SecurityStateChangeAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecurityStateChange (
		BulletinID,
		StateTo,
		StateFrom,
		DateChanged,
		Comment,
		Username
	)
		SELECT	BulletinID,
			StateTo,
			StateFrom,
			DateChanged,
			Comment,
			Username
		FROM #SecurityStateChange
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityStateChange	-- Drop temporary table
	RETURN @count
GO

/*
Add new SecurityStateChange bound to
	SecurityState using Description
	SecurityState using Description
	with BulletinID, DateChanged, Comment, Username
*/

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityStateChangeUpdateByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityStateChangeUpdateByID]
GO
CREATE PROCEDURE [dbo].[SecurityStateChangeUpdateByID]
	@SecurityStateChangeID	int,
	@BulletinID		nvarchar(32),
	@StateTo		int,
	@StateFrom		int,
	@DateChanged		datetime,
	@Comment		ntext = NULL,
	@Username		nvarchar(64)
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[SecurityStateChange]
	SET	@ID = SecurityStateChangeID,
		BulletinID = @BulletinID,
		StateTo = @StateTo,
		StateFrom = @StateFrom,
		DateChanged = @DateChanged,
		Comment = @Comment,
		Username = @Username
	WHERE	SecurityStateChangeID = @SecurityStateChangeID
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityStateChangeUpdateBatchByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityStateChangeUpdateBatchByID]
GO
CREATE PROCEDURE dbo.[SecurityStateChangeUpdateBatchByID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityStateChangeID]
		ON #SecurityStateChange (SecurityStateChangeID)

	UPDATE	[dbo].[SecurityStateChange]
	SET	BulletinID = t.BulletinID,
		StateTo = t.StateTo,
		StateFrom = t.StateFrom,
		DateChanged = t.DateChanged,
		Comment = t.Comment,
		Username = t.Username
	FROM	#SecurityStateChange AS t
	WHERE	SecurityStateChange.SecurityStateChangeID = t.SecurityStateChangeID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityStateChange	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityStateChangeUpdateByBulletinIDDateChanged]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityStateChangeUpdateByBulletinIDDateChanged]
GO
CREATE PROCEDURE [dbo].[SecurityStateChangeUpdateByBulletinIDDateChanged]
	@BulletinID		nvarchar(32),
	@DateChanged		datetime,
	@StateTo		int,
	@StateFrom		int,
	@Comment		ntext = NULL,
	@Username		nvarchar(64)
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[SecurityStateChange]
	SET	@ID = SecurityStateChangeID,
		StateTo = @StateTo,
		StateFrom = @StateFrom,
		Comment = @Comment,
		Username = @Username
	WHERE	BulletinID = @BulletinID
	  AND	DateChanged = @DateChanged
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityStateChangeUpdateBatchByBulletinIDDateChanged]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityStateChangeUpdateBatchByBulletinIDDateChanged]
GO
CREATE PROCEDURE dbo.[SecurityStateChangeUpdateBatchByBulletinIDDateChanged]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityStateChangeBulletinIDDateChanged]
		ON #SecurityStateChange (BulletinID, DateChanged)

	UPDATE	[dbo].[SecurityStateChange]
	SET	StateTo = t.StateTo,
		StateFrom = t.StateFrom,
		Comment = t.Comment,
		Username = t.Username
	FROM	#SecurityStateChange AS t
	WHERE	SecurityStateChange.BulletinID = t.BulletinID
	  AND	SecurityStateChange.DateChanged = t.DateChanged
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityStateChange	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityStateChangePutByBulletinIDDateChanged]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityStateChangePutByBulletinIDDateChanged]
GO
CREATE PROCEDURE [dbo].[SecurityStateChangePutByBulletinIDDateChanged]
	@BulletinID		nvarchar(32),
	@DateChanged		datetime,
	@StateTo		int,
	@StateFrom		int,
	@Comment		ntext = NULL,
	@Username		nvarchar(64)
AS
	DECLARE @ID	int

	SELECT	@ID = SecurityStateChangeID
	FROM	SecurityStateChange
	WHERE	BulletinID = @BulletinID
	  AND	DateChanged = @DateChanged

	IF @ID IS NULL
		EXEC @ID = SecurityStateChangeAdd @BulletinID,
			@StateTo,
			@StateFrom,
			@DateChanged,
			@Comment,
			@Username
	ELSE
		EXEC SecurityStateChangeUpdateByBulletinIDDateChanged @BulletinID,
			@DateChanged,
			@StateTo,
			@StateFrom,
			@Comment,
			@Username

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityStateChangePutBatchByBulletinIDDateChanged]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityStateChangePutBatchByBulletinIDDateChanged]
GO
CREATE PROCEDURE [dbo].[SecurityStateChangePutBatchByBulletinIDDateChanged]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecurityStateChangeBulletinIDDateChanged]
		ON #SecurityStateChange (BulletinID, DateChanged)

	BEGIN TRANSACTION
	UPDATE [dbo].[SecurityStateChange]
		SET	StateTo = t.StateTo,
			StateFrom = t.StateFrom,
			Comment = t.Comment,
			Username = t.Username
		FROM	#SecurityStateChange AS t
		WHERE	SecurityStateChange.BulletinID = t.BulletinID
		  AND	SecurityStateChange.DateChanged = t.DateChanged
	SET @count = @@ROWCOUNT

	INSERT [dbo].[SecurityStateChange] (
		BulletinID,
		StateTo,
		StateFrom,
		DateChanged,
		Comment,
		Username
	)
		SELECT	BulletinID,
			StateTo,
			StateFrom,
			DateChanged,
			Comment,
			Username
		FROM	#SecurityStateChange AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecurityStateChange]
			WHERE	SecurityStateChange.BulletinID = t.BulletinID
			  AND	SecurityStateChange.DateChanged = t.DateChanged
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecurityStateChange	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityStateChangeRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityStateChangeRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecurityStateChangeRemoveBatch]
AS

	CREATE INDEX [TempSecurityStateChangeSecurityStateChangeRemoveBatch]
		ON #SecurityStateChange (SecurityStateChangeID)	

	-- Delete records from SecurityStateChange identified by fields of [TempSecurityStateChangeSecurityStateChangeRemoveBatch]
	DELETE [dbo].[SecurityStateChange]
	WHERE EXISTS(
			SELECT * FROM #SecurityStateChange AS t
			WHERE	SecurityStateChange.SecurityStateChangeID = t.SecurityStateChangeID
		)
	DROP TABLE #SecurityStateChange      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityStateChangeRemoveByBulletinIDDateChanged]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityStateChangeRemoveByBulletinIDDateChanged]
GO
CREATE PROCEDURE [dbo].[SecurityStateChangeRemoveByBulletinIDDateChanged]
	@BulletinID		nvarchar(32),
	@DateChanged		datetime
AS
	DELETE	[dbo].[SecurityStateChange]
	WHERE	BulletinID = @BulletinID
	  AND	DateChanged = @DateChanged
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityStateChangeRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityStateChangeRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecurityStateChangeRemoveAll]
	
AS
	DELETE	[dbo].[SecurityStateChange]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityUserStateChangeGetByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityUserStateChangeGetByID]
GO
CREATE PROCEDURE [dbo].[SecurityUserStateChangeGetByID]
	@SecurityUserStateChangeID int
AS
	SELECT	SecurityUserStateChangeID,
		SecurityBulletinID,
		UserStateID,
		DateChanged,
		Comment,
		Username,
		Certified
	FROM	[dbo].[SecurityUserStateChange]
	WHERE	SecurityUserStateChangeID = @SecurityUserStateChangeID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityUserStateChangeGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityUserStateChangeGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityUserStateChangeGetAll]
AS
	SELECT	SecurityUserStateChangeID,
		SecurityBulletinID,
		UserStateID,
		DateChanged,
		Comment,
		Username,
		Certified
	FROM	[dbo].[SecurityUserStateChange]
	ORDER BY SecurityUserStateChangeID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityUserStateChangeAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityUserStateChangeAdd]
GO
CREATE PROCEDURE [dbo].[SecurityUserStateChangeAdd]
	@SecurityBulletinID	int,
	@UserStateID		int,
	@DateChanged		datetime,
	@Comment		ntext = NULL,
	@Username		nvarchar(64),
	@Certified		int
AS
	INSERT INTO  dbo.SecurityUserStateChange (
		SecurityBulletinID,
		UserStateID,
		DateChanged,
		Comment,
		Username,
		Certified
	)
	VALUES (
		@SecurityBulletinID,
		@UserStateID,
		@DateChanged,
		@Comment,
		@Username,
		@Certified
	)
	RETURN SCOPE_IDENTITY()
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityUserStateChangeSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityUserStateChangeSchema]
GO
CREATE PROCEDURE [dbo].[SecurityUserStateChangeSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecurityUserStateChange'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecurityUserStateChange (' + CAST(0x0A AS CHAR(1)) +
	'		SecurityUserStateChangeID int NULL,' + CAST(0x0A AS CHAR(1)) +
	'		SecurityBulletinID	int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		UserStateID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		DateChanged		datetime NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Comment			ntext COLLATE database_default NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Username		nvarchar(64) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Certified		int NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecurityUserStateChange' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityUserStateChangeTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityUserStateChangeTempAdd]
GO
CREATE PROCEDURE dbo.[SecurityUserStateChangeTempAdd]
	@SecurityUserStateChangeID int,
	@SecurityBulletinID	int,
	@UserStateID		int,
	@DateChanged		datetime,
	@Comment		ntext = NULL,
	@Username		nvarchar(64),
	@Certified		int
AS
	INSERT INTO #SecurityUserStateChange (
		SecurityUserStateChangeID,
		SecurityBulletinID,
		UserStateID,
		DateChanged,
		Comment,
		Username,
		Certified
	)
	VALUES (
		@SecurityUserStateChangeID,
		@SecurityBulletinID,
		@UserStateID,
		@DateChanged,
		@Comment,
		@Username,
		@Certified
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityUserStateChangeAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityUserStateChangeAddBatch]
GO
CREATE PROCEDURE dbo.[SecurityUserStateChangeAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecurityUserStateChange (
		SecurityBulletinID,
		UserStateID,
		DateChanged,
		Comment,
		Username,
		Certified
	)
		SELECT	SecurityBulletinID,
			UserStateID,
			DateChanged,
			Comment,
			Username,
			Certified
		FROM #SecurityUserStateChange
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityUserStateChange	-- Drop temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityUserStateChangeUpdateByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityUserStateChangeUpdateByID]
GO
CREATE PROCEDURE [dbo].[SecurityUserStateChangeUpdateByID]
	@SecurityUserStateChangeID int,
	@SecurityBulletinID	int,
	@UserStateID		int,
	@DateChanged		datetime,
	@Comment		ntext = NULL,
	@Username		nvarchar(64),
	@Certified		int
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[SecurityUserStateChange]
	SET	@ID = SecurityUserStateChangeID,
		SecurityBulletinID = @SecurityBulletinID,
		UserStateID = @UserStateID,
		DateChanged = @DateChanged,
		Comment = @Comment,
		Username = @Username,
		Certified = @Certified
	WHERE	SecurityUserStateChangeID = @SecurityUserStateChangeID
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityUserStateChangeUpdateBatchByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityUserStateChangeUpdateBatchByID]
GO
CREATE PROCEDURE dbo.[SecurityUserStateChangeUpdateBatchByID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityUserStateChangeID]
		ON #SecurityUserStateChange (SecurityUserStateChangeID)

	UPDATE	[dbo].[SecurityUserStateChange]
	SET	SecurityBulletinID = t.SecurityBulletinID,
		UserStateID = t.UserStateID,
		DateChanged = t.DateChanged,
		Comment = t.Comment,
		Username = t.Username,
		Certified = t.Certified
	FROM	#SecurityUserStateChange AS t
	WHERE	SecurityUserStateChange.SecurityUserStateChangeID = t.SecurityUserStateChangeID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityUserStateChange	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityUserStateChangeRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityUserStateChangeRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecurityUserStateChangeRemoveBatch]
AS

	CREATE INDEX [TempSecurityUserStateChangeSecurityUserStateChangeRemoveBatch]
		ON #SecurityUserStateChange (SecurityUserStateChangeID)	

	-- Delete records from SecurityUserStateChange identified by fields of [TempSecurityUserStateChangeSecurityUserStateChangeRemoveBatch]
	DELETE [dbo].[SecurityUserStateChange]
	WHERE EXISTS(
			SELECT * FROM #SecurityUserStateChange AS t
			WHERE	SecurityUserStateChange.SecurityUserStateChangeID = t.SecurityUserStateChangeID
		)
	DROP TABLE #SecurityUserStateChange      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityUserStateChangeRemoveByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityUserStateChangeRemoveByID]
GO
CREATE PROCEDURE [dbo].[SecurityUserStateChangeRemoveByID]
	@SecurityUserStateChangeID int
AS
	DELETE	[dbo].[SecurityUserStateChange]
	WHERE	SecurityUserStateChangeID = @SecurityUserStateChangeID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityUserStateChangeRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityUserStateChangeRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecurityUserStateChangeRemoveAll]
	
AS
	DELETE	[dbo].[SecurityUserStateChange]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAnalysisReportGetByComputerID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAnalysisReportGetByComputerID]
GO
CREATE PROCEDURE [dbo].[SecurityAnalysisReportGetByComputerID]
	@ComputerID		int
AS
	SELECT	ComputerID,
		DataSourceDate,
		DataSourceVersion,
		AnalysisDate,
		ReceiveDate
	FROM	[dbo].[SecurityAnalysisReport]
	WHERE	ComputerID = @ComputerID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAnalysisReportGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAnalysisReportGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityAnalysisReportGetAll]
AS
	SELECT	ComputerID,
		DataSourceDate,
		DataSourceVersion,
		AnalysisDate,
		ReceiveDate
	FROM	[dbo].[SecurityAnalysisReport]
	ORDER BY ComputerID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAnalysisReportAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAnalysisReportAdd]
GO
CREATE PROCEDURE [dbo].[SecurityAnalysisReportAdd]
	@ComputerID		int,
	@DataSourceDate		datetime,
	@DataSourceVersion	nvarchar(32) = NULL,
	@AnalysisDate		datetime,
	@ReceiveDate		datetime
AS
	INSERT INTO  dbo.SecurityAnalysisReport (
		ComputerID,
		DataSourceDate,
		DataSourceVersion,
		AnalysisDate,
		ReceiveDate
	)
	VALUES (
		@ComputerID,
		@DataSourceDate,
		@DataSourceVersion,
		@AnalysisDate,
		@ReceiveDate
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAnalysisReportSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAnalysisReportSchema]
GO
CREATE PROCEDURE [dbo].[SecurityAnalysisReportSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecurityAnalysisReport'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecurityAnalysisReport (' + CAST(0x0A AS CHAR(1)) +
	'		ComputerID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		DataSourceDate		datetime NOT NULL DEFAULT getdate(),' + CAST(0x0A AS CHAR(1)) +
	'		DataSourceVersion	nvarchar(32) COLLATE database_default NULL,' + CAST(0x0A AS CHAR(1)) +
	'		AnalysisDate		datetime NOT NULL DEFAULT getdate(),' + CAST(0x0A AS CHAR(1)) +
	'		ReceiveDate		datetime NOT NULL DEFAULT getdate()' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecurityAnalysisReport' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAnalysisReportTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAnalysisReportTempAdd]
GO
CREATE PROCEDURE dbo.[SecurityAnalysisReportTempAdd]
	@ComputerID		int,
	@DataSourceDate		datetime,
	@DataSourceVersion	nvarchar(32) = NULL,
	@AnalysisDate		datetime,
	@ReceiveDate		datetime
AS
	INSERT INTO #SecurityAnalysisReport (
		ComputerID,
		DataSourceDate,
		DataSourceVersion,
		AnalysisDate,
		ReceiveDate
	)
	VALUES (
		@ComputerID,
		@DataSourceDate,
		@DataSourceVersion,
		@AnalysisDate,
		@ReceiveDate
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAnalysisReportAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAnalysisReportAddBatch]
GO
CREATE PROCEDURE dbo.[SecurityAnalysisReportAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecurityAnalysisReport (
		ComputerID,
		DataSourceDate,
		DataSourceVersion,
		AnalysisDate,
		ReceiveDate
	)
		SELECT	ComputerID,
			DataSourceDate,
			DataSourceVersion,
			AnalysisDate,
			ReceiveDate
		FROM #SecurityAnalysisReport
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityAnalysisReport	-- Drop temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAnalysisReportUpdateByComputerID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAnalysisReportUpdateByComputerID]
GO
CREATE PROCEDURE [dbo].[SecurityAnalysisReportUpdateByComputerID]
	@ComputerID		int,
	@DataSourceDate		datetime,
	@DataSourceVersion	nvarchar(32) = NULL,
	@AnalysisDate		datetime,
	@ReceiveDate		datetime
AS
	UPDATE	[dbo].[SecurityAnalysisReport]
	SET	DataSourceDate = @DataSourceDate,
		DataSourceVersion = @DataSourceVersion,
		AnalysisDate = @AnalysisDate,
		ReceiveDate = @ReceiveDate
	WHERE	ComputerID = @ComputerID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAnalysisReportUpdateBatchByComputerID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAnalysisReportUpdateBatchByComputerID]
GO
CREATE PROCEDURE dbo.[SecurityAnalysisReportUpdateBatchByComputerID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityAnalysisReportComputerID]
		ON #SecurityAnalysisReport (ComputerID)

	UPDATE	[dbo].[SecurityAnalysisReport]
	SET	DataSourceDate = t.DataSourceDate,
		DataSourceVersion = t.DataSourceVersion,
		AnalysisDate = t.AnalysisDate,
		ReceiveDate = t.ReceiveDate
	FROM	#SecurityAnalysisReport AS t
	WHERE	SecurityAnalysisReport.ComputerID = t.ComputerID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityAnalysisReport	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAnalysisReportPutByComputerID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAnalysisReportPutByComputerID]
GO
CREATE PROCEDURE [dbo].[SecurityAnalysisReportPutByComputerID]
	@ComputerID		int,
	@DataSourceDate		datetime,
	@DataSourceVersion	nvarchar(32) = NULL,
	@AnalysisDate		datetime,
	@ReceiveDate		datetime
AS
	IF NOT EXISTS(
		SELECT	1
		FROM	dbo.SecurityAnalysisReport
		WHERE	ComputerID = @ComputerID
	)
		EXEC SecurityAnalysisReportAdd @ComputerID,
			@DataSourceDate,
			@DataSourceVersion,
			@AnalysisDate,
			@ReceiveDate
	ELSE
		EXEC SecurityAnalysisReportUpdateByComputerID @ComputerID,
			@DataSourceDate,
			@DataSourceVersion,
			@AnalysisDate,
			@ReceiveDate
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAnalysisReportPutBatchByComputerID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAnalysisReportPutBatchByComputerID]
GO
CREATE PROCEDURE [dbo].[SecurityAnalysisReportPutBatchByComputerID]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecurityAnalysisReportComputerID]
		ON #SecurityAnalysisReport (ComputerID)

	BEGIN TRANSACTION
	UPDATE [dbo].[SecurityAnalysisReport]
		SET	DataSourceDate = t.DataSourceDate,
			DataSourceVersion = t.DataSourceVersion,
			AnalysisDate = t.AnalysisDate,
			ReceiveDate = t.ReceiveDate
		FROM	#SecurityAnalysisReport AS t
		WHERE	SecurityAnalysisReport.ComputerID = t.ComputerID
	SET @count = @@ROWCOUNT

	INSERT [dbo].[SecurityAnalysisReport] (
		ComputerID,
		DataSourceDate,
		DataSourceVersion,
		AnalysisDate,
		ReceiveDate
	)
		SELECT	ComputerID,
			DataSourceDate,
			DataSourceVersion,
			AnalysisDate,
			ReceiveDate
		FROM	#SecurityAnalysisReport AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecurityAnalysisReport]
			WHERE	SecurityAnalysisReport.ComputerID = t.ComputerID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecurityAnalysisReport	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAnalysisReportRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAnalysisReportRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecurityAnalysisReportRemoveBatch]
AS

	CREATE INDEX [TempSecurityAnalysisReportSecurityAnalysisReportRemoveBatch]
		ON #SecurityAnalysisReport (ComputerID)	

	-- Delete records from SecurityAnalysisReport identified by fields of [TempSecurityAnalysisReportSecurityAnalysisReportRemoveBatch]
	DELETE [dbo].[SecurityAnalysisReport]
	WHERE EXISTS(
			SELECT * FROM #SecurityAnalysisReport AS t
			WHERE	SecurityAnalysisReport.ComputerID = t.ComputerID
		)
	DROP TABLE #SecurityAnalysisReport      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAnalysisReportRemoveByComputerID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAnalysisReportRemoveByComputerID]
GO
CREATE PROCEDURE [dbo].[SecurityAnalysisReportRemoveByComputerID]
	@ComputerID		int
AS
	DELETE	[dbo].[SecurityAnalysisReport]
	WHERE	ComputerID = @ComputerID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAnalysisReportRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAnalysisReportRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecurityAnalysisReportRemoveAll]
	
AS
	DELETE	[dbo].[SecurityAnalysisReport]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAnalysisGetByComputerIDBulletinIDSecurityPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAnalysisGetByComputerIDBulletinIDSecurityPatchID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchAnalysisGetByComputerIDBulletinIDSecurityPatchID]
	@ComputerID		int,
	@BulletinID		nvarchar(32),
	@SecurityPatchID	int
AS
	SELECT	ComputerID,
		BulletinID,
		SecurityPatchID,
		ProductID,
		ServicePackID,
		Status,
		StatusMessage,
		IsManaged
	FROM	[dbo].[SecurityPatchAnalysis]
	WHERE	ComputerID = @ComputerID
	  AND	BulletinID = @BulletinID
	  AND	SecurityPatchID = @SecurityPatchID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAnalysisGetAllByComputerID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAnalysisGetAllByComputerID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchAnalysisGetAllByComputerID]
	@ComputerID		int
AS
	SELECT	ComputerID,
		BulletinID,
		SecurityPatchID,
		ProductID,
		ServicePackID,
		Status,
		StatusMessage,
		IsManaged
	FROM	[dbo].[SecurityPatchAnalysis]
	WHERE	ComputerID = @ComputerID
	ORDER BY BulletinID, SecurityPatchID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAnalysisGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAnalysisGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchAnalysisGetAll]
AS
	SELECT	ComputerID,
		BulletinID,
		SecurityPatchID,
		ProductID,
		ServicePackID,
		Status,
		StatusMessage,
		IsManaged
	FROM	[dbo].[SecurityPatchAnalysis]
	ORDER BY ComputerID, BulletinID, SecurityPatchID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAnalysisAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAnalysisAdd]
GO
CREATE PROCEDURE [dbo].[SecurityPatchAnalysisAdd]
	@ComputerID		int,
	@BulletinID		nvarchar(32),
	@SecurityPatchID	int,
	@ProductID		int = NULL,
	@ServicePackID		int = NULL,
	@Status			int,
	@StatusMessage		nvarchar(3000) = NULL,
	@IsManaged		bit = 0
AS
	INSERT INTO  dbo.SecurityPatchAnalysis (
		ComputerID,
		BulletinID,
		SecurityPatchID,
		ProductID,
		ServicePackID,
		Status,
		StatusMessage,
		IsManaged
	)
	VALUES (
		@ComputerID,
		@BulletinID,
		@SecurityPatchID,
		@ProductID,
		@ServicePackID,
		@Status,
		@StatusMessage,
		@IsManaged
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAnalysisSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAnalysisSchema]
GO
CREATE PROCEDURE [dbo].[SecurityPatchAnalysisSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecurityPatchAnalysis'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecurityPatchAnalysis (' + CAST(0x0A AS CHAR(1)) +
	'		ComputerID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		BulletinID		nvarchar(32) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		SecurityPatchID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		ProductID		int NULL,' + CAST(0x0A AS CHAR(1)) +
	'		ServicePackID		int NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Status			int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		StatusMessage		nvarchar(3000) COLLATE database_default NULL,' + CAST(0x0A AS CHAR(1)) +
	'		IsManaged		bit NOT NULL DEFAULT 0' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecurityPatchAnalysis' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAnalysisTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAnalysisTempAdd]
GO
CREATE PROCEDURE dbo.[SecurityPatchAnalysisTempAdd]
	@ComputerID		int,
	@BulletinID		nvarchar(32),
	@SecurityPatchID	int,
	@ProductID		int = NULL,
	@ServicePackID		int = NULL,
	@Status			int,
	@StatusMessage		nvarchar(3000) = NULL,
	@IsManaged		bit = 0
AS
	INSERT INTO #SecurityPatchAnalysis (
		ComputerID,
		BulletinID,
		SecurityPatchID,
		ProductID,
		ServicePackID,
		Status,
		StatusMessage,
		IsManaged
	)
	VALUES (
		@ComputerID,
		@BulletinID,
		@SecurityPatchID,
		@ProductID,
		@ServicePackID,
		@Status,
		@StatusMessage,
		@IsManaged
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAnalysisAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAnalysisAddBatch]
GO
CREATE PROCEDURE dbo.[SecurityPatchAnalysisAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecurityPatchAnalysis (
		ComputerID,
		BulletinID,
		SecurityPatchID,
		ProductID,
		ServicePackID,
		Status,
		StatusMessage,
		IsManaged
	)
		SELECT	ComputerID,
			BulletinID,
			SecurityPatchID,
			ProductID,
			ServicePackID,
			Status,
			StatusMessage,
			IsManaged
		FROM #SecurityPatchAnalysis
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchAnalysis	-- Drop temporary table
	RETURN @count
GO

/*
Add new SecurityPatchAnalysis bound to
	SecurityPatch using BulletinID, PatchName with Title, QNumber
	SecurityPatchStatus using InternalText
	with ComputerID, BulletinID, ProductID, ServicePackID, StatusMessage, IsManaged
*/

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAnalysisUpdateByComputerIDBulletinIDSecurityPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAnalysisUpdateByComputerIDBulletinIDSecurityPatchID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchAnalysisUpdateByComputerIDBulletinIDSecurityPatchID]
	@ComputerID		int,
	@BulletinID		nvarchar(32),
	@SecurityPatchID	int,
	@ProductID		int = NULL,
	@ServicePackID		int = NULL,
	@Status			int,
	@StatusMessage		nvarchar(3000) = NULL,
	@IsManaged		bit = 0
AS
	UPDATE	[dbo].[SecurityPatchAnalysis]
	SET	ProductID = @ProductID,
		ServicePackID = @ServicePackID,
		Status = @Status,
		StatusMessage = @StatusMessage,
		IsManaged = @IsManaged
	WHERE	ComputerID = @ComputerID
	  AND	BulletinID = @BulletinID
	  AND	SecurityPatchID = @SecurityPatchID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAnalysisUpdateBatchByComputerIDBulletinIDSecurityPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAnalysisUpdateBatchByComputerIDBulletinIDSecurityPatchID]
GO
CREATE PROCEDURE dbo.[SecurityPatchAnalysisUpdateBatchByComputerIDBulletinIDSecurityPatchID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityPatchAnalysisComputerIDBulletinIDSecurityPatchID]
		ON #SecurityPatchAnalysis (ComputerID, BulletinID, SecurityPatchID)

	UPDATE	[dbo].[SecurityPatchAnalysis]
	SET	ProductID = t.ProductID,
		ServicePackID = t.ServicePackID,
		Status = t.Status,
		StatusMessage = t.StatusMessage,
		IsManaged = t.IsManaged
	FROM	#SecurityPatchAnalysis AS t
	WHERE	SecurityPatchAnalysis.ComputerID = t.ComputerID
	  AND	SecurityPatchAnalysis.BulletinID = t.BulletinID
	  AND	SecurityPatchAnalysis.SecurityPatchID = t.SecurityPatchID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchAnalysis	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAnalysisPutByComputerIDBulletinIDSecurityPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAnalysisPutByComputerIDBulletinIDSecurityPatchID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchAnalysisPutByComputerIDBulletinIDSecurityPatchID]
	@ComputerID		int,
	@BulletinID		nvarchar(32),
	@SecurityPatchID	int,
	@ProductID		int = NULL,
	@ServicePackID		int = NULL,
	@Status			int,
	@StatusMessage		nvarchar(3000) = NULL,
	@IsManaged		bit = 0
AS
	IF NOT EXISTS(
		SELECT	1
		FROM	dbo.SecurityPatchAnalysis
		WHERE	ComputerID = @ComputerID
		  AND	BulletinID = @BulletinID
		  AND	SecurityPatchID = @SecurityPatchID
	)
		EXEC SecurityPatchAnalysisAdd @ComputerID,
			@BulletinID,
			@SecurityPatchID,
			@ProductID,
			@ServicePackID,
			@Status,
			@StatusMessage,
			@IsManaged
	ELSE
		EXEC SecurityPatchAnalysisUpdateByComputerIDBulletinIDSecurityPatchID @ComputerID,
			@BulletinID,
			@SecurityPatchID,
			@ProductID,
			@ServicePackID,
			@Status,
			@StatusMessage,
			@IsManaged
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAnalysisPutBatchByComputerIDBulletinIDSecurityPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAnalysisPutBatchByComputerIDBulletinIDSecurityPatchID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchAnalysisPutBatchByComputerIDBulletinIDSecurityPatchID]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecurityPatchAnalysisComputerIDBulletinIDSecurityPatchID]
		ON #SecurityPatchAnalysis (ComputerID, BulletinID, SecurityPatchID)

	BEGIN TRANSACTION
	UPDATE [dbo].[SecurityPatchAnalysis]
		SET	ProductID = t.ProductID,
			ServicePackID = t.ServicePackID,
			Status = t.Status,
			StatusMessage = t.StatusMessage,
			IsManaged = t.IsManaged
		FROM	#SecurityPatchAnalysis AS t
		WHERE	SecurityPatchAnalysis.ComputerID = t.ComputerID
		  AND	SecurityPatchAnalysis.BulletinID = t.BulletinID
		  AND	SecurityPatchAnalysis.SecurityPatchID = t.SecurityPatchID
	SET @count = @@ROWCOUNT

	INSERT [dbo].[SecurityPatchAnalysis] (
		ComputerID,
		BulletinID,
		SecurityPatchID,
		ProductID,
		ServicePackID,
		Status,
		StatusMessage,
		IsManaged
	)
		SELECT	ComputerID,
			BulletinID,
			SecurityPatchID,
			ProductID,
			ServicePackID,
			Status,
			StatusMessage,
			IsManaged
		FROM	#SecurityPatchAnalysis AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecurityPatchAnalysis]
			WHERE	SecurityPatchAnalysis.ComputerID = t.ComputerID
			  AND	SecurityPatchAnalysis.BulletinID = t.BulletinID
			  AND	SecurityPatchAnalysis.SecurityPatchID = t.SecurityPatchID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecurityPatchAnalysis	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAnalysisRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAnalysisRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecurityPatchAnalysisRemoveBatch]
AS

	CREATE INDEX [TempSecurityPatchAnalysisSecurityPatchAnalysisRemoveBatch]
		ON #SecurityPatchAnalysis (ComputerID, BulletinID, SecurityPatchID)	

	-- Delete records from SecurityPatchAnalysis identified by fields of [TempSecurityPatchAnalysisSecurityPatchAnalysisRemoveBatch]
	DELETE [dbo].[SecurityPatchAnalysis]
	WHERE EXISTS(
			SELECT * FROM #SecurityPatchAnalysis AS t
			WHERE	SecurityPatchAnalysis.ComputerID = t.ComputerID
			  AND	SecurityPatchAnalysis.BulletinID = t.BulletinID
			  AND	SecurityPatchAnalysis.SecurityPatchID = t.SecurityPatchID
		)
	DROP TABLE #SecurityPatchAnalysis      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAnalysisRemoveByComputerIDBulletinIDSecurityPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAnalysisRemoveByComputerIDBulletinIDSecurityPatchID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchAnalysisRemoveByComputerIDBulletinIDSecurityPatchID]
	@ComputerID		int,
	@BulletinID		nvarchar(32),
	@SecurityPatchID	int
AS
	DELETE	[dbo].[SecurityPatchAnalysis]
	WHERE	ComputerID = @ComputerID
	  AND	BulletinID = @BulletinID
	  AND	SecurityPatchID = @SecurityPatchID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAnalysisRemoveAllByComputerID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAnalysisRemoveAllByComputerID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchAnalysisRemoveAllByComputerID]
	@ComputerID		int
AS
	DELETE	[dbo].[SecurityPatchAnalysis]
	WHERE	ComputerID = @ComputerID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAnalysisRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAnalysisRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchAnalysisRemoveAll]
	
AS
	DELETE	[dbo].[SecurityPatchAnalysis]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchAnalysisReplaceSubsetByComputerID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchAnalysisReplaceSubsetByComputerID]
GO
-- Replace the record subset selected by (@ComputerID)
-- using unique identifier (ComputerID, BulletinID, SecurityPatchID)
-- updating fields (ProductID, ServicePackID, Status, StatusMessage, IsManaged)
CREATE PROCEDURE [dbo].[SecurityPatchAnalysisReplaceSubsetByComputerID]
	@ComputerID		int
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecurityPatchAnalysisByComputerID]
		ON #SecurityPatchAnalysis (ComputerID, BulletinID, SecurityPatchID)

	BEGIN TRANSACTION
	DELETE [SecurityPatchAnalysis]
		WHERE	ComputerID = @ComputerID
		AND NOT EXISTS(		-- Replacement record doesn't exist
			SELECT * FROM #SecurityPatchAnalysis AS t
			WHERE	SecurityPatchAnalysis.ComputerID = t.ComputerID
			  AND	SecurityPatchAnalysis.BulletinID = t.BulletinID
			  AND	SecurityPatchAnalysis.SecurityPatchID = t.SecurityPatchID
		)

	UPDATE [dbo].[SecurityPatchAnalysis]
		SET	ProductID = t.ProductID,
			ServicePackID = t.ServicePackID,
			Status = t.Status,
			StatusMessage = t.StatusMessage,
			IsManaged = t.IsManaged
		FROM	#SecurityPatchAnalysis AS t
		WHERE	SecurityPatchAnalysis.ComputerID = t.ComputerID
		  AND	SecurityPatchAnalysis.BulletinID = t.BulletinID
		  AND	SecurityPatchAnalysis.SecurityPatchID = t.SecurityPatchID
	SET @count = @@ROWCOUNT

	INSERT [SecurityPatchAnalysis] (
		ComputerID,
		BulletinID,
		SecurityPatchID,
		ProductID,
		ServicePackID,
		Status,
		StatusMessage,
		IsManaged
	)
		SELECT	ComputerID,
			BulletinID,
			SecurityPatchID,
			ProductID,
			ServicePackID,
			Status,
			StatusMessage,
			IsManaged
		FROM	#SecurityPatchAnalysis AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [SecurityPatchAnalysis]
			WHERE	SecurityPatchAnalysis.ComputerID = t.ComputerID
			  AND	SecurityPatchAnalysis.BulletinID = t.BulletinID
			  AND	SecurityPatchAnalysis.SecurityPatchID = t.SecurityPatchID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecurityPatchAnalysis	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchStatusGetByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchStatusGetByID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchStatusGetByID]
	@SecurityPatchStatusID	int
AS
	SELECT	SecurityPatchStatusID,
		InternalText,
		DisplayText,
		Severity
	FROM	[dbo].[SecurityPatchStatus]
	WHERE	SecurityPatchStatusID = @SecurityPatchStatusID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchStatusGetByInternalText]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchStatusGetByInternalText]
GO
CREATE PROCEDURE [dbo].[SecurityPatchStatusGetByInternalText]
	@InternalText		nvarchar(64)
AS
	SELECT	SecurityPatchStatusID,
		InternalText,
		DisplayText,
		Severity
	FROM	[dbo].[SecurityPatchStatus]
	WHERE	InternalText = @InternalText
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchStatusGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchStatusGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchStatusGetAll]
AS
	SELECT	SecurityPatchStatusID,
		InternalText,
		DisplayText,
		Severity
	FROM	[dbo].[SecurityPatchStatus]
	ORDER BY SecurityPatchStatusID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchStatusBind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchStatusBind]
GO
CREATE PROCEDURE [dbo].[SecurityPatchStatusBind]
	@InternalText		nvarchar(64),
	@DisplayText		nvarchar(64),
	@Severity		int
AS
	DECLARE	@ID	int

	SELECT	@ID = SecurityPatchStatusID
	FROM	[dbo].[SecurityPatchStatus]
	WHERE	InternalText = @InternalText

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUIProductGroupGetByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUIProductGroupGetByID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchUIProductGroupGetByID]
	@SecurityPatchUIProductGroupID int
AS
	SELECT	SecurityPatchUIProductGroupID,
		GroupName,
		Product
	FROM	[dbo].[SecurityPatchUIProductGroup]
	WHERE	SecurityPatchUIProductGroupID = @SecurityPatchUIProductGroupID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUIProductGroupGetAllOrderedByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUIProductGroupGetAllOrderedByID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchUIProductGroupGetAllOrderedByID]
AS
	SELECT	SecurityPatchUIProductGroupID,
		GroupName,
		Product
	FROM	[dbo].[SecurityPatchUIProductGroup]
	ORDER BY SecurityPatchUIProductGroupID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUIProductGroupGetByProduct]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUIProductGroupGetByProduct]
GO
CREATE PROCEDURE [dbo].[SecurityPatchUIProductGroupGetByProduct]
	@Product		nvarchar(128)
AS
	SELECT	SecurityPatchUIProductGroupID,
		GroupName,
		Product
	FROM	[dbo].[SecurityPatchUIProductGroup]
	WHERE	Product = @Product
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUIProductGroupGetAllOrderedByProduct]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUIProductGroupGetAllOrderedByProduct]
GO
CREATE PROCEDURE [dbo].[SecurityPatchUIProductGroupGetAllOrderedByProduct]
AS
	SELECT	SecurityPatchUIProductGroupID,
		GroupName,
		Product
	FROM	[dbo].[SecurityPatchUIProductGroup]
	ORDER BY Product
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUIProductGroupGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUIProductGroupGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchUIProductGroupGetAll]
AS
	SELECT	SecurityPatchUIProductGroupID,
		GroupName,
		Product
	FROM	[dbo].[SecurityPatchUIProductGroup]
	ORDER BY GroupName
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUIProductGroupAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUIProductGroupAdd]
GO
CREATE PROCEDURE [dbo].[SecurityPatchUIProductGroupAdd]
	@GroupName		nvarchar(64),
	@Product		nvarchar(128)
AS
	INSERT INTO  dbo.SecurityPatchUIProductGroup (
		GroupName,
		Product
	)
	VALUES (
		@GroupName,
		@Product
	)
	RETURN SCOPE_IDENTITY()
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUIProductGroupBind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUIProductGroupBind]
GO
CREATE PROCEDURE [dbo].[SecurityPatchUIProductGroupBind]
	@GroupName		nvarchar(64),
	@Product		nvarchar(128)
AS
	DECLARE	@ID	int

	SELECT	@ID = SecurityPatchUIProductGroupID
	FROM	[dbo].[SecurityPatchUIProductGroup]
	WHERE	Product = @Product

	IF @ID IS NULL
		EXEC @ID = SecurityPatchUIProductGroupAdd @GroupName,
			@Product

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUIProductGroupSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUIProductGroupSchema]
GO
CREATE PROCEDURE [dbo].[SecurityPatchUIProductGroupSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecurityPatchUIProductGroup'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecurityPatchUIProductGroup (' + CAST(0x0A AS CHAR(1)) +
	'		SecurityPatchUIProductGroupID int NULL,' + CAST(0x0A AS CHAR(1)) +
	'		GroupName		nvarchar(64) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Product			nvarchar(128) COLLATE database_default NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecurityPatchUIProductGroup' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUIProductGroupTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUIProductGroupTempAdd]
GO
CREATE PROCEDURE dbo.[SecurityPatchUIProductGroupTempAdd]
	@SecurityPatchUIProductGroupID int,
	@GroupName		nvarchar(64),
	@Product		nvarchar(128)
AS
	INSERT INTO #SecurityPatchUIProductGroup (
		SecurityPatchUIProductGroupID,
		GroupName,
		Product
	)
	VALUES (
		@SecurityPatchUIProductGroupID,
		@GroupName,
		@Product
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUIProductGroupAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUIProductGroupAddBatch]
GO
CREATE PROCEDURE dbo.[SecurityPatchUIProductGroupAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecurityPatchUIProductGroup (
		GroupName,
		Product
	)
		SELECT	GroupName,
			Product
		FROM #SecurityPatchUIProductGroup
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchUIProductGroup	-- Drop temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUIProductGroupUpdateByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUIProductGroupUpdateByID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchUIProductGroupUpdateByID]
	@SecurityPatchUIProductGroupID int,
	@GroupName		nvarchar(64),
	@Product		nvarchar(128)
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[SecurityPatchUIProductGroup]
	SET	@ID = SecurityPatchUIProductGroupID,
		GroupName = @GroupName,
		Product = @Product
	WHERE	SecurityPatchUIProductGroupID = @SecurityPatchUIProductGroupID
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUIProductGroupUpdateBatchByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUIProductGroupUpdateBatchByID]
GO
CREATE PROCEDURE dbo.[SecurityPatchUIProductGroupUpdateBatchByID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityPatchUIProductGroupID]
		ON #SecurityPatchUIProductGroup (SecurityPatchUIProductGroupID)

	UPDATE	[dbo].[SecurityPatchUIProductGroup]
	SET	GroupName = t.GroupName,
		Product = t.Product
	FROM	#SecurityPatchUIProductGroup AS t
	WHERE	SecurityPatchUIProductGroup.SecurityPatchUIProductGroupID = t.SecurityPatchUIProductGroupID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchUIProductGroup	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUIProductGroupUpdateByProduct]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUIProductGroupUpdateByProduct]
GO
CREATE PROCEDURE [dbo].[SecurityPatchUIProductGroupUpdateByProduct]
	@Product		nvarchar(128),
	@GroupName		nvarchar(64)
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[SecurityPatchUIProductGroup]
	SET	@ID = SecurityPatchUIProductGroupID,
		GroupName = @GroupName
	WHERE	Product = @Product
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUIProductGroupUpdateBatchByProduct]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUIProductGroupUpdateBatchByProduct]
GO
CREATE PROCEDURE dbo.[SecurityPatchUIProductGroupUpdateBatchByProduct]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityPatchUIProductGroupProduct]
		ON #SecurityPatchUIProductGroup (Product)

	UPDATE	[dbo].[SecurityPatchUIProductGroup]
	SET	GroupName = t.GroupName
	FROM	#SecurityPatchUIProductGroup AS t
	WHERE	SecurityPatchUIProductGroup.Product = t.Product
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchUIProductGroup	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUIProductGroupPutByProduct]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUIProductGroupPutByProduct]
GO
CREATE PROCEDURE [dbo].[SecurityPatchUIProductGroupPutByProduct]
	@Product		nvarchar(128),
	@GroupName		nvarchar(64)
AS
	DECLARE @ID	int

	SELECT	@ID = SecurityPatchUIProductGroupID
	FROM	SecurityPatchUIProductGroup
	WHERE	Product = @Product

	IF @ID IS NULL
		EXEC @ID = SecurityPatchUIProductGroupAdd @GroupName,
			@Product
	ELSE
		EXEC SecurityPatchUIProductGroupUpdateByProduct @Product,
			@GroupName

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUIProductGroupPutBatchByProduct]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUIProductGroupPutBatchByProduct]
GO
CREATE PROCEDURE [dbo].[SecurityPatchUIProductGroupPutBatchByProduct]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecurityPatchUIProductGroupProduct]
		ON #SecurityPatchUIProductGroup (Product)

	BEGIN TRANSACTION
	UPDATE [dbo].[SecurityPatchUIProductGroup]
		SET	GroupName = t.GroupName
		FROM	#SecurityPatchUIProductGroup AS t
		WHERE	SecurityPatchUIProductGroup.Product = t.Product
	SET @count = @@ROWCOUNT

	INSERT [dbo].[SecurityPatchUIProductGroup] (
		GroupName,
		Product
	)
		SELECT	GroupName,
			Product
		FROM	#SecurityPatchUIProductGroup AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecurityPatchUIProductGroup]
			WHERE	SecurityPatchUIProductGroup.Product = t.Product
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecurityPatchUIProductGroup	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUIProductGroupRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUIProductGroupRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecurityPatchUIProductGroupRemoveBatch]
AS

	CREATE INDEX [TempSecurityPatchUIProductGroupSecurityPatchUIProductGroupRemoveBatch]
		ON #SecurityPatchUIProductGroup (SecurityPatchUIProductGroupID)	

	-- Delete records from SecurityPatchUIProductGroup identified by fields of [TempSecurityPatchUIProductGroupSecurityPatchUIProductGroupRemoveBatch]
	DELETE [dbo].[SecurityPatchUIProductGroup]
	WHERE EXISTS(
			SELECT * FROM #SecurityPatchUIProductGroup AS t
			WHERE	SecurityPatchUIProductGroup.SecurityPatchUIProductGroupID = t.SecurityPatchUIProductGroupID
		)
	DROP TABLE #SecurityPatchUIProductGroup      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUIProductGroupRemoveByProduct]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUIProductGroupRemoveByProduct]
GO
CREATE PROCEDURE [dbo].[SecurityPatchUIProductGroupRemoveByProduct]
	@Product		nvarchar(128)
AS
	-- SecurityPatchUIProductGroup deletes cascade to:
	--	SecurityPatchOperatingSystem by FK_SecurityPatchOperatingSystem_SecurityPatchUIProductGroup
	--	SecurityPatchApplication by FK_SecurityPatchApplication_SecurityPatchUIProductGroup
	DELETE	[dbo].[SecurityPatchUIProductGroup]
	WHERE	Product = @Product
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUIProductGroupRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUIProductGroupRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchUIProductGroupRemoveAll]
	
AS
	DELETE	[dbo].[SecurityPatchUIProductGroup]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchProductGroupGetByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchProductGroupGetByID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchProductGroupGetByID]
	@SecurityPatchProductGroupID int
AS
	SELECT	SecurityPatchProductGroupID,
		Environment,
		Product
	FROM	[dbo].[SecurityPatchProductGroup]
	WHERE	SecurityPatchProductGroupID = @SecurityPatchProductGroupID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchProductGroupGetAllByProduct]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchProductGroupGetAllByProduct]
GO
CREATE PROCEDURE [dbo].[SecurityPatchProductGroupGetAllByProduct]
	@Product		nvarchar(128)
AS
	SELECT	SecurityPatchProductGroupID,
		Environment,
		Product
	FROM	[dbo].[SecurityPatchProductGroup]
	WHERE	Product = @Product
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchProductGroupGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchProductGroupGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchProductGroupGetAll]
AS
	SELECT	SecurityPatchProductGroupID,
		Environment,
		Product
	FROM	[dbo].[SecurityPatchProductGroup]
	ORDER BY Product
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchProductGroupAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchProductGroupAdd]
GO
CREATE PROCEDURE [dbo].[SecurityPatchProductGroupAdd]
	@Environment		nvarchar(64),
	@Product		nvarchar(128)
AS
	INSERT INTO  dbo.SecurityPatchProductGroup (
		Environment,
		Product
	)
	VALUES (
		@Environment,
		@Product
	)
	RETURN SCOPE_IDENTITY()
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchProductGroupSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchProductGroupSchema]
GO
CREATE PROCEDURE [dbo].[SecurityPatchProductGroupSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecurityPatchProductGroup'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecurityPatchProductGroup (' + CAST(0x0A AS CHAR(1)) +
	'		SecurityPatchProductGroupID int NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Environment		nvarchar(64) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Product			nvarchar(128) COLLATE database_default NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecurityPatchProductGroup' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchProductGroupTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchProductGroupTempAdd]
GO
CREATE PROCEDURE dbo.[SecurityPatchProductGroupTempAdd]
	@SecurityPatchProductGroupID int,
	@Environment		nvarchar(64),
	@Product		nvarchar(128)
AS
	INSERT INTO #SecurityPatchProductGroup (
		SecurityPatchProductGroupID,
		Environment,
		Product
	)
	VALUES (
		@SecurityPatchProductGroupID,
		@Environment,
		@Product
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchProductGroupAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchProductGroupAddBatch]
GO
CREATE PROCEDURE dbo.[SecurityPatchProductGroupAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecurityPatchProductGroup (
		Environment,
		Product
	)
		SELECT	Environment,
			Product
		FROM #SecurityPatchProductGroup
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchProductGroup	-- Drop temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchProductGroupUpdateByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchProductGroupUpdateByID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchProductGroupUpdateByID]
	@SecurityPatchProductGroupID int,
	@Environment		nvarchar(64),
	@Product		nvarchar(128)
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[SecurityPatchProductGroup]
	SET	@ID = SecurityPatchProductGroupID,
		Environment = @Environment,
		Product = @Product
	WHERE	SecurityPatchProductGroupID = @SecurityPatchProductGroupID
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchProductGroupUpdateBatchByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchProductGroupUpdateBatchByID]
GO
CREATE PROCEDURE dbo.[SecurityPatchProductGroupUpdateBatchByID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityPatchProductGroupID]
		ON #SecurityPatchProductGroup (SecurityPatchProductGroupID)

	UPDATE	[dbo].[SecurityPatchProductGroup]
	SET	Environment = t.Environment,
		Product = t.Product
	FROM	#SecurityPatchProductGroup AS t
	WHERE	SecurityPatchProductGroup.SecurityPatchProductGroupID = t.SecurityPatchProductGroupID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchProductGroup	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchProductGroupRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchProductGroupRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecurityPatchProductGroupRemoveBatch]
AS

	CREATE INDEX [TempSecurityPatchProductGroupSecurityPatchProductGroupRemoveBatch]
		ON #SecurityPatchProductGroup (SecurityPatchProductGroupID)	

	-- Delete records from SecurityPatchProductGroup identified by fields of [TempSecurityPatchProductGroupSecurityPatchProductGroupRemoveBatch]
	DELETE [dbo].[SecurityPatchProductGroup]
	WHERE EXISTS(
			SELECT * FROM #SecurityPatchProductGroup AS t
			WHERE	SecurityPatchProductGroup.SecurityPatchProductGroupID = t.SecurityPatchProductGroupID
		)
	DROP TABLE #SecurityPatchProductGroup      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchProductGroupRemoveByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchProductGroupRemoveByID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchProductGroupRemoveByID]
	@SecurityPatchProductGroupID int
AS
	DELETE	[dbo].[SecurityPatchProductGroup]
	WHERE	SecurityPatchProductGroupID = @SecurityPatchProductGroupID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchProductGroupRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchProductGroupRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchProductGroupRemoveAll]
	
AS
	DELETE	[dbo].[SecurityPatchProductGroup]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchProductUninstallValuesGetByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchProductUninstallValuesGetByID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchProductUninstallValuesGetByID]
	@SecurityPatchProductUninstallValuesID int
AS
	SELECT	SecurityPatchProductUninstallValuesID,
		Product,
		RegistryKey,
		AbsoluteCommandLine,
		UninstallKey
	FROM	[dbo].[SecurityPatchProductUninstallValues]
	WHERE	SecurityPatchProductUninstallValuesID = @SecurityPatchProductUninstallValuesID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchProductUninstallValuesGetAllByProduct]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchProductUninstallValuesGetAllByProduct]
GO
CREATE PROCEDURE [dbo].[SecurityPatchProductUninstallValuesGetAllByProduct]
	@Product		nvarchar(128)
AS
	SELECT	SecurityPatchProductUninstallValuesID,
		Product,
		RegistryKey,
		AbsoluteCommandLine,
		UninstallKey
	FROM	[dbo].[SecurityPatchProductUninstallValues]
	WHERE	Product = @Product
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchProductUninstallValuesGetAllOrderedByProduct]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchProductUninstallValuesGetAllOrderedByProduct]
GO
CREATE PROCEDURE [dbo].[SecurityPatchProductUninstallValuesGetAllOrderedByProduct]
AS
	SELECT	SecurityPatchProductUninstallValuesID,
		Product,
		RegistryKey,
		AbsoluteCommandLine,
		UninstallKey
	FROM	[dbo].[SecurityPatchProductUninstallValues]
	ORDER BY Product
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchProductUninstallValuesGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchProductUninstallValuesGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchProductUninstallValuesGetAll]
AS
	SELECT	SecurityPatchProductUninstallValuesID,
		Product,
		RegistryKey,
		AbsoluteCommandLine,
		UninstallKey
	FROM	[dbo].[SecurityPatchProductUninstallValues]
	ORDER BY SecurityPatchProductUninstallValuesID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchProductUninstallValuesAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchProductUninstallValuesAdd]
GO
CREATE PROCEDURE [dbo].[SecurityPatchProductUninstallValuesAdd]
	@Product		nvarchar(128),
	@RegistryKey		nvarchar(256),
	@AbsoluteCommandLine	nvarchar(256),
	@UninstallKey		nvarchar(128)
AS
	INSERT INTO  dbo.SecurityPatchProductUninstallValues (
		Product,
		RegistryKey,
		AbsoluteCommandLine,
		UninstallKey
	)
	VALUES (
		@Product,
		@RegistryKey,
		@AbsoluteCommandLine,
		@UninstallKey
	)
	RETURN SCOPE_IDENTITY()
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchProductUninstallValuesSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchProductUninstallValuesSchema]
GO
CREATE PROCEDURE [dbo].[SecurityPatchProductUninstallValuesSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecurityPatchProductUninstallValues'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecurityPatchProductUninstallValues (' + CAST(0x0A AS CHAR(1)) +
	'		SecurityPatchProductUninstallValuesID int NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Product			nvarchar(128) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		RegistryKey		nvarchar(256) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		AbsoluteCommandLine	nvarchar(256) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		UninstallKey		nvarchar(128) COLLATE database_default NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecurityPatchProductUninstallValues' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchProductUninstallValuesTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchProductUninstallValuesTempAdd]
GO
CREATE PROCEDURE dbo.[SecurityPatchProductUninstallValuesTempAdd]
	@SecurityPatchProductUninstallValuesID int,
	@Product		nvarchar(128),
	@RegistryKey		nvarchar(256),
	@AbsoluteCommandLine	nvarchar(256),
	@UninstallKey		nvarchar(128)
AS
	INSERT INTO #SecurityPatchProductUninstallValues (
		SecurityPatchProductUninstallValuesID,
		Product,
		RegistryKey,
		AbsoluteCommandLine,
		UninstallKey
	)
	VALUES (
		@SecurityPatchProductUninstallValuesID,
		@Product,
		@RegistryKey,
		@AbsoluteCommandLine,
		@UninstallKey
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchProductUninstallValuesAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchProductUninstallValuesAddBatch]
GO
CREATE PROCEDURE dbo.[SecurityPatchProductUninstallValuesAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecurityPatchProductUninstallValues (
		Product,
		RegistryKey,
		AbsoluteCommandLine,
		UninstallKey
	)
		SELECT	Product,
			RegistryKey,
			AbsoluteCommandLine,
			UninstallKey
		FROM #SecurityPatchProductUninstallValues
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchProductUninstallValues	-- Drop temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchProductUninstallValuesUpdateByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchProductUninstallValuesUpdateByID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchProductUninstallValuesUpdateByID]
	@SecurityPatchProductUninstallValuesID int,
	@Product		nvarchar(128),
	@RegistryKey		nvarchar(256),
	@AbsoluteCommandLine	nvarchar(256),
	@UninstallKey		nvarchar(128)
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[SecurityPatchProductUninstallValues]
	SET	@ID = SecurityPatchProductUninstallValuesID,
		Product = @Product,
		RegistryKey = @RegistryKey,
		AbsoluteCommandLine = @AbsoluteCommandLine,
		UninstallKey = @UninstallKey
	WHERE	SecurityPatchProductUninstallValuesID = @SecurityPatchProductUninstallValuesID
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchProductUninstallValuesUpdateBatchByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchProductUninstallValuesUpdateBatchByID]
GO
CREATE PROCEDURE dbo.[SecurityPatchProductUninstallValuesUpdateBatchByID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityPatchProductUninstallValuesID]
		ON #SecurityPatchProductUninstallValues (SecurityPatchProductUninstallValuesID)

	UPDATE	[dbo].[SecurityPatchProductUninstallValues]
	SET	Product = t.Product,
		RegistryKey = t.RegistryKey,
		AbsoluteCommandLine = t.AbsoluteCommandLine,
		UninstallKey = t.UninstallKey
	FROM	#SecurityPatchProductUninstallValues AS t
	WHERE	SecurityPatchProductUninstallValues.SecurityPatchProductUninstallValuesID = t.SecurityPatchProductUninstallValuesID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchProductUninstallValues	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchProductUninstallValuesRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchProductUninstallValuesRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecurityPatchProductUninstallValuesRemoveBatch]
AS

	CREATE INDEX [TempSecurityPatchProductUninstallValuesSecurityPatchProductUninstallValuesRemoveBatch]
		ON #SecurityPatchProductUninstallValues (SecurityPatchProductUninstallValuesID)	

	-- Delete records from SecurityPatchProductUninstallValues identified by fields of [TempSecurityPatchProductUninstallValuesSecurityPatchProductUninstallValuesRemoveBatch]
	DELETE [dbo].[SecurityPatchProductUninstallValues]
	WHERE EXISTS(
			SELECT * FROM #SecurityPatchProductUninstallValues AS t
			WHERE	SecurityPatchProductUninstallValues.SecurityPatchProductUninstallValuesID = t.SecurityPatchProductUninstallValuesID
		)
	DROP TABLE #SecurityPatchProductUninstallValues      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchProductUninstallValuesRemoveByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchProductUninstallValuesRemoveByID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchProductUninstallValuesRemoveByID]
	@SecurityPatchProductUninstallValuesID int
AS
	DELETE	[dbo].[SecurityPatchProductUninstallValues]
	WHERE	SecurityPatchProductUninstallValuesID = @SecurityPatchProductUninstallValuesID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchProductUninstallValuesRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchProductUninstallValuesRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchProductUninstallValuesRemoveAll]
	
AS
	DELETE	[dbo].[SecurityPatchProductUninstallValues]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUninstallValuesGetByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUninstallValuesGetByID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchUninstallValuesGetByID]
	@SecurityPatchUninstallValuesID int
AS
	SELECT	SecurityPatchUninstallValuesID,
		SecurityPatchID,
		RegistryKey,
		AbsoluteCommandLine,
		UninstallKey
	FROM	[dbo].[SecurityPatchUninstallValues]
	WHERE	SecurityPatchUninstallValuesID = @SecurityPatchUninstallValuesID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUninstallValuesGetAllBySecurityPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUninstallValuesGetAllBySecurityPatchID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchUninstallValuesGetAllBySecurityPatchID]
	@SecurityPatchID	int
AS
	SELECT	SecurityPatchUninstallValuesID,
		SecurityPatchID,
		RegistryKey,
		AbsoluteCommandLine,
		UninstallKey
	FROM	[dbo].[SecurityPatchUninstallValues]
	WHERE	SecurityPatchID = @SecurityPatchID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUninstallValuesGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUninstallValuesGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchUninstallValuesGetAll]
AS
	SELECT	SecurityPatchUninstallValuesID,
		SecurityPatchID,
		RegistryKey,
		AbsoluteCommandLine,
		UninstallKey
	FROM	[dbo].[SecurityPatchUninstallValues]
	ORDER BY SecurityPatchID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUninstallValuesAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUninstallValuesAdd]
GO
CREATE PROCEDURE [dbo].[SecurityPatchUninstallValuesAdd]
	@SecurityPatchID	int,
	@RegistryKey		nvarchar(256),
	@AbsoluteCommandLine	nvarchar(256),
	@UninstallKey		nvarchar(128)
AS
	INSERT INTO  dbo.SecurityPatchUninstallValues (
		SecurityPatchID,
		RegistryKey,
		AbsoluteCommandLine,
		UninstallKey
	)
	VALUES (
		@SecurityPatchID,
		@RegistryKey,
		@AbsoluteCommandLine,
		@UninstallKey
	)
	RETURN SCOPE_IDENTITY()
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUninstallValuesSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUninstallValuesSchema]
GO
CREATE PROCEDURE [dbo].[SecurityPatchUninstallValuesSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecurityPatchUninstallValues'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecurityPatchUninstallValues (' + CAST(0x0A AS CHAR(1)) +
	'		SecurityPatchUninstallValuesID int NULL,' + CAST(0x0A AS CHAR(1)) +
	'		SecurityPatchID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		RegistryKey		nvarchar(256) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		AbsoluteCommandLine	nvarchar(256) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		UninstallKey		nvarchar(128) COLLATE database_default NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecurityPatchUninstallValues' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUninstallValuesTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUninstallValuesTempAdd]
GO
CREATE PROCEDURE dbo.[SecurityPatchUninstallValuesTempAdd]
	@SecurityPatchUninstallValuesID int,
	@SecurityPatchID	int,
	@RegistryKey		nvarchar(256),
	@AbsoluteCommandLine	nvarchar(256),
	@UninstallKey		nvarchar(128)
AS
	INSERT INTO #SecurityPatchUninstallValues (
		SecurityPatchUninstallValuesID,
		SecurityPatchID,
		RegistryKey,
		AbsoluteCommandLine,
		UninstallKey
	)
	VALUES (
		@SecurityPatchUninstallValuesID,
		@SecurityPatchID,
		@RegistryKey,
		@AbsoluteCommandLine,
		@UninstallKey
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUninstallValuesAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUninstallValuesAddBatch]
GO
CREATE PROCEDURE dbo.[SecurityPatchUninstallValuesAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecurityPatchUninstallValues (
		SecurityPatchID,
		RegistryKey,
		AbsoluteCommandLine,
		UninstallKey
	)
		SELECT	SecurityPatchID,
			RegistryKey,
			AbsoluteCommandLine,
			UninstallKey
		FROM #SecurityPatchUninstallValues
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchUninstallValues	-- Drop temporary table
	RETURN @count
GO

/*
Add new SecurityPatchUninstallValues bound to
	SecurityPatch using BulletinID, PatchName with Title, QNumber
	with RegistryKey, AbsoluteCommandLine, UninstallKey
*/

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUninstallValuesUpdateByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUninstallValuesUpdateByID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchUninstallValuesUpdateByID]
	@SecurityPatchUninstallValuesID int,
	@SecurityPatchID	int,
	@RegistryKey		nvarchar(256),
	@AbsoluteCommandLine	nvarchar(256),
	@UninstallKey		nvarchar(128)
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[SecurityPatchUninstallValues]
	SET	@ID = SecurityPatchUninstallValuesID,
		SecurityPatchID = @SecurityPatchID,
		RegistryKey = @RegistryKey,
		AbsoluteCommandLine = @AbsoluteCommandLine,
		UninstallKey = @UninstallKey
	WHERE	SecurityPatchUninstallValuesID = @SecurityPatchUninstallValuesID
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUninstallValuesUpdateBatchByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUninstallValuesUpdateBatchByID]
GO
CREATE PROCEDURE dbo.[SecurityPatchUninstallValuesUpdateBatchByID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityPatchUninstallValuesID]
		ON #SecurityPatchUninstallValues (SecurityPatchUninstallValuesID)

	UPDATE	[dbo].[SecurityPatchUninstallValues]
	SET	SecurityPatchID = t.SecurityPatchID,
		RegistryKey = t.RegistryKey,
		AbsoluteCommandLine = t.AbsoluteCommandLine,
		UninstallKey = t.UninstallKey
	FROM	#SecurityPatchUninstallValues AS t
	WHERE	SecurityPatchUninstallValues.SecurityPatchUninstallValuesID = t.SecurityPatchUninstallValuesID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchUninstallValues	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUninstallValuesRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUninstallValuesRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecurityPatchUninstallValuesRemoveBatch]
AS

	CREATE INDEX [TempSecurityPatchUninstallValuesSecurityPatchUninstallValuesRemoveBatch]
		ON #SecurityPatchUninstallValues (SecurityPatchUninstallValuesID)	

	-- Delete records from SecurityPatchUninstallValues identified by fields of [TempSecurityPatchUninstallValuesSecurityPatchUninstallValuesRemoveBatch]
	DELETE [dbo].[SecurityPatchUninstallValues]
	WHERE EXISTS(
			SELECT * FROM #SecurityPatchUninstallValues AS t
			WHERE	SecurityPatchUninstallValues.SecurityPatchUninstallValuesID = t.SecurityPatchUninstallValuesID
		)
	DROP TABLE #SecurityPatchUninstallValues      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUninstallValuesRemoveByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUninstallValuesRemoveByID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchUninstallValuesRemoveByID]
	@SecurityPatchUninstallValuesID int
AS
	DELETE	[dbo].[SecurityPatchUninstallValues]
	WHERE	SecurityPatchUninstallValuesID = @SecurityPatchUninstallValuesID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchUninstallValuesRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchUninstallValuesRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchUninstallValuesRemoveAll]
	
AS
	DELETE	[dbo].[SecurityPatchUninstallValues]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchResourceGetBySecurityPatchIDResourceURLArchitectureIDLanguageID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchResourceGetBySecurityPatchIDResourceURLArchitectureIDLanguageID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchResourceGetBySecurityPatchIDResourceURLArchitectureIDLanguageID]
	@SecurityPatchID	int,
	@ResourceURL		nvarchar(2000),
	@ArchitectureID		int,
	@LanguageID		nvarchar(6) = 'eng'
AS
	SELECT	SecurityPatchResourceID,
		SecurityPatchID,
		ResourceURL,
		ArchitectureID,
		LanguageID,
		Checksum,
		ActualResourceURL,
		LocalPath,
		Incorporate,
		BulletinID,
		PatchResourceName
	FROM	[dbo].[SecurityPatchResource]
	WHERE	SecurityPatchID = @SecurityPatchID
	  AND	ResourceURL = @ResourceURL
	  AND	ArchitectureID = @ArchitectureID
	  AND	LanguageID = @LanguageID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchResourceGetAllBySecurityPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchResourceGetAllBySecurityPatchID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchResourceGetAllBySecurityPatchID]
	@SecurityPatchID	int
AS
	SELECT	SecurityPatchResourceID,
		SecurityPatchID,
		ResourceURL,
		ArchitectureID,
		LanguageID,
		Checksum,
		ActualResourceURL,
		LocalPath,
		Incorporate,
		BulletinID,
		PatchResourceName
	FROM	[dbo].[SecurityPatchResource]
	WHERE	SecurityPatchID = @SecurityPatchID
	ORDER BY ResourceURL, ArchitectureID, LanguageID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchResourceGetAllOrderedBySecurityPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchResourceGetAllOrderedBySecurityPatchID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchResourceGetAllOrderedBySecurityPatchID]
AS
	SELECT	SecurityPatchResourceID,
		SecurityPatchID,
		ResourceURL,
		ArchitectureID,
		LanguageID,
		Checksum,
		ActualResourceURL,
		LocalPath,
		Incorporate,
		BulletinID,
		PatchResourceName
	FROM	[dbo].[SecurityPatchResource]
	ORDER BY SecurityPatchID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchResourceGetByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchResourceGetByID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchResourceGetByID]
	@SecurityPatchResourceID int
AS
	SELECT	SecurityPatchResourceID,
		SecurityPatchID,
		ResourceURL,
		ArchitectureID,
		LanguageID,
		Checksum,
		ActualResourceURL,
		LocalPath,
		Incorporate,
		BulletinID,
		PatchResourceName
	FROM	[dbo].[SecurityPatchResource]
	WHERE	SecurityPatchResourceID = @SecurityPatchResourceID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchResourceGetAllByBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchResourceGetAllByBulletinID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchResourceGetAllByBulletinID]
	@BulletinID		nvarchar(32)
AS
	SELECT	SecurityPatchResourceID,
		SecurityPatchID,
		ResourceURL,
		ArchitectureID,
		LanguageID,
		Checksum,
		ActualResourceURL,
		LocalPath,
		Incorporate,
		BulletinID,
		PatchResourceName
	FROM	[dbo].[SecurityPatchResource]
	WHERE	BulletinID = @BulletinID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchResourceGetAllOrderedByBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchResourceGetAllOrderedByBulletinID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchResourceGetAllOrderedByBulletinID]
AS
	SELECT	SecurityPatchResourceID,
		SecurityPatchID,
		ResourceURL,
		ArchitectureID,
		LanguageID,
		Checksum,
		ActualResourceURL,
		LocalPath,
		Incorporate,
		BulletinID,
		PatchResourceName
	FROM	[dbo].[SecurityPatchResource]
	ORDER BY BulletinID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchResourceGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchResourceGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchResourceGetAll]
AS
	SELECT	SecurityPatchResourceID,
		SecurityPatchID,
		ResourceURL,
		ArchitectureID,
		LanguageID,
		Checksum,
		ActualResourceURL,
		LocalPath,
		Incorporate,
		BulletinID,
		PatchResourceName
	FROM	[dbo].[SecurityPatchResource]
	ORDER BY SecurityPatchResourceID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchResourceAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchResourceAdd]
GO
CREATE PROCEDURE [dbo].[SecurityPatchResourceAdd]
	@SecurityPatchID	int,
	@ResourceURL		nvarchar(2000),
	@ArchitectureID		int,
	@LanguageID		nvarchar(6) = 'eng',
	@Checksum		nvarchar(256) = NULL,
	@ActualResourceURL	nvarchar(2000) = NULL,
	@LocalPath		nvarchar(256) = NULL,
	@Incorporate		bit = 1,
	@BulletinID		nvarchar(32),
	@PatchResourceName	nvarchar(512) = NULL
AS
	INSERT INTO  dbo.SecurityPatchResource (
		SecurityPatchID,
		ResourceURL,
		ArchitectureID,
		LanguageID,
		Checksum,
		ActualResourceURL,
		LocalPath,
		Incorporate,
		BulletinID,
		PatchResourceName
	)
	VALUES (
		@SecurityPatchID,
		@ResourceURL,
		@ArchitectureID,
		@LanguageID,
		@Checksum,
		@ActualResourceURL,
		@LocalPath,
		@Incorporate,
		@BulletinID,
		@PatchResourceName
	)
	RETURN SCOPE_IDENTITY()
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchResourceBind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchResourceBind]
GO
CREATE PROCEDURE [dbo].[SecurityPatchResourceBind]
	@SecurityPatchID	int,
	@ResourceURL		nvarchar(2000),
	@ArchitectureID		int,
	@LanguageID		nvarchar(6) = 'eng',
	@Checksum		nvarchar(256) = NULL,
	@ActualResourceURL	nvarchar(2000) = NULL,
	@LocalPath		nvarchar(256) = NULL,
	@Incorporate		bit = 1,
	@BulletinID		nvarchar(32),
	@PatchResourceName	nvarchar(512) = NULL
AS
	DECLARE	@ID	int

	SELECT	@ID = SecurityPatchResourceID
	FROM	[dbo].[SecurityPatchResource]
	WHERE	SecurityPatchID = @SecurityPatchID
	  AND	ResourceURL = @ResourceURL
	  AND	ArchitectureID = @ArchitectureID
	  AND	LanguageID = @LanguageID

	IF @ID IS NULL
		EXEC @ID = SecurityPatchResourceAdd @SecurityPatchID,
			@ResourceURL,
			@ArchitectureID,
			@LanguageID,
			@Checksum,
			@ActualResourceURL,
			@LocalPath,
			@Incorporate,
			@BulletinID,
			@PatchResourceName

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchResourceSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchResourceSchema]
GO
CREATE PROCEDURE [dbo].[SecurityPatchResourceSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecurityPatchResource'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecurityPatchResource (' + CAST(0x0A AS CHAR(1)) +
	'		SecurityPatchResourceID	int NULL,' + CAST(0x0A AS CHAR(1)) +
	'		SecurityPatchID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		ResourceURL		nvarchar(2000) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		ArchitectureID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		LanguageID		nvarchar(6) COLLATE database_default NOT NULL DEFAULT ''eng'',' + CAST(0x0A AS CHAR(1)) +
	'		Checksum		nvarchar(256) COLLATE database_default NULL,' + CAST(0x0A AS CHAR(1)) +
	'		ActualResourceURL	nvarchar(2000) COLLATE database_default NULL,' + CAST(0x0A AS CHAR(1)) +
	'		LocalPath		nvarchar(256) COLLATE database_default NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Incorporate		bit NOT NULL DEFAULT 1,' + CAST(0x0A AS CHAR(1)) +
	'		BulletinID		nvarchar(32) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		PatchResourceName	nvarchar(512) COLLATE database_default NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecurityPatchResource' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchResourceTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchResourceTempAdd]
GO
CREATE PROCEDURE dbo.[SecurityPatchResourceTempAdd]
	@SecurityPatchResourceID int,
	@SecurityPatchID	int,
	@ResourceURL		nvarchar(2000),
	@ArchitectureID		int,
	@LanguageID		nvarchar(6) = 'eng',
	@Checksum		nvarchar(256) = NULL,
	@ActualResourceURL	nvarchar(2000) = NULL,
	@LocalPath		nvarchar(256) = NULL,
	@Incorporate		bit = 1,
	@BulletinID		nvarchar(32),
	@PatchResourceName	nvarchar(512) = NULL
AS
	INSERT INTO #SecurityPatchResource (
		SecurityPatchResourceID,
		SecurityPatchID,
		ResourceURL,
		ArchitectureID,
		LanguageID,
		Checksum,
		ActualResourceURL,
		LocalPath,
		Incorporate,
		BulletinID,
		PatchResourceName
	)
	VALUES (
		@SecurityPatchResourceID,
		@SecurityPatchID,
		@ResourceURL,
		@ArchitectureID,
		@LanguageID,
		@Checksum,
		@ActualResourceURL,
		@LocalPath,
		@Incorporate,
		@BulletinID,
		@PatchResourceName
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchResourceAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchResourceAddBatch]
GO
CREATE PROCEDURE dbo.[SecurityPatchResourceAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecurityPatchResource (
		SecurityPatchID,
		ResourceURL,
		ArchitectureID,
		LanguageID,
		Checksum,
		ActualResourceURL,
		LocalPath,
		Incorporate,
		BulletinID,
		PatchResourceName
	)
		SELECT	SecurityPatchID,
			ResourceURL,
			ArchitectureID,
			LanguageID,
			Checksum,
			ActualResourceURL,
			LocalPath,
			Incorporate,
			BulletinID,
			PatchResourceName
		FROM #SecurityPatchResource
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchResource	-- Drop temporary table
	RETURN @count
GO

/*
Add new SecurityPatchResource bound to
	SecurityPatch using BulletinID, PatchName with Title, QNumber
	Architecture using ArchitectureName
	with ResourceURL, LanguageID, Checksum, ActualResourceURL, LocalPath, Incorporate, BulletinID, PatchResourceName
*/

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchResourceUpdateByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchResourceUpdateByID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchResourceUpdateByID]
	@SecurityPatchResourceID int,
	@SecurityPatchID	int,
	@ResourceURL		nvarchar(2000),
	@ArchitectureID		int,
	@LanguageID		nvarchar(6) = 'eng',
	@Checksum		nvarchar(256) = NULL,
	@ActualResourceURL	nvarchar(2000) = NULL,
	@LocalPath		nvarchar(256) = NULL,
	@Incorporate		bit = 1,
	@BulletinID		nvarchar(32),
	@PatchResourceName	nvarchar(512) = NULL
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[SecurityPatchResource]
	SET	@ID = SecurityPatchResourceID,
		SecurityPatchID = @SecurityPatchID,
		ResourceURL = @ResourceURL,
		ArchitectureID = @ArchitectureID,
		LanguageID = @LanguageID,
		Checksum = @Checksum,
		ActualResourceURL = @ActualResourceURL,
		LocalPath = @LocalPath,
		Incorporate = @Incorporate,
		BulletinID = @BulletinID,
		PatchResourceName = @PatchResourceName
	WHERE	SecurityPatchResourceID = @SecurityPatchResourceID
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchResourceUpdateBatchByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchResourceUpdateBatchByID]
GO
CREATE PROCEDURE dbo.[SecurityPatchResourceUpdateBatchByID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityPatchResourceID]
		ON #SecurityPatchResource (SecurityPatchResourceID)

	UPDATE	[dbo].[SecurityPatchResource]
	SET	SecurityPatchID = t.SecurityPatchID,
		ResourceURL = t.ResourceURL,
		ArchitectureID = t.ArchitectureID,
		LanguageID = t.LanguageID,
		Checksum = t.Checksum,
		ActualResourceURL = t.ActualResourceURL,
		LocalPath = t.LocalPath,
		Incorporate = t.Incorporate,
		BulletinID = t.BulletinID,
		PatchResourceName = t.PatchResourceName
	FROM	#SecurityPatchResource AS t
	WHERE	SecurityPatchResource.SecurityPatchResourceID = t.SecurityPatchResourceID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchResource	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchResourceUpdateBySecurityPatchIDResourceURLArchitectureIDLanguageID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchResourceUpdateBySecurityPatchIDResourceURLArchitectureIDLanguageID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchResourceUpdateBySecurityPatchIDResourceURLArchitectureIDLanguageID]
	@SecurityPatchID	int,
	@ResourceURL		nvarchar(2000),
	@ArchitectureID		int,
	@LanguageID		nvarchar(6) = 'eng',
	@Checksum		nvarchar(256) = NULL,
	@ActualResourceURL	nvarchar(2000) = NULL,
	@LocalPath		nvarchar(256) = NULL,
	@Incorporate		bit = 1,
	@BulletinID		nvarchar(32),
	@PatchResourceName	nvarchar(512) = NULL
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[SecurityPatchResource]
	SET	@ID = SecurityPatchResourceID,
		Checksum = @Checksum,
		ActualResourceURL = @ActualResourceURL,
		LocalPath = @LocalPath,
		Incorporate = @Incorporate,
		BulletinID = @BulletinID,
		PatchResourceName = @PatchResourceName
	WHERE	SecurityPatchID = @SecurityPatchID
	  AND	ResourceURL = @ResourceURL
	  AND	ArchitectureID = @ArchitectureID
	  AND	LanguageID = @LanguageID
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchResourceUpdateBatchBySecurityPatchIDResourceURLArchitectureIDLanguageID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchResourceUpdateBatchBySecurityPatchIDResourceURLArchitectureIDLanguageID]
GO
CREATE PROCEDURE dbo.[SecurityPatchResourceUpdateBatchBySecurityPatchIDResourceURLArchitectureIDLanguageID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityPatchResourceSecurityPatchIDResourceURLArchitectureIDLanguageID]
		ON #SecurityPatchResource (SecurityPatchID, ResourceURL, ArchitectureID, LanguageID)

	UPDATE	[dbo].[SecurityPatchResource]
	SET	Checksum = t.Checksum,
		ActualResourceURL = t.ActualResourceURL,
		LocalPath = t.LocalPath,
		Incorporate = t.Incorporate,
		BulletinID = t.BulletinID,
		PatchResourceName = t.PatchResourceName
	FROM	#SecurityPatchResource AS t
	WHERE	SecurityPatchResource.SecurityPatchID = t.SecurityPatchID
	  AND	SecurityPatchResource.ResourceURL = t.ResourceURL
	  AND	SecurityPatchResource.ArchitectureID = t.ArchitectureID
	  AND	SecurityPatchResource.LanguageID = t.LanguageID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchResource	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchResourcePutBySecurityPatchIDResourceURLArchitectureIDLanguageID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchResourcePutBySecurityPatchIDResourceURLArchitectureIDLanguageID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchResourcePutBySecurityPatchIDResourceURLArchitectureIDLanguageID]
	@SecurityPatchID	int,
	@ResourceURL		nvarchar(2000),
	@ArchitectureID		int,
	@LanguageID		nvarchar(6) = 'eng',
	@Checksum		nvarchar(256) = NULL,
	@ActualResourceURL	nvarchar(2000) = NULL,
	@LocalPath		nvarchar(256) = NULL,
	@Incorporate		bit = 1,
	@BulletinID		nvarchar(32),
	@PatchResourceName	nvarchar(512) = NULL
AS
	DECLARE @ID	int

	SELECT	@ID = SecurityPatchResourceID
	FROM	SecurityPatchResource
	WHERE	SecurityPatchID = @SecurityPatchID
	  AND	ResourceURL = @ResourceURL
	  AND	ArchitectureID = @ArchitectureID
	  AND	LanguageID = @LanguageID

	IF @ID IS NULL
		EXEC @ID = SecurityPatchResourceAdd @SecurityPatchID,
			@ResourceURL,
			@ArchitectureID,
			@LanguageID,
			@Checksum,
			@ActualResourceURL,
			@LocalPath,
			@Incorporate,
			@BulletinID,
			@PatchResourceName
	ELSE
		EXEC SecurityPatchResourceUpdateBySecurityPatchIDResourceURLArchitectureIDLanguageID @SecurityPatchID,
			@ResourceURL,
			@ArchitectureID,
			@LanguageID,
			@Checksum,
			@ActualResourceURL,
			@LocalPath,
			@Incorporate,
			@BulletinID,
			@PatchResourceName

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchResourcePutBatchBySecurityPatchIDResourceURLArchitectureIDLanguageID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchResourcePutBatchBySecurityPatchIDResourceURLArchitectureIDLanguageID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchResourcePutBatchBySecurityPatchIDResourceURLArchitectureIDLanguageID]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecurityPatchResourceSecurityPatchIDResourceURLArchitectureIDLanguageID]
		ON #SecurityPatchResource (SecurityPatchID, ResourceURL, ArchitectureID, LanguageID)

	BEGIN TRANSACTION
	UPDATE [dbo].[SecurityPatchResource]
		SET	Checksum = t.Checksum,
			ActualResourceURL = t.ActualResourceURL,
			LocalPath = t.LocalPath,
			Incorporate = t.Incorporate,
			BulletinID = t.BulletinID,
			PatchResourceName = t.PatchResourceName
		FROM	#SecurityPatchResource AS t
		WHERE	SecurityPatchResource.SecurityPatchID = t.SecurityPatchID
		  AND	SecurityPatchResource.ResourceURL = t.ResourceURL
		  AND	SecurityPatchResource.ArchitectureID = t.ArchitectureID
		  AND	SecurityPatchResource.LanguageID = t.LanguageID
	SET @count = @@ROWCOUNT

	INSERT [dbo].[SecurityPatchResource] (
		SecurityPatchID,
		ResourceURL,
		ArchitectureID,
		LanguageID,
		Checksum,
		ActualResourceURL,
		LocalPath,
		Incorporate,
		BulletinID,
		PatchResourceName
	)
		SELECT	SecurityPatchID,
			ResourceURL,
			ArchitectureID,
			LanguageID,
			Checksum,
			ActualResourceURL,
			LocalPath,
			Incorporate,
			BulletinID,
			PatchResourceName
		FROM	#SecurityPatchResource AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecurityPatchResource]
			WHERE	SecurityPatchResource.SecurityPatchID = t.SecurityPatchID
			  AND	SecurityPatchResource.ResourceURL = t.ResourceURL
			  AND	SecurityPatchResource.ArchitectureID = t.ArchitectureID
			  AND	SecurityPatchResource.LanguageID = t.LanguageID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecurityPatchResource	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchResourceRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchResourceRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecurityPatchResourceRemoveBatch]
AS

	CREATE INDEX [TempSecurityPatchResourceSecurityPatchResourceRemoveBatch]
		ON #SecurityPatchResource (SecurityPatchResourceID)	

	-- Delete records from SecurityPatchResource identified by fields of [TempSecurityPatchResourceSecurityPatchResourceRemoveBatch]
	DELETE [dbo].[SecurityPatchResource]
	WHERE EXISTS(
			SELECT * FROM #SecurityPatchResource AS t
			WHERE	SecurityPatchResource.SecurityPatchResourceID = t.SecurityPatchResourceID
		)
	DROP TABLE #SecurityPatchResource      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchResourceRemoveBySecurityPatchIDResourceURLArchitectureIDLanguageID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchResourceRemoveBySecurityPatchIDResourceURLArchitectureIDLanguageID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchResourceRemoveBySecurityPatchIDResourceURLArchitectureIDLanguageID]
	@SecurityPatchID	int,
	@ResourceURL		nvarchar(2000),
	@ArchitectureID		int,
	@LanguageID		nvarchar(6) = 'eng'
AS
	DELETE	[dbo].[SecurityPatchResource]
	WHERE	SecurityPatchID = @SecurityPatchID
	  AND	ResourceURL = @ResourceURL
	  AND	ArchitectureID = @ArchitectureID
	  AND	LanguageID = @LanguageID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchResourceRemoveAllBySecurityPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchResourceRemoveAllBySecurityPatchID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchResourceRemoveAllBySecurityPatchID]
	@SecurityPatchID	int
AS
	DELETE	[dbo].[SecurityPatchResource]
	WHERE	SecurityPatchID = @SecurityPatchID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchResourceRemoveByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchResourceRemoveByID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchResourceRemoveByID]
	@SecurityPatchResourceID int
AS
	DELETE	[dbo].[SecurityPatchResource]
	WHERE	SecurityPatchResourceID = @SecurityPatchResourceID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchResourceRemoveAllByBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchResourceRemoveAllByBulletinID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchResourceRemoveAllByBulletinID]
	@BulletinID		nvarchar(32)
AS
	DELETE	[dbo].[SecurityPatchResource]
	WHERE	BulletinID = @BulletinID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchResourceRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchResourceRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchResourceRemoveAll]
	
AS
	DELETE	[dbo].[SecurityPatchResource]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchResourceReplaceSubsetBySecurityPatchID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchResourceReplaceSubsetBySecurityPatchID]
GO
-- Replace the record subset selected by (@SecurityPatchID)
-- using unique identifier (SecurityPatchID, ResourceURL, ArchitectureID, LanguageID)
-- updating fields (Checksum, ActualResourceURL, LocalPath, Incorporate, BulletinID, PatchResourceName)
CREATE PROCEDURE [dbo].[SecurityPatchResourceReplaceSubsetBySecurityPatchID]
	@SecurityPatchID	int
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecurityPatchResourceBySecurityPatchID]
		ON #SecurityPatchResource (SecurityPatchID, ResourceURL, ArchitectureID, LanguageID)

	BEGIN TRANSACTION
	DELETE [SecurityPatchResource]
		WHERE	SecurityPatchID = @SecurityPatchID
		AND NOT EXISTS(		-- Replacement record doesn't exist
			SELECT * FROM #SecurityPatchResource AS t
			WHERE	SecurityPatchResource.SecurityPatchID = t.SecurityPatchID
			  AND	SecurityPatchResource.ResourceURL = t.ResourceURL
			  AND	SecurityPatchResource.ArchitectureID = t.ArchitectureID
			  AND	SecurityPatchResource.LanguageID = t.LanguageID
		)

	UPDATE [dbo].[SecurityPatchResource]
		SET	Checksum = t.Checksum,
			ActualResourceURL = t.ActualResourceURL,
			LocalPath = t.LocalPath,
			Incorporate = t.Incorporate,
			BulletinID = t.BulletinID,
			PatchResourceName = t.PatchResourceName
		FROM	#SecurityPatchResource AS t
		WHERE	SecurityPatchResource.SecurityPatchID = t.SecurityPatchID
		  AND	SecurityPatchResource.ResourceURL = t.ResourceURL
		  AND	SecurityPatchResource.ArchitectureID = t.ArchitectureID
		  AND	SecurityPatchResource.LanguageID = t.LanguageID
	SET @count = @@ROWCOUNT

	INSERT [SecurityPatchResource] (
		SecurityPatchID,
		ResourceURL,
		ArchitectureID,
		LanguageID,
		Checksum,
		ActualResourceURL,
		LocalPath,
		Incorporate,
		BulletinID,
		PatchResourceName
	)
		SELECT	SecurityPatchID,
			ResourceURL,
			ArchitectureID,
			LanguageID,
			Checksum,
			ActualResourceURL,
			LocalPath,
			Incorporate,
			BulletinID,
			PatchResourceName
		FROM	#SecurityPatchResource AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [SecurityPatchResource]
			WHERE	SecurityPatchResource.SecurityPatchID = t.SecurityPatchID
			  AND	SecurityPatchResource.ResourceURL = t.ResourceURL
			  AND	SecurityPatchResource.ArchitectureID = t.ArchitectureID
			  AND	SecurityPatchResource.LanguageID = t.LanguageID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecurityPatchResource	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchLanguageGetByLanguageName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchLanguageGetByLanguageName]
GO
CREATE PROCEDURE [dbo].[SecurityPatchLanguageGetByLanguageName]
	@LanguageName		nvarchar(6)
AS
	SELECT	LanguageName,
		Description,
		Selected,
		Visible
	FROM	[dbo].[SecurityPatchLanguage]
	WHERE	LanguageName = @LanguageName
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchLanguageGetAllBySelected]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchLanguageGetAllBySelected]
GO
CREATE PROCEDURE [dbo].[SecurityPatchLanguageGetAllBySelected]
	@Selected		bit
AS
	SELECT	LanguageName,
		Description,
		Selected,
		Visible
	FROM	[dbo].[SecurityPatchLanguage]
	WHERE	Selected = @Selected
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchLanguageGetAllOrderedBySelected]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchLanguageGetAllOrderedBySelected]
GO
CREATE PROCEDURE [dbo].[SecurityPatchLanguageGetAllOrderedBySelected]
AS
	SELECT	LanguageName,
		Description,
		Selected,
		Visible
	FROM	[dbo].[SecurityPatchLanguage]
	ORDER BY Selected
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchLanguageGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchLanguageGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchLanguageGetAll]
AS
	SELECT	LanguageName,
		Description,
		Selected,
		Visible
	FROM	[dbo].[SecurityPatchLanguage]
	ORDER BY LanguageName
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchLanguageAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchLanguageAdd]
GO
CREATE PROCEDURE [dbo].[SecurityPatchLanguageAdd]
	@LanguageName		nvarchar(6),
	@Description		nvarchar(128),
	@Selected		bit,
	@Visible		bit
AS
	INSERT INTO  dbo.SecurityPatchLanguage (
		LanguageName,
		Description,
		Selected,
		Visible
	)
	VALUES (
		@LanguageName,
		@Description,
		@Selected,
		@Visible
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchLanguageSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchLanguageSchema]
GO
CREATE PROCEDURE [dbo].[SecurityPatchLanguageSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecurityPatchLanguage'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecurityPatchLanguage (' + CAST(0x0A AS CHAR(1)) +
	'		LanguageName		nvarchar(6) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Description		nvarchar(128) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Selected		bit NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Visible			bit NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecurityPatchLanguage' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchLanguageTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchLanguageTempAdd]
GO
CREATE PROCEDURE dbo.[SecurityPatchLanguageTempAdd]
	@LanguageName		nvarchar(6),
	@Description		nvarchar(128),
	@Selected		bit,
	@Visible		bit
AS
	INSERT INTO #SecurityPatchLanguage (
		LanguageName,
		Description,
		Selected,
		Visible
	)
	VALUES (
		@LanguageName,
		@Description,
		@Selected,
		@Visible
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchLanguageAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchLanguageAddBatch]
GO
CREATE PROCEDURE dbo.[SecurityPatchLanguageAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecurityPatchLanguage (
		LanguageName,
		Description,
		Selected,
		Visible
	)
		SELECT	LanguageName,
			Description,
			Selected,
			Visible
		FROM #SecurityPatchLanguage
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchLanguage	-- Drop temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchLanguageUpdateByLanguageName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchLanguageUpdateByLanguageName]
GO
CREATE PROCEDURE [dbo].[SecurityPatchLanguageUpdateByLanguageName]
	@LanguageName		nvarchar(6),
	@Description		nvarchar(128),
	@Selected		bit,
	@Visible		bit
AS
	UPDATE	[dbo].[SecurityPatchLanguage]
	SET	Description = @Description,
		Selected = @Selected,
		Visible = @Visible
	WHERE	LanguageName = @LanguageName
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchLanguageUpdateBatchByLanguageName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchLanguageUpdateBatchByLanguageName]
GO
CREATE PROCEDURE dbo.[SecurityPatchLanguageUpdateBatchByLanguageName]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityPatchLanguageLanguageName]
		ON #SecurityPatchLanguage (LanguageName)

	UPDATE	[dbo].[SecurityPatchLanguage]
	SET	Description = t.Description,
		Selected = t.Selected,
		Visible = t.Visible
	FROM	#SecurityPatchLanguage AS t
	WHERE	SecurityPatchLanguage.LanguageName = t.LanguageName
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchLanguage	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchLanguagePutByLanguageName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchLanguagePutByLanguageName]
GO
CREATE PROCEDURE [dbo].[SecurityPatchLanguagePutByLanguageName]
	@LanguageName		nvarchar(6),
	@Description		nvarchar(128),
	@Selected		bit,
	@Visible		bit
AS
	IF NOT EXISTS(
		SELECT	1
		FROM	dbo.SecurityPatchLanguage
		WHERE	LanguageName = @LanguageName
	)
		EXEC SecurityPatchLanguageAdd @LanguageName,
			@Description,
			@Selected,
			@Visible
	ELSE
		EXEC SecurityPatchLanguageUpdateByLanguageName @LanguageName,
			@Description,
			@Selected,
			@Visible
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchLanguagePutBatchByLanguageName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchLanguagePutBatchByLanguageName]
GO
CREATE PROCEDURE [dbo].[SecurityPatchLanguagePutBatchByLanguageName]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecurityPatchLanguageLanguageName]
		ON #SecurityPatchLanguage (LanguageName)

	BEGIN TRANSACTION
	UPDATE [dbo].[SecurityPatchLanguage]
		SET	Description = t.Description,
			Selected = t.Selected,
			Visible = t.Visible
		FROM	#SecurityPatchLanguage AS t
		WHERE	SecurityPatchLanguage.LanguageName = t.LanguageName
	SET @count = @@ROWCOUNT

	INSERT [dbo].[SecurityPatchLanguage] (
		LanguageName,
		Description,
		Selected,
		Visible
	)
		SELECT	LanguageName,
			Description,
			Selected,
			Visible
		FROM	#SecurityPatchLanguage AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecurityPatchLanguage]
			WHERE	SecurityPatchLanguage.LanguageName = t.LanguageName
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecurityPatchLanguage	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchLanguageRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchLanguageRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecurityPatchLanguageRemoveBatch]
AS

	CREATE INDEX [TempSecurityPatchLanguageSecurityPatchLanguageRemoveBatch]
		ON #SecurityPatchLanguage (LanguageName)	

	-- Delete records from SecurityPatchLanguage identified by fields of [TempSecurityPatchLanguageSecurityPatchLanguageRemoveBatch]
	DELETE [dbo].[SecurityPatchLanguage]
	WHERE EXISTS(
			SELECT * FROM #SecurityPatchLanguage AS t
			WHERE	SecurityPatchLanguage.LanguageName = t.LanguageName
		)
	DROP TABLE #SecurityPatchLanguage      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchLanguageRemoveByLanguageName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchLanguageRemoveByLanguageName]
GO
CREATE PROCEDURE [dbo].[SecurityPatchLanguageRemoveByLanguageName]
	@LanguageName		nvarchar(6)
AS
	DELETE	[dbo].[SecurityPatchLanguage]
	WHERE	LanguageName = @LanguageName
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchLanguageRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchLanguageRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchLanguageRemoveAll]
	
AS
	DELETE	[dbo].[SecurityPatchLanguage]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchOperatingSystemGetByOperatingSystemID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchOperatingSystemGetByOperatingSystemID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchOperatingSystemGetByOperatingSystemID]
	@OperatingSystemID	int
AS
	SELECT	OperatingSystemID,
		Description,
		Selected,
		Visible
	FROM	[dbo].[SecurityPatchOperatingSystem]
	WHERE	OperatingSystemID = @OperatingSystemID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchOperatingSystemGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchOperatingSystemGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchOperatingSystemGetAll]
AS
	SELECT	OperatingSystemID,
		Description,
		Selected,
		Visible
	FROM	[dbo].[SecurityPatchOperatingSystem]
	ORDER BY OperatingSystemID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchOperatingSystemAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchOperatingSystemAdd]
GO
CREATE PROCEDURE [dbo].[SecurityPatchOperatingSystemAdd]
	@OperatingSystemID	int,
	@Description		nvarchar(128),
	@Selected		bit,
	@Visible		bit
AS
	INSERT INTO  dbo.SecurityPatchOperatingSystem (
		OperatingSystemID,
		Description,
		Selected,
		Visible
	)
	VALUES (
		@OperatingSystemID,
		@Description,
		@Selected,
		@Visible
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchOperatingSystemSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchOperatingSystemSchema]
GO
CREATE PROCEDURE [dbo].[SecurityPatchOperatingSystemSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecurityPatchOperatingSystem'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecurityPatchOperatingSystem (' + CAST(0x0A AS CHAR(1)) +
	'		OperatingSystemID	int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Description		nvarchar(128) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Selected		bit NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Visible			bit NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecurityPatchOperatingSystem' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchOperatingSystemTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchOperatingSystemTempAdd]
GO
CREATE PROCEDURE dbo.[SecurityPatchOperatingSystemTempAdd]
	@OperatingSystemID	int,
	@Description		nvarchar(128),
	@Selected		bit,
	@Visible		bit
AS
	INSERT INTO #SecurityPatchOperatingSystem (
		OperatingSystemID,
		Description,
		Selected,
		Visible
	)
	VALUES (
		@OperatingSystemID,
		@Description,
		@Selected,
		@Visible
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchOperatingSystemAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchOperatingSystemAddBatch]
GO
CREATE PROCEDURE dbo.[SecurityPatchOperatingSystemAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecurityPatchOperatingSystem (
		OperatingSystemID,
		Description,
		Selected,
		Visible
	)
		SELECT	OperatingSystemID,
			Description,
			Selected,
			Visible
		FROM #SecurityPatchOperatingSystem
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchOperatingSystem	-- Drop temporary table
	RETURN @count
GO

/*
Add new SecurityPatchOperatingSystem bound to
	SecurityPatchUIProductGroup using Product with GroupName
	with Description, Selected, Visible
*/

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchOperatingSystemUpdateByOperatingSystemID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchOperatingSystemUpdateByOperatingSystemID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchOperatingSystemUpdateByOperatingSystemID]
	@OperatingSystemID	int,
	@Description		nvarchar(128),
	@Selected		bit,
	@Visible		bit
AS
	UPDATE	[dbo].[SecurityPatchOperatingSystem]
	SET	Description = @Description,
		Selected = @Selected,
		Visible = @Visible
	WHERE	OperatingSystemID = @OperatingSystemID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchOperatingSystemUpdateBatchByOperatingSystemID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchOperatingSystemUpdateBatchByOperatingSystemID]
GO
CREATE PROCEDURE dbo.[SecurityPatchOperatingSystemUpdateBatchByOperatingSystemID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityPatchOperatingSystemOperatingSystemID]
		ON #SecurityPatchOperatingSystem (OperatingSystemID)

	UPDATE	[dbo].[SecurityPatchOperatingSystem]
	SET	Description = t.Description,
		Selected = t.Selected,
		Visible = t.Visible
	FROM	#SecurityPatchOperatingSystem AS t
	WHERE	SecurityPatchOperatingSystem.OperatingSystemID = t.OperatingSystemID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchOperatingSystem	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchOperatingSystemPutByOperatingSystemID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchOperatingSystemPutByOperatingSystemID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchOperatingSystemPutByOperatingSystemID]
	@OperatingSystemID	int,
	@Description		nvarchar(128),
	@Selected		bit,
	@Visible		bit
AS
	IF NOT EXISTS(
		SELECT	1
		FROM	dbo.SecurityPatchOperatingSystem
		WHERE	OperatingSystemID = @OperatingSystemID
	)
		EXEC SecurityPatchOperatingSystemAdd @OperatingSystemID,
			@Description,
			@Selected,
			@Visible
	ELSE
		EXEC SecurityPatchOperatingSystemUpdateByOperatingSystemID @OperatingSystemID,
			@Description,
			@Selected,
			@Visible
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchOperatingSystemPutBatchByOperatingSystemID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchOperatingSystemPutBatchByOperatingSystemID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchOperatingSystemPutBatchByOperatingSystemID]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecurityPatchOperatingSystemOperatingSystemID]
		ON #SecurityPatchOperatingSystem (OperatingSystemID)

	BEGIN TRANSACTION
	UPDATE [dbo].[SecurityPatchOperatingSystem]
		SET	Description = t.Description,
			Selected = t.Selected,
			Visible = t.Visible
		FROM	#SecurityPatchOperatingSystem AS t
		WHERE	SecurityPatchOperatingSystem.OperatingSystemID = t.OperatingSystemID
	SET @count = @@ROWCOUNT

	INSERT [dbo].[SecurityPatchOperatingSystem] (
		OperatingSystemID,
		Description,
		Selected,
		Visible
	)
		SELECT	OperatingSystemID,
			Description,
			Selected,
			Visible
		FROM	#SecurityPatchOperatingSystem AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecurityPatchOperatingSystem]
			WHERE	SecurityPatchOperatingSystem.OperatingSystemID = t.OperatingSystemID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecurityPatchOperatingSystem	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchOperatingSystemRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchOperatingSystemRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecurityPatchOperatingSystemRemoveBatch]
AS

	CREATE INDEX [TempSecurityPatchOperatingSystemSecurityPatchOperatingSystemRemoveBatch]
		ON #SecurityPatchOperatingSystem (OperatingSystemID)	

	-- Delete records from SecurityPatchOperatingSystem identified by fields of [TempSecurityPatchOperatingSystemSecurityPatchOperatingSystemRemoveBatch]
	DELETE [dbo].[SecurityPatchOperatingSystem]
	WHERE EXISTS(
			SELECT * FROM #SecurityPatchOperatingSystem AS t
			WHERE	SecurityPatchOperatingSystem.OperatingSystemID = t.OperatingSystemID
		)
	DROP TABLE #SecurityPatchOperatingSystem      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchOperatingSystemRemoveByOperatingSystemID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchOperatingSystemRemoveByOperatingSystemID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchOperatingSystemRemoveByOperatingSystemID]
	@OperatingSystemID	int
AS
	DELETE	[dbo].[SecurityPatchOperatingSystem]
	WHERE	OperatingSystemID = @OperatingSystemID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchOperatingSystemRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchOperatingSystemRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchOperatingSystemRemoveAll]
	
AS
	DELETE	[dbo].[SecurityPatchOperatingSystem]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchArchitectureGetByArchitectureID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchArchitectureGetByArchitectureID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchArchitectureGetByArchitectureID]
	@ArchitectureID		int
AS
	SELECT	ArchitectureID,
		Description,
		Selected,
		Visible
	FROM	[dbo].[SecurityPatchArchitecture]
	WHERE	ArchitectureID = @ArchitectureID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchArchitectureGetAllBySelected]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchArchitectureGetAllBySelected]
GO
CREATE PROCEDURE [dbo].[SecurityPatchArchitectureGetAllBySelected]
	@Selected		bit
AS
	SELECT	ArchitectureID,
		Description,
		Selected,
		Visible
	FROM	[dbo].[SecurityPatchArchitecture]
	WHERE	Selected = @Selected
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchArchitectureGetAllOrderedBySelected]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchArchitectureGetAllOrderedBySelected]
GO
CREATE PROCEDURE [dbo].[SecurityPatchArchitectureGetAllOrderedBySelected]
AS
	SELECT	ArchitectureID,
		Description,
		Selected,
		Visible
	FROM	[dbo].[SecurityPatchArchitecture]
	ORDER BY Selected
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchArchitectureGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchArchitectureGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchArchitectureGetAll]
AS
	SELECT	ArchitectureID,
		Description,
		Selected,
		Visible
	FROM	[dbo].[SecurityPatchArchitecture]
	ORDER BY ArchitectureID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchArchitectureAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchArchitectureAdd]
GO
CREATE PROCEDURE [dbo].[SecurityPatchArchitectureAdd]
	@ArchitectureID		int,
	@Description		nvarchar(128),
	@Selected		bit,
	@Visible		bit
AS
	INSERT INTO  dbo.SecurityPatchArchitecture (
		ArchitectureID,
		Description,
		Selected,
		Visible
	)
	VALUES (
		@ArchitectureID,
		@Description,
		@Selected,
		@Visible
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchArchitectureSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchArchitectureSchema]
GO
CREATE PROCEDURE [dbo].[SecurityPatchArchitectureSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecurityPatchArchitecture'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecurityPatchArchitecture (' + CAST(0x0A AS CHAR(1)) +
	'		ArchitectureID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Description		nvarchar(128) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Selected		bit NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Visible			bit NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecurityPatchArchitecture' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchArchitectureTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchArchitectureTempAdd]
GO
CREATE PROCEDURE dbo.[SecurityPatchArchitectureTempAdd]
	@ArchitectureID		int,
	@Description		nvarchar(128),
	@Selected		bit,
	@Visible		bit
AS
	INSERT INTO #SecurityPatchArchitecture (
		ArchitectureID,
		Description,
		Selected,
		Visible
	)
	VALUES (
		@ArchitectureID,
		@Description,
		@Selected,
		@Visible
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchArchitectureAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchArchitectureAddBatch]
GO
CREATE PROCEDURE dbo.[SecurityPatchArchitectureAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecurityPatchArchitecture (
		ArchitectureID,
		Description,
		Selected,
		Visible
	)
		SELECT	ArchitectureID,
			Description,
			Selected,
			Visible
		FROM #SecurityPatchArchitecture
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchArchitecture	-- Drop temporary table
	RETURN @count
GO

/*
Add new SecurityPatchArchitecture bound to
	Architecture using ArchitectureName
	with Description, Selected, Visible
*/

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchArchitectureUpdateByArchitectureID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchArchitectureUpdateByArchitectureID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchArchitectureUpdateByArchitectureID]
	@ArchitectureID		int,
	@Description		nvarchar(128),
	@Selected		bit,
	@Visible		bit
AS
	UPDATE	[dbo].[SecurityPatchArchitecture]
	SET	Description = @Description,
		Selected = @Selected,
		Visible = @Visible
	WHERE	ArchitectureID = @ArchitectureID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchArchitectureUpdateBatchByArchitectureID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchArchitectureUpdateBatchByArchitectureID]
GO
CREATE PROCEDURE dbo.[SecurityPatchArchitectureUpdateBatchByArchitectureID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityPatchArchitectureArchitectureID]
		ON #SecurityPatchArchitecture (ArchitectureID)

	UPDATE	[dbo].[SecurityPatchArchitecture]
	SET	Description = t.Description,
		Selected = t.Selected,
		Visible = t.Visible
	FROM	#SecurityPatchArchitecture AS t
	WHERE	SecurityPatchArchitecture.ArchitectureID = t.ArchitectureID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchArchitecture	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchArchitecturePutByArchitectureID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchArchitecturePutByArchitectureID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchArchitecturePutByArchitectureID]
	@ArchitectureID		int,
	@Description		nvarchar(128),
	@Selected		bit,
	@Visible		bit
AS
	IF NOT EXISTS(
		SELECT	1
		FROM	dbo.SecurityPatchArchitecture
		WHERE	ArchitectureID = @ArchitectureID
	)
		EXEC SecurityPatchArchitectureAdd @ArchitectureID,
			@Description,
			@Selected,
			@Visible
	ELSE
		EXEC SecurityPatchArchitectureUpdateByArchitectureID @ArchitectureID,
			@Description,
			@Selected,
			@Visible
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchArchitecturePutBatchByArchitectureID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchArchitecturePutBatchByArchitectureID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchArchitecturePutBatchByArchitectureID]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecurityPatchArchitectureArchitectureID]
		ON #SecurityPatchArchitecture (ArchitectureID)

	BEGIN TRANSACTION
	UPDATE [dbo].[SecurityPatchArchitecture]
		SET	Description = t.Description,
			Selected = t.Selected,
			Visible = t.Visible
		FROM	#SecurityPatchArchitecture AS t
		WHERE	SecurityPatchArchitecture.ArchitectureID = t.ArchitectureID
	SET @count = @@ROWCOUNT

	INSERT [dbo].[SecurityPatchArchitecture] (
		ArchitectureID,
		Description,
		Selected,
		Visible
	)
		SELECT	ArchitectureID,
			Description,
			Selected,
			Visible
		FROM	#SecurityPatchArchitecture AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecurityPatchArchitecture]
			WHERE	SecurityPatchArchitecture.ArchitectureID = t.ArchitectureID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecurityPatchArchitecture	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchArchitectureRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchArchitectureRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecurityPatchArchitectureRemoveBatch]
AS

	CREATE INDEX [TempSecurityPatchArchitectureSecurityPatchArchitectureRemoveBatch]
		ON #SecurityPatchArchitecture (ArchitectureID)	

	-- Delete records from SecurityPatchArchitecture identified by fields of [TempSecurityPatchArchitectureSecurityPatchArchitectureRemoveBatch]
	DELETE [dbo].[SecurityPatchArchitecture]
	WHERE EXISTS(
			SELECT * FROM #SecurityPatchArchitecture AS t
			WHERE	SecurityPatchArchitecture.ArchitectureID = t.ArchitectureID
		)
	DROP TABLE #SecurityPatchArchitecture      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchArchitectureRemoveByArchitectureID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchArchitectureRemoveByArchitectureID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchArchitectureRemoveByArchitectureID]
	@ArchitectureID		int
AS
	DELETE	[dbo].[SecurityPatchArchitecture]
	WHERE	ArchitectureID = @ArchitectureID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchArchitectureRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchArchitectureRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchArchitectureRemoveAll]
	
AS
	DELETE	[dbo].[SecurityPatchArchitecture]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchModelGetByModelID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchModelGetByModelID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchModelGetByModelID]
	@ModelID		int
AS
	SELECT	ModelID,
		Description,
		Selected,
		Visible
	FROM	[dbo].[SecurityPatchModel]
	WHERE	ModelID = @ModelID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchModelGetAllBySelected]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchModelGetAllBySelected]
GO
CREATE PROCEDURE [dbo].[SecurityPatchModelGetAllBySelected]
	@Selected		bit
AS
	SELECT	ModelID,
		Description,
		Selected,
		Visible
	FROM	[dbo].[SecurityPatchModel]
	WHERE	Selected = @Selected
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchModelGetAllOrderedBySelected]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchModelGetAllOrderedBySelected]
GO
CREATE PROCEDURE [dbo].[SecurityPatchModelGetAllOrderedBySelected]
AS
	SELECT	ModelID,
		Description,
		Selected,
		Visible
	FROM	[dbo].[SecurityPatchModel]
	ORDER BY Selected
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchModelGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchModelGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchModelGetAll]
AS
	SELECT	ModelID,
		Description,
		Selected,
		Visible
	FROM	[dbo].[SecurityPatchModel]
	ORDER BY ModelID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchModelAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchModelAdd]
GO
CREATE PROCEDURE [dbo].[SecurityPatchModelAdd]
	@ModelID		int,
	@Description		nvarchar(128),
	@Selected		bit,
	@Visible		bit
AS
	INSERT INTO  dbo.SecurityPatchModel (
		ModelID,
		Description,
		Selected,
		Visible
	)
	VALUES (
		@ModelID,
		@Description,
		@Selected,
		@Visible
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchModelSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchModelSchema]
GO
CREATE PROCEDURE [dbo].[SecurityPatchModelSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecurityPatchModel'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecurityPatchModel (' + CAST(0x0A AS CHAR(1)) +
	'		ModelID			int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Description		nvarchar(128) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Selected		bit NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Visible			bit NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecurityPatchModel' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchModelTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchModelTempAdd]
GO
CREATE PROCEDURE dbo.[SecurityPatchModelTempAdd]
	@ModelID		int,
	@Description		nvarchar(128),
	@Selected		bit,
	@Visible		bit
AS
	INSERT INTO #SecurityPatchModel (
		ModelID,
		Description,
		Selected,
		Visible
	)
	VALUES (
		@ModelID,
		@Description,
		@Selected,
		@Visible
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchModelAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchModelAddBatch]
GO
CREATE PROCEDURE dbo.[SecurityPatchModelAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecurityPatchModel (
		ModelID,
		Description,
		Selected,
		Visible
	)
		SELECT	ModelID,
			Description,
			Selected,
			Visible
		FROM #SecurityPatchModel
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchModel	-- Drop temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchModelUpdateByModelID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchModelUpdateByModelID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchModelUpdateByModelID]
	@ModelID		int,
	@Description		nvarchar(128),
	@Selected		bit,
	@Visible		bit
AS
	UPDATE	[dbo].[SecurityPatchModel]
	SET	Description = @Description,
		Selected = @Selected,
		Visible = @Visible
	WHERE	ModelID = @ModelID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchModelUpdateBatchByModelID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchModelUpdateBatchByModelID]
GO
CREATE PROCEDURE dbo.[SecurityPatchModelUpdateBatchByModelID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityPatchModelModelID]
		ON #SecurityPatchModel (ModelID)

	UPDATE	[dbo].[SecurityPatchModel]
	SET	Description = t.Description,
		Selected = t.Selected,
		Visible = t.Visible
	FROM	#SecurityPatchModel AS t
	WHERE	SecurityPatchModel.ModelID = t.ModelID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchModel	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchModelPutByModelID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchModelPutByModelID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchModelPutByModelID]
	@ModelID		int,
	@Description		nvarchar(128),
	@Selected		bit,
	@Visible		bit
AS
	IF NOT EXISTS(
		SELECT	1
		FROM	dbo.SecurityPatchModel
		WHERE	ModelID = @ModelID
	)
		EXEC SecurityPatchModelAdd @ModelID,
			@Description,
			@Selected,
			@Visible
	ELSE
		EXEC SecurityPatchModelUpdateByModelID @ModelID,
			@Description,
			@Selected,
			@Visible
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchModelPutBatchByModelID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchModelPutBatchByModelID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchModelPutBatchByModelID]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecurityPatchModelModelID]
		ON #SecurityPatchModel (ModelID)

	BEGIN TRANSACTION
	UPDATE [dbo].[SecurityPatchModel]
		SET	Description = t.Description,
			Selected = t.Selected,
			Visible = t.Visible
		FROM	#SecurityPatchModel AS t
		WHERE	SecurityPatchModel.ModelID = t.ModelID
	SET @count = @@ROWCOUNT

	INSERT [dbo].[SecurityPatchModel] (
		ModelID,
		Description,
		Selected,
		Visible
	)
		SELECT	ModelID,
			Description,
			Selected,
			Visible
		FROM	#SecurityPatchModel AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecurityPatchModel]
			WHERE	SecurityPatchModel.ModelID = t.ModelID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecurityPatchModel	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchModelRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchModelRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecurityPatchModelRemoveBatch]
AS

	CREATE INDEX [TempSecurityPatchModelSecurityPatchModelRemoveBatch]
		ON #SecurityPatchModel (ModelID)	

	-- Delete records from SecurityPatchModel identified by fields of [TempSecurityPatchModelSecurityPatchModelRemoveBatch]
	DELETE [dbo].[SecurityPatchModel]
	WHERE EXISTS(
			SELECT * FROM #SecurityPatchModel AS t
			WHERE	SecurityPatchModel.ModelID = t.ModelID
		)
	DROP TABLE #SecurityPatchModel      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchModelRemoveByModelID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchModelRemoveByModelID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchModelRemoveByModelID]
	@ModelID		int
AS
	DELETE	[dbo].[SecurityPatchModel]
	WHERE	ModelID = @ModelID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchModelRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchModelRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchModelRemoveAll]
	
AS
	DELETE	[dbo].[SecurityPatchModel]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchApplicationGetByApplicationID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchApplicationGetByApplicationID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchApplicationGetByApplicationID]
	@ApplicationID		int
AS
	SELECT	ApplicationID,
		Description,
		Selected,
		Visible
	FROM	[dbo].[SecurityPatchApplication]
	WHERE	ApplicationID = @ApplicationID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchApplicationGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchApplicationGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchApplicationGetAll]
AS
	SELECT	ApplicationID,
		Description,
		Selected,
		Visible
	FROM	[dbo].[SecurityPatchApplication]
	ORDER BY ApplicationID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchApplicationAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchApplicationAdd]
GO
CREATE PROCEDURE [dbo].[SecurityPatchApplicationAdd]
	@ApplicationID		int,
	@Description		nvarchar(128),
	@Selected		bit,
	@Visible		bit
AS
	INSERT INTO  dbo.SecurityPatchApplication (
		ApplicationID,
		Description,
		Selected,
		Visible
	)
	VALUES (
		@ApplicationID,
		@Description,
		@Selected,
		@Visible
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchApplicationSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchApplicationSchema]
GO
CREATE PROCEDURE [dbo].[SecurityPatchApplicationSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecurityPatchApplication'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecurityPatchApplication (' + CAST(0x0A AS CHAR(1)) +
	'		ApplicationID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Description		nvarchar(128) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Selected		bit NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Visible			bit NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecurityPatchApplication' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchApplicationTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchApplicationTempAdd]
GO
CREATE PROCEDURE dbo.[SecurityPatchApplicationTempAdd]
	@ApplicationID		int,
	@Description		nvarchar(128),
	@Selected		bit,
	@Visible		bit
AS
	INSERT INTO #SecurityPatchApplication (
		ApplicationID,
		Description,
		Selected,
		Visible
	)
	VALUES (
		@ApplicationID,
		@Description,
		@Selected,
		@Visible
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchApplicationAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchApplicationAddBatch]
GO
CREATE PROCEDURE dbo.[SecurityPatchApplicationAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecurityPatchApplication (
		ApplicationID,
		Description,
		Selected,
		Visible
	)
		SELECT	ApplicationID,
			Description,
			Selected,
			Visible
		FROM #SecurityPatchApplication
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchApplication	-- Drop temporary table
	RETURN @count
GO

/*
Add new SecurityPatchApplication bound to
	SecurityPatchUIProductGroup using Product with GroupName
	with Description, Selected, Visible
*/

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchApplicationUpdateByApplicationID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchApplicationUpdateByApplicationID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchApplicationUpdateByApplicationID]
	@ApplicationID		int,
	@Description		nvarchar(128),
	@Selected		bit,
	@Visible		bit
AS
	UPDATE	[dbo].[SecurityPatchApplication]
	SET	Description = @Description,
		Selected = @Selected,
		Visible = @Visible
	WHERE	ApplicationID = @ApplicationID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchApplicationUpdateBatchByApplicationID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchApplicationUpdateBatchByApplicationID]
GO
CREATE PROCEDURE dbo.[SecurityPatchApplicationUpdateBatchByApplicationID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityPatchApplicationApplicationID]
		ON #SecurityPatchApplication (ApplicationID)

	UPDATE	[dbo].[SecurityPatchApplication]
	SET	Description = t.Description,
		Selected = t.Selected,
		Visible = t.Visible
	FROM	#SecurityPatchApplication AS t
	WHERE	SecurityPatchApplication.ApplicationID = t.ApplicationID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityPatchApplication	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchApplicationPutByApplicationID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchApplicationPutByApplicationID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchApplicationPutByApplicationID]
	@ApplicationID		int,
	@Description		nvarchar(128),
	@Selected		bit,
	@Visible		bit
AS
	IF NOT EXISTS(
		SELECT	1
		FROM	dbo.SecurityPatchApplication
		WHERE	ApplicationID = @ApplicationID
	)
		EXEC SecurityPatchApplicationAdd @ApplicationID,
			@Description,
			@Selected,
			@Visible
	ELSE
		EXEC SecurityPatchApplicationUpdateByApplicationID @ApplicationID,
			@Description,
			@Selected,
			@Visible
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchApplicationPutBatchByApplicationID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchApplicationPutBatchByApplicationID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchApplicationPutBatchByApplicationID]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecurityPatchApplicationApplicationID]
		ON #SecurityPatchApplication (ApplicationID)

	BEGIN TRANSACTION
	UPDATE [dbo].[SecurityPatchApplication]
		SET	Description = t.Description,
			Selected = t.Selected,
			Visible = t.Visible
		FROM	#SecurityPatchApplication AS t
		WHERE	SecurityPatchApplication.ApplicationID = t.ApplicationID
	SET @count = @@ROWCOUNT

	INSERT [dbo].[SecurityPatchApplication] (
		ApplicationID,
		Description,
		Selected,
		Visible
	)
		SELECT	ApplicationID,
			Description,
			Selected,
			Visible
		FROM	#SecurityPatchApplication AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecurityPatchApplication]
			WHERE	SecurityPatchApplication.ApplicationID = t.ApplicationID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecurityPatchApplication	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchApplicationRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchApplicationRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecurityPatchApplicationRemoveBatch]
AS

	CREATE INDEX [TempSecurityPatchApplicationSecurityPatchApplicationRemoveBatch]
		ON #SecurityPatchApplication (ApplicationID)	

	-- Delete records from SecurityPatchApplication identified by fields of [TempSecurityPatchApplicationSecurityPatchApplicationRemoveBatch]
	DELETE [dbo].[SecurityPatchApplication]
	WHERE EXISTS(
			SELECT * FROM #SecurityPatchApplication AS t
			WHERE	SecurityPatchApplication.ApplicationID = t.ApplicationID
		)
	DROP TABLE #SecurityPatchApplication      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchApplicationRemoveByApplicationID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchApplicationRemoveByApplicationID]
GO
CREATE PROCEDURE [dbo].[SecurityPatchApplicationRemoveByApplicationID]
	@ApplicationID		int
AS
	DELETE	[dbo].[SecurityPatchApplication]
	WHERE	ApplicationID = @ApplicationID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityPatchApplicationRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityPatchApplicationRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecurityPatchApplicationRemoveAll]
	
AS
	DELETE	[dbo].[SecurityPatchApplication]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAutomationTaskGetByScheduleID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAutomationTaskGetByScheduleID]
GO
CREATE PROCEDURE [dbo].[SecurityAutomationTaskGetByScheduleID]
	@ScheduleID		int
AS
	SELECT	ScheduleID,
		TaskName,
		GroupID,
		GroupName,
		ATPDelay,
		DelayDays,
		[Order],
		IsSyncTask
	FROM	[dbo].[SecurityAutomationTask]
	WHERE	ScheduleID = @ScheduleID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAutomationTaskGetByTaskName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAutomationTaskGetByTaskName]
GO
CREATE PROCEDURE [dbo].[SecurityAutomationTaskGetByTaskName]
	@TaskName		nvarchar(128)
AS
	SELECT	ScheduleID,
		TaskName,
		GroupID,
		GroupName,
		ATPDelay,
		DelayDays,
		[Order],
		IsSyncTask
	FROM	[dbo].[SecurityAutomationTask]
	WHERE	TaskName = @TaskName
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAutomationTaskGetAllOrderedByTaskName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAutomationTaskGetAllOrderedByTaskName]
GO
CREATE PROCEDURE [dbo].[SecurityAutomationTaskGetAllOrderedByTaskName]
AS
	SELECT	ScheduleID,
		TaskName,
		GroupID,
		GroupName,
		ATPDelay,
		DelayDays,
		[Order],
		IsSyncTask
	FROM	[dbo].[SecurityAutomationTask]
	ORDER BY TaskName
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAutomationTaskGetAllByGroupID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAutomationTaskGetAllByGroupID]
GO
CREATE PROCEDURE [dbo].[SecurityAutomationTaskGetAllByGroupID]
	@GroupID		nvarchar(128)
AS
	SELECT	ScheduleID,
		TaskName,
		GroupID,
		GroupName,
		ATPDelay,
		DelayDays,
		[Order],
		IsSyncTask
	FROM	[dbo].[SecurityAutomationTask]
	WHERE	GroupID = @GroupID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAutomationTaskGetAllOrderedByGroupID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAutomationTaskGetAllOrderedByGroupID]
GO
CREATE PROCEDURE [dbo].[SecurityAutomationTaskGetAllOrderedByGroupID]
AS
	SELECT	ScheduleID,
		TaskName,
		GroupID,
		GroupName,
		ATPDelay,
		DelayDays,
		[Order],
		IsSyncTask
	FROM	[dbo].[SecurityAutomationTask]
	ORDER BY GroupID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAutomationTaskGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAutomationTaskGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityAutomationTaskGetAll]
AS
	SELECT	ScheduleID,
		TaskName,
		GroupID,
		GroupName,
		ATPDelay,
		DelayDays,
		[Order],
		IsSyncTask
	FROM	[dbo].[SecurityAutomationTask]
	ORDER BY ScheduleID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAutomationTaskAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAutomationTaskAdd]
GO
CREATE PROCEDURE [dbo].[SecurityAutomationTaskAdd]
	@TaskName		nvarchar(128),
	@GroupID		nvarchar(128),
	@GroupName		nvarchar(128),
	@ATPDelay		int,
	@DelayDays		int,
	@Order			int,
	@IsSyncTask		bit
AS
	INSERT INTO  dbo.SecurityAutomationTask (
		TaskName,
		GroupID,
		GroupName,
		ATPDelay,
		DelayDays,
		[Order],
		IsSyncTask
	)
	VALUES (
		@TaskName,
		@GroupID,
		@GroupName,
		@ATPDelay,
		@DelayDays,
		@Order,
		@IsSyncTask
	)
	RETURN SCOPE_IDENTITY()
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAutomationTaskBind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAutomationTaskBind]
GO
CREATE PROCEDURE [dbo].[SecurityAutomationTaskBind]
	@TaskName		nvarchar(128),
	@GroupID		nvarchar(128),
	@GroupName		nvarchar(128),
	@ATPDelay		int,
	@DelayDays		int,
	@Order			int,
	@IsSyncTask		bit
AS
	DECLARE	@ID	int

	SELECT	@ID = ScheduleID
	FROM	[dbo].[SecurityAutomationTask]
	WHERE	TaskName = @TaskName

	IF @ID IS NULL
		EXEC @ID = SecurityAutomationTaskAdd @TaskName,
			@GroupID,
			@GroupName,
			@ATPDelay,
			@DelayDays,
			@Order,
			@IsSyncTask

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAutomationTaskSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAutomationTaskSchema]
GO
CREATE PROCEDURE [dbo].[SecurityAutomationTaskSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecurityAutomationTask'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecurityAutomationTask (' + CAST(0x0A AS CHAR(1)) +
	'		ScheduleID		int NULL,' + CAST(0x0A AS CHAR(1)) +
	'		TaskName		nvarchar(128) COLLATE Latin1_General_CS_AS NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		GroupID			nvarchar(128) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		GroupName		nvarchar(128) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		ATPDelay		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		DelayDays		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		[Order]			int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		IsSyncTask		bit NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecurityAutomationTask' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAutomationTaskTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAutomationTaskTempAdd]
GO
CREATE PROCEDURE dbo.[SecurityAutomationTaskTempAdd]
	@ScheduleID		int,
	@TaskName		nvarchar(128),
	@GroupID		nvarchar(128),
	@GroupName		nvarchar(128),
	@ATPDelay		int,
	@DelayDays		int,
	@Order			int,
	@IsSyncTask		bit
AS
	INSERT INTO #SecurityAutomationTask (
		ScheduleID,
		TaskName,
		GroupID,
		GroupName,
		ATPDelay,
		DelayDays,
		[Order],
		IsSyncTask
	)
	VALUES (
		@ScheduleID,
		@TaskName,
		@GroupID,
		@GroupName,
		@ATPDelay,
		@DelayDays,
		@Order,
		@IsSyncTask
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAutomationTaskAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAutomationTaskAddBatch]
GO
CREATE PROCEDURE dbo.[SecurityAutomationTaskAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecurityAutomationTask (
		TaskName,
		GroupID,
		GroupName,
		ATPDelay,
		DelayDays,
		[Order],
		IsSyncTask
	)
		SELECT	TaskName,
			GroupID,
			GroupName,
			ATPDelay,
			DelayDays,
			[Order],
			IsSyncTask
		FROM #SecurityAutomationTask
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityAutomationTask	-- Drop temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAutomationTaskUpdateByScheduleID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAutomationTaskUpdateByScheduleID]
GO
CREATE PROCEDURE [dbo].[SecurityAutomationTaskUpdateByScheduleID]
	@ScheduleID		int,
	@TaskName		nvarchar(128),
	@GroupID		nvarchar(128),
	@GroupName		nvarchar(128),
	@ATPDelay		int,
	@DelayDays		int,
	@Order			int,
	@IsSyncTask		bit
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[SecurityAutomationTask]
	SET	@ID = ScheduleID,
		TaskName = @TaskName,
		GroupID = @GroupID,
		GroupName = @GroupName,
		ATPDelay = @ATPDelay,
		DelayDays = @DelayDays,
		[Order] = @Order,
		IsSyncTask = @IsSyncTask
	WHERE	ScheduleID = @ScheduleID
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAutomationTaskUpdateBatchByScheduleID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAutomationTaskUpdateBatchByScheduleID]
GO
CREATE PROCEDURE dbo.[SecurityAutomationTaskUpdateBatchByScheduleID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityAutomationTaskScheduleID]
		ON #SecurityAutomationTask (ScheduleID)

	UPDATE	[dbo].[SecurityAutomationTask]
	SET	TaskName = t.TaskName,
		GroupID = t.GroupID,
		GroupName = t.GroupName,
		ATPDelay = t.ATPDelay,
		DelayDays = t.DelayDays,
		[Order] = t.[Order],
		IsSyncTask = t.IsSyncTask
	FROM	#SecurityAutomationTask AS t
	WHERE	SecurityAutomationTask.ScheduleID = t.ScheduleID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityAutomationTask	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAutomationTaskUpdateByTaskName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAutomationTaskUpdateByTaskName]
GO
CREATE PROCEDURE [dbo].[SecurityAutomationTaskUpdateByTaskName]
	@TaskName		nvarchar(128),
	@GroupID		nvarchar(128),
	@GroupName		nvarchar(128),
	@ATPDelay		int,
	@DelayDays		int,
	@Order			int,
	@IsSyncTask		bit
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[SecurityAutomationTask]
	SET	@ID = ScheduleID,
		GroupID = @GroupID,
		GroupName = @GroupName,
		ATPDelay = @ATPDelay,
		DelayDays = @DelayDays,
		[Order] = @Order,
		IsSyncTask = @IsSyncTask
	WHERE	TaskName = @TaskName
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAutomationTaskUpdateBatchByTaskName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAutomationTaskUpdateBatchByTaskName]
GO
CREATE PROCEDURE dbo.[SecurityAutomationTaskUpdateBatchByTaskName]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityAutomationTaskTaskName]
		ON #SecurityAutomationTask (TaskName)

	UPDATE	[dbo].[SecurityAutomationTask]
	SET	GroupID = t.GroupID,
		GroupName = t.GroupName,
		ATPDelay = t.ATPDelay,
		DelayDays = t.DelayDays,
		[Order] = t.[Order],
		IsSyncTask = t.IsSyncTask
	FROM	#SecurityAutomationTask AS t
	WHERE	SecurityAutomationTask.TaskName = t.TaskName
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityAutomationTask	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAutomationTaskPutByTaskName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAutomationTaskPutByTaskName]
GO
CREATE PROCEDURE [dbo].[SecurityAutomationTaskPutByTaskName]
	@TaskName		nvarchar(128),
	@GroupID		nvarchar(128),
	@GroupName		nvarchar(128),
	@ATPDelay		int,
	@DelayDays		int,
	@Order			int,
	@IsSyncTask		bit
AS
	DECLARE @ID	int

	SELECT	@ID = ScheduleID
	FROM	SecurityAutomationTask
	WHERE	TaskName = @TaskName

	IF @ID IS NULL
		EXEC @ID = SecurityAutomationTaskAdd @TaskName,
			@GroupID,
			@GroupName,
			@ATPDelay,
			@DelayDays,
			@Order,
			@IsSyncTask
	ELSE
		EXEC SecurityAutomationTaskUpdateByTaskName @TaskName,
			@GroupID,
			@GroupName,
			@ATPDelay,
			@DelayDays,
			@Order,
			@IsSyncTask

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAutomationTaskPutBatchByTaskName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAutomationTaskPutBatchByTaskName]
GO
CREATE PROCEDURE [dbo].[SecurityAutomationTaskPutBatchByTaskName]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecurityAutomationTaskTaskName]
		ON #SecurityAutomationTask (TaskName)

	BEGIN TRANSACTION
	UPDATE [dbo].[SecurityAutomationTask]
		SET	GroupID = t.GroupID,
			GroupName = t.GroupName,
			ATPDelay = t.ATPDelay,
			DelayDays = t.DelayDays,
			[Order] = t.[Order],
			IsSyncTask = t.IsSyncTask
		FROM	#SecurityAutomationTask AS t
		WHERE	SecurityAutomationTask.TaskName = t.TaskName
	SET @count = @@ROWCOUNT

	INSERT [dbo].[SecurityAutomationTask] (
		TaskName,
		GroupID,
		GroupName,
		ATPDelay,
		DelayDays,
		[Order],
		IsSyncTask
	)
		SELECT	TaskName,
			GroupID,
			GroupName,
			ATPDelay,
			DelayDays,
			[Order],
			IsSyncTask
		FROM	#SecurityAutomationTask AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecurityAutomationTask]
			WHERE	SecurityAutomationTask.TaskName = t.TaskName
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecurityAutomationTask	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAutomationTaskRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAutomationTaskRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecurityAutomationTaskRemoveBatch]
AS

	CREATE INDEX [TempSecurityAutomationTaskSecurityAutomationTaskRemoveBatch]
		ON #SecurityAutomationTask (ScheduleID)	

	-- Delete records from SecurityAutomationTask identified by fields of [TempSecurityAutomationTaskSecurityAutomationTaskRemoveBatch]
	DELETE [dbo].[SecurityAutomationTask]
	WHERE EXISTS(
			SELECT * FROM #SecurityAutomationTask AS t
			WHERE	SecurityAutomationTask.ScheduleID = t.ScheduleID
		)
	DROP TABLE #SecurityAutomationTask      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAutomationTaskRemoveByTaskName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAutomationTaskRemoveByTaskName]
GO
CREATE PROCEDURE [dbo].[SecurityAutomationTaskRemoveByTaskName]
	@TaskName		nvarchar(128)
AS
	DELETE	[dbo].[SecurityAutomationTask]
	WHERE	TaskName = @TaskName
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAutomationTaskRemoveAllByGroupID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAutomationTaskRemoveAllByGroupID]
GO
CREATE PROCEDURE [dbo].[SecurityAutomationTaskRemoveAllByGroupID]
	@GroupID		nvarchar(128)
AS
	DELETE	[dbo].[SecurityAutomationTask]
	WHERE	GroupID = @GroupID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityAutomationTaskRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityAutomationTaskRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecurityAutomationTaskRemoveAll]
	
AS
	DELETE	[dbo].[SecurityAutomationTask]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinChangeGetByBulletinIDChangeTypeID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinChangeGetByBulletinIDChangeTypeID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinChangeGetByBulletinIDChangeTypeID]
	@BulletinID		nvarchar(32),
	@ChangeTypeID		int
AS
	SELECT	BulletinID,
		ChangeTypeID
	FROM	[dbo].[SecurityBulletinChange]
	WHERE	BulletinID = @BulletinID
	  AND	ChangeTypeID = @ChangeTypeID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinChangeGetAllByBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinChangeGetAllByBulletinID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinChangeGetAllByBulletinID]
	@BulletinID		nvarchar(32)
AS
	SELECT	BulletinID,
		ChangeTypeID
	FROM	[dbo].[SecurityBulletinChange]
	WHERE	BulletinID = @BulletinID
	ORDER BY ChangeTypeID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinChangeGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinChangeGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinChangeGetAll]
AS
	SELECT	BulletinID,
		ChangeTypeID
	FROM	[dbo].[SecurityBulletinChange]
	ORDER BY BulletinID, ChangeTypeID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinChangeAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinChangeAdd]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinChangeAdd]
	@BulletinID		nvarchar(32),
	@ChangeTypeID		int
AS
	INSERT INTO  dbo.SecurityBulletinChange (
		BulletinID,
		ChangeTypeID
	)
	VALUES (
		@BulletinID,
		@ChangeTypeID
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinChangeSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinChangeSchema]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinChangeSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecurityBulletinChange'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecurityBulletinChange (' + CAST(0x0A AS CHAR(1)) +
	'		BulletinID		nvarchar(32) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		ChangeTypeID		int NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecurityBulletinChange' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinChangeTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinChangeTempAdd]
GO
CREATE PROCEDURE dbo.[SecurityBulletinChangeTempAdd]
	@BulletinID		nvarchar(32),
	@ChangeTypeID		int
AS
	INSERT INTO #SecurityBulletinChange (
		BulletinID,
		ChangeTypeID
	)
	VALUES (
		@BulletinID,
		@ChangeTypeID
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinChangeAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinChangeAddBatch]
GO
CREATE PROCEDURE dbo.[SecurityBulletinChangeAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecurityBulletinChange (
		BulletinID,
		ChangeTypeID
	)
		SELECT	BulletinID,
			ChangeTypeID
		FROM #SecurityBulletinChange
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityBulletinChange	-- Drop temporary table
	RETURN @count
GO

/*
Add new SecurityBulletinChange bound to
	SecurityBulletinChangeType using Description
	with BulletinID
*/

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinChangePutByBulletinIDChangeTypeID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinChangePutByBulletinIDChangeTypeID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinChangePutByBulletinIDChangeTypeID]
	@BulletinID		nvarchar(32),
	@ChangeTypeID		int
AS
	IF NOT EXISTS(
		SELECT	1
		FROM	dbo.SecurityBulletinChange
		WHERE	BulletinID = @BulletinID
		  AND	ChangeTypeID = @ChangeTypeID
	)
		EXEC SecurityBulletinChangeAdd @BulletinID,
			@ChangeTypeID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinChangePutBatchByBulletinIDChangeTypeID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinChangePutBatchByBulletinIDChangeTypeID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinChangePutBatchByBulletinIDChangeTypeID]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecurityBulletinChangeBulletinIDChangeTypeID]
		ON #SecurityBulletinChange (BulletinID, ChangeTypeID)

	BEGIN TRANSACTION

	INSERT [dbo].[SecurityBulletinChange] (
		BulletinID,
		ChangeTypeID
	)
		SELECT	BulletinID,
			ChangeTypeID
		FROM	#SecurityBulletinChange AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecurityBulletinChange]
			WHERE	SecurityBulletinChange.BulletinID = t.BulletinID
			  AND	SecurityBulletinChange.ChangeTypeID = t.ChangeTypeID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecurityBulletinChange	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinChangeRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinChangeRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecurityBulletinChangeRemoveBatch]
AS

	CREATE INDEX [TempSecurityBulletinChangeSecurityBulletinChangeRemoveBatch]
		ON #SecurityBulletinChange (BulletinID, ChangeTypeID)	

	-- Delete records from SecurityBulletinChange identified by fields of [TempSecurityBulletinChangeSecurityBulletinChangeRemoveBatch]
	DELETE [dbo].[SecurityBulletinChange]
	WHERE EXISTS(
			SELECT * FROM #SecurityBulletinChange AS t
			WHERE	SecurityBulletinChange.BulletinID = t.BulletinID
			  AND	SecurityBulletinChange.ChangeTypeID = t.ChangeTypeID
		)
	DROP TABLE #SecurityBulletinChange      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinChangeRemoveByBulletinIDChangeTypeID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinChangeRemoveByBulletinIDChangeTypeID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinChangeRemoveByBulletinIDChangeTypeID]
	@BulletinID		nvarchar(32),
	@ChangeTypeID		int
AS
	DELETE	[dbo].[SecurityBulletinChange]
	WHERE	BulletinID = @BulletinID
	  AND	ChangeTypeID = @ChangeTypeID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinChangeRemoveAllByBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinChangeRemoveAllByBulletinID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinChangeRemoveAllByBulletinID]
	@BulletinID		nvarchar(32)
AS
	DELETE	[dbo].[SecurityBulletinChange]
	WHERE	BulletinID = @BulletinID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinChangeRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinChangeRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinChangeRemoveAll]
	
AS
	DELETE	[dbo].[SecurityBulletinChange]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinChangeReplaceSubsetByBulletinID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinChangeReplaceSubsetByBulletinID]
GO
-- Replace the record subset selected by (@BulletinID)
-- using unique identifier (BulletinID, ChangeTypeID)
CREATE PROCEDURE [dbo].[SecurityBulletinChangeReplaceSubsetByBulletinID]
	@BulletinID		nvarchar(32)
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecurityBulletinChangeByBulletinID]
		ON #SecurityBulletinChange (BulletinID, ChangeTypeID)

	BEGIN TRANSACTION
	DELETE [SecurityBulletinChange]
		WHERE	BulletinID = @BulletinID
		AND NOT EXISTS(		-- Replacement record doesn't exist
			SELECT * FROM #SecurityBulletinChange AS t
			WHERE	SecurityBulletinChange.BulletinID = t.BulletinID
			  AND	SecurityBulletinChange.ChangeTypeID = t.ChangeTypeID
		)

	INSERT [SecurityBulletinChange] (
		BulletinID,
		ChangeTypeID
	)
		SELECT	BulletinID,
			ChangeTypeID
		FROM	#SecurityBulletinChange AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [SecurityBulletinChange]
			WHERE	SecurityBulletinChange.BulletinID = t.BulletinID
			  AND	SecurityBulletinChange.ChangeTypeID = t.ChangeTypeID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecurityBulletinChange	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinChangeTypeGetByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinChangeTypeGetByID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinChangeTypeGetByID]
	@SecurityBulletinChangeTypeID int
AS
	SELECT	SecurityBulletinChangeTypeID,
		Description
	FROM	[dbo].[SecurityBulletinChangeType]
	WHERE	SecurityBulletinChangeTypeID = @SecurityBulletinChangeTypeID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinChangeTypeGetByDescription]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinChangeTypeGetByDescription]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinChangeTypeGetByDescription]
	@Description		nvarchar(64)
AS
	SELECT	SecurityBulletinChangeTypeID,
		Description
	FROM	[dbo].[SecurityBulletinChangeType]
	WHERE	Description = @Description
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinChangeTypeGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinChangeTypeGetAll]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinChangeTypeGetAll]
AS
	SELECT	SecurityBulletinChangeTypeID,
		Description
	FROM	[dbo].[SecurityBulletinChangeType]
	ORDER BY SecurityBulletinChangeTypeID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinChangeTypeAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinChangeTypeAdd]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinChangeTypeAdd]
	@Description		nvarchar(64)
AS
	INSERT INTO  dbo.SecurityBulletinChangeType (
		Description
	)
	VALUES (
		@Description
	)
	RETURN SCOPE_IDENTITY()
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinChangeTypeBind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinChangeTypeBind]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinChangeTypeBind]
	@Description		nvarchar(64)
AS
	DECLARE	@ID	int

	SELECT	@ID = SecurityBulletinChangeTypeID
	FROM	[dbo].[SecurityBulletinChangeType]
	WHERE	Description = @Description

	IF @ID IS NULL
		EXEC @ID = SecurityBulletinChangeTypeAdd @Description

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinChangeTypeSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinChangeTypeSchema]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinChangeTypeSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#SecurityBulletinChangeType'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #SecurityBulletinChangeType (' + CAST(0x0A AS CHAR(1)) +
	'		SecurityBulletinChangeTypeID int NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Description		nvarchar(64) COLLATE database_default NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #SecurityBulletinChangeType' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinChangeTypeTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinChangeTypeTempAdd]
GO
CREATE PROCEDURE dbo.[SecurityBulletinChangeTypeTempAdd]
	@SecurityBulletinChangeTypeID int,
	@Description		nvarchar(64)
AS
	INSERT INTO #SecurityBulletinChangeType (
		SecurityBulletinChangeTypeID,
		Description
	)
	VALUES (
		@SecurityBulletinChangeTypeID,
		@Description
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinChangeTypeAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinChangeTypeAddBatch]
GO
CREATE PROCEDURE dbo.[SecurityBulletinChangeTypeAddBatch]
AS
	DECLARE @count int
	INSERT dbo.SecurityBulletinChangeType (
		Description
	)
		SELECT	Description
		FROM #SecurityBulletinChangeType
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityBulletinChangeType	-- Drop temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinChangeTypeUpdateByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinChangeTypeUpdateByID]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinChangeTypeUpdateByID]
	@SecurityBulletinChangeTypeID int,
	@Description		nvarchar(64)
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[SecurityBulletinChangeType]
	SET	@ID = SecurityBulletinChangeTypeID,
		Description = @Description
	WHERE	SecurityBulletinChangeTypeID = @SecurityBulletinChangeTypeID
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinChangeTypeUpdateBatchByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinChangeTypeUpdateBatchByID]
GO
CREATE PROCEDURE dbo.[SecurityBulletinChangeTypeUpdateBatchByID]
AS
	DECLARE @count int

	CREATE INDEX [TempSecurityBulletinChangeTypeID]
		ON #SecurityBulletinChangeType (SecurityBulletinChangeTypeID)

	UPDATE	[dbo].[SecurityBulletinChangeType]
	SET	Description = t.Description
	FROM	#SecurityBulletinChangeType AS t
	WHERE	SecurityBulletinChangeType.SecurityBulletinChangeTypeID = t.SecurityBulletinChangeTypeID
	SET @count = @@ROWCOUNT
	DROP TABLE #SecurityBulletinChangeType	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinChangeTypePutByDescription]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinChangeTypePutByDescription]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinChangeTypePutByDescription]
	@Description		nvarchar(64)
AS
	DECLARE @ID	int

	SELECT	@ID = SecurityBulletinChangeTypeID
	FROM	SecurityBulletinChangeType
	WHERE	Description = @Description

	IF @ID IS NULL
		EXEC @ID = SecurityBulletinChangeTypeAdd @Description

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinChangeTypePutBatchByDescription]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinChangeTypePutBatchByDescription]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinChangeTypePutBatchByDescription]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempSecurityBulletinChangeTypeDescription]
		ON #SecurityBulletinChangeType (Description)

	BEGIN TRANSACTION

	INSERT [dbo].[SecurityBulletinChangeType] (
		Description
	)
		SELECT	Description
		FROM	#SecurityBulletinChangeType AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[SecurityBulletinChangeType]
			WHERE	SecurityBulletinChangeType.Description = t.Description
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #SecurityBulletinChangeType	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinChangeTypeRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinChangeTypeRemoveBatch]
GO

CREATE PROCEDURE [dbo].[SecurityBulletinChangeTypeRemoveBatch]
AS

	CREATE INDEX [TempSecurityBulletinChangeTypeSecurityBulletinChangeTypeRemoveBatch]
		ON #SecurityBulletinChangeType (SecurityBulletinChangeTypeID)	

	-- Delete records from SecurityBulletinChangeType identified by fields of [TempSecurityBulletinChangeTypeSecurityBulletinChangeTypeRemoveBatch]
	DELETE [dbo].[SecurityBulletinChangeType]
	WHERE EXISTS(
			SELECT * FROM #SecurityBulletinChangeType AS t
			WHERE	SecurityBulletinChangeType.SecurityBulletinChangeTypeID = t.SecurityBulletinChangeTypeID
		)
	DROP TABLE #SecurityBulletinChangeType      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinChangeTypeRemoveByDescription]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinChangeTypeRemoveByDescription]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinChangeTypeRemoveByDescription]
	@Description		nvarchar(64)
AS
	-- SecurityBulletinChangeType deletes cascade to:
	--	SecurityBulletinChange by FK_SecurityBulletinChange_SecurityBulletinChangeType
	DELETE	[dbo].[SecurityBulletinChangeType]
	WHERE	Description = @Description
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[SecurityBulletinChangeTypeRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SecurityBulletinChangeTypeRemoveAll]
GO
CREATE PROCEDURE [dbo].[SecurityBulletinChangeTypeRemoveAll]
	
AS
	DELETE	[dbo].[SecurityBulletinChangeType]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatTypeGetByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatTypeGetByName]
GO
CREATE PROCEDURE [dbo].[ThreatTypeGetByName]
	@Name			nvarchar(64)
AS
	SELECT	ThreatTypeID,
		[Name]
	FROM	[dbo].[ThreatType]
	WHERE	[Name] = @Name
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatTypeGetAllOrderedByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatTypeGetAllOrderedByName]
GO
CREATE PROCEDURE [dbo].[ThreatTypeGetAllOrderedByName]
AS
	SELECT	ThreatTypeID,
		[Name]
	FROM	[dbo].[ThreatType]
	ORDER BY [Name]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatTypeGetByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatTypeGetByID]
GO
CREATE PROCEDURE [dbo].[ThreatTypeGetByID]
	@ThreatTypeID		int
AS
	SELECT	ThreatTypeID,
		[Name]
	FROM	[dbo].[ThreatType]
	WHERE	ThreatTypeID = @ThreatTypeID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatTypeGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatTypeGetAll]
GO
CREATE PROCEDURE [dbo].[ThreatTypeGetAll]
AS
	SELECT	ThreatTypeID,
		[Name]
	FROM	[dbo].[ThreatType]
	ORDER BY ThreatTypeID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatTypeBind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatTypeBind]
GO
CREATE PROCEDURE [dbo].[ThreatTypeBind]
	@Name			nvarchar(64)
AS
	DECLARE	@ID	int

	SELECT	@ID = ThreatTypeID
	FROM	[dbo].[ThreatType]
	WHERE	[Name] = @Name

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatCategoryGetByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatCategoryGetByName]
GO
CREATE PROCEDURE [dbo].[ThreatCategoryGetByName]
	@Name			nvarchar(64)
AS
	SELECT	ThreatCategoryID,
		[Name],
		ThreatTypeID
	FROM	[dbo].[ThreatCategory]
	WHERE	[Name] = @Name
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatCategoryGetAllOrderedByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatCategoryGetAllOrderedByName]
GO
CREATE PROCEDURE [dbo].[ThreatCategoryGetAllOrderedByName]
AS
	SELECT	ThreatCategoryID,
		[Name],
		ThreatTypeID
	FROM	[dbo].[ThreatCategory]
	ORDER BY [Name]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatCategoryGetByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatCategoryGetByID]
GO
CREATE PROCEDURE [dbo].[ThreatCategoryGetByID]
	@ThreatCategoryID	int
AS
	SELECT	ThreatCategoryID,
		[Name],
		ThreatTypeID
	FROM	[dbo].[ThreatCategory]
	WHERE	ThreatCategoryID = @ThreatCategoryID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatCategoryGetAllByThreatTypeID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatCategoryGetAllByThreatTypeID]
GO
CREATE PROCEDURE [dbo].[ThreatCategoryGetAllByThreatTypeID]
	@ThreatTypeID		int
AS
	SELECT	ThreatCategoryID,
		[Name],
		ThreatTypeID
	FROM	[dbo].[ThreatCategory]
	WHERE	ThreatTypeID = @ThreatTypeID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatCategoryGetAllOrderedByThreatTypeID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatCategoryGetAllOrderedByThreatTypeID]
GO
CREATE PROCEDURE [dbo].[ThreatCategoryGetAllOrderedByThreatTypeID]
AS
	SELECT	ThreatCategoryID,
		[Name],
		ThreatTypeID
	FROM	[dbo].[ThreatCategory]
	ORDER BY ThreatTypeID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatCategoryGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatCategoryGetAll]
GO
CREATE PROCEDURE [dbo].[ThreatCategoryGetAll]
AS
	SELECT	ThreatCategoryID,
		[Name],
		ThreatTypeID
	FROM	[dbo].[ThreatCategory]
	ORDER BY ThreatCategoryID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatCategoryAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatCategoryAdd]
GO
CREATE PROCEDURE [dbo].[ThreatCategoryAdd]
	@Name			nvarchar(64),
	@ThreatTypeID		int
AS
	INSERT INTO  dbo.ThreatCategory (
		[Name],
		ThreatTypeID
	)
	VALUES (
		@Name,
		@ThreatTypeID
	)
	RETURN SCOPE_IDENTITY()
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatCategoryBind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatCategoryBind]
GO
CREATE PROCEDURE [dbo].[ThreatCategoryBind]
	@Name			nvarchar(64),
	@ThreatTypeID		int
AS
	DECLARE	@ID	int

	SELECT	@ID = ThreatCategoryID
	FROM	[dbo].[ThreatCategory]
	WHERE	[Name] = @Name

	IF @ID IS NULL
		EXEC @ID = ThreatCategoryAdd @Name,
			@ThreatTypeID

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatCategorySchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatCategorySchema]
GO
CREATE PROCEDURE [dbo].[ThreatCategorySchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#ThreatCategory'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #ThreatCategory (' + CAST(0x0A AS CHAR(1)) +
	'		ThreatCategoryID	int NULL,' + CAST(0x0A AS CHAR(1)) +
	'		[Name]			nvarchar(64) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		ThreatTypeID		int NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #ThreatCategory' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatCategoryTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatCategoryTempAdd]
GO
CREATE PROCEDURE dbo.[ThreatCategoryTempAdd]
	@ThreatCategoryID	int,
	@Name			nvarchar(64),
	@ThreatTypeID		int
AS
	INSERT INTO #ThreatCategory (
		ThreatCategoryID,
		[Name],
		ThreatTypeID
	)
	VALUES (
		@ThreatCategoryID,
		@Name,
		@ThreatTypeID
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatCategoryAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatCategoryAddBatch]
GO
CREATE PROCEDURE dbo.[ThreatCategoryAddBatch]
AS
	DECLARE @count int
	INSERT dbo.ThreatCategory (
		[Name],
		ThreatTypeID
	)
		SELECT	[Name],
			ThreatTypeID
		FROM #ThreatCategory
	SET @count = @@ROWCOUNT
	DROP TABLE #ThreatCategory	-- Drop temporary table
	RETURN @count
GO

/*
Add new ThreatCategory bound to
	ThreatType using Name
	with Name
*/

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatCategoryUpdateByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatCategoryUpdateByID]
GO
CREATE PROCEDURE [dbo].[ThreatCategoryUpdateByID]
	@ThreatCategoryID	int,
	@Name			nvarchar(64),
	@ThreatTypeID		int
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[ThreatCategory]
	SET	@ID = ThreatCategoryID,
		[Name] = @Name,
		ThreatTypeID = @ThreatTypeID
	WHERE	ThreatCategoryID = @ThreatCategoryID
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatCategoryUpdateBatchByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatCategoryUpdateBatchByID]
GO
CREATE PROCEDURE dbo.[ThreatCategoryUpdateBatchByID]
AS
	DECLARE @count int

	CREATE INDEX [TempThreatCategoryID]
		ON #ThreatCategory (ThreatCategoryID)

	UPDATE	[dbo].[ThreatCategory]
	SET	[Name] = t.[Name],
		ThreatTypeID = t.ThreatTypeID
	FROM	#ThreatCategory AS t
	WHERE	ThreatCategory.ThreatCategoryID = t.ThreatCategoryID
	SET @count = @@ROWCOUNT
	DROP TABLE #ThreatCategory	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatCategoryUpdateByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatCategoryUpdateByName]
GO
CREATE PROCEDURE [dbo].[ThreatCategoryUpdateByName]
	@Name			nvarchar(64),
	@ThreatTypeID		int
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[ThreatCategory]
	SET	@ID = ThreatCategoryID,
		ThreatTypeID = @ThreatTypeID
	WHERE	[Name] = @Name
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatCategoryUpdateBatchByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatCategoryUpdateBatchByName]
GO
CREATE PROCEDURE dbo.[ThreatCategoryUpdateBatchByName]
AS
	DECLARE @count int

	CREATE INDEX [TempThreatCategoryName]
		ON #ThreatCategory ([Name])

	UPDATE	[dbo].[ThreatCategory]
	SET	ThreatTypeID = t.ThreatTypeID
	FROM	#ThreatCategory AS t
	WHERE	ThreatCategory.[Name] = t.[Name]
	SET @count = @@ROWCOUNT
	DROP TABLE #ThreatCategory	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatCategoryPutByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatCategoryPutByName]
GO
CREATE PROCEDURE [dbo].[ThreatCategoryPutByName]
	@Name			nvarchar(64),
	@ThreatTypeID		int
AS
	DECLARE @ID	int

	SELECT	@ID = ThreatCategoryID
	FROM	ThreatCategory
	WHERE	[Name] = @Name

	IF @ID IS NULL
		EXEC @ID = ThreatCategoryAdd @Name,
			@ThreatTypeID
	ELSE
		EXEC ThreatCategoryUpdateByName @Name,
			@ThreatTypeID

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatCategoryPutBatchByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatCategoryPutBatchByName]
GO
CREATE PROCEDURE [dbo].[ThreatCategoryPutBatchByName]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempThreatCategoryName]
		ON #ThreatCategory ([Name])

	BEGIN TRANSACTION
	UPDATE [dbo].[ThreatCategory]
		SET	ThreatTypeID = t.ThreatTypeID
		FROM	#ThreatCategory AS t
		WHERE	ThreatCategory.[Name] = t.[Name]
	SET @count = @@ROWCOUNT

	INSERT [dbo].[ThreatCategory] (
		[Name],
		ThreatTypeID
	)
		SELECT	[Name],
			ThreatTypeID
		FROM	#ThreatCategory AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[ThreatCategory]
			WHERE	ThreatCategory.[Name] = t.[Name]
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #ThreatCategory	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatCategoryRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatCategoryRemoveBatch]
GO

CREATE PROCEDURE [dbo].[ThreatCategoryRemoveBatch]
AS

	CREATE INDEX [TempThreatCategoryThreatCategoryRemoveBatch]
		ON #ThreatCategory (ThreatCategoryID)	

	-- Delete records from ThreatCategory identified by fields of [TempThreatCategoryThreatCategoryRemoveBatch]
	DELETE [dbo].[ThreatCategory]
	WHERE EXISTS(
			SELECT * FROM #ThreatCategory AS t
			WHERE	ThreatCategory.ThreatCategoryID = t.ThreatCategoryID
		)
	DROP TABLE #ThreatCategory      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatCategoryRemoveByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatCategoryRemoveByName]
GO
CREATE PROCEDURE [dbo].[ThreatCategoryRemoveByName]
	@Name			nvarchar(64)
AS
	-- ThreatCategory deletes cascade to:
	--	ThreatToCategory by FK_ThreatToCategory_ThreatCategory
	DELETE	[dbo].[ThreatCategory]
	WHERE	[Name] = @Name
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatCategoryRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatCategoryRemoveAll]
GO
CREATE PROCEDURE [dbo].[ThreatCategoryRemoveAll]
	
AS
	DELETE	[dbo].[ThreatCategory]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatActionGetByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatActionGetByName]
GO
CREATE PROCEDURE [dbo].[ThreatActionGetByName]
	@Name			nvarchar(64)
AS
	SELECT	ThreatActionID,
		[Name]
	FROM	[dbo].[ThreatAction]
	WHERE	[Name] = @Name
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatActionGetAllOrderedByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatActionGetAllOrderedByName]
GO
CREATE PROCEDURE [dbo].[ThreatActionGetAllOrderedByName]
AS
	SELECT	ThreatActionID,
		[Name]
	FROM	[dbo].[ThreatAction]
	ORDER BY [Name]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatActionGetByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatActionGetByID]
GO
CREATE PROCEDURE [dbo].[ThreatActionGetByID]
	@ThreatActionID		int
AS
	SELECT	ThreatActionID,
		[Name]
	FROM	[dbo].[ThreatAction]
	WHERE	ThreatActionID = @ThreatActionID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatActionGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatActionGetAll]
GO
CREATE PROCEDURE [dbo].[ThreatActionGetAll]
AS
	SELECT	ThreatActionID,
		[Name]
	FROM	[dbo].[ThreatAction]
	ORDER BY ThreatActionID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatActionBind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatActionBind]
GO
CREATE PROCEDURE [dbo].[ThreatActionBind]
	@Name			nvarchar(64)
AS
	DECLARE	@ID	int

	SELECT	@ID = ThreatActionID
	FROM	[dbo].[ThreatAction]
	WHERE	[Name] = @Name

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatRiskGetByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatRiskGetByName]
GO
CREATE PROCEDURE [dbo].[ThreatRiskGetByName]
	@Name			nvarchar(64)
AS
	SELECT	ThreatRiskID,
		[Name],
		Severity
	FROM	[dbo].[ThreatRisk]
	WHERE	[Name] = @Name
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatRiskGetAllOrderedByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatRiskGetAllOrderedByName]
GO
CREATE PROCEDURE [dbo].[ThreatRiskGetAllOrderedByName]
AS
	SELECT	ThreatRiskID,
		[Name],
		Severity
	FROM	[dbo].[ThreatRisk]
	ORDER BY [Name]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatRiskGetByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatRiskGetByID]
GO
CREATE PROCEDURE [dbo].[ThreatRiskGetByID]
	@ThreatRiskID		int
AS
	SELECT	ThreatRiskID,
		[Name],
		Severity
	FROM	[dbo].[ThreatRisk]
	WHERE	ThreatRiskID = @ThreatRiskID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatRiskGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatRiskGetAll]
GO
CREATE PROCEDURE [dbo].[ThreatRiskGetAll]
AS
	SELECT	ThreatRiskID,
		[Name],
		Severity
	FROM	[dbo].[ThreatRisk]
	ORDER BY ThreatRiskID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatRiskBind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatRiskBind]
GO
CREATE PROCEDURE [dbo].[ThreatRiskBind]
	@Name			nvarchar(64),
	@Severity		int
AS
	DECLARE	@ID	int

	SELECT	@ID = ThreatRiskID
	FROM	[dbo].[ThreatRisk]
	WHERE	[Name] = @Name

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatScannerGetByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatScannerGetByName]
GO
CREATE PROCEDURE [dbo].[ThreatScannerGetByName]
	@Name			nvarchar(128)
AS
	SELECT	ThreatScannerID,
		[Name],
		Title,
		Version,
		Manufacturer
	FROM	[dbo].[ThreatScanner]
	WHERE	[Name] = @Name
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatScannerGetByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatScannerGetByID]
GO
CREATE PROCEDURE [dbo].[ThreatScannerGetByID]
	@ThreatScannerID	int
AS
	SELECT	ThreatScannerID,
		[Name],
		Title,
		Version,
		Manufacturer
	FROM	[dbo].[ThreatScanner]
	WHERE	ThreatScannerID = @ThreatScannerID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatScannerGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatScannerGetAll]
GO
CREATE PROCEDURE [dbo].[ThreatScannerGetAll]
AS
	SELECT	ThreatScannerID,
		[Name],
		Title,
		Version,
		Manufacturer
	FROM	[dbo].[ThreatScanner]
	ORDER BY ThreatScannerID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatScannerBind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatScannerBind]
GO
CREATE PROCEDURE [dbo].[ThreatScannerBind]
	@Name			nvarchar(128),
	@Title			nvarchar(256) = NULL,
	@Version		nvarchar(256) = NULL,
	@Manufacturer		nvarchar(256) = NULL
AS
	DECLARE	@ID	int

	SELECT	@ID = ThreatScannerID
	FROM	[dbo].[ThreatScanner]
	WHERE	[Name] = @Name

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatScannerToTypeGetByThreatScannerIDThreatTypeID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatScannerToTypeGetByThreatScannerIDThreatTypeID]
GO
CREATE PROCEDURE [dbo].[ThreatScannerToTypeGetByThreatScannerIDThreatTypeID]
	@ThreatScannerID	int,
	@ThreatTypeID		int
AS
	SELECT	ThreatScannerID,
		ThreatTypeID
	FROM	[dbo].[ThreatScannerToType]
	WHERE	ThreatScannerID = @ThreatScannerID
	  AND	ThreatTypeID = @ThreatTypeID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatScannerToTypeGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatScannerToTypeGetAll]
GO
CREATE PROCEDURE [dbo].[ThreatScannerToTypeGetAll]
AS
	SELECT	ThreatScannerID,
		ThreatTypeID
	FROM	[dbo].[ThreatScannerToType]
	ORDER BY ThreatScannerID, ThreatTypeID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatGetByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatGetByName]
GO
CREATE PROCEDURE [dbo].[ThreatGetByName]
	@Name			nvarchar(128)
AS
	SELECT	ThreatID,
		[Name],
		Title,
		ThreatTypeID,
		ThreatRiskID,
		CategorySummary,
		State,
		DatePosted,
		Description
	FROM	[dbo].[Threat]
	WHERE	[Name] = @Name
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatGetAllOrderedByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatGetAllOrderedByName]
GO
CREATE PROCEDURE [dbo].[ThreatGetAllOrderedByName]
AS
	SELECT	ThreatID,
		[Name],
		Title,
		ThreatTypeID,
		ThreatRiskID,
		CategorySummary,
		State,
		DatePosted,
		Description
	FROM	[dbo].[Threat]
	ORDER BY [Name]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatGetByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatGetByID]
GO
CREATE PROCEDURE [dbo].[ThreatGetByID]
	@ThreatID		int
AS
	SELECT	ThreatID,
		[Name],
		Title,
		ThreatTypeID,
		ThreatRiskID,
		CategorySummary,
		State,
		DatePosted,
		Description
	FROM	[dbo].[Threat]
	WHERE	ThreatID = @ThreatID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatGetAllByTypeID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatGetAllByTypeID]
GO
CREATE PROCEDURE [dbo].[ThreatGetAllByTypeID]
	@ThreatTypeID		int
AS
	SELECT	ThreatID,
		[Name],
		Title,
		ThreatTypeID,
		ThreatRiskID,
		CategorySummary,
		State,
		DatePosted,
		Description
	FROM	[dbo].[Threat]
	WHERE	ThreatTypeID = @ThreatTypeID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatGetAllOrderedByTypeID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatGetAllOrderedByTypeID]
GO
CREATE PROCEDURE [dbo].[ThreatGetAllOrderedByTypeID]
AS
	SELECT	ThreatID,
		[Name],
		Title,
		ThreatTypeID,
		ThreatRiskID,
		CategorySummary,
		State,
		DatePosted,
		Description
	FROM	[dbo].[Threat]
	ORDER BY ThreatTypeID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatGetAll]
GO
CREATE PROCEDURE [dbo].[ThreatGetAll]
AS
	SELECT	ThreatID,
		[Name],
		Title,
		ThreatTypeID,
		ThreatRiskID,
		CategorySummary,
		State,
		DatePosted,
		Description
	FROM	[dbo].[Threat]
	ORDER BY ThreatID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatAdd]
GO
CREATE PROCEDURE [dbo].[ThreatAdd]
	@Name			nvarchar(128),
	@Title			nvarchar(256),
	@ThreatTypeID		int,
	@ThreatRiskID		int,
	@CategorySummary	nvarchar(256) = '',
	@State			int = 2,
	@DatePosted		datetime,
	@Description		ntext = ''
AS
	INSERT INTO  dbo.Threat (
		[Name],
		Title,
		ThreatTypeID,
		ThreatRiskID,
		CategorySummary,
		State,
		DatePosted,
		Description
	)
	VALUES (
		@Name,
		@Title,
		@ThreatTypeID,
		@ThreatRiskID,
		@CategorySummary,
		@State,
		@DatePosted,
		@Description
	)
	RETURN SCOPE_IDENTITY()
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatBind]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatBind]
GO
CREATE PROCEDURE [dbo].[ThreatBind]
	@Name			nvarchar(128),
	@Title			nvarchar(256),
	@ThreatTypeID		int,
	@ThreatRiskID		int,
	@CategorySummary	nvarchar(256) = '',
	@State			int = 2,
	@DatePosted		datetime,
	@Description		ntext = ''
AS
	DECLARE	@ID	int

	SELECT	@ID = ThreatID
	FROM	[dbo].[Threat]
	WHERE	[Name] = @Name

	IF @ID IS NULL
		EXEC @ID = ThreatAdd @Name,
			@Title,
			@ThreatTypeID,
			@ThreatRiskID,
			@CategorySummary,
			@State,
			@DatePosted,
			@Description

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatSchema]
GO
CREATE PROCEDURE [dbo].[ThreatSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#Threat'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #Threat (' + CAST(0x0A AS CHAR(1)) +
	'		ThreatID		int NULL,' + CAST(0x0A AS CHAR(1)) +
	'		[Name]			nvarchar(128) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Title			nvarchar(256) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		ThreatTypeID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		ThreatRiskID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		CategorySummary		nvarchar(256) COLLATE database_default NOT NULL DEFAULT '''',' + CAST(0x0A AS CHAR(1)) +
	'		State			int NOT NULL DEFAULT 2,' + CAST(0x0A AS CHAR(1)) +
	'		DatePosted		datetime NOT NULL DEFAULT getdate(),' + CAST(0x0A AS CHAR(1)) +
	'		Description		ntext COLLATE database_default NOT NULL DEFAULT ''''' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #Threat' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatTempAdd]
GO
CREATE PROCEDURE dbo.[ThreatTempAdd]
	@ThreatID		int,
	@Name			nvarchar(128),
	@Title			nvarchar(256),
	@ThreatTypeID		int,
	@ThreatRiskID		int,
	@CategorySummary	nvarchar(256) = '',
	@State			int = 2,
	@DatePosted		datetime,
	@Description		ntext = ''
AS
	INSERT INTO #Threat (
		ThreatID,
		[Name],
		Title,
		ThreatTypeID,
		ThreatRiskID,
		CategorySummary,
		State,
		DatePosted,
		Description
	)
	VALUES (
		@ThreatID,
		@Name,
		@Title,
		@ThreatTypeID,
		@ThreatRiskID,
		@CategorySummary,
		@State,
		@DatePosted,
		@Description
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatAddBatch]
GO
CREATE PROCEDURE dbo.[ThreatAddBatch]
AS
	DECLARE @count int
	INSERT dbo.Threat (
		[Name],
		Title,
		ThreatTypeID,
		ThreatRiskID,
		CategorySummary,
		State,
		DatePosted,
		Description
	)
		SELECT	[Name],
			Title,
			ThreatTypeID,
			ThreatRiskID,
			CategorySummary,
			State,
			DatePosted,
			Description
		FROM #Threat
	SET @count = @@ROWCOUNT
	DROP TABLE #Threat	-- Drop temporary table
	RETURN @count
GO

/*
Add new Threat bound to
	ThreatType using Name
	ThreatRisk using Name
	with Name, Title, CategorySummary, State, DatePosted, Description
*/

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatUpdateByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatUpdateByID]
GO
CREATE PROCEDURE [dbo].[ThreatUpdateByID]
	@ThreatID		int,
	@Name			nvarchar(128),
	@Title			nvarchar(256),
	@ThreatTypeID		int,
	@ThreatRiskID		int,
	@CategorySummary	nvarchar(256) = '',
	@State			int = 2,
	@DatePosted		datetime,
	@Description		ntext = ''
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[Threat]
	SET	@ID = ThreatID,
		[Name] = @Name,
		Title = @Title,
		ThreatTypeID = @ThreatTypeID,
		ThreatRiskID = @ThreatRiskID,
		CategorySummary = @CategorySummary,
		State = @State,
		DatePosted = @DatePosted,
		Description = @Description
	WHERE	ThreatID = @ThreatID
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatUpdateBatchByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatUpdateBatchByID]
GO
CREATE PROCEDURE dbo.[ThreatUpdateBatchByID]
AS
	DECLARE @count int

	CREATE INDEX [TempThreatID]
		ON #Threat (ThreatID)

	UPDATE	[dbo].[Threat]
	SET	[Name] = t.[Name],
		Title = t.Title,
		ThreatTypeID = t.ThreatTypeID,
		ThreatRiskID = t.ThreatRiskID,
		CategorySummary = t.CategorySummary,
		State = t.State,
		DatePosted = t.DatePosted,
		Description = t.Description
	FROM	#Threat AS t
	WHERE	Threat.ThreatID = t.ThreatID
	SET @count = @@ROWCOUNT
	DROP TABLE #Threat	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatUpdateByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatUpdateByName]
GO
CREATE PROCEDURE [dbo].[ThreatUpdateByName]
	@Name			nvarchar(128),
	@Title			nvarchar(256),
	@ThreatTypeID		int,
	@ThreatRiskID		int,
	@CategorySummary	nvarchar(256) = '',
	@State			int = 2,
	@DatePosted		datetime,
	@Description		ntext = ''
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[Threat]
	SET	@ID = ThreatID,
		Title = @Title,
		ThreatTypeID = @ThreatTypeID,
		ThreatRiskID = @ThreatRiskID,
		CategorySummary = @CategorySummary,
		State = @State,
		DatePosted = @DatePosted,
		Description = @Description
	WHERE	[Name] = @Name
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatUpdateBatchByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatUpdateBatchByName]
GO
CREATE PROCEDURE dbo.[ThreatUpdateBatchByName]
AS
	DECLARE @count int

	CREATE INDEX [TempThreatName]
		ON #Threat ([Name])

	UPDATE	[dbo].[Threat]
	SET	Title = t.Title,
		ThreatTypeID = t.ThreatTypeID,
		ThreatRiskID = t.ThreatRiskID,
		CategorySummary = t.CategorySummary,
		State = t.State,
		DatePosted = t.DatePosted,
		Description = t.Description
	FROM	#Threat AS t
	WHERE	Threat.[Name] = t.[Name]
	SET @count = @@ROWCOUNT
	DROP TABLE #Threat	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatPutByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatPutByName]
GO
CREATE PROCEDURE [dbo].[ThreatPutByName]
	@Name			nvarchar(128),
	@Title			nvarchar(256),
	@ThreatTypeID		int,
	@ThreatRiskID		int,
	@CategorySummary	nvarchar(256) = '',
	@State			int = 2,
	@DatePosted		datetime,
	@Description		ntext = ''
AS
	DECLARE @ID	int

	SELECT	@ID = ThreatID
	FROM	Threat
	WHERE	[Name] = @Name

	IF @ID IS NULL
		EXEC @ID = ThreatAdd @Name,
			@Title,
			@ThreatTypeID,
			@ThreatRiskID,
			@CategorySummary,
			@State,
			@DatePosted,
			@Description
	ELSE
		EXEC ThreatUpdateByName @Name,
			@Title,
			@ThreatTypeID,
			@ThreatRiskID,
			@CategorySummary,
			@State,
			@DatePosted,
			@Description

	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatPutBatchByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatPutBatchByName]
GO
CREATE PROCEDURE [dbo].[ThreatPutBatchByName]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempThreatName]
		ON #Threat ([Name])

	BEGIN TRANSACTION
	UPDATE [dbo].[Threat]
		SET	Title = t.Title,
			ThreatTypeID = t.ThreatTypeID,
			ThreatRiskID = t.ThreatRiskID,
			CategorySummary = t.CategorySummary,
			State = t.State,
			DatePosted = t.DatePosted,
			Description = t.Description
		FROM	#Threat AS t
		WHERE	Threat.[Name] = t.[Name]
	SET @count = @@ROWCOUNT

	INSERT [dbo].[Threat] (
		[Name],
		Title,
		ThreatTypeID,
		ThreatRiskID,
		CategorySummary,
		State,
		DatePosted,
		Description
	)
		SELECT	[Name],
			Title,
			ThreatTypeID,
			ThreatRiskID,
			CategorySummary,
			State,
			DatePosted,
			Description
		FROM	#Threat AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[Threat]
			WHERE	Threat.[Name] = t.[Name]
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #Threat	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatRemoveBatch]
GO

CREATE PROCEDURE [dbo].[ThreatRemoveBatch]
AS

	CREATE INDEX [TempThreatThreatRemoveBatch]
		ON #Threat (ThreatID)	

	-- Delete records from Threat identified by fields of [TempThreatThreatRemoveBatch]
	DELETE [dbo].[Threat]
	WHERE EXISTS(
			SELECT * FROM #Threat AS t
			WHERE	Threat.ThreatID = t.ThreatID
		)
	DROP TABLE #Threat      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatRemoveByName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatRemoveByName]
GO
CREATE PROCEDURE [dbo].[ThreatRemoveByName]
	@Name			nvarchar(128)
AS
	-- Threat deletes cascade to:
	--	ThreatToCategory by FK_ThreatToCategory_Threat
	--	ThreatToScanner by FK_ThreatToScanner_Threat
	--	ThreatLog by FK_ThreatMessageLog_Threat
	--	ThreatOccurrence by FK_ThreatOccurrence_Threat
	DELETE	[dbo].[Threat]
	WHERE	[Name] = @Name
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatRemoveAll]
GO
CREATE PROCEDURE [dbo].[ThreatRemoveAll]
	
AS
	DELETE	[dbo].[Threat]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToCategoryGetByThreatIDThreatCategoryID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToCategoryGetByThreatIDThreatCategoryID]
GO
CREATE PROCEDURE [dbo].[ThreatToCategoryGetByThreatIDThreatCategoryID]
	@ThreatID		int,
	@ThreatCategoryID	int
AS
	SELECT	ThreatID,
		ThreatCategoryID
	FROM	[dbo].[ThreatToCategory]
	WHERE	ThreatID = @ThreatID
	  AND	ThreatCategoryID = @ThreatCategoryID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToCategoryGetAllByThreatID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToCategoryGetAllByThreatID]
GO
CREATE PROCEDURE [dbo].[ThreatToCategoryGetAllByThreatID]
	@ThreatID		int
AS
	SELECT	ThreatID,
		ThreatCategoryID
	FROM	[dbo].[ThreatToCategory]
	WHERE	ThreatID = @ThreatID
	ORDER BY ThreatCategoryID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToCategoryGetAllByThreatCategoryID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToCategoryGetAllByThreatCategoryID]
GO
CREATE PROCEDURE [dbo].[ThreatToCategoryGetAllByThreatCategoryID]
	@ThreatCategoryID	int
AS
	SELECT	ThreatID,
		ThreatCategoryID
	FROM	[dbo].[ThreatToCategory]
	WHERE	ThreatCategoryID = @ThreatCategoryID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToCategoryGetAllOrderedByThreatCategoryID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToCategoryGetAllOrderedByThreatCategoryID]
GO
CREATE PROCEDURE [dbo].[ThreatToCategoryGetAllOrderedByThreatCategoryID]
AS
	SELECT	ThreatID,
		ThreatCategoryID
	FROM	[dbo].[ThreatToCategory]
	ORDER BY ThreatCategoryID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToCategoryGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToCategoryGetAll]
GO
CREATE PROCEDURE [dbo].[ThreatToCategoryGetAll]
AS
	SELECT	ThreatID,
		ThreatCategoryID
	FROM	[dbo].[ThreatToCategory]
	ORDER BY ThreatID, ThreatCategoryID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToCategoryAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToCategoryAdd]
GO
CREATE PROCEDURE [dbo].[ThreatToCategoryAdd]
	@ThreatID		int,
	@ThreatCategoryID	int
AS
	INSERT INTO  dbo.ThreatToCategory (
		ThreatID,
		ThreatCategoryID
	)
	VALUES (
		@ThreatID,
		@ThreatCategoryID
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToCategorySchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToCategorySchema]
GO
CREATE PROCEDURE [dbo].[ThreatToCategorySchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#ThreatToCategory'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #ThreatToCategory (' + CAST(0x0A AS CHAR(1)) +
	'		ThreatID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		ThreatCategoryID	int NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #ThreatToCategory' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToCategoryTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToCategoryTempAdd]
GO
CREATE PROCEDURE dbo.[ThreatToCategoryTempAdd]
	@ThreatID		int,
	@ThreatCategoryID	int
AS
	INSERT INTO #ThreatToCategory (
		ThreatID,
		ThreatCategoryID
	)
	VALUES (
		@ThreatID,
		@ThreatCategoryID
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToCategoryAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToCategoryAddBatch]
GO
CREATE PROCEDURE dbo.[ThreatToCategoryAddBatch]
AS
	DECLARE @count int
	INSERT dbo.ThreatToCategory (
		ThreatID,
		ThreatCategoryID
	)
		SELECT	ThreatID,
			ThreatCategoryID
		FROM #ThreatToCategory
	SET @count = @@ROWCOUNT
	DROP TABLE #ThreatToCategory	-- Drop temporary table
	RETURN @count
GO

/*
Add new ThreatToCategory bound to
	Threat using Name with Title, ThreatTypeID, ThreatRiskID
	ThreatCategory using Name with ThreatTypeID
	with 
*/

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToCategoryPutByThreatIDThreatCategoryID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToCategoryPutByThreatIDThreatCategoryID]
GO
CREATE PROCEDURE [dbo].[ThreatToCategoryPutByThreatIDThreatCategoryID]
	@ThreatID		int,
	@ThreatCategoryID	int
AS
	IF NOT EXISTS(
		SELECT	1
		FROM	dbo.ThreatToCategory
		WHERE	ThreatID = @ThreatID
		  AND	ThreatCategoryID = @ThreatCategoryID
	)
		EXEC ThreatToCategoryAdd @ThreatID,
			@ThreatCategoryID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToCategoryPutBatchByThreatIDThreatCategoryID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToCategoryPutBatchByThreatIDThreatCategoryID]
GO
CREATE PROCEDURE [dbo].[ThreatToCategoryPutBatchByThreatIDThreatCategoryID]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempThreatToCategoryThreatIDThreatCategoryID]
		ON #ThreatToCategory (ThreatID, ThreatCategoryID)

	BEGIN TRANSACTION

	INSERT [dbo].[ThreatToCategory] (
		ThreatID,
		ThreatCategoryID
	)
		SELECT	ThreatID,
			ThreatCategoryID
		FROM	#ThreatToCategory AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[ThreatToCategory]
			WHERE	ThreatToCategory.ThreatID = t.ThreatID
			  AND	ThreatToCategory.ThreatCategoryID = t.ThreatCategoryID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #ThreatToCategory	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToCategoryRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToCategoryRemoveBatch]
GO

CREATE PROCEDURE [dbo].[ThreatToCategoryRemoveBatch]
AS

	CREATE INDEX [TempThreatToCategoryThreatToCategoryRemoveBatch]
		ON #ThreatToCategory (ThreatID, ThreatCategoryID)	

	-- Delete records from ThreatToCategory identified by fields of [TempThreatToCategoryThreatToCategoryRemoveBatch]
	DELETE [dbo].[ThreatToCategory]
	WHERE EXISTS(
			SELECT * FROM #ThreatToCategory AS t
			WHERE	ThreatToCategory.ThreatID = t.ThreatID
			  AND	ThreatToCategory.ThreatCategoryID = t.ThreatCategoryID
		)
	DROP TABLE #ThreatToCategory      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToCategoryRemoveByThreatIDThreatCategoryID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToCategoryRemoveByThreatIDThreatCategoryID]
GO
CREATE PROCEDURE [dbo].[ThreatToCategoryRemoveByThreatIDThreatCategoryID]
	@ThreatID		int,
	@ThreatCategoryID	int
AS
	DELETE	[dbo].[ThreatToCategory]
	WHERE	ThreatID = @ThreatID
	  AND	ThreatCategoryID = @ThreatCategoryID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToCategoryRemoveAllByThreatID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToCategoryRemoveAllByThreatID]
GO
CREATE PROCEDURE [dbo].[ThreatToCategoryRemoveAllByThreatID]
	@ThreatID		int
AS
	DELETE	[dbo].[ThreatToCategory]
	WHERE	ThreatID = @ThreatID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToCategoryRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToCategoryRemoveAll]
GO
CREATE PROCEDURE [dbo].[ThreatToCategoryRemoveAll]
	
AS
	DELETE	[dbo].[ThreatToCategory]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToCategoryReplaceSubsetByThreatID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToCategoryReplaceSubsetByThreatID]
GO
-- Replace the record subset selected by (@ThreatID)
-- using unique identifier (ThreatID, ThreatCategoryID)
CREATE PROCEDURE [dbo].[ThreatToCategoryReplaceSubsetByThreatID]
	@ThreatID		int
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempThreatToCategoryByThreatID]
		ON #ThreatToCategory (ThreatID, ThreatCategoryID)

	BEGIN TRANSACTION
	DELETE [ThreatToCategory]
		WHERE	ThreatID = @ThreatID
		AND NOT EXISTS(		-- Replacement record doesn't exist
			SELECT * FROM #ThreatToCategory AS t
			WHERE	ThreatToCategory.ThreatID = t.ThreatID
			  AND	ThreatToCategory.ThreatCategoryID = t.ThreatCategoryID
		)

	INSERT [ThreatToCategory] (
		ThreatID,
		ThreatCategoryID
	)
		SELECT	ThreatID,
			ThreatCategoryID
		FROM	#ThreatToCategory AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [ThreatToCategory]
			WHERE	ThreatToCategory.ThreatID = t.ThreatID
			  AND	ThreatToCategory.ThreatCategoryID = t.ThreatCategoryID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #ThreatToCategory	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToScannerGetByThreatIDThreatScannerID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToScannerGetByThreatIDThreatScannerID]
GO
CREATE PROCEDURE [dbo].[ThreatToScannerGetByThreatIDThreatScannerID]
	@ThreatID		int,
	@ThreatScannerID	int
AS
	SELECT	ThreatID,
		ThreatScannerID
	FROM	[dbo].[ThreatToScanner]
	WHERE	ThreatID = @ThreatID
	  AND	ThreatScannerID = @ThreatScannerID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToScannerGetAllByThreatID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToScannerGetAllByThreatID]
GO
CREATE PROCEDURE [dbo].[ThreatToScannerGetAllByThreatID]
	@ThreatID		int
AS
	SELECT	ThreatID,
		ThreatScannerID
	FROM	[dbo].[ThreatToScanner]
	WHERE	ThreatID = @ThreatID
	ORDER BY ThreatScannerID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToScannerGetAllByThreatScannerID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToScannerGetAllByThreatScannerID]
GO
CREATE PROCEDURE [dbo].[ThreatToScannerGetAllByThreatScannerID]
	@ThreatScannerID	int
AS
	SELECT	ThreatID,
		ThreatScannerID
	FROM	[dbo].[ThreatToScanner]
	WHERE	ThreatScannerID = @ThreatScannerID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToScannerGetAllOrderedByThreatScannerID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToScannerGetAllOrderedByThreatScannerID]
GO
CREATE PROCEDURE [dbo].[ThreatToScannerGetAllOrderedByThreatScannerID]
AS
	SELECT	ThreatID,
		ThreatScannerID
	FROM	[dbo].[ThreatToScanner]
	ORDER BY ThreatScannerID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToScannerGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToScannerGetAll]
GO
CREATE PROCEDURE [dbo].[ThreatToScannerGetAll]
AS
	SELECT	ThreatID,
		ThreatScannerID
	FROM	[dbo].[ThreatToScanner]
	ORDER BY ThreatID, ThreatScannerID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToScannerAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToScannerAdd]
GO
CREATE PROCEDURE [dbo].[ThreatToScannerAdd]
	@ThreatID		int,
	@ThreatScannerID	int
AS
	INSERT INTO  dbo.ThreatToScanner (
		ThreatID,
		ThreatScannerID
	)
	VALUES (
		@ThreatID,
		@ThreatScannerID
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToScannerSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToScannerSchema]
GO
CREATE PROCEDURE [dbo].[ThreatToScannerSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#ThreatToScanner'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #ThreatToScanner (' + CAST(0x0A AS CHAR(1)) +
	'		ThreatID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		ThreatScannerID		int NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #ThreatToScanner' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToScannerTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToScannerTempAdd]
GO
CREATE PROCEDURE dbo.[ThreatToScannerTempAdd]
	@ThreatID		int,
	@ThreatScannerID	int
AS
	INSERT INTO #ThreatToScanner (
		ThreatID,
		ThreatScannerID
	)
	VALUES (
		@ThreatID,
		@ThreatScannerID
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToScannerAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToScannerAddBatch]
GO
CREATE PROCEDURE dbo.[ThreatToScannerAddBatch]
AS
	DECLARE @count int
	INSERT dbo.ThreatToScanner (
		ThreatID,
		ThreatScannerID
	)
		SELECT	ThreatID,
			ThreatScannerID
		FROM #ThreatToScanner
	SET @count = @@ROWCOUNT
	DROP TABLE #ThreatToScanner	-- Drop temporary table
	RETURN @count
GO

/*
Add new ThreatToScanner bound to
	Threat using Name with Title, ThreatTypeID, ThreatRiskID
	ThreatScanner using Name
	with 
*/

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToScannerPutByThreatIDThreatScannerID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToScannerPutByThreatIDThreatScannerID]
GO
CREATE PROCEDURE [dbo].[ThreatToScannerPutByThreatIDThreatScannerID]
	@ThreatID		int,
	@ThreatScannerID	int
AS
	IF NOT EXISTS(
		SELECT	1
		FROM	dbo.ThreatToScanner
		WHERE	ThreatID = @ThreatID
		  AND	ThreatScannerID = @ThreatScannerID
	)
		EXEC ThreatToScannerAdd @ThreatID,
			@ThreatScannerID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToScannerPutBatchByThreatIDThreatScannerID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToScannerPutBatchByThreatIDThreatScannerID]
GO
CREATE PROCEDURE [dbo].[ThreatToScannerPutBatchByThreatIDThreatScannerID]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempThreatToScannerThreatIDThreatScannerID]
		ON #ThreatToScanner (ThreatID, ThreatScannerID)

	BEGIN TRANSACTION

	INSERT [dbo].[ThreatToScanner] (
		ThreatID,
		ThreatScannerID
	)
		SELECT	ThreatID,
			ThreatScannerID
		FROM	#ThreatToScanner AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[ThreatToScanner]
			WHERE	ThreatToScanner.ThreatID = t.ThreatID
			  AND	ThreatToScanner.ThreatScannerID = t.ThreatScannerID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #ThreatToScanner	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToScannerRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToScannerRemoveBatch]
GO

CREATE PROCEDURE [dbo].[ThreatToScannerRemoveBatch]
AS

	CREATE INDEX [TempThreatToScannerThreatToScannerRemoveBatch]
		ON #ThreatToScanner (ThreatID, ThreatScannerID)	

	-- Delete records from ThreatToScanner identified by fields of [TempThreatToScannerThreatToScannerRemoveBatch]
	DELETE [dbo].[ThreatToScanner]
	WHERE EXISTS(
			SELECT * FROM #ThreatToScanner AS t
			WHERE	ThreatToScanner.ThreatID = t.ThreatID
			  AND	ThreatToScanner.ThreatScannerID = t.ThreatScannerID
		)
	DROP TABLE #ThreatToScanner      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToScannerRemoveByThreatIDThreatScannerID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToScannerRemoveByThreatIDThreatScannerID]
GO
CREATE PROCEDURE [dbo].[ThreatToScannerRemoveByThreatIDThreatScannerID]
	@ThreatID		int,
	@ThreatScannerID	int
AS
	DELETE	[dbo].[ThreatToScanner]
	WHERE	ThreatID = @ThreatID
	  AND	ThreatScannerID = @ThreatScannerID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToScannerRemoveAllByThreatID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToScannerRemoveAllByThreatID]
GO
CREATE PROCEDURE [dbo].[ThreatToScannerRemoveAllByThreatID]
	@ThreatID		int
AS
	DELETE	[dbo].[ThreatToScanner]
	WHERE	ThreatID = @ThreatID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToScannerRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToScannerRemoveAll]
GO
CREATE PROCEDURE [dbo].[ThreatToScannerRemoveAll]
	
AS
	DELETE	[dbo].[ThreatToScanner]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatToScannerReplaceSubsetByThreatID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatToScannerReplaceSubsetByThreatID]
GO
-- Replace the record subset selected by (@ThreatID)
-- using unique identifier (ThreatID, ThreatScannerID)
CREATE PROCEDURE [dbo].[ThreatToScannerReplaceSubsetByThreatID]
	@ThreatID		int
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempThreatToScannerByThreatID]
		ON #ThreatToScanner (ThreatID, ThreatScannerID)

	BEGIN TRANSACTION
	DELETE [ThreatToScanner]
		WHERE	ThreatID = @ThreatID
		AND NOT EXISTS(		-- Replacement record doesn't exist
			SELECT * FROM #ThreatToScanner AS t
			WHERE	ThreatToScanner.ThreatID = t.ThreatID
			  AND	ThreatToScanner.ThreatScannerID = t.ThreatScannerID
		)

	INSERT [ThreatToScanner] (
		ThreatID,
		ThreatScannerID
	)
		SELECT	ThreatID,
			ThreatScannerID
		FROM	#ThreatToScanner AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [ThreatToScanner]
			WHERE	ThreatToScanner.ThreatID = t.ThreatID
			  AND	ThreatToScanner.ThreatScannerID = t.ThreatScannerID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #ThreatToScanner	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatLogGetByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatLogGetByID]
GO
CREATE PROCEDURE [dbo].[ThreatLogGetByID]
	@ThreatLogID		int
AS
	SELECT	ThreatLogID,
		ThreatID,
		Message,
		DatePosted
	FROM	[dbo].[ThreatLog]
	WHERE	ThreatLogID = @ThreatLogID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatLogGetAllByThreatID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatLogGetAllByThreatID]
GO
CREATE PROCEDURE [dbo].[ThreatLogGetAllByThreatID]
	@ThreatID		int
AS
	SELECT	ThreatLogID,
		ThreatID,
		Message,
		DatePosted
	FROM	[dbo].[ThreatLog]
	WHERE	ThreatID = @ThreatID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatLogGetAllOrderedByThreatID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatLogGetAllOrderedByThreatID]
GO
CREATE PROCEDURE [dbo].[ThreatLogGetAllOrderedByThreatID]
AS
	SELECT	ThreatLogID,
		ThreatID,
		Message,
		DatePosted
	FROM	[dbo].[ThreatLog]
	ORDER BY ThreatID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatLogGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatLogGetAll]
GO
CREATE PROCEDURE [dbo].[ThreatLogGetAll]
AS
	SELECT	ThreatLogID,
		ThreatID,
		Message,
		DatePosted
	FROM	[dbo].[ThreatLog]
	ORDER BY ThreatLogID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatLogAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatLogAdd]
GO
CREATE PROCEDURE [dbo].[ThreatLogAdd]
	@ThreatID		int,
	@Message		nvarchar(128),
	@DatePosted		datetime
AS
	INSERT INTO  dbo.ThreatLog (
		ThreatID,
		Message,
		DatePosted
	)
	VALUES (
		@ThreatID,
		@Message,
		@DatePosted
	)
	RETURN SCOPE_IDENTITY()
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatLogSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatLogSchema]
GO
CREATE PROCEDURE [dbo].[ThreatLogSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#ThreatLog'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #ThreatLog (' + CAST(0x0A AS CHAR(1)) +
	'		ThreatLogID		int NULL,' + CAST(0x0A AS CHAR(1)) +
	'		ThreatID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Message			nvarchar(128) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		DatePosted		datetime NOT NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #ThreatLog' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatLogTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatLogTempAdd]
GO
CREATE PROCEDURE dbo.[ThreatLogTempAdd]
	@ThreatLogID		int,
	@ThreatID		int,
	@Message		nvarchar(128),
	@DatePosted		datetime
AS
	INSERT INTO #ThreatLog (
		ThreatLogID,
		ThreatID,
		Message,
		DatePosted
	)
	VALUES (
		@ThreatLogID,
		@ThreatID,
		@Message,
		@DatePosted
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatLogAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatLogAddBatch]
GO
CREATE PROCEDURE dbo.[ThreatLogAddBatch]
AS
	DECLARE @count int
	INSERT dbo.ThreatLog (
		ThreatID,
		Message,
		DatePosted
	)
		SELECT	ThreatID,
			Message,
			DatePosted
		FROM #ThreatLog
	SET @count = @@ROWCOUNT
	DROP TABLE #ThreatLog	-- Drop temporary table
	RETURN @count
GO

/*
Add new ThreatLog bound to
	Threat using Name with Title, ThreatTypeID, ThreatRiskID
	with Message, DatePosted
*/

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatLogUpdateByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatLogUpdateByID]
GO
CREATE PROCEDURE [dbo].[ThreatLogUpdateByID]
	@ThreatLogID		int,
	@ThreatID		int,
	@Message		nvarchar(128),
	@DatePosted		datetime
AS
	DECLARE	@ID	int
	SET @ID = 0

	UPDATE	[dbo].[ThreatLog]
	SET	@ID = ThreatLogID,
		ThreatID = @ThreatID,
		Message = @Message,
		DatePosted = @DatePosted
	WHERE	ThreatLogID = @ThreatLogID
	RETURN @ID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatLogUpdateBatchByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatLogUpdateBatchByID]
GO
CREATE PROCEDURE dbo.[ThreatLogUpdateBatchByID]
AS
	DECLARE @count int

	CREATE INDEX [TempThreatLogID]
		ON #ThreatLog (ThreatLogID)

	UPDATE	[dbo].[ThreatLog]
	SET	ThreatID = t.ThreatID,
		Message = t.Message,
		DatePosted = t.DatePosted
	FROM	#ThreatLog AS t
	WHERE	ThreatLog.ThreatLogID = t.ThreatLogID
	SET @count = @@ROWCOUNT
	DROP TABLE #ThreatLog	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatLogRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatLogRemoveBatch]
GO

CREATE PROCEDURE [dbo].[ThreatLogRemoveBatch]
AS

	CREATE INDEX [TempThreatLogThreatLogRemoveBatch]
		ON #ThreatLog (ThreatLogID)	

	-- Delete records from ThreatLog identified by fields of [TempThreatLogThreatLogRemoveBatch]
	DELETE [dbo].[ThreatLog]
	WHERE EXISTS(
			SELECT * FROM #ThreatLog AS t
			WHERE	ThreatLog.ThreatLogID = t.ThreatLogID
		)
	DROP TABLE #ThreatLog      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatLogRemoveByID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatLogRemoveByID]
GO
CREATE PROCEDURE [dbo].[ThreatLogRemoveByID]
	@ThreatLogID		int
AS
	DELETE	[dbo].[ThreatLog]
	WHERE	ThreatLogID = @ThreatLogID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatLogRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatLogRemoveAll]
GO
CREATE PROCEDURE [dbo].[ThreatLogRemoveAll]
	
AS
	DELETE	[dbo].[ThreatLog]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatScanGetByComputerIDUserIDThreatTypeIDnerID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatScanGetByComputerIDUserIDThreatTypeIDnerID]
GO
CREATE PROCEDURE [dbo].[ThreatScanGetByComputerIDUserIDThreatTypeIDnerID]
	@ComputerID		int,
	@UserID			int,
	@ThreatTypeID		int,
	@ThreatScannerID	int
AS
	SELECT	ComputerID,
		UserID,
		ThreatTypeID,
		ThreatScannerID,
		DataSourceDate,
		DataSourceVersion,
		ScanStart,
		ScanEnd
	FROM	[dbo].[ThreatScan]
	WHERE	ComputerID = @ComputerID
	  AND	UserID = @UserID
	  AND	ThreatTypeID = @ThreatTypeID
	  AND	ThreatScannerID = @ThreatScannerID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatScanGetAllByComputerID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatScanGetAllByComputerID]
GO
CREATE PROCEDURE [dbo].[ThreatScanGetAllByComputerID]
	@ComputerID		int
AS
	SELECT	ComputerID,
		UserID,
		ThreatTypeID,
		ThreatScannerID,
		DataSourceDate,
		DataSourceVersion,
		ScanStart,
		ScanEnd
	FROM	[dbo].[ThreatScan]
	WHERE	ComputerID = @ComputerID
	ORDER BY UserID, ThreatTypeID, ThreatScannerID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatScanGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatScanGetAll]
GO
CREATE PROCEDURE [dbo].[ThreatScanGetAll]
AS
	SELECT	ComputerID,
		UserID,
		ThreatTypeID,
		ThreatScannerID,
		DataSourceDate,
		DataSourceVersion,
		ScanStart,
		ScanEnd
	FROM	[dbo].[ThreatScan]
	ORDER BY ComputerID, UserID, ThreatTypeID, ThreatScannerID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatScanAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatScanAdd]
GO
CREATE PROCEDURE [dbo].[ThreatScanAdd]
	@ComputerID		int,
	@UserID			int,
	@ThreatTypeID		int,
	@ThreatScannerID	int,
	@DataSourceDate		datetime = NULL,
	@DataSourceVersion	nvarchar(128) = NULL,
	@ScanStart		datetime = NULL,
	@ScanEnd		datetime = NULL
AS
	INSERT INTO  dbo.ThreatScan (
		ComputerID,
		UserID,
		ThreatTypeID,
		ThreatScannerID,
		DataSourceDate,
		DataSourceVersion,
		ScanStart,
		ScanEnd
	)
	VALUES (
		@ComputerID,
		@UserID,
		@ThreatTypeID,
		@ThreatScannerID,
		@DataSourceDate,
		@DataSourceVersion,
		@ScanStart,
		@ScanEnd
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatScanSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatScanSchema]
GO
CREATE PROCEDURE [dbo].[ThreatScanSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#ThreatScan'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #ThreatScan (' + CAST(0x0A AS CHAR(1)) +
	'		ComputerID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		UserID			int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		ThreatTypeID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		ThreatScannerID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		DataSourceDate		datetime NULL,' + CAST(0x0A AS CHAR(1)) +
	'		DataSourceVersion	nvarchar(128) COLLATE database_default NULL,' + CAST(0x0A AS CHAR(1)) +
	'		ScanStart		datetime NULL,' + CAST(0x0A AS CHAR(1)) +
	'		ScanEnd			datetime NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #ThreatScan' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatScanTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatScanTempAdd]
GO
CREATE PROCEDURE dbo.[ThreatScanTempAdd]
	@ComputerID		int,
	@UserID			int,
	@ThreatTypeID		int,
	@ThreatScannerID	int,
	@DataSourceDate		datetime = NULL,
	@DataSourceVersion	nvarchar(128) = NULL,
	@ScanStart		datetime = NULL,
	@ScanEnd		datetime = NULL
AS
	INSERT INTO #ThreatScan (
		ComputerID,
		UserID,
		ThreatTypeID,
		ThreatScannerID,
		DataSourceDate,
		DataSourceVersion,
		ScanStart,
		ScanEnd
	)
	VALUES (
		@ComputerID,
		@UserID,
		@ThreatTypeID,
		@ThreatScannerID,
		@DataSourceDate,
		@DataSourceVersion,
		@ScanStart,
		@ScanEnd
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatScanAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatScanAddBatch]
GO
CREATE PROCEDURE dbo.[ThreatScanAddBatch]
AS
	DECLARE @count int
	INSERT dbo.ThreatScan (
		ComputerID,
		UserID,
		ThreatTypeID,
		ThreatScannerID,
		DataSourceDate,
		DataSourceVersion,
		ScanStart,
		ScanEnd
	)
		SELECT	ComputerID,
			UserID,
			ThreatTypeID,
			ThreatScannerID,
			DataSourceDate,
			DataSourceVersion,
			ScanStart,
			ScanEnd
		FROM #ThreatScan
	SET @count = @@ROWCOUNT
	DROP TABLE #ThreatScan	-- Drop temporary table
	RETURN @count
GO

/*
Add new ThreatScan bound to
	User using UserOUID, UserCN
	ThreatType using Name
	ThreatScanner using Name
	with ComputerID, DataSourceDate, DataSourceVersion, ScanStart, ScanEnd
*/

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatScanUpdateByComputerIDUserIDThreatTypeIDnerID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatScanUpdateByComputerIDUserIDThreatTypeIDnerID]
GO
CREATE PROCEDURE [dbo].[ThreatScanUpdateByComputerIDUserIDThreatTypeIDnerID]
	@ComputerID		int,
	@UserID			int,
	@ThreatTypeID		int,
	@ThreatScannerID	int,
	@DataSourceDate		datetime = NULL,
	@DataSourceVersion	nvarchar(128) = NULL,
	@ScanStart		datetime = NULL,
	@ScanEnd		datetime = NULL
AS
	UPDATE	[dbo].[ThreatScan]
	SET	DataSourceDate = @DataSourceDate,
		DataSourceVersion = @DataSourceVersion,
		ScanStart = @ScanStart,
		ScanEnd = @ScanEnd
	WHERE	ComputerID = @ComputerID
	  AND	UserID = @UserID
	  AND	ThreatTypeID = @ThreatTypeID
	  AND	ThreatScannerID = @ThreatScannerID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatScanUpdateBatchByComputerIDUserIDThreatTypeIDnerID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatScanUpdateBatchByComputerIDUserIDThreatTypeIDnerID]
GO
CREATE PROCEDURE dbo.[ThreatScanUpdateBatchByComputerIDUserIDThreatTypeIDnerID]
AS
	DECLARE @count int

	CREATE INDEX [TempThreatScanComputerIDUserIDThreatTypeIDnerID]
		ON #ThreatScan (ComputerID, UserID, ThreatTypeID, ThreatScannerID)

	UPDATE	[dbo].[ThreatScan]
	SET	DataSourceDate = t.DataSourceDate,
		DataSourceVersion = t.DataSourceVersion,
		ScanStart = t.ScanStart,
		ScanEnd = t.ScanEnd
	FROM	#ThreatScan AS t
	WHERE	ThreatScan.ComputerID = t.ComputerID
	  AND	ThreatScan.UserID = t.UserID
	  AND	ThreatScan.ThreatTypeID = t.ThreatTypeID
	  AND	ThreatScan.ThreatScannerID = t.ThreatScannerID
	SET @count = @@ROWCOUNT
	DROP TABLE #ThreatScan	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatScanPutByComputerIDUserIDThreatTypeIDnerID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatScanPutByComputerIDUserIDThreatTypeIDnerID]
GO
CREATE PROCEDURE [dbo].[ThreatScanPutByComputerIDUserIDThreatTypeIDnerID]
	@ComputerID		int,
	@UserID			int,
	@ThreatTypeID		int,
	@ThreatScannerID	int,
	@DataSourceDate		datetime = NULL,
	@DataSourceVersion	nvarchar(128) = NULL,
	@ScanStart		datetime = NULL,
	@ScanEnd		datetime = NULL
AS
	IF NOT EXISTS(
		SELECT	1
		FROM	dbo.ThreatScan
		WHERE	ComputerID = @ComputerID
		  AND	UserID = @UserID
		  AND	ThreatTypeID = @ThreatTypeID
		  AND	ThreatScannerID = @ThreatScannerID
	)
		EXEC ThreatScanAdd @ComputerID,
			@UserID,
			@ThreatTypeID,
			@ThreatScannerID,
			@DataSourceDate,
			@DataSourceVersion,
			@ScanStart,
			@ScanEnd
	ELSE
		EXEC ThreatScanUpdateByComputerIDUserIDThreatTypeIDnerID @ComputerID,
			@UserID,
			@ThreatTypeID,
			@ThreatScannerID,
			@DataSourceDate,
			@DataSourceVersion,
			@ScanStart,
			@ScanEnd
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatScanPutBatchByComputerIDUserIDThreatTypeIDnerID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatScanPutBatchByComputerIDUserIDThreatTypeIDnerID]
GO
CREATE PROCEDURE [dbo].[ThreatScanPutBatchByComputerIDUserIDThreatTypeIDnerID]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempThreatScanComputerIDUserIDThreatTypeIDnerID]
		ON #ThreatScan (ComputerID, UserID, ThreatTypeID, ThreatScannerID)

	BEGIN TRANSACTION
	UPDATE [dbo].[ThreatScan]
		SET	DataSourceDate = t.DataSourceDate,
			DataSourceVersion = t.DataSourceVersion,
			ScanStart = t.ScanStart,
			ScanEnd = t.ScanEnd
		FROM	#ThreatScan AS t
		WHERE	ThreatScan.ComputerID = t.ComputerID
		  AND	ThreatScan.UserID = t.UserID
		  AND	ThreatScan.ThreatTypeID = t.ThreatTypeID
		  AND	ThreatScan.ThreatScannerID = t.ThreatScannerID
	SET @count = @@ROWCOUNT

	INSERT [dbo].[ThreatScan] (
		ComputerID,
		UserID,
		ThreatTypeID,
		ThreatScannerID,
		DataSourceDate,
		DataSourceVersion,
		ScanStart,
		ScanEnd
	)
		SELECT	ComputerID,
			UserID,
			ThreatTypeID,
			ThreatScannerID,
			DataSourceDate,
			DataSourceVersion,
			ScanStart,
			ScanEnd
		FROM	#ThreatScan AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[ThreatScan]
			WHERE	ThreatScan.ComputerID = t.ComputerID
			  AND	ThreatScan.UserID = t.UserID
			  AND	ThreatScan.ThreatTypeID = t.ThreatTypeID
			  AND	ThreatScan.ThreatScannerID = t.ThreatScannerID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #ThreatScan	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatScanRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatScanRemoveBatch]
GO

CREATE PROCEDURE [dbo].[ThreatScanRemoveBatch]
AS

	CREATE INDEX [TempThreatScanThreatScanRemoveBatch]
		ON #ThreatScan (ComputerID, UserID, ThreatTypeID, ThreatScannerID)	

	-- Delete records from ThreatScan identified by fields of [TempThreatScanThreatScanRemoveBatch]
	DELETE [dbo].[ThreatScan]
	WHERE EXISTS(
			SELECT * FROM #ThreatScan AS t
			WHERE	ThreatScan.ComputerID = t.ComputerID
			  AND	ThreatScan.UserID = t.UserID
			  AND	ThreatScan.ThreatTypeID = t.ThreatTypeID
			  AND	ThreatScan.ThreatScannerID = t.ThreatScannerID
		)
	DROP TABLE #ThreatScan      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatScanRemoveByComputerIDUserIDThreatTypeIDnerID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatScanRemoveByComputerIDUserIDThreatTypeIDnerID]
GO
CREATE PROCEDURE [dbo].[ThreatScanRemoveByComputerIDUserIDThreatTypeIDnerID]
	@ComputerID		int,
	@UserID			int,
	@ThreatTypeID		int,
	@ThreatScannerID	int
AS
	DELETE	[dbo].[ThreatScan]
	WHERE	ComputerID = @ComputerID
	  AND	UserID = @UserID
	  AND	ThreatTypeID = @ThreatTypeID
	  AND	ThreatScannerID = @ThreatScannerID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatScanRemoveAllByComputerID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatScanRemoveAllByComputerID]
GO
CREATE PROCEDURE [dbo].[ThreatScanRemoveAllByComputerID]
	@ComputerID		int
AS
	DELETE	[dbo].[ThreatScan]
	WHERE	ComputerID = @ComputerID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatScanRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatScanRemoveAll]
GO
CREATE PROCEDURE [dbo].[ThreatScanRemoveAll]
	
AS
	DELETE	[dbo].[ThreatScan]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatScanReplaceSubsetByComputerID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatScanReplaceSubsetByComputerID]
GO
-- Replace the record subset selected by (@ComputerID)
-- using unique identifier (ComputerID, UserID, ThreatTypeID, ThreatScannerID)
-- updating fields (DataSourceDate, DataSourceVersion, ScanStart, ScanEnd)
CREATE PROCEDURE [dbo].[ThreatScanReplaceSubsetByComputerID]
	@ComputerID		int
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempThreatScanByComputerID]
		ON #ThreatScan (ComputerID, UserID, ThreatTypeID, ThreatScannerID)

	BEGIN TRANSACTION
	DELETE [ThreatScan]
		WHERE	ComputerID = @ComputerID
		AND NOT EXISTS(		-- Replacement record doesn't exist
			SELECT * FROM #ThreatScan AS t
			WHERE	ThreatScan.ComputerID = t.ComputerID
			  AND	ThreatScan.UserID = t.UserID
			  AND	ThreatScan.ThreatTypeID = t.ThreatTypeID
			  AND	ThreatScan.ThreatScannerID = t.ThreatScannerID
		)

	UPDATE [dbo].[ThreatScan]
		SET	DataSourceDate = t.DataSourceDate,
			DataSourceVersion = t.DataSourceVersion,
			ScanStart = t.ScanStart,
			ScanEnd = t.ScanEnd
		FROM	#ThreatScan AS t
		WHERE	ThreatScan.ComputerID = t.ComputerID
		  AND	ThreatScan.UserID = t.UserID
		  AND	ThreatScan.ThreatTypeID = t.ThreatTypeID
		  AND	ThreatScan.ThreatScannerID = t.ThreatScannerID
	SET @count = @@ROWCOUNT

	INSERT [ThreatScan] (
		ComputerID,
		UserID,
		ThreatTypeID,
		ThreatScannerID,
		DataSourceDate,
		DataSourceVersion,
		ScanStart,
		ScanEnd
	)
		SELECT	ComputerID,
			UserID,
			ThreatTypeID,
			ThreatScannerID,
			DataSourceDate,
			DataSourceVersion,
			ScanStart,
			ScanEnd
		FROM	#ThreatScan AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [ThreatScan]
			WHERE	ThreatScan.ComputerID = t.ComputerID
			  AND	ThreatScan.UserID = t.UserID
			  AND	ThreatScan.ThreatTypeID = t.ThreatTypeID
			  AND	ThreatScan.ThreatScannerID = t.ThreatScannerID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #ThreatScan	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatOccurrenceGetByComputerIDUserIDThreatTypeIDThreatID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatOccurrenceGetByComputerIDUserIDThreatTypeIDThreatID]
GO
CREATE PROCEDURE [dbo].[ThreatOccurrenceGetByComputerIDUserIDThreatTypeIDThreatID]
	@ComputerID		int,
	@UserID			int,
	@ThreatTypeID		int,
	@ThreatID		int
AS
	SELECT	ComputerID,
		UserID,
		ThreatTypeID,
		ThreatID,
		ThreatScannerID,
		ThreatOccurrenceRiskID,
		ThreatActionID,
		Details
	FROM	[dbo].[ThreatOccurrence]
	WHERE	ComputerID = @ComputerID
	  AND	UserID = @UserID
	  AND	ThreatTypeID = @ThreatTypeID
	  AND	ThreatID = @ThreatID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatOccurrenceGetAllByComputerIDUserIDThreatTypeID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatOccurrenceGetAllByComputerIDUserIDThreatTypeID]
GO
CREATE PROCEDURE [dbo].[ThreatOccurrenceGetAllByComputerIDUserIDThreatTypeID]
	@ComputerID		int,
	@UserID			int,
	@ThreatTypeID		int
AS
	SELECT	ComputerID,
		UserID,
		ThreatTypeID,
		ThreatID,
		ThreatScannerID,
		ThreatOccurrenceRiskID,
		ThreatActionID,
		Details
	FROM	[dbo].[ThreatOccurrence]
	WHERE	ComputerID = @ComputerID
	  AND	UserID = @UserID
	  AND	ThreatTypeID = @ThreatTypeID
	ORDER BY ThreatID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatOccurrenceGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatOccurrenceGetAll]
GO
CREATE PROCEDURE [dbo].[ThreatOccurrenceGetAll]
AS
	SELECT	ComputerID,
		UserID,
		ThreatTypeID,
		ThreatID,
		ThreatScannerID,
		ThreatOccurrenceRiskID,
		ThreatActionID,
		Details
	FROM	[dbo].[ThreatOccurrence]
	ORDER BY ComputerID, UserID, ThreatTypeID, ThreatID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatOccurrenceAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatOccurrenceAdd]
GO
CREATE PROCEDURE [dbo].[ThreatOccurrenceAdd]
	@ComputerID		int,
	@UserID			int,
	@ThreatTypeID		int,
	@ThreatID		int,
	@ThreatScannerID	int,
	@ThreatOccurrenceRiskID	int,
	@ThreatActionID		int,
	@Details		ntext = NULL
AS
	INSERT INTO  dbo.ThreatOccurrence (
		ComputerID,
		UserID,
		ThreatTypeID,
		ThreatID,
		ThreatScannerID,
		ThreatOccurrenceRiskID,
		ThreatActionID,
		Details
	)
	VALUES (
		@ComputerID,
		@UserID,
		@ThreatTypeID,
		@ThreatID,
		@ThreatScannerID,
		@ThreatOccurrenceRiskID,
		@ThreatActionID,
		@Details
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatOccurrenceSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatOccurrenceSchema]
GO
CREATE PROCEDURE [dbo].[ThreatOccurrenceSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#ThreatOccurrence'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #ThreatOccurrence (' + CAST(0x0A AS CHAR(1)) +
	'		ComputerID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		UserID			int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		ThreatTypeID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		ThreatID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		ThreatScannerID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		ThreatOccurrenceRiskID	int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		ThreatActionID		int NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		Details			ntext COLLATE database_default NULL' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #ThreatOccurrence' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatOccurrenceTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatOccurrenceTempAdd]
GO
CREATE PROCEDURE dbo.[ThreatOccurrenceTempAdd]
	@ComputerID		int,
	@UserID			int,
	@ThreatTypeID		int,
	@ThreatID		int,
	@ThreatScannerID	int,
	@ThreatOccurrenceRiskID	int,
	@ThreatActionID		int,
	@Details		ntext = NULL
AS
	INSERT INTO #ThreatOccurrence (
		ComputerID,
		UserID,
		ThreatTypeID,
		ThreatID,
		ThreatScannerID,
		ThreatOccurrenceRiskID,
		ThreatActionID,
		Details
	)
	VALUES (
		@ComputerID,
		@UserID,
		@ThreatTypeID,
		@ThreatID,
		@ThreatScannerID,
		@ThreatOccurrenceRiskID,
		@ThreatActionID,
		@Details
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatOccurrenceAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatOccurrenceAddBatch]
GO
CREATE PROCEDURE dbo.[ThreatOccurrenceAddBatch]
AS
	DECLARE @count int
	INSERT dbo.ThreatOccurrence (
		ComputerID,
		UserID,
		ThreatTypeID,
		ThreatID,
		ThreatScannerID,
		ThreatOccurrenceRiskID,
		ThreatActionID,
		Details
	)
		SELECT	ComputerID,
			UserID,
			ThreatTypeID,
			ThreatID,
			ThreatScannerID,
			ThreatOccurrenceRiskID,
			ThreatActionID,
			Details
		FROM #ThreatOccurrence
	SET @count = @@ROWCOUNT
	DROP TABLE #ThreatOccurrence	-- Drop temporary table
	RETURN @count
GO

/*
Add new ThreatOccurrence bound to
	User using UserOUID, UserCN
	ThreatType using Name
	Threat using Name with Title, ThreatTypeID, ThreatRiskID
	ThreatScanner using Name
	ThreatRisk using Name
	ThreatAction using Name
	with ComputerID, Details
*/

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatOccurrenceUpdateByComputerIDUserIDThreatTypeIDThreatID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatOccurrenceUpdateByComputerIDUserIDThreatTypeIDThreatID]
GO
CREATE PROCEDURE [dbo].[ThreatOccurrenceUpdateByComputerIDUserIDThreatTypeIDThreatID]
	@ComputerID		int,
	@UserID			int,
	@ThreatTypeID		int,
	@ThreatID		int,
	@ThreatScannerID	int,
	@ThreatOccurrenceRiskID	int,
	@ThreatActionID		int,
	@Details		ntext = NULL
AS
	UPDATE	[dbo].[ThreatOccurrence]
	SET	ThreatScannerID = @ThreatScannerID,
		ThreatOccurrenceRiskID = @ThreatOccurrenceRiskID,
		ThreatActionID = @ThreatActionID,
		Details = @Details
	WHERE	ComputerID = @ComputerID
	  AND	UserID = @UserID
	  AND	ThreatTypeID = @ThreatTypeID
	  AND	ThreatID = @ThreatID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatOccurrenceUpdateBatchByComputerIDUserIDThreatTypeIDThreatID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatOccurrenceUpdateBatchByComputerIDUserIDThreatTypeIDThreatID]
GO
CREATE PROCEDURE dbo.[ThreatOccurrenceUpdateBatchByComputerIDUserIDThreatTypeIDThreatID]
AS
	DECLARE @count int

	CREATE INDEX [TempThreatOccurrenceComputerIDUserIDThreatTypeIDThreatID]
		ON #ThreatOccurrence (ComputerID, UserID, ThreatTypeID, ThreatID)

	UPDATE	[dbo].[ThreatOccurrence]
	SET	ThreatScannerID = t.ThreatScannerID,
		ThreatOccurrenceRiskID = t.ThreatOccurrenceRiskID,
		ThreatActionID = t.ThreatActionID,
		Details = t.Details
	FROM	#ThreatOccurrence AS t
	WHERE	ThreatOccurrence.ComputerID = t.ComputerID
	  AND	ThreatOccurrence.UserID = t.UserID
	  AND	ThreatOccurrence.ThreatTypeID = t.ThreatTypeID
	  AND	ThreatOccurrence.ThreatID = t.ThreatID
	SET @count = @@ROWCOUNT
	DROP TABLE #ThreatOccurrence	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatOccurrencePutByComputerIDUserIDThreatTypeIDThreatID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatOccurrencePutByComputerIDUserIDThreatTypeIDThreatID]
GO
CREATE PROCEDURE [dbo].[ThreatOccurrencePutByComputerIDUserIDThreatTypeIDThreatID]
	@ComputerID		int,
	@UserID			int,
	@ThreatTypeID		int,
	@ThreatID		int,
	@ThreatScannerID	int,
	@ThreatOccurrenceRiskID	int,
	@ThreatActionID		int,
	@Details		ntext = NULL
AS
	IF NOT EXISTS(
		SELECT	1
		FROM	dbo.ThreatOccurrence
		WHERE	ComputerID = @ComputerID
		  AND	UserID = @UserID
		  AND	ThreatTypeID = @ThreatTypeID
		  AND	ThreatID = @ThreatID
	)
		EXEC ThreatOccurrenceAdd @ComputerID,
			@UserID,
			@ThreatTypeID,
			@ThreatID,
			@ThreatScannerID,
			@ThreatOccurrenceRiskID,
			@ThreatActionID,
			@Details
	ELSE
		EXEC ThreatOccurrenceUpdateByComputerIDUserIDThreatTypeIDThreatID @ComputerID,
			@UserID,
			@ThreatTypeID,
			@ThreatID,
			@ThreatScannerID,
			@ThreatOccurrenceRiskID,
			@ThreatActionID,
			@Details
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatOccurrencePutBatchByComputerIDUserIDThreatTypeIDThreatID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatOccurrencePutBatchByComputerIDUserIDThreatTypeIDThreatID]
GO
CREATE PROCEDURE [dbo].[ThreatOccurrencePutBatchByComputerIDUserIDThreatTypeIDThreatID]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempThreatOccurrenceComputerIDUserIDThreatTypeIDThreatID]
		ON #ThreatOccurrence (ComputerID, UserID, ThreatTypeID, ThreatID)

	BEGIN TRANSACTION
	UPDATE [dbo].[ThreatOccurrence]
		SET	ThreatScannerID = t.ThreatScannerID,
			ThreatOccurrenceRiskID = t.ThreatOccurrenceRiskID,
			ThreatActionID = t.ThreatActionID,
			Details = t.Details
		FROM	#ThreatOccurrence AS t
		WHERE	ThreatOccurrence.ComputerID = t.ComputerID
		  AND	ThreatOccurrence.UserID = t.UserID
		  AND	ThreatOccurrence.ThreatTypeID = t.ThreatTypeID
		  AND	ThreatOccurrence.ThreatID = t.ThreatID
	SET @count = @@ROWCOUNT

	INSERT [dbo].[ThreatOccurrence] (
		ComputerID,
		UserID,
		ThreatTypeID,
		ThreatID,
		ThreatScannerID,
		ThreatOccurrenceRiskID,
		ThreatActionID,
		Details
	)
		SELECT	ComputerID,
			UserID,
			ThreatTypeID,
			ThreatID,
			ThreatScannerID,
			ThreatOccurrenceRiskID,
			ThreatActionID,
			Details
		FROM	#ThreatOccurrence AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[ThreatOccurrence]
			WHERE	ThreatOccurrence.ComputerID = t.ComputerID
			  AND	ThreatOccurrence.UserID = t.UserID
			  AND	ThreatOccurrence.ThreatTypeID = t.ThreatTypeID
			  AND	ThreatOccurrence.ThreatID = t.ThreatID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #ThreatOccurrence	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatOccurrenceRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatOccurrenceRemoveBatch]
GO

CREATE PROCEDURE [dbo].[ThreatOccurrenceRemoveBatch]
AS

	CREATE INDEX [TempThreatOccurrenceThreatOccurrenceRemoveBatch]
		ON #ThreatOccurrence (ComputerID, UserID, ThreatTypeID, ThreatID)	

	-- Delete records from ThreatOccurrence identified by fields of [TempThreatOccurrenceThreatOccurrenceRemoveBatch]
	DELETE [dbo].[ThreatOccurrence]
	WHERE EXISTS(
			SELECT * FROM #ThreatOccurrence AS t
			WHERE	ThreatOccurrence.ComputerID = t.ComputerID
			  AND	ThreatOccurrence.UserID = t.UserID
			  AND	ThreatOccurrence.ThreatTypeID = t.ThreatTypeID
			  AND	ThreatOccurrence.ThreatID = t.ThreatID
		)
	DROP TABLE #ThreatOccurrence      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatOccurrenceRemoveByComputerIDUserIDThreatTypeIDThreatID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatOccurrenceRemoveByComputerIDUserIDThreatTypeIDThreatID]
GO
CREATE PROCEDURE [dbo].[ThreatOccurrenceRemoveByComputerIDUserIDThreatTypeIDThreatID]
	@ComputerID		int,
	@UserID			int,
	@ThreatTypeID		int,
	@ThreatID		int
AS
	DELETE	[dbo].[ThreatOccurrence]
	WHERE	ComputerID = @ComputerID
	  AND	UserID = @UserID
	  AND	ThreatTypeID = @ThreatTypeID
	  AND	ThreatID = @ThreatID
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatOccurrenceRemoveAllByComputerIDUserIDThreatTypeID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatOccurrenceRemoveAllByComputerIDUserIDThreatTypeID]
GO
CREATE PROCEDURE [dbo].[ThreatOccurrenceRemoveAllByComputerIDUserIDThreatTypeID]
	@ComputerID		int,
	@UserID			int,
	@ThreatTypeID		int
AS
	DELETE	[dbo].[ThreatOccurrence]
	WHERE	ComputerID = @ComputerID
	  AND	UserID = @UserID
	  AND	ThreatTypeID = @ThreatTypeID
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatOccurrenceRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatOccurrenceRemoveAll]
GO
CREATE PROCEDURE [dbo].[ThreatOccurrenceRemoveAll]
	
AS
	DELETE	[dbo].[ThreatOccurrence]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[ThreatOccurrenceReplaceSubsetByComputerIDUserIDThreatTypeID]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[ThreatOccurrenceReplaceSubsetByComputerIDUserIDThreatTypeID]
GO
-- Replace the record subset selected by (@ComputerID, @UserID, @ThreatTypeID)
-- using unique identifier (ComputerID, UserID, ThreatTypeID, ThreatID)
-- updating fields (ThreatScannerID, ThreatOccurrenceRiskID, ThreatActionID, Details)
CREATE PROCEDURE [dbo].[ThreatOccurrenceReplaceSubsetByComputerIDUserIDThreatTypeID]
	@ComputerID		int,
	@UserID			int,
	@ThreatTypeID		int
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempThreatOccurrenceByComputerIDUserIDThreatTypeID]
		ON #ThreatOccurrence (ComputerID, UserID, ThreatTypeID, ThreatID)

	BEGIN TRANSACTION
	DELETE [ThreatOccurrence]
		WHERE	ComputerID = @ComputerID
		  AND	UserID = @UserID
		  AND	ThreatTypeID = @ThreatTypeID
		AND NOT EXISTS(		-- Replacement record doesn't exist
			SELECT * FROM #ThreatOccurrence AS t
			WHERE	ThreatOccurrence.ComputerID = t.ComputerID
			  AND	ThreatOccurrence.UserID = t.UserID
			  AND	ThreatOccurrence.ThreatTypeID = t.ThreatTypeID
			  AND	ThreatOccurrence.ThreatID = t.ThreatID
		)

	UPDATE [dbo].[ThreatOccurrence]
		SET	ThreatScannerID = t.ThreatScannerID,
			ThreatOccurrenceRiskID = t.ThreatOccurrenceRiskID,
			ThreatActionID = t.ThreatActionID,
			Details = t.Details
		FROM	#ThreatOccurrence AS t
		WHERE	ThreatOccurrence.ComputerID = t.ComputerID
		  AND	ThreatOccurrence.UserID = t.UserID
		  AND	ThreatOccurrence.ThreatTypeID = t.ThreatTypeID
		  AND	ThreatOccurrence.ThreatID = t.ThreatID
	SET @count = @@ROWCOUNT

	INSERT [ThreatOccurrence] (
		ComputerID,
		UserID,
		ThreatTypeID,
		ThreatID,
		ThreatScannerID,
		ThreatOccurrenceRiskID,
		ThreatActionID,
		Details
	)
		SELECT	ComputerID,
			UserID,
			ThreatTypeID,
			ThreatID,
			ThreatScannerID,
			ThreatOccurrenceRiskID,
			ThreatActionID,
			Details
		FROM	#ThreatOccurrence AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [ThreatOccurrence]
			WHERE	ThreatOccurrence.ComputerID = t.ComputerID
			  AND	ThreatOccurrence.UserID = t.UserID
			  AND	ThreatOccurrence.ThreatTypeID = t.ThreatTypeID
			  AND	ThreatOccurrence.ThreatID = t.ThreatID
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #ThreatOccurrence	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[BlockedApplicationGetByFileName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[BlockedApplicationGetByFileName]
GO
CREATE PROCEDURE [dbo].[BlockedApplicationGetByFileName]
	@FileName		nvarchar(256)
AS
	SELECT	[FileName],
		ApplicationName,
		Description,
		Visible
	FROM	[dbo].[BlockedApplication]
	WHERE	[FileName] = @FileName
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[BlockedApplicationGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[BlockedApplicationGetAll]
GO
CREATE PROCEDURE [dbo].[BlockedApplicationGetAll]
AS
	SELECT	[FileName],
		ApplicationName,
		Description,
		Visible
	FROM	[dbo].[BlockedApplication]
	ORDER BY [FileName]
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[BlockedApplicationAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[BlockedApplicationAdd]
GO
CREATE PROCEDURE [dbo].[BlockedApplicationAdd]
	@FileName		nvarchar(256),
	@ApplicationName	nvarchar(256) = '',
	@Description		ntext = '',
	@Visible		bit = 1
AS
	INSERT INTO  dbo.BlockedApplication (
		[FileName],
		ApplicationName,
		Description,
		Visible
	)
	VALUES (
		@FileName,
		@ApplicationName,
		@Description,
		@Visible
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[BlockedApplicationSchema]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[BlockedApplicationSchema]
GO
CREATE PROCEDURE [dbo].[BlockedApplicationSchema]
AS
	SELECT
	'IF OBJECT_ID(''tempdb..#BlockedApplication'') IS NULL' + CAST(0x0A AS CHAR(1)) +
	'	CREATE TABLE #BlockedApplication (' + CAST(0x0A AS CHAR(1)) +
	'		[FileName]		nvarchar(256) COLLATE database_default NOT NULL,' + CAST(0x0A AS CHAR(1)) +
	'		ApplicationName		nvarchar(256) COLLATE database_default NOT NULL DEFAULT '''',' + CAST(0x0A AS CHAR(1)) +
	'		Description		ntext COLLATE database_default NOT NULL DEFAULT '''',' + CAST(0x0A AS CHAR(1)) +
	'		Visible			bit NOT NULL DEFAULT 1' + CAST(0x0A AS CHAR(1)) +
	'	)' + CAST(0x0A AS CHAR(1)) +
	'ELSE' + CAST(0x0A AS CHAR(1)) +
	'	DELETE FROM #BlockedApplication' + CAST(0x0A AS CHAR(1)) +
	'' AS SQL
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[BlockedApplicationTempAdd]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[BlockedApplicationTempAdd]
GO
CREATE PROCEDURE dbo.[BlockedApplicationTempAdd]
	@FileName		nvarchar(256),
	@ApplicationName	nvarchar(256) = '',
	@Description		ntext = '',
	@Visible		bit = 1
AS
	INSERT INTO #BlockedApplication (
		[FileName],
		ApplicationName,
		Description,
		Visible
	)
	VALUES (
		@FileName,
		@ApplicationName,
		@Description,
		@Visible
	)
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[BlockedApplicationAddBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[BlockedApplicationAddBatch]
GO
CREATE PROCEDURE dbo.[BlockedApplicationAddBatch]
AS
	DECLARE @count int
	INSERT dbo.BlockedApplication (
		[FileName],
		ApplicationName,
		Description,
		Visible
	)
		SELECT	[FileName],
			ApplicationName,
			Description,
			Visible
		FROM #BlockedApplication
	SET @count = @@ROWCOUNT
	DROP TABLE #BlockedApplication	-- Drop temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[BlockedApplicationUpdateByFileName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[BlockedApplicationUpdateByFileName]
GO
CREATE PROCEDURE [dbo].[BlockedApplicationUpdateByFileName]
	@FileName		nvarchar(256),
	@ApplicationName	nvarchar(256) = '',
	@Description		ntext = '',
	@Visible		bit = 1
AS
	UPDATE	[dbo].[BlockedApplication]
	SET	ApplicationName = @ApplicationName,
		Description = @Description,
		Visible = @Visible
	WHERE	[FileName] = @FileName
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[BlockedApplicationUpdateBatchByFileName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[BlockedApplicationUpdateBatchByFileName]
GO
CREATE PROCEDURE dbo.[BlockedApplicationUpdateBatchByFileName]
AS
	DECLARE @count int

	CREATE INDEX [TempBlockedApplicationFileName]
		ON #BlockedApplication ([FileName])

	UPDATE	[dbo].[BlockedApplication]
	SET	ApplicationName = t.ApplicationName,
		Description = t.Description,
		Visible = t.Visible
	FROM	#BlockedApplication AS t
	WHERE	BlockedApplication.[FileName] = t.[FileName]
	SET @count = @@ROWCOUNT
	DROP TABLE #BlockedApplication	-- Drop the temporary table
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[BlockedApplicationPutByFileName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[BlockedApplicationPutByFileName]
GO
CREATE PROCEDURE [dbo].[BlockedApplicationPutByFileName]
	@FileName		nvarchar(256),
	@ApplicationName	nvarchar(256) = '',
	@Description		ntext = '',
	@Visible		bit = 1
AS
	IF NOT EXISTS(
		SELECT	1
		FROM	dbo.BlockedApplication
		WHERE	[FileName] = @FileName
	)
		EXEC BlockedApplicationAdd @FileName,
			@ApplicationName,
			@Description,
			@Visible
	ELSE
		EXEC BlockedApplicationUpdateByFileName @FileName,
			@ApplicationName,
			@Description,
			@Visible
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[BlockedApplicationPutBatchByFileName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[BlockedApplicationPutBatchByFileName]
GO
CREATE PROCEDURE [dbo].[BlockedApplicationPutBatchByFileName]
AS
	DECLARE @count AS int
	SET @count = 0

	CREATE INDEX [TempBlockedApplicationFileName]
		ON #BlockedApplication ([FileName])

	BEGIN TRANSACTION
	UPDATE [dbo].[BlockedApplication]
		SET	ApplicationName = t.ApplicationName,
			Description = t.Description,
			Visible = t.Visible
		FROM	#BlockedApplication AS t
		WHERE	BlockedApplication.[FileName] = t.[FileName]
	SET @count = @@ROWCOUNT

	INSERT [dbo].[BlockedApplication] (
		[FileName],
		ApplicationName,
		Description,
		Visible
	)
		SELECT	[FileName],
			ApplicationName,
			Description,
			Visible
		FROM	#BlockedApplication AS t
		WHERE NOT EXISTS(	-- Current record doesn't exist
			SELECT * FROM [dbo].[BlockedApplication]
			WHERE	BlockedApplication.[FileName] = t.[FileName]
		)
	SET @count = @count + @@ROWCOUNT
	DROP TABLE #BlockedApplication	-- Drop the temporary table
	COMMIT WORK
	RETURN @count
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[BlockedApplicationRemoveBatch]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[BlockedApplicationRemoveBatch]
GO

CREATE PROCEDURE [dbo].[BlockedApplicationRemoveBatch]
AS

	CREATE INDEX [TempBlockedApplicationBlockedApplicationRemoveBatch]
		ON #BlockedApplication ([FileName])	

	-- Delete records from BlockedApplication identified by fields of [TempBlockedApplicationBlockedApplicationRemoveBatch]
	DELETE [dbo].[BlockedApplication]
	WHERE EXISTS(
			SELECT * FROM #BlockedApplication AS t
			WHERE	BlockedApplication.[FileName] = t.[FileName]
		)
	DROP TABLE #BlockedApplication      -- Drop the temporary table
	RETURN @@ROWCOUNT
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[BlockedApplicationRemoveByFileName]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[BlockedApplicationRemoveByFileName]
GO
CREATE PROCEDURE [dbo].[BlockedApplicationRemoveByFileName]
	@FileName		nvarchar(256)
AS
	DELETE	[dbo].[BlockedApplication]
	WHERE	[FileName] = @FileName
GO

IF EXISTS(SELECT * FROM dbo.sysobjects WHERE id = object_ID(N'[dbo].[BlockedApplicationRemoveAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[BlockedApplicationRemoveAll]
GO
CREATE PROCEDURE [dbo].[BlockedApplicationRemoveAll]
	
AS
	DELETE	[dbo].[BlockedApplication]
	RETURN @@ROWCOUNT
GO



IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'DomainGetAll')
	DROP PROCEDURE DomainGetAll
GO
CREATE PROCEDURE DomainGetAll
AS
	SELECT	OrganizationID,
		DN,
		DomainType,
		FlatName,
		PreferredDomainController,
		PreferredDomainControllerOnly,
		ADReconcile,
		ADLoadLatency,
		MergePolicies,
		LastADReconcile,
		LastADReconcileStatus,
		LastADLoad,
		LastPolicyMerge,
		LastPolicyMergeStatus,
		DNReverse
	FROM	Domain
	RETURN @@ROWCOUNT
GO
CopyPermission 'DomainGetAll', 'mgsOSBreakdown'
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
                AND name = 'PackagePathGetAllBySecurityBulletinID')
        DROP PROCEDURE PackagePathGetAllBySecurityBulletinID
GO
CREATE PROCEDURE PackagePathGetAllBySecurityBulletinID
        @SecurityBulletinID     int
AS
	SELECT  pp.PackagePathID,
	pp.PackageFullName,
	pp.ParentPathID,
	pp.PackagePathTypeID
	FROM
	(
		SELECT  sb.BulletinID
		FROM    SecurityBulletin AS sb
		WHERE   sb.SecurityBulletinID = @SecurityBulletinID
	) AS bulletin
	INNER JOIN SecurityPatch AS sp
	ON	sp.BulletinID = bulletin.BulletinID
	AND	sp.Incorporate > 0
	AND	sp.Supported > 0
	INNER JOIN SecurityPatchToPackageVersion AS sptpv
	ON	sptpv.PatchID = sp.PatchID
	INNER JOIN PackagePath AS pp
	ON	pp.PackageFullName = sptpv.PackageFullName
	INNER JOIN SecPatch_Patch AS spp
	ON	spp.SecurityPatchID = sp.PatchID

	RETURN @@ROWCOUNT
GO
CopyPermission 'PackagePathGetAllBySecurityBulletinID', 'mgsOSBreakdown'
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
	AND name = 'DistributionGroupCreate'
)
	DROP PROCEDURE DistributionGroupCreate
GO
CREATE PROCEDURE DistributionGroupCreate
	@p_GroupName 	nvarchar(128),
	@p_GroupGuid 	binary(16)
AS
	BEGIN TRANSACTION		
	IF NOT EXISTS(
		SELECT * FROM DistributionGroup
			WHERE GroupName = @p_GroupName
	)
	BEGIN
		INSERT INTO DistributionGroup (GroupUID, GroupName)
			VALUES (@p_GroupGuid, @p_GroupName)
		INSERT INTO DistributionGroupMember (GroupUID, MemberID, MemberType)
			SELECT	@p_GroupGuid,
				ServerUID,
				11
			FROM DistributionServer
				WHERE ServerType = 0
	END
	COMMIT TRANSACTION
GO
CopyPermission 'PackagePathGetAllBySecurityBulletinID', 'mgsOSBreakdown'
GO

--
-- Malware stored procedures
--

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
	AND name = 'MalwareGetAllDetailed'
)
	DROP PROCEDURE MalwareGetAllDetailed
GO
CREATE PROCEDURE MalwareGetAllDetailed
AS
	SELECT	t.ThreatID,
		t.Name,
		t.ThreatRiskID AS Risk,
		t.CategorySummary AS Type,
		SUBSTRING(t.Description, 0, 3000) AS Description,
		SUM(CASE WHEN (tocc.ThreatActionID = 1) THEN 1 ELSE 0 END) AS UnresolvedCount,
		SUM(CASE WHEN (tocc.ThreatActionID = 3) THEN 1 ELSE 0 END) AS QuarantinedCount,
		t.DatePosted,
		t.State
	FROM	Threat AS t
	LEFT OUTER JOIN ThreatOccurrence AS tocc ON t.ThreatID = tocc.ThreatID
	WHERE	t.ThreatTypeID = 1 -- threat is malware
	GROUP BY t.ThreatID,
		t.Name,
		t.ThreatRiskID,
		t.CategorySummary,
		SUBSTRING(t.Description, 0, 3000),
		t.DatePosted,
		t.State
	ORDER BY t.Name ASC

	RETURN @@ROWCOUNT
GO
CopyPermission 'MalwareGetAllDetailed', 'mgsOSBreakdown'
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
	AND name = 'VulnerabilityGetAllDetailed'
)
	DROP PROCEDURE VulnerabilityGetAllDetailed
GO
CREATE PROCEDURE VulnerabilityGetAllDetailed
AS
	SELECT	threat.ThreatID,
		t.Name,
		t.ThreatRiskID AS Severity,
		'MBSA' AS Scanner,
		t.State,
		t.Description,
		threat.UnresolvedCount
	FROM
	(
		SELECT	t.ThreatID,
			SUM(CASE WHEN tocc.ThreatID IS NULL THEN 0 ELSE 1 END) AS UnresolvedCount
		FROM	Threat AS t
		LEFT OUTER JOIN ThreatOccurrence AS tocc
		ON	tocc.ThreatID = t.ThreatID
		  AND	tocc.ThreatOccurrenceRiskID > 2
		WHERE t.ThreatTypeID = 3 -- threat is vulnerability
		GROUP BY t.ThreatID
	) AS threat
	INNER JOIN Threat AS t
	ON t.ThreatID = threat.ThreatID
	ORDER BY t.Name ASC

	RETURN @@ROWCOUNT
GO
CopyPermission 'VulnerabilityGetAllDetailed', 'mgsOSBreakdown'
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityItemGetAllBySearchString')
	DROP PROCEDURE SecurityItemGetAllBySearchString
GO
CREATE PROCEDURE SecurityItemGetAllBySearchString
	@SearchString		nvarchar(128)
AS
	SET @SearchString = '%' + @SearchString + '%'

	SELECT	1 AS Type,	-- Bulletin
		b.BulletinID AS Name,
		b.Title AS Description
	FROM	SecPatch_Bulletin AS b
	WHERE	b.BulletinID LIKE @SearchString
	   OR	b.Title LIKE @SearchString
	   OR	b.Summary LIKE @SearchString

	UNION

	SELECT	2 AS Type,	-- Patch
		p.PatchName collate SQL_Latin1_General_Cp1_CI_AS AS Name,
		'Q' + p.SQNumber + ' - Bulletin ' + p.BulletinID AS Description
	FROM	SecPatch_Patch AS p
	WHERE	p.PatchName LIKE @SearchString
	   OR	p.SQNumber LIKE @SearchString

	UNION

	SELECT	3 AS Type,	-- Malware
		t.Name,
		SUBSTRING(t.Description, 0, DATALENGTH(t.Description)) AS Description
	FROM	Threat AS t
	WHERE	t.ThreatTypeID = 1 -- threat is malware
	  AND	(
			t.Name LIKE @SearchString
		   OR	t.Description LIKE @SearchString
		)

	UNION

	SELECT	4 AS Type,	-- Vulnerability
		t.Name,
		SUBSTRING(t.Description, 0, DATALENGTH(t.Description)) AS Description
	FROM	Threat AS t
	WHERE	t.ThreatTypeID = 3 -- threat is vulnerability
	  AND	(
			t.Name LIKE @SearchString
		   OR	t.Description LIKE @SearchString
		)

	RETURN @@ROWCOUNT
GO
CopyPermission 'SecurityItemGetAllBySearchString', 'mgsOSBreakdown'
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
	AND name = 'MalwareGetAllSummaryCount'
)
	DROP PROCEDURE MalwareGetAllSummaryCount
GO
CREATE PROCEDURE MalwareGetAllSummaryCount
AS
	-- Get all computers that have one or more scans
	SELECT	CASE WHEN results.UnknownCount IS NULL THEN 0 ELSE results.UnknownCount END AS UnknownCount,
		CASE WHEN results.CompliantCount IS NULL THEN 0 ELSE results.CompliantCount END AS CompliantCount,
		CASE WHEN results.NonCompliantCount IS NULL THEN 0 ELSE results.NonCompliantCount END AS NonCompliantCount
	FROM
	(
		SELECT	SUM(CASE WHEN scannedComputer.ComputerID IS NULL THEN 1 ELSE 0 END) AS UnknownCount,
			SUM(CASE WHEN scannedComputer.ComputerID IS NOT NULL AND threatenedComputer.ComputerID IS NULL THEN 1 ELSE 0 END) AS CompliantCount,
			SUM(CASE WHEN scannedComputer.ComputerID IS NOT NULL AND threatenedComputer.ComputerID IS NOT NULL THEN 1 ELSE 0 END) AS NonCompliantCount
		FROM	Computer AS c
		LEFT OUTER JOIN
		(
			-- Determine which computers have done at least one scan
			SELECT	DISTINCT
				c.ComputerID
			FROM	Computer AS c
			INNER JOIN ThreatScan AS ts
			ON	ts.ComputerID = c.ComputerID
			WHERE	ts.ThreatTypeID = 1 -- threat is malware
		) AS scannedComputer
		ON	scannedComputer.ComputerID = c.ComputerID
		LEFT OUTER JOIN
		(
			-- Determine which computers have at least one threat
			SELECT	DISTINCT
				c.ComputerID
			FROM	Computer AS c
			INNER JOIN ThreatOccurrence AS tocc
			ON	tocc.ComputerID = c.ComputerID
			WHERE	tocc.ThreatTypeID = 1 -- threat is malware
			  AND	tocc.ThreatActionID = 1 -- threat is infection
		) AS threatenedComputer
		ON	threatenedComputer.ComputerID = c.ComputerID
	) AS results

	RETURN @@ROWCOUNT
GO
CopyPermission 'MalwareGetAllSummaryCount', 'mgsOSBreakdown'
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
	AND name = 'MalwareGetManagedSummaryCount'
)
	DROP PROCEDURE MalwareGetManagedSummaryCount
GO
CREATE PROCEDURE MalwareGetManagedSummaryCount
AS
	DECLARE @SecurityScannedComputer table(ComputerID int PRIMARY KEY)

	-- Determine which computers have done at least one scan
	INSERT INTO @SecurityScannedComputer(ComputerID)	
	SELECT	 ComputerID
	FROM	 SecurityAnalysisReport

	-- Get all computers that have one or more scans
	SELECT	CASE WHEN results.UnknownCount IS NULL THEN 0 ELSE results.UnknownCount END AS UnknownCount,
		CASE WHEN results.CompliantCount IS NULL THEN 0 ELSE results.CompliantCount END AS CompliantCount,
		CASE WHEN results.NonCompliantCount IS NULL THEN 0 ELSE results.NonCompliantCount END AS NonCompliantCount
	FROM
	(
		SELECT	SUM(CASE WHEN malwareScannedComputer.ComputerID IS NULL THEN 1 ELSE 0 END) AS UnknownCount,
			SUM(CASE WHEN malwareScannedComputer.ComputerID IS NOT NULL AND threatenedComputer.ComputerID IS NULL THEN 1 ELSE 0 END) AS CompliantCount,
			SUM(CASE WHEN malwareScannedComputer.ComputerID IS NOT NULL AND threatenedComputer.ComputerID IS NOT NULL THEN 1 ELSE 0 END) AS NonCompliantCount
		FROM	Computer AS c
		LEFT OUTER JOIN InventoryReport AS ir
		ON	ir.ComputerID = c.ComputerID
		  AND	ir.UserID = 1
		LEFT OUTER JOIN
		(
			SELECT	DISTINCT ComputerID
			FROM	NetworkDevice
			WHERE	IsManaged = 1
		) AS networkDeviceComputer
		ON	networkDeviceComputer.ComputerID = c.ComputerID
		LEFT OUTER JOIN
		(
			-- Determine which computers have done at least one scan
			SELECT	DISTINCT ComputerID
			FROM	ThreatScan
			WHERE	ThreatTypeID = 1 -- threat is malware
		) AS malwareScannedComputer
		ON	malwareScannedComputer.ComputerID = c.ComputerID
		LEFT OUTER JOIN
		(
			-- Determine which computers have done at least one scan
			SELECT	DISTINCT ComputerID
			FROM	ThreatScan
		) AS threatScannedComputer
		ON	threatScannedComputer.ComputerID = c.ComputerID
		LEFT OUTER JOIN @SecurityScannedComputer AS securityScannedComputer
		ON	securityScannedComputer.ComputerID = c.ComputerID
		LEFT OUTER JOIN
		(
			-- Determine which computers have at least one threat
			SELECT	DISTINCT ComputerID
			FROM	ThreatOccurrence
			WHERE	ThreatTypeID = 1 -- threat is malware
			  AND	ThreatActionID = 1 -- threat is infection
		) AS threatenedComputer
		ON	threatenedComputer.ComputerID = c.ComputerID
		WHERE	threatScannedComputer.ComputerID IS NOT NULL OR securityScannedComputer.ComputerID IS NOT NULL
			OR ir.ComputerID IS NOT NULL OR networkDeviceComputer.ComputerID IS NOT NULL
	) AS results

	RETURN @@ROWCOUNT
GO
CopyPermission 'MalwareGetManagedSummaryCount', 'mgsOSBreakdown'
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
	AND name = 'VulnerabilityGetAllSummaryCount'
)
	DROP PROCEDURE VulnerabilityGetAllSummaryCount
GO
CREATE PROCEDURE VulnerabilityGetAllSummaryCount
AS
	-- Get all computers that have one or more scans
	SELECT	CASE WHEN results.UnknownCount IS NULL THEN 0 ELSE results.UnknownCount END AS UnknownCount,
		CASE WHEN results.CompliantCount IS NULL THEN 0 ELSE results.CompliantCount END AS CompliantCount,
		CASE WHEN results.NonCompliantCount IS NULL THEN 0 ELSE results.NonCompliantCount END AS NonCompliantCount
	FROM
	(
		SELECT	SUM(CASE WHEN scannedComputer.ComputerID IS NULL THEN 1 ELSE 0 END) AS UnknownCount,
			SUM(CASE WHEN scannedComputer.ComputerID IS NOT NULL AND threatenedComputer.ComputerID IS NULL THEN 1 ELSE 0 END) AS CompliantCount,
			SUM(CASE WHEN scannedComputer.ComputerID IS NOT NULL AND threatenedComputer.ComputerID IS NOT NULL THEN 1 ELSE 0 END) AS NonCompliantCount
		FROM	Computer AS c
		LEFT OUTER JOIN
		(
			-- Determine which computers have done at least one scan
			SELECT	DISTINCT
				c.ComputerID
			FROM	Computer AS c
			INNER JOIN ThreatScan AS ts
			ON	ts.ComputerID = c.ComputerID
			WHERE	ts.ThreatTypeID = 3 -- threat is vulnerability
		) AS scannedComputer
		ON	scannedComputer.ComputerID = c.ComputerID
		LEFT OUTER JOIN
		(
			-- Determine which computers have at least one threat
			SELECT	DISTINCT
				c.ComputerID
			FROM	Computer AS c
			INNER JOIN ThreatOccurrence AS tocc
			ON	tocc.ComputerID = c.ComputerID
			WHERE	tocc.ThreatTypeID = 3 -- threat is vulnerability
			  AND	tocc.ThreatOccurrenceRiskID > 2
		) AS threatenedComputer
		ON	threatenedComputer.ComputerID = c.ComputerID
	) AS results

	RETURN @@ROWCOUNT
GO
CopyPermission 'VulnerabilityGetAllSummaryCount', 'mgsOSBreakdown'
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
	AND name = 'VulnerabilityGetManagedSummaryCount'
)
	DROP PROCEDURE VulnerabilityGetManagedSummaryCount
GO
CREATE PROCEDURE VulnerabilityGetManagedSummaryCount
AS
	DECLARE @SecurityScannedComputer table(ComputerID int PRIMARY KEY)

	-- Determine which computers have done at least one scan
	INSERT INTO @SecurityScannedComputer(ComputerID)	
	SELECT	 ComputerID
	FROM	 SecurityAnalysisReport

	-- Get all computers that have one or more scans
	SELECT	CASE WHEN results.UnknownCount IS NULL THEN 0 ELSE results.UnknownCount END AS UnknownCount,
		CASE WHEN results.CompliantCount IS NULL THEN 0 ELSE results.CompliantCount END AS CompliantCount,
		CASE WHEN results.NonCompliantCount IS NULL THEN 0 ELSE results.NonCompliantCount END AS NonCompliantCount
	FROM
	(
		SELECT	SUM(CASE WHEN vulnerabilityScannedComputer.ComputerID IS NULL THEN 1 ELSE 0 END) AS UnknownCount,
			SUM(CASE WHEN vulnerabilityScannedComputer.ComputerID IS NOT NULL AND threatenedComputer.ComputerID IS NULL THEN 1 ELSE 0 END) AS CompliantCount,
			SUM(CASE WHEN vulnerabilityScannedComputer.ComputerID IS NOT NULL AND threatenedComputer.ComputerID IS NOT NULL THEN 1 ELSE 0 END) AS NonCompliantCount
		FROM	Computer AS c
		LEFT OUTER JOIN InventoryReport AS ir
		ON	ir.ComputerID = c.ComputerID
		  AND	ir.UserID = 1
		LEFT OUTER JOIN
		(
			SELECT	DISTINCT ComputerID
			FROM	NetworkDevice
			WHERE	IsManaged = 1
		) AS networkDeviceComputer
		ON	networkDeviceComputer.ComputerID = c.ComputerID
		LEFT OUTER JOIN
		(
			-- Determine which computers have done at least one scan
			SELECT	DISTINCT ComputerID
			FROM	ThreatScan
			WHERE	ThreatTypeID = 3 -- threat is vulnerability
		) AS vulnerabilityScannedComputer
		ON	vulnerabilityScannedComputer.ComputerID = c.ComputerID
		LEFT OUTER JOIN
		(
			-- Determine which computers have done at least one scan
			SELECT	DISTINCT ComputerID
			FROM	ThreatScan
		) AS threatScannedComputer
		ON	threatScannedComputer.ComputerID = c.ComputerID
		LEFT OUTER JOIN @SecurityScannedComputer AS securityScannedComputer
		ON	securityScannedComputer.ComputerID = c.ComputerID
		LEFT OUTER JOIN
		(
			-- Determine which computers have at least one threat
			SELECT	DISTINCT ComputerID
			FROM	ThreatOccurrence
			WHERE	ThreatTypeID = 3 -- threat is vulnerability
			  AND	ThreatOccurrenceRiskID > 2
		) AS threatenedComputer
		ON	threatenedComputer.ComputerID = c.ComputerID
		WHERE	threatScannedComputer.ComputerID IS NOT NULL OR securityScannedComputer.ComputerID IS NOT NULL
			OR ir.ComputerID IS NOT NULL OR networkDeviceComputer.ComputerID IS NOT NULL
	) AS results

	RETURN @@ROWCOUNT
GO
CopyPermission 'VulnerabilityGetManagedSummaryCount', 'mgsOSBreakdown'
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
	AND name = 'SecurityBulletinGetAllSummaryCount'
)
	DROP PROCEDURE SecurityBulletinGetAllSummaryCount
GO
CREATE PROCEDURE SecurityBulletinGetAllSummaryCount
AS
	DECLARE @LatestDateRevised datetime
	SELECT	@LatestDateRevised = MAX(DateRevised) FROM SecurityBulletin

	-- Get all computers that have one or more scans
	SELECT	CASE WHEN results.UnknownCount IS NULL THEN 0 ELSE results.UnknownCount END AS UnknownCount,
		CASE WHEN results.CompliantCount IS NULL THEN 0 ELSE results.CompliantCount END AS CompliantCount,
		CASE WHEN results.NonCompliantCount IS NULL THEN 0 ELSE results.NonCompliantCount END AS NonCompliantCount
	FROM
	(
		SELECT	SUM(CASE WHEN ((scannedComputer.ComputerID IS NULL OR scannedComputer.DataSourceDate < @LatestDateRevised) AND computerAnalysis.ComputerID IS NULL) OR computerAnalysis.NonCompliantCount = 0 THEN 1 ELSE 0 END) AS UnknownCount,
			SUM(CASE WHEN scannedComputer.DataSourceDate >= @LatestDateRevised AND computerAnalysis.ComputerID IS NULL THEN 1 ELSE 0 END) AS CompliantCount,
			SUM(CASE WHEN computerAnalysis.NonCompliantCount > 0 THEN 1 ELSE 0 END) AS NonCompliantCount
		FROM	Computer AS c
		LEFT OUTER JOIN SecurityAnalysisReport AS scannedComputer -- Determine which computers have done at least one scan
		ON	scannedComputer.ComputerID = c.ComputerID
		LEFT OUTER JOIN
		(
			-- Determine which computers have at least one threat
			SELECT	ComputerID,
				CASE WHEN SUM(CASE WHEN Status = 1 THEN 1 ELSE 0 END) > 0 THEN 1 ELSE 0 END AS NonCompliantCount,
				CASE WHEN SUM(CASE WHEN Status = 2 THEN 1 ELSE 0 END) > 0 THEN 1 ELSE 0 END AS UnknownCount
			FROM	SecurityPatchAnalysis
			WHERE	Status IN (1, 2)	-- Status is unknown or non-compliant
			GROUP BY ComputerID
		) AS computerAnalysis
		ON	computerAnalysis.ComputerID = c.ComputerID
	) AS results

	RETURN @@ROWCOUNT
GO
CopyPermission 'SecurityBulletinGetAllSummaryCount', 'mgsOSBreakdown'
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
	AND name = 'SecurityBulletinGetManagedSummaryCount'
)
	DROP PROCEDURE SecurityBulletinGetManagedSummaryCount
GO
CREATE PROCEDURE SecurityBulletinGetManagedSummaryCount
AS
	DECLARE @LatestDateRevised datetime
	SELECT	@LatestDateRevised = MAX(DateRevised) FROM SecurityBulletin

	-- Get all computers that have one or more scans
	SELECT	CASE WHEN results.UnknownCount IS NULL THEN 0 ELSE results.UnknownCount END AS UnknownCount,
		CASE WHEN results.CompliantCount IS NULL THEN 0 ELSE results.CompliantCount END AS CompliantCount,
		CASE WHEN results.NonCompliantCount IS NULL THEN 0 ELSE results.NonCompliantCount END AS NonCompliantCount
	FROM
	(
		SELECT	SUM(CASE WHEN ((securityScannedComputer.ComputerID IS NULL OR securityScannedComputer.DataSourceDate < @LatestDateRevised) AND computerAnalysis.ComputerID IS NULL) OR computerAnalysis.NonCompliantCount = 0 THEN 1 ELSE 0 END) AS UnknownCount,
			SUM(CASE WHEN securityScannedComputer.DataSourceDate >= @LatestDateRevised AND computerAnalysis.ComputerID IS NULL THEN 1 ELSE 0 END) AS CompliantCount,
			SUM(CASE WHEN computerAnalysis.NonCompliantCount > 0 THEN 1 ELSE 0 END) AS NonCompliantCount
		FROM	Computer AS c
		LEFT OUTER JOIN InventoryReport AS ir
		ON	ir.ComputerID = c.ComputerID
		  AND	ir.UserID = 1
		LEFT OUTER JOIN
		(
			SELECT	DISTINCT ComputerID
			FROM	NetworkDevice
			WHERE	IsManaged = 1
		) AS networkDeviceComputer
		ON	networkDeviceComputer.ComputerID = c.ComputerID
		LEFT OUTER JOIN
		(
			-- Determine which computers have done at least one scan
			SELECT	DISTINCT ComputerID
			FROM	ThreatScan
		) AS threatScannedComputer
		ON	threatScannedComputer.ComputerID = c.ComputerID
		LEFT OUTER JOIN SecurityAnalysisReport AS securityScannedComputer
		ON	securityScannedComputer.ComputerID = c.ComputerID
		LEFT OUTER JOIN
		(
			-- Determine which computers have at least one threat
			SELECT	ComputerID,
				CASE WHEN SUM(CASE WHEN Status = 1 THEN 1 ELSE 0 END) > 0 THEN 1 ELSE 0 END AS NonCompliantCount,
				CASE WHEN SUM(CASE WHEN Status = 2 THEN 1 ELSE 0 END) > 0 THEN 1 ELSE 0 END AS UnknownCount
			FROM	SecurityPatchAnalysis
			WHERE	Status IN (1, 2)	-- Status is unknown or non-compliant
			GROUP BY ComputerID
		) AS computerAnalysis
		ON	computerAnalysis.ComputerID = c.ComputerID
		WHERE	threatScannedComputer.ComputerID IS NOT NULL OR securityScannedComputer.ComputerID IS NOT NULL
			OR ir.ComputerID IS NOT NULL OR networkDeviceComputer.ComputerID IS NOT NULL
	) AS results

	RETURN @@ROWCOUNT
GO
CopyPermission 'SecurityBulletinGetManagedSummaryCount', 'mgsOSBreakdown'
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
	AND name = 'SecurityBulletinGetNewCount'
)
	DROP PROCEDURE SecurityBulletinGetNewCount
GO
CREATE PROCEDURE SecurityBulletinGetNewCount
AS
	SELECT	COUNT(*) AS BulletinCount
	FROM	SecurityBulletin AS sb
	WHERE	sb.Ignore = 0
	  AND	sb.UIStateID = 1
	  AND	sb.SecurityBulletinID <> 0

	RETURN @@ROWCOUNT
GO
CopyPermission 'SecurityBulletinGetNewCount', 'mgsOSBreakdown'
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
	AND name = 'MalwareGetByNameDetailed'
)
	DROP PROCEDURE MalwareGetByNameDetailed
GO
CREATE PROCEDURE MalwareGetByNameDetailed
	@Name		nvarchar(128)
AS
	SELECT	t.ThreatID,
		t.Name,
		t.ThreatRiskID AS Risk,
		t.CategorySummary AS Type,
		t.Description,
		0 AS UnresolvedCount,	-- Not used
		0 AS QuarantinedCount,	-- Not used
		t.DatePosted,
		t.State
	FROM	Threat AS t
	WHERE	t.Name = @Name
	  AND	t.ThreatTypeID = 1 -- threat is malware

	RETURN @@ROWCOUNT
GO
CopyPermission 'MalwareGetByNameDetailed', 'mgsOSBreakdown'
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
	AND name = 'VulnerabilityGetByNameDetailed'
)
	DROP PROCEDURE VulnerabilityGetByNameDetailed
GO
CREATE PROCEDURE VulnerabilityGetByNameDetailed
	@Name		nvarchar(128)
AS
	SELECT	t.ThreatID,
		t.Name,
		t.ThreatRiskID AS Severity,
		'MBSA' AS Scanner,
		t.State,
		t.Description,
		0 AS UnresolvedCount	-- Not used
	FROM	Threat AS t
	WHERE	t.Name = @Name
	  AND	t.ThreatTypeID = 3 -- threat is vulnerability

	RETURN @@ROWCOUNT
GO
CopyPermission 'VulnerabilityGetByNameDetailed', 'mgsOSBreakdown'
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
	AND name = 'SecurityBulletinGetByBulletinIDDetailed'
)
	DROP PROCEDURE SecurityBulletinGetByBulletinIDDetailed
GO
CREATE PROCEDURE [dbo].[SecurityBulletinGetByBulletinIDDetailed]
	@BulletinID	nvarchar(128)
AS
	SELECT	sb.SecurityBulletinID,
		sb.Severity,
		ss.Description AS State,
		sus.Description AS UIState,
		sb.BulletinID,
		sb.HelpUrl,
		spb.Title,
		spb.Summary,
		sb.DatePosted,
		sb.DateRevised,
		sb.UpdateAvailable,
		sb.Errata,
		spb.Supported,
		sb.Ignore,
		sb.CustomID
	FROM	SecurityBulletin AS sb
	INNER JOIN SecPatch_Bulletin AS spb
	ON	spb.BulletinID = sb.BulletinID
	INNER JOIN SecurityState AS ss
	ON	ss.StateID = sb.State
	INNER JOIN SecurityUIState AS sus
	ON	sus.UIStateID = sb.UIStateID
	WHERE	sb.BulletinID = @BulletinID

	RETURN @@ROWCOUNT
GO
CopyPermission 'SecurityBulletinGetByBulletinIDDetailed', 'mgsOSBreakdown'
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
	AND name = 'SecurityBulletinGetByBulletinIDDetailedRMS'
)
	DROP PROCEDURE SecurityBulletinGetByBulletinIDDetailedRMS
GO
CREATE PROCEDURE [dbo].[SecurityBulletinGetByBulletinIDDetailedRMS]
	@BulletinID	nvarchar(128)
AS
	SELECT
	 sb.SecurityBulletinID,
	 sb.BulletinID,                     
	 Title,                          
	 Severity,                       
	 State,                          
	 Comments,                       
	 HelpUrl,                        
	 sb.DatePosted,                     
	 sb.DateRevised,                    
	 Version,                        
	 UpdateAvailable,               
	 UIStateID,                     
	 Hidden,                        
	 PackageVersionID,              
	 Errata,                        
	 Ignore,
	 SupersedeStatus,
	 sb.CustomID,
	 sb.RequiredCount,
	 Summary,
	(select TOP (1) UserStateID   from SecurityBulletinToUserState WHERE SecurityBulletinID = sb.SecurityBulletinID
	order by DateChanged DESC) as UserStateID
	,
	(select TOP (1) Certified   from SecurityBulletinToUserState WHERE SecurityBulletinID = sb.SecurityBulletinID
	order by DateChanged DESC) as Certified

	,(	SELECT nm  + '|' as 'data()' FROM
	(
	SELECT	DISTINCT  spprod.Name as nm 
		FROM	SecPatch_Patch AS spp2
		INNER JOIN SecPatch_AffectedProduct AS spa
		ON	spa.PatchID = spp2.PatchID
		INNER JOIN SecPatch_Product AS spprod
		ON	spprod.ProductID = spa.ProductID
		WHERE spp2.BulletinID =   sb.BulletinID
	) AS A
	ORDER BY nm for xml path('')
	) Products
		FROM SecurityBulletin AS sb
		INNER JOIN SecPatch_Bulletin AS spb ON sb.BulletinID = spb.BulletinID
		WHERE	sb.BulletinID = @BulletinID
GO
CopyPermission 'SecurityBulletinGetByBulletinIDDetailedRMS', 'mgsOSBreakdown'
GO
IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetAllByBulletinIDProducts')
	DROP PROCEDURE SecurityBulletinGetAllByBulletinIDProducts
GO
CREATE PROCEDURE SecurityBulletinGetAllByBulletinIDProducts
	@BulletinID	nvarchar(128)
AS
	SELECT	spprod.Name
	FROM	SecPatch_Patch AS spp
	INNER JOIN SecPatch_AffectedProduct AS spa
	ON	spa.PatchID = spp.PatchID
	INNER JOIN SecPatch_Product AS spprod
	ON	spprod.ProductID = spa.ProductID
	WHERE	spp.BulletinID = @BulletinID

	RETURN @@ROWCOUNT
GO
CopyPermission 'SecurityBulletinGetAllByBulletinIDProducts', 'mgsOSBreakdown'
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
		AND name = 'SecurityBulletinGetAllByBulletinIDProductGroups')
	DROP PROCEDURE SecurityBulletinGetAllByBulletinIDProductGroups
GO
CREATE PROCEDURE SecurityBulletinGetAllByBulletinIDProductGroups
	@BulletinID	nvarchar(128)
AS
	SELECT	DISTINCT
		spupg.GroupName,
		spupg.Product
	FROM	SecPatch_Patch AS spp
	INNER JOIN SecPatch_AffectedProduct AS spa
	ON	spa.PatchID = spp.PatchID
	INNER JOIN SecPatch_Product AS spprod
	ON	spprod.ProductID = spa.ProductID
	INNER JOIN SecurityPatchUIProductGroup AS spupg
	ON	spupg.Product = spprod.Name
	WHERE	spp.BulletinID = @BulletinID
GO
CopyPermission 'SecurityBulletinGetAllByBulletinIDProductGroups', 'mgsOSBreakdown'
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
                AND name = 'SecurityBulletinGetAllByBulletinIDUserStates')
        DROP PROCEDURE SecurityBulletinGetAllByBulletinIDUserStates
GO
CREATE PROCEDURE SecurityBulletinGetAllByBulletinIDUserStates
	@BulletinID	nvarchar(128)
AS
	SELECT	sus.Description,
		sbtus.Certified
	FROM	SecurityBulletin AS sb
	INNER JOIN SecurityBulletinToUserState AS sbtus
	ON	sbtus.SecurityBulletinID = sb.SecurityBulletinID
	INNER JOIN SecurityUserState AS sus
	ON	sus.UserStateID = sbtus.UserStateID
        WHERE	sb.BulletinID = @BulletinID
GO
CopyPermission 'SecurityBulletinGetAllByBulletinIDUserStates', 'mgsOSBreakdown'
GO

IF EXISTS(SELECT * FROM sysobjects WHERE xtype = 'P'
                AND name = 'SecurityPatchGetBulletinIDByPatchName')
        DROP PROCEDURE SecurityPatchGetBulletinIDByPatchName
GO
CREATE PROCEDURE SecurityPatchGetBulletinIDByPatchName
	@PatchName	nvarchar(128)
AS
	SELECT	sp.BulletinID
	FROM	SecurityPatch AS sp
	WHERE	sp.PatchName = @PatchName
GO
CopyPermission 'SecurityPatchGetBulletinIDByPatchName', 'mgsOSBreakdown'
GO
